dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/lib/coroutines.lua")

async(function()
	
	local warningRange = 300 -- controls how far the player can be from the boss to receive a warning
	local despawnRange = 500 -- controls how far the player must be from the boss for it to despawn
	
	local playerInRange = true
	local rangeWarningShown = false
	local despawnWarningShown = false
	
	while(playerInRange) do 
		wait(15)
		
		spawnedBoss = GetUpdatedEntityID()
		local enemy_x, enemy_y = EntityGetTransform( spawnedBoss )

		local player_entity_warningRange = EntityGetInRadiusWithTag( enemy_x, enemy_y, warningRange, "player_unit" )
		local player_entity_despawnRange = EntityGetInRadiusWithTag( enemy_x, enemy_y, despawnRange, "player_unit" )
		
		if ((#player_entity_warningRange > 0) and (#player_entity_despawnRange > 0)) then
			-- player is within warning and despawn ranges, no warning necessary
		elseif((not (#player_entity_warningRange > 0)) and (#player_entity_despawnRange > 0)) then
			-- player is outside of warning range but inside despawn range, so the player is warned 
			GamePrint("You are too far from the boss")
			if(not rangeWarningShown) then
				GamePrintImportant("You're getting too far from the boss", "")
				rangeWarningShown = true
			end
		elseif(not(#player_entity_despawnRange > 0)) then
			-- player is outside of despawn range, boss despawns
			GamePrint("Boss despawned")
			if(not despawnWarningShown) then
				GamePrintImportant("The boss found you unworthy and despawned, try again next time", "")
				despawnWarningShown = true
			end
			playerInRange = false
			
			-- loads custom explosion sprite
			EntityLoad("data/entities/explosion_miniboss_spawned.xml", enemy_x, enemy_y)
			
			EntityKill(spawnedBoss) -- Despawns miniboss
		end

	end
end)

