RegisterSpawnFunction( 0xff7E1A65, "spawn_armory_chest" )

--------------------------------------------------------------------------------
-- ALL SPAWN POINTS FOR CHESTS WERE REMOVED FROM REGULAR WORLD TILES
-- MEANING THIS FILE NO LONGER CONTROLS THE SPAWNING OF TIERED CHESTS
-- THE SPAWNING OF CHESTS IS NOW HANDLED SOLELY BY chest_room_assets_spawn.lua
--------------------------------------------------------------------------------

-- This file controls the spawning of the following containers:
-- - tiered chests
-- - ammo, throwables, grenades and first aid boxes
-- - gun part boxes

function spawn_armory_chest(x, y)
	SetRandomSeed( x, y )
	
	-- 50% chance an armory chest can spawn on wang color spawn pixel
	local mainChance = Random(1,2)
	-- biome chance, calculated per biome
	local biomeChance = 0
	local biomeChance_secondary = 0
	local biomeChance_gunpart_box = 0
	
	if(mainChance > 1) then
	
		-- spawn chances are set per biome
		
		-- Obtaining current biome
		biomeName = BiomeMapGetName( x, y )
		
		-- Mines
		if(biomeName == "$biome_coalmine") then
			biomeChance = Random(1,6)
			if(biomeChance > 1) then -- 66% chance for regular chests
				EntityLoad( "data/entities/items/pickup/chest_armory_regular.xml", x, y)
			elseif(biomeChance == 1) then -- 17% chance for exquisite chests, first aid or ammo/grenade boxes
				
				biomeChance_secondary = Random(1,10)
				if(biomeChance_secondary == 1) then
					EntityLoad( "data/entities/items/pickup/chest_armory_exquisite.xml", x, y)
				elseif(biomeChance_secondary == 2) then
					EntityLoad( "data/entities/items/pickup/first_aid_box.xml", x, y)
				elseif(biomeChance_secondary == 3) then
					EntityLoad( "data/entities/items/pickup/bullet_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 4) then
					EntityLoad( "data/entities/items/pickup/grenade_box.xml", x, y)
				elseif(biomeChance_secondary == 5) then
					EntityLoad( "data/entities/items/pickup/special_grenades_box.xml", x, y)
				elseif(biomeChance_secondary == 6) then
					EntityLoad( "data/entities/items/pickup/basic_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 7) then
					EntityLoad( "data/entities/items/pickup/explosive_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 8) then
					EntityLoad( "data/entities/items/pickup/special_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 9) then
					EntityLoad( "data/entities/items/pickup/throwable_weapons_box.xml", x, y)
				elseif(biomeChance_secondary == 10) then
					biomeChance_gunpart_box = Random(1,5)
					if(biomeChance_gunpart_box == 1) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 2) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 3) then
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 4) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 5) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
					end
				end
			end
		end
		
		-- Collapsed Mines
		if(biomeName == "$biome_coalmine_alt") then
			biomeChance = Random(1,3)
			if(biomeChance > 1) then -- 67% chance for regular chests
				EntityLoad( "data/entities/items/pickup/chest_armory_regular.xml", x, y)
			elseif(biomeChance == 1) then -- 33% chance for exquisite chests, first aid or ammo/grenade boxes
			
				biomeChance_secondary = Random(1,10)
				if(biomeChance_secondary == 1) then
					EntityLoad( "data/entities/items/pickup/chest_armory_exquisite.xml", x, y)
				elseif(biomeChance_secondary == 2) then
					EntityLoad( "data/entities/items/pickup/first_aid_box.xml", x, y)
				elseif(biomeChance_secondary == 3) then
					EntityLoad( "data/entities/items/pickup/bullet_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 4) then
					EntityLoad( "data/entities/items/pickup/grenade_box.xml", x, y)
				elseif(biomeChance_secondary == 5) then
					EntityLoad( "data/entities/items/pickup/special_grenades_box.xml", x, y)
				elseif(biomeChance_secondary == 6) then
					EntityLoad( "data/entities/items/pickup/basic_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 7) then
					EntityLoad( "data/entities/items/pickup/explosive_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 8) then
					EntityLoad( "data/entities/items/pickup/special_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 9) then
					EntityLoad( "data/entities/items/pickup/throwable_weapons_box.xml", x, y)
				elseif(biomeChance_secondary == 10) then
					biomeChance_gunpart_box = Random(1,5)
					if(biomeChance_gunpart_box == 1) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 2) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 3) then
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 4) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 5) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
					end
				end
				
			end
		end
		
		-- Coal Mines
		if(biomeName == "$biome_excavationsite") then
			biomeChance = Random(1,6)
			if(biomeChance > 1) then -- 83% chance for exquisite chests
				EntityLoad( "data/entities/items/pickup/chest_armory_exquisite.xml", x, y)
			elseif(biomeChance == 1) then -- 17% chance for special chests, first aid or ammo/grenade boxes
				
				biomeChance_secondary = Random(1,10)
				if(biomeChance_secondary == 1) then
					EntityLoad( "data/entities/items/pickup/chest_armory_special.xml", x, y)
				elseif(biomeChance_secondary == 2) then
					EntityLoad( "data/entities/items/pickup/first_aid_box.xml", x, y)
				elseif(biomeChance_secondary == 3) then
					EntityLoad( "data/entities/items/pickup/bullet_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 4) then
					EntityLoad( "data/entities/items/pickup/grenade_box.xml", x, y)
				elseif(biomeChance_secondary == 5) then
					EntityLoad( "data/entities/items/pickup/special_grenades_box.xml", x, y)
				elseif(biomeChance_secondary == 6) then
					EntityLoad( "data/entities/items/pickup/basic_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 7) then
					EntityLoad( "data/entities/items/pickup/explosive_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 8) then
					EntityLoad( "data/entities/items/pickup/special_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 9) then
					EntityLoad( "data/entities/items/pickup/throwable_weapons_box.xml", x, y)
				elseif(biomeChance_secondary == 10) then
					biomeChance_gunpart_box = Random(1,5)
					if(biomeChance_gunpart_box == 1) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 2) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 3) then
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 4) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 5) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
					end
				end
				
			end

		end
		
		-- Fungal Caverns
		if(biomeName == "$biome_fungicave") then
			biomeChance = Random(1,6)
			if(biomeChance >= 1 or biomeChance <= 2) then -- 33% chance for rare chests
				EntityLoad( "data/entities/items/pickup/chest_armory_rare.xml", x, y)
			elseif(biomeChance >= 3 or biomeChance <= 4) then -- 33% chance for legendary chests
				EntityLoad( "data/entities/items/pickup/chest_armory_legendary.xml", x, y)
			elseif(biomeChance >= 5 or biomeChance <= 6) then -- 33% chance for epic chests
				EntityLoad( "data/entities/items/pickup/chest_armory_epic.xml", x, y)
			end
		end
		
		-- Snowy Depths
		if(biomeName == "$biome_snowcave") then
			biomeChance = Random(1,6)
			if(biomeChance > 3) then -- 52% chance for special chests
				EntityLoad( "data/entities/items/pickup/chest_armory_special.xml", x, y)
			elseif(biomeChance == 1) then -- 16% chance for rare chests
				EntityLoad( "data/entities/items/pickup/chest_armory_rare.xml", x, y)
			elseif(biomeChance == 2) then -- 16% chance for legendary chests
				EntityLoad( "data/entities/items/pickup/chest_armory_legendary.xml", x, y)
			elseif(biomeChance == 3) then -- 16% chance for firs aid or ammo/grenade boxes
			
				biomeChance_secondary = Random(1,9)
				if(biomeChance_secondary == 1) then
					EntityLoad( "data/entities/items/pickup/first_aid_box.xml", x, y)
				elseif(biomeChance_secondary == 2) then
					EntityLoad( "data/entities/items/pickup/bullet_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 3) then
					EntityLoad( "data/entities/items/pickup/grenade_box.xml", x, y)
				elseif(biomeChance_secondary == 4) then
					EntityLoad( "data/entities/items/pickup/special_grenades_box.xml", x, y)
				elseif(biomeChance_secondary == 5) then
					EntityLoad( "data/entities/items/pickup/basic_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 6) then
					EntityLoad( "data/entities/items/pickup/explosive_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 7) then
					EntityLoad( "data/entities/items/pickup/special_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 8) then
					EntityLoad( "data/entities/items/pickup/throwable_weapons_box.xml", x, y)
				elseif(biomeChance_secondary == 9) then
					biomeChance_gunpart_box = Random(1,5)
					if(biomeChance_gunpart_box == 1) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 2) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 3) then
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 4) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 5) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
					end
				end
				
			end
		end
		
		-- Hiisi Base
		if(biomeName == "$biome_snowcastle") then
			biomeChance = Random(1,12)
			if(biomeChance == 1 or biomeChance == 2) then -- 16% chance for special chests
				EntityLoad( "data/entities/items/pickup/chest_armory_special.xml", x, y)
			elseif(biomeChance == 3 or biomeChance == 4) then -- 16% chance for rare chests
				EntityLoad( "data/entities/items/pickup/chest_armory_rare.xml", x, y)
			elseif(biomeChance == 5 or biomeChance == 6) then -- 16% chance for regular chests
				EntityLoad( "data/entities/items/pickup/chest_armory_regular.xml", x, y)
			elseif(biomeChance == 7 or biomeChance == 8) then -- 16% chance for exquisite chests
				EntityLoad( "data/entities/items/pickup/chest_armory_exquisite.xml", x, y)
			elseif(biomeChance == 9 or biomeChance == 10) then -- 16% chance for legendary chests
				EntityLoad( "data/entities/items/pickup/chest_armory_legendary.xml", x, y)
			elseif(biomeChance == 11) then -- 8% chance for epic chests
				EntityLoad( "data/entities/items/pickup/chest_armory_epic.xml", x, y)
			elseif(biomeChance == 12) then -- 8% chance for first aid or ammo/grenade boxes
			
				biomeChance_secondary = Random(1,9)
				if(biomeChance_secondary == 1) then
					EntityLoad( "data/entities/items/pickup/first_aid_box.xml", x, y)
				elseif(biomeChance_secondary == 2) then
					EntityLoad( "data/entities/items/pickup/bullet_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 3) then
					EntityLoad( "data/entities/items/pickup/grenade_box.xml", x, y)
				elseif(biomeChance_secondary == 4) then
					EntityLoad( "data/entities/items/pickup/special_grenades_box.xml", x, y)
				elseif(biomeChance_secondary == 5) then
					EntityLoad( "data/entities/items/pickup/basic_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 6) then
					EntityLoad( "data/entities/items/pickup/explosive_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 7) then
					EntityLoad( "data/entities/items/pickup/special_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 8) then
					EntityLoad( "data/entities/items/pickup/throwable_weapons_box.xml", x, y)
				elseif(biomeChance_secondary == 9) then
					biomeChance_gunpart_box = Random(1,5)
					if(biomeChance_gunpart_box == 1) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 2) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 3) then
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 4) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 5) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
					end
				end
				
			end
		end
		
		-- Underground Jungle
		if(biomeName == "$biome_rainforest") then
			biomeChance = Random(1,10)
			if(biomeChance > 6) then -- 40% chance for special chests
				EntityLoad( "data/entities/items/pickup/chest_armory_special.xml", x, y)
			elseif(biomeChance == 1 or biomeChance == 2) then -- 20% chance for rare chests
				EntityLoad( "data/entities/items/pickup/chest_armory_rare.xml", x, y)
			elseif(biomeChance == 3 or biomeChance == 4) then -- 20% chance for legendary chests
				EntityLoad( "data/entities/items/pickup/chest_armory_legendary.xml", x, y)
			elseif(biomeChance == 5) then -- 10% chance for epic chests
				EntityLoad( "data/entities/items/pickup/chest_armory_epic.xml", x, y)
			elseif(biomeChance == 6) then -- 10% chance for first aid or ammo/grenade boxes
			
				biomeChance_secondary = Random(1,9)
				if(biomeChance_secondary == 1) then
					EntityLoad( "data/entities/items/pickup/first_aid_box.xml", x, y)
				elseif(biomeChance_secondary == 2) then
					EntityLoad( "data/entities/items/pickup/bullet_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 3) then
					EntityLoad( "data/entities/items/pickup/grenade_box.xml", x, y)
				elseif(biomeChance_secondary == 4) then
					EntityLoad( "data/entities/items/pickup/special_grenades_box.xml", x, y)
				elseif(biomeChance_secondary == 5) then
					EntityLoad( "data/entities/items/pickup/basic_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 6) then
					EntityLoad( "data/entities/items/pickup/explosive_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 7) then
					EntityLoad( "data/entities/items/pickup/special_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 8) then
					EntityLoad( "data/entities/items/pickup/throwable_weapons_box.xml", x, y)
				elseif(biomeChance_secondary == 9) then
					biomeChance_gunpart_box = Random(1,5)
					if(biomeChance_gunpart_box == 1) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 2) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 3) then
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 4) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 5) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
					end
				end
				
			end
		end
		
		-- The Vault
		if(biomeName == "$biome_vault") then
			biomeChance = Random(1,7)
			if(biomeChance >= 1 or biomeChance <= 2) then -- 29% chance for rare chests
				EntityLoad( "data/entities/items/pickup/chest_armory_rare.xml", x, y)
			elseif(biomeChance >= 3 or biomeChance <= 4) then -- 29% chance for legendary chests
				EntityLoad( "data/entities/items/pickup/chest_armory_legendary.xml", x, y)
			elseif(biomeChance >= 5 or biomeChance <= 6) then -- 29% chance for epic chests
				EntityLoad( "data/entities/items/pickup/chest_armory_epic.xml", x, y)
			elseif(biomeChance == 7) then -- 15% chance for first aid or ammo/grenade boxes
				
				biomeChance_secondary = Random(1,9)
				if(biomeChance_secondary == 1) then
					EntityLoad( "data/entities/items/pickup/first_aid_box.xml", x, y)
				elseif(biomeChance_secondary == 2) then
					EntityLoad( "data/entities/items/pickup/bullet_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 3) then
					EntityLoad( "data/entities/items/pickup/grenade_box.xml", x, y)
				elseif(biomeChance_secondary == 4) then
					EntityLoad( "data/entities/items/pickup/special_grenades_box.xml", x, y)
				elseif(biomeChance_secondary == 5) then
					EntityLoad( "data/entities/items/pickup/basic_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 6) then
					EntityLoad( "data/entities/items/pickup/explosive_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 7) then
					EntityLoad( "data/entities/items/pickup/special_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 8) then
					EntityLoad( "data/entities/items/pickup/throwable_weapons_box.xml", x, y)
				elseif(biomeChance_secondary == 9) then
					biomeChance_gunpart_box = Random(1,5)
					if(biomeChance_gunpart_box == 1) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 2) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 3) then
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 4) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 5) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
					end
				end
			
			end
		end
		
		-- Magical Temple
		if(biomeName == "$biome_wandcave") then
			biomeChance = Random(1,7)
			if(biomeChance >= 1 or biomeChance <= 2) then -- 29% chance for rare chests
				EntityLoad( "data/entities/items/pickup/chest_armory_rare.xml", x, y)
			elseif(biomeChance >= 3 or biomeChance <= 4) then -- 29% chance for rare chests
				EntityLoad( "data/entities/items/pickup/chest_armory_legendary.xml", x, y)
			elseif(biomeChance >= 5 or biomeChance <= 6) then -- 29% chance for rare chests
				EntityLoad( "data/entities/items/pickup/chest_armory_epic.xml", x, y)
			elseif(biomeChance == 7) then -- 15% chance for first aid or ammo/grenade boxes
				
				biomeChance_secondary = Random(1,9)
				if(biomeChance_secondary == 1) then
					EntityLoad( "data/entities/items/pickup/first_aid_box.xml", x, y)
				elseif(biomeChance_secondary == 2) then
					EntityLoad( "data/entities/items/pickup/bullet_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 3) then
					EntityLoad( "data/entities/items/pickup/grenade_box.xml", x, y)
				elseif(biomeChance_secondary == 4) then
					EntityLoad( "data/entities/items/pickup/special_grenades_box.xml", x, y)
				elseif(biomeChance_secondary == 5) then
					EntityLoad( "data/entities/items/pickup/basic_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 6) then
					EntityLoad( "data/entities/items/pickup/explosive_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 7) then
					EntityLoad( "data/entities/items/pickup/special_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 8) then
					EntityLoad( "data/entities/items/pickup/throwable_weapons_box.xml", x, y)
				elseif(biomeChance_secondary == 9) then
					biomeChance_gunpart_box = Random(1,5)
					if(biomeChance_gunpart_box == 1) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 2) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 3) then
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 4) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 5) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
					end
				end
			end
		end
		
		-- Temple of the Art
		if(biomeName == "$biome_crypt") then
			biomeChance = Random(1,6)
			if(biomeChance > 2) then -- 66% chance for legendary chests
				EntityLoad( "data/entities/items/pickup/chest_armory_legendary.xml", x, y)
			elseif(biomeChance == 1) then -- 17% chance for epic chests
				EntityLoad( "data/entities/items/pickup/chest_armory_epic.xml", x, y)
			elseif(biomeChance == 2) then -- 17% chance for first aid or ammo/grenade boxes

				biomeChance_secondary = Random(1,9)
				if(biomeChance_secondary == 1) then
					EntityLoad( "data/entities/items/pickup/first_aid_box.xml", x, y)
				elseif(biomeChance_secondary == 2) then
					EntityLoad( "data/entities/items/pickup/bullet_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 3) then
					EntityLoad( "data/entities/items/pickup/grenade_box.xml", x, y)
				elseif(biomeChance_secondary == 4) then
					EntityLoad( "data/entities/items/pickup/special_grenades_box.xml", x, y)
				elseif(biomeChance_secondary == 5) then
					EntityLoad( "data/entities/items/pickup/basic_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 6) then
					EntityLoad( "data/entities/items/pickup/explosive_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 7) then
					EntityLoad( "data/entities/items/pickup/special_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 8) then
					EntityLoad( "data/entities/items/pickup/throwable_weapons_box.xml", x, y)
				elseif(biomeChance_secondary == 9) then
					biomeChance_gunpart_box = Random(1,5)
					if(biomeChance_gunpart_box == 1) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 2) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 3) then
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 4) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 5) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
					end
				end
				
			end
		end
		
		-- Magical Temple
		if(biomeName == "$biome_pyramid") then
			biomeChance = Random(1,7)
			if(biomeChance >= 1 or biomeChance <= 2) then -- 29% chance for rare chests
				EntityLoad( "data/entities/items/pickup/chest_armory_rare.xml", x, y)
			elseif(biomeChance >= 3 or biomeChance <= 4) then -- 29% chance for rare chests
				EntityLoad( "data/entities/items/pickup/chest_armory_legendary.xml", x, y)
			elseif(biomeChance >= 5 or biomeChance <= 6) then -- 29% chance for rare chests
				EntityLoad( "data/entities/items/pickup/chest_armory_epic.xml", x, y)
			elseif(biomeChance == 7) then -- 15% chance for first aid or ammo/grenade boxes
				
				biomeChance_secondary = Random(1,9)
				if(biomeChance_secondary == 1) then
					EntityLoad( "data/entities/items/pickup/first_aid_box.xml", x, y)
				elseif(biomeChance_secondary == 2) then
					EntityLoad( "data/entities/items/pickup/bullet_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 3) then
					EntityLoad( "data/entities/items/pickup/grenade_box.xml", x, y)
				elseif(biomeChance_secondary == 4) then
					EntityLoad( "data/entities/items/pickup/special_grenades_box.xml", x, y)
				elseif(biomeChance_secondary == 5) then
					EntityLoad( "data/entities/items/pickup/basic_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 6) then
					EntityLoad( "data/entities/items/pickup/explosive_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 7) then
					EntityLoad( "data/entities/items/pickup/special_ammo_box.xml", x, y)
				elseif(biomeChance_secondary == 8) then
					EntityLoad( "data/entities/items/pickup/throwable_weapons_box.xml", x, y)
				elseif(biomeChance_secondary == 9) then
					biomeChance_gunpart_box = Random(1,5)
					if(biomeChance_gunpart_box == 1) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 2) then
						EntityLoad( "data/entities/props/supply_box_receivers.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 3) then
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_elementals.xml", x, y)
					elseif(biomeChance_gunpart_box == 4) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_mags.xml", x, y)
					elseif(biomeChance_gunpart_box == 5) then
						EntityLoad( "data/entities/props/supply_box_melee.xml", x, y)
						EntityLoad( "data/entities/props/supply_box_essentials.xml", x, y)
					end
				end
			end
		end
		
	end
end