dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/thearmory_generic_functions.lua")

local entity_id = GetUpdatedEntityID()
entity_id = EntityGetRootEntity( entity_id )
local x, y = EntityGetTransform(entity_id)
local field_id = EntityLoad("data/entities/projectiles/midas_field.xml", x, y)

local field_x, field_y = EntityGetTransform(field_id)


local projectiles = EntityGetInRadiusWithTag(field_x, field_y, 25, "projectile")
local creatures = EntityGetInRadiusWithTag(field_x, field_y, 25, "human")

-- converts projectiles into gold dust
for i, projectile_id in ipairs(projectiles) do
	for i, component in ipairs(EntityGetComponent(projectile_id, "ProjectileComponent") or {}) do
		if ComponentGetValue2(component, "mWhoShot") ~= entity_id then -- projectiles are only deflected if not shot by the entity under the effect, this check is necessary otherwise the field itself will be caught within its own field
			
			-- strips projectile from its ability to explode on death, then kills it and loads gold dust on its place
			local x, y = EntityGetTransform(projectile_id)
			
			edit_component( projectile_id, "ProjectileComponent", function(comp,vars)
				vars.on_death_explode=false
			end)
			EntityKill(projectile_id)
			EntityLoad("data/entities/gold_dust_pocket_small.xml", x, y)
		end
	end
end

-- converts enemies into gold dust
for i, creature_id in ipairs(creatures) do
	if(creature_id ~= entity_id) then -- only knocks back creatures other than the entity under this effect
		local x, y = EntityGetTransform(creature_id)
		EntityLoad("data/entities/projectiles/golddust_lines.xml", x, y)
		EntityKill(creature_id)
		
	end	
end