-- This file controls the spawning of objects inside donation room tiles

-- Fixed spawns for blood donation machines
RegisterSpawnFunction( 0xff3e7522, "spawn_blood_machine_keys" )
RegisterSpawnFunction( 0xff4c9228, "spawn_blood_machine_gold" )
RegisterSpawnFunction( 0xff58a631, "spawn_blood_machine_ammo" )
RegisterSpawnFunction( 0xff5fb234, "spawn_blood_machine_gun" )

-- Fixed justice machine spawn
RegisterSpawnFunction( 0xff325c1d, "spawn_justice_machine" )

-- Fixed spawns for health for machines
RegisterSpawnFunction( 0xffa56c17, "spawn_health_for_ammo_machine" )
RegisterSpawnFunction( 0xffa06611, "spawn_health_for_gun_machine" )
RegisterSpawnFunction( 0xff956319, "spawn_health_for_keys_machine" )
RegisterSpawnFunction( 0xff835613, "spawn_health_for_gold_machine" )

-- These may spawn either a blood donation or a health for machine
RegisterSpawnFunction( 0xffb0b35c, "spawn_ammo_related_machine" )
RegisterSpawnFunction( 0xff9ea04f, "spawn_gun_related_machine" )
RegisterSpawnFunction( 0xff8e9140, "spawn_keys_related_machine" )
RegisterSpawnFunction( 0xff84864f, "spawn_gold_related_machine" )

function spawn_justice_machine(x, y)
	EntityLoad( "data/entities/items/pickup/justice_machine.xml", x, y)
end

function spawn_blood_machine_gold(x, y)
	EntityLoad( "data/entities/items/pickup/blood_machine_gold.xml", x, y)
end
function spawn_blood_machine_ammo(x, y)
	EntityLoad( "data/entities/items/pickup/blood_machine_ammo.xml", x, y)
end
function spawn_blood_machine_gun(x, y)
	EntityLoad( "data/entities/items/pickup/blood_machine_gun.xml", x, y)
end
function spawn_blood_machine_keys(x, y)
	EntityLoad( "data/entities/items/pickup/blood_machine_keys.xml", x, y)
end

function spawn_health_for_ammo_machine(x, y)
	EntityLoad( "data/entities/items/pickup/health_for_ammo_machine.xml", x, y)
end
function spawn_health_for_gold_machine(x, y)
	EntityLoad( "data/entities/items/pickup/health_for_gold_machine.xml", x, y)
end
function spawn_health_for_gun_machine(x, y)
	EntityLoad( "data/entities/items/pickup/health_for_gun_machine.xml", x, y)
end
function spawn_health_for_keys_machine(x, y)
	EntityLoad( "data/entities/items/pickup/health_for_keys_machine.xml", x, y)
end

function spawn_ammo_related_machine(x, y)
	SetRandomSeed( x, y )
	local machineChance = Random(1,2)
	if(machineChance == 1) then
		EntityLoad( "data/entities/items/pickup/blood_machine_ammo.xml", x, y)
	else
		EntityLoad( "data/entities/items/pickup/health_for_ammo_machine.xml", x, y)
	end
end
function spawn_gun_related_machine(x, y)
	SetRandomSeed( x, y )
	local machineChance = Random(1,2)
	if(machineChance == 1) then
		EntityLoad( "data/entities/items/pickup/blood_machine_gun.xml", x, y)
	else
		EntityLoad( "data/entities/items/pickup/health_for_gun_machine.xml", x, y)
	end
end
function spawn_keys_related_machine(x, y)
	SetRandomSeed( x, y )
	local machineChance = Random(1,2)
	if(machineChance == 1) then
		EntityLoad( "data/entities/items/pickup/blood_machine_keys.xml", x, y)
	else
		EntityLoad( "data/entities/items/pickup/health_for_keys_machine.xml", x, y)
	end
end
function spawn_gold_related_machine(x, y)
	SetRandomSeed( x, y )
	local machineChance = Random(1,2)
	if(machineChance == 1) then
		EntityLoad( "data/entities/items/pickup/blood_machine_gold.xml", x, y)
	else
		EntityLoad( "data/entities/items/pickup/health_for_gold_machine.xml", x, y)
	end
end

