-- This file is an adapted version of update.lua file from UI: Hits, Timer, Depth mod by Goki
-- The original mod can be found here: https://steamcommunity.com/sharedfiles/filedetails/?id=1994700788

dofile_once("data/scripts/lib/coroutines.lua")
dofile_once("data/scripts/thearmory_utilities.lua")

dofile_once("mods/TheArmory/files/trinkets_list.lua")
dofile_once("mods/TheArmory/files/wands_list.lua")
dofile_once("mods/TheArmory/files/smallpickups_list.lua")

-- Control variables
local renderCounter = true -- used to hide or show counters gui
local renderTrinkets = true -- used to hide or show counters gui
local craftingMenuIndexControl_weapon = 1 -- used to control the item index of weapon crafting list
local craftingMenuIndexControl_ammo = 1 -- used to control the item index of ammo crafting list
local craftingMenuIndexControl_trinket = 1 -- used to control the item index of trinket crafting list
local frameNum_countersMenu = 0
local frameNum_trinketsMenu = 0

-- General gui elements settings
local gui = gui or GuiCreate()
local gui_id = 23728

local gui_trinket1 = gui_trinket1 or GuiCreate()
local gui_trinkets1_id = 24541
local gui_trinket2 = gui_trinket2 or GuiCreate()
local gui_trinkets2_id = 24542
local gui_trinket3 = gui_trinket3 or GuiCreate()
local gui_trinkets3_id = 24543
local gui_trinket4 = gui_trinket4 or GuiCreate()
local gui_trinkets4_id = 24544

local gui_crafting_menu = gui_crafting_menu or GuiCreate()
local gui_crafting_menu_id = 25953

-- Button settings

-- counter toggle
local toggle_counters_button = toggle_counters_button or GuiCreate()
local toggle_counters_button_id = 16254

-- trinkets toggle
local toggle_trinkets_button = toggle_trinkets_button or GuiCreate()
local toggle_trinkets_button_id = 18364

-- trinket drop buttons
local trinket1_buttom = trinket1_buttom or GuiCreate()
local trinket1_buttom_id = 15931
local trinket2_buttom = trinket2_buttom or GuiCreate()
local trinket2_buttom_id = 15932
local trinket3_buttom = trinket3_buttom or GuiCreate()
local trinket3_buttom_id = 15933
local trinket4_buttom = trinket4_buttom or GuiCreate()
local trinket4_buttom_id = 15934

-- crafting menu buttons
local crafting_menu_previous_button = crafting_menu_previous_button or GuiCreate()
local crafting_menu_previous_button_id = 11284
local crafting_menu_next_button = crafting_menu_next_button or GuiCreate()
local crafting_menu_next_button_id = 11285
local crafting_menu_craft_button = crafting_menu_craft_button or GuiCreate()
local crafting_menu_craft_button_id = 11286

-- coordinates for GUI elements
local thumbnail_trinkets_x = 415
local thumbnail_trinket1_y = 112
local thumbnail_trinket2_y = 132
local thumbnail_trinket3_y = 151
local thumbnail_trinket4_y = 172
local trinkets_infotext_x = 34
local trinket1_infotext_y = 15
local trinket2_infotext_y = 18
local trinket3_infotext_y = 20
local trinket4_infotext_y = 23
local trinkets_drop_button_x = 24
local trinket1_drop_button_y = 12
local trinket2_drop_button_y = 14
local trinket3_drop_button_y = 16
local trinket4_drop_button_y = 18

-- coordinates functions and table for counters

function getTextCoordinates(name)
	
	local text_x, text_y = 0
	
	for i,element in ipairs(counter_coordinates) do 
		if(element.counter_name == name) then
			text_x = element.text_x
			text_y = element.text_y
		end	
	end
	
	return text_x, text_y
end

counter_coordinates = 
{
	{
		counter_name = "utility_title",
		text_x = 4,
		text_y = 14
	},
	{
		counter_name = "ammo_title",
		text_x = 4,
		text_y = 20
	},
	{
		counter_name = "crafting_title",
		text_x = 14,
		text_y = 20
	},
	{
		counter_name = "enemy_guts",
		text_x = 6,
		text_y = 17
	},
	{
		counter_name = "chest_keys",
		text_x = 21,
		text_y = 17
	},
	{
		counter_name = "safe_keys",
		text_x = 16,
		text_y = 17
	},
	
	{
		counter_name = "miniboss_keys",
		text_x = 26,
		text_y = 17
	},
	
	{
		counter_name = "slot_machine_chips",
		text_x = 11,
		text_y = 17
	},
	{
		counter_name = "pistol_ammo",
		text_x = 6,
		text_y = 23
	},
	{
		counter_name = "smg_ammo",
		text_x = 6,
		text_y = 26
	},
	{
		counter_name = "shotgun_ammo",
		text_x = 6,
		text_y = 32
	},
	{
		counter_name = "ar_rifle_ammo",
		text_x = 6,
		text_y = 35
	},
	{
		counter_name = "rifle_ammo",
		text_x = 6,
		text_y = 38
	},
	{
		counter_name = "revolver_ammo",
		text_x = 6,
		text_y = 29
	},
	{
		counter_name = "energy_cells",
		text_x = 11,
		text_y = 38
	},
	{
		counter_name = "grenades_ammo",
		text_x = 11,
		text_y = 41
	},
	{
		counter_name = "nails_ammo",
		text_x = 6,
		text_y = 53
	},
	{
		counter_name = "throwable_weapons_ammo",
		text_x = 6,
		text_y = 56
	},
	{
		counter_name = "fluid_ammo",
		text_x = 11,
		text_y = 35
	},
	{
		counter_name = "mininukes_ammo",
		text_x = 11,
		text_y = 47
	},
	{
		counter_name = "elementalbullets_ammo",
		text_x = 6,
		text_y = 41
	},
	{
		counter_name = "knives_ammo",
		text_x = 11,
		text_y = 23
	},
	{
		counter_name = "metalsticks_ammo",
		text_x = 11,
		text_y = 26
	},
	{
		counter_name = "rockets_ammo",
		text_x = 11,
		text_y = 44
	},
	{
		counter_name = "shovels_ammo",
		text_x = 11,
		text_y = 29
	},
	{
		counter_name = "syringes_ammo",
		text_x = 11,
		text_y = 32
	},
	{
		counter_name = "trash_ammo",
		text_x = 11,
		text_y = 50
	},
	{
		counter_name = "arrows_ammo",
		text_x = 6,
		text_y = 44
	},
	{
		counter_name = "crossbowbolts_ammo",
		text_x = 6,
		text_y = 47
	},
	{
		counter_name = "spears_ammo",
		text_x = 6,
		text_y = 50
	},
	{
		counter_name = "fuel_ammo",
		text_x = 11,
		text_y = 53
	},
	
	{
		counter_name = "throwable_explosives_ammo",
		text_x = 11,
		text_y = 56
	},
	
	{
		counter_name = "crafting_parts_weapon",
		text_x = 26,
		text_y = 23
	},
	{
		counter_name = "crafting_parts_ammo",
		text_x = 26,
		text_y = 26
	},
	{
		counter_name = "crafting_parts_trinket",
		text_x = 26,
		text_y = 29
	},
	
	{
		counter_name = "ingot_amethyst",
		text_x = 16,
		text_y = 23
	},
	{
		counter_name = "ingot_copper",
		text_x = 16,
		text_y = 26
	},
	{
		counter_name = "ingot_diamond",
		text_x = 16,
		text_y = 29
	},
	{
		counter_name = "ingot_gold",
		text_x = 16,
		text_y = 32
	},
	{
		counter_name = "ingot_iron",
		text_x = 16,
		text_y = 35
	},
	{
		counter_name = "ingot_jade",
		text_x = 16,
		text_y = 38
	},
	{
		counter_name = "ingot_purple_fluorite",
		text_x = 16,
		text_y = 41
	},
	{
		counter_name = "ingot_ruby",
		text_x = 16,
		text_y = 44
	},
	
	{
		counter_name = "ore_amethyst",
		text_x = 21,
		text_y = 23
	},
	{
		counter_name = "ore_copper",
		text_x = 21,
		text_y = 26
	},
	{
		counter_name = "ore_diamond",
		text_x = 21,
		text_y = 29
	},
	{
		counter_name = "ore_gold",
		text_x = 21,
		text_y = 32
	},
	{
		counter_name = "ore_iron",
		text_x = 21,
		text_y = 35
	},
	{
		counter_name = "ore_jade",
		text_x = 21,
		text_y = 38
	},
	{
		counter_name = "ore_purple_fluorite",
		text_x = 21,
		text_y = 41
	},
	{
		counter_name = "ore_ruby",
		text_x = 21,
		text_y = 44
	},
}

function isAmmoTypeActive(ammo_type_check)
	local wand_name, wand_tag = getCurrentlyEquippedWandNameAndTag()
	if(wand_name ~= "[unknown]") then
		local ammo_type = getWandAmmoType(wand_name, wand_tag)
		if(ammo_type_check == ammo_type) then
			return true
		else
			return false
		end
	end
end

function isTrinketActive(trinket_name)
	
	local flag = false
	local trinket_category = getTrinketCategory(trinket_name)
	
	local wand_name, wand_tag = getCurrentlyEquippedWandNameAndTag()
	if(wand_name ~= "[unknown]" and wand_tag ~= "[unknown]") then
		local trinket_types = getWandTrinketTypes(wand_name, wand_tag)
		if(trinket_types ~= "[none]") then
			if(string.match(trinket_types, trinket_category)) then
				flag = true
			end
		end
	end
	
	return flag
end

-- Toggles trinkets info on or off
function toggleTrinkets()
	renderTrinkets = not renderTrinkets
	
	if(renderTrinkets) then
		frameNum_trinketsMenu = GameGetFrameNum()
	end
end

-- Toggles counters on or off
function toggleRenderedCounters()
	renderCounter = not renderCounter
	
	if(renderCounter) then
		frameNum_countersMenu = GameGetFrameNum()
	end
end

function autoHideToggleableMenus()
	if(GameGetFrameNum() - frameNum_countersMenu > 400) then
		renderCounter = false
	end
	if(GameGetFrameNum() - frameNum_trinketsMenu > 400) then
		renderTrinkets = false
	end
end

-- Function controlling the rendering of Toggle Trinkets gui button
function do_gui_button_trinkets()
	if(getPlayerEntity() ~= nil) then
		if(not isInventoryOpen()) then
			local renderedText = "[Show/Hide Trinket Slots]"
			
			local gui_x = 24;
			local gui_y = 9;
			
			GuiStartFrame(toggle_trinkets_button);
			GuiLayoutBeginVertical( toggle_trinkets_button, gui_x, gui_y ); 
			if(GuiButton( toggle_trinkets_button, gui_x, gui_y, renderedText, toggle_trinkets_button_id )) then
				toggleTrinkets()
			end
			GuiLayoutEnd( toggle_trinkets_button );
			
		end
	end
end

-- trinket individual buttons
function do_gui_trinket_control_buttons()

	if(not isInventoryOpen()) then
		if(getPlayerEntity() ~= nil) then
			if(renderTrinkets) then		
			
				local renderedText = "[drop]"
				
				if(checkTrinketSlot("1")) then
					-- Button 1
					
					GuiStartFrame(trinket1_buttom);
					GuiLayoutBeginVertical( trinket1_buttom, trinkets_drop_button_x, trinket1_drop_button_y ); 
					if(GuiButton( trinket1_buttom, trinkets_drop_button_x, trinket1_drop_button_y, renderedText, trinket1_buttom_id )) then
						removeTrinketBySlotNumber("1")
					end
					GuiLayoutEnd( trinket1_buttom );
				end
				
				if(checkTrinketSlot("2")) then
					-- Button 2
					
					GuiStartFrame(trinket2_buttom);
					GuiLayoutBeginVertical( trinket2_buttom, trinkets_drop_button_x, trinket2_drop_button_y ); 
					if(GuiButton( trinket2_buttom, trinkets_drop_button_x, trinket2_drop_button_y, renderedText, trinket2_buttom_id )) then
						removeTrinketBySlotNumber("2")
					end
					GuiLayoutEnd( trinket2_buttom );
				end
				
				if(checkTrinketSlot("3")) then
					-- Button 3
					
					GuiStartFrame(trinket3_buttom);
					GuiLayoutBeginVertical( trinket3_buttom, trinkets_drop_button_x, trinket3_drop_button_y ); 
					if(GuiButton( trinket3_buttom, trinkets_drop_button_x, trinket3_drop_button_y, renderedText, trinket3_buttom_id )) then
						removeTrinketBySlotNumber("3")
					end
					GuiLayoutEnd( trinket3_buttom );
				end

				if(checkTrinketSlot("4")) then
					-- Button 4
					
					GuiStartFrame(trinket4_buttom);
					GuiLayoutBeginVertical( trinket4_buttom, trinkets_drop_button_x, trinket4_drop_button_y ); 
					if(GuiButton( trinket4_buttom, trinkets_drop_button_x, trinket4_drop_button_y, renderedText, trinket4_buttom_id )) then
						removeTrinketBySlotNumber("4")
					end
					GuiLayoutEnd( trinket4_buttom );
				end
			end
		end
	end
end

-- Function controlling rendering of trinkets info
function do_gui_trinkets()
	if(not isInventoryOpen()) then
		if(getPlayerEntity() ~= nil) then
			if(renderTrinkets) then
				
				local renderedText_trinket1 = ""
				local renderedText_trinket2 = ""
				local renderedText_trinket3 = ""
				local renderedText_trinket4 = ""
				local emptySlotText = " -- empty --"
				
				local gui_y = 0
				
				GuiStartFrame(gui_trinket1);
				GuiLayoutBeginVertical( gui_trinket1, trinkets_infotext_x, trinket1_infotext_y );
				if(checkTrinketSlot("1")) then
					renderedText_trinket1 = getTrinketUIName(getStringValuePlayerStorageComp("trinket1")) .. getTrinketDescription(getStringValuePlayerStorageComp("trinket1"))
				else
					renderedText_trinket1 = emptySlotText
				end
				GuiText( gui_trinket1, 0, 0, renderedText_trinket1 );
				if(checkTrinketSlot("1")) then
					if(isTrinketActive(getStringValuePlayerStorageComp("trinket1"))) then
						GuiImage( gui_trinket1, 200, -17, -9, "data/items_gfx/active_trinket_indicator.png", 1, 1.2)
					end
					GuiImage( gui_trinket1, 200, -9, -9, getTrinketThumbnailPath(getStringValuePlayerStorageComp("trinket1")), 1, 1.2)
					
				end
				GuiLayoutEnd( gui_trinket1 );
				
				-- Trinket 2
				
				GuiStartFrame(gui_trinket2);
				GuiLayoutBeginVertical( gui_trinket2, trinkets_infotext_x, trinket2_infotext_y );
				if(checkTrinketSlot("2")) then
					renderedText_trinket2 = getTrinketUIName(getStringValuePlayerStorageComp("trinket2")) .. getTrinketDescription(getStringValuePlayerStorageComp("trinket2"))
				else
					renderedText_trinket2 = emptySlotText
				end
				GuiText( gui_trinket2, 0, 0, renderedText_trinket2);
				if(checkTrinketSlot("2")) then
					if(isTrinketActive(getStringValuePlayerStorageComp("trinket2"))) then
						GuiImage( gui_trinket2, 200, -17, -9, "data/items_gfx/active_trinket_indicator.png", 1, 1.2)
					end
					GuiImage( gui_trinket2, 200, -9, -9, getTrinketThumbnailPath(getStringValuePlayerStorageComp("trinket2")), 1, 1.2)
					
				end
				GuiLayoutEnd( gui_trinket2 );

				-- Trinket 3
				
				GuiStartFrame(gui_trinket3);
				GuiLayoutBeginVertical( gui_trinket3, trinkets_infotext_x, trinket3_infotext_y );
				if(checkTrinketSlot("3")) then
					renderedText_trinket3 = getTrinketUIName(getStringValuePlayerStorageComp("trinket3")) .. getTrinketDescription(getStringValuePlayerStorageComp("trinket3"))
				else
					renderedText_trinket3 = emptySlotText
				end
				GuiText( gui_trinket3, 0, 0, renderedText_trinket3 );
				if(checkTrinketSlot("3")) then
					if(isTrinketActive(getStringValuePlayerStorageComp("trinket3"))) then
						GuiImage( gui_trinket3, 200, -17, -9, "data/items_gfx/active_trinket_indicator.png", 1, 1.2)
					end
					GuiImage( gui_trinket3, 200, -9, -9, getTrinketThumbnailPath(getStringValuePlayerStorageComp("trinket3")), 1, 1.2)
					
				end
				GuiLayoutEnd( gui_trinket3 );

				-- Trinket 4
				
				GuiStartFrame(gui_trinket4);
				GuiLayoutBeginVertical( gui_trinket4, trinkets_infotext_x, trinket4_infotext_y ); 
				if(checkTrinketSlot("4")) then
					renderedText_trinket4 = getTrinketUIName(getStringValuePlayerStorageComp("trinket4")) .. getTrinketDescription(getStringValuePlayerStorageComp("trinket4"))
				else
					renderedText_trinket4 = emptySlotText
				end
				GuiText( gui_trinket4, 0, 0, renderedText_trinket4 );
				if(checkTrinketSlot("4")) then
					if(isTrinketActive(getStringValuePlayerStorageComp("trinket4"))) then
						GuiImage( gui_trinket4, 200, -17, -9, "data/items_gfx/active_trinket_indicator.png", 1, 1.2)
					end
					GuiImage( gui_trinket4, 200, -9, -9, getTrinketThumbnailPath(getStringValuePlayerStorageComp("trinket4")), 1, 1.2)
					
				end
				GuiLayoutEnd( gui_trinket4 );
			end
		end
	end
end

-- Function that controls the rendering of Toggle Counters gui button
function do_gui_button()
	if(getPlayerEntity() ~= nil) then
		if(not isInventoryOpen()) then
			local renderedText = "[Show/Hide Item Counters]"
			
			local gui_x = 3;
			local gui_y = 9;
			
			GuiStartFrame(toggle_counters_button);
			GuiLayoutBeginVertical( toggle_counters_button, gui_x, gui_y ); 
			if(GuiButton( toggle_counters_button, gui_x, gui_y, renderedText, toggle_counters_button_id )) then
				toggleRenderedCounters()
			end
			GuiLayoutEnd( toggle_counters_button );
		end
	end
end

-- Function that controls the rendering of ammo counters
function do_gui()
	if(not isInventoryOpen()) then
		--local renderedText = ""
		
		local utility_title = ""
		local ammo_title = ""
		local crafting_title = ""
		
		local enemy_guts_counter = ""
		local slot_machines_counter = ""
		local safe_keys_counter = ""
		local chest_keys_counter = ""
		local miniboss_keys_counter = ""
		
		local pistol_ammo_counter = ""
		local revolver_ammo_counter = ""
		local smg_ammo_counter = ""
		local shotgun_ammo_counter = ""
		
		local ar_rifle_ammo_counter = ""
		local rifle_ammo_counter = ""
		local elementalbullets_ammo_counter = ""
		
		local arrows_ammo_counter = ""
		local crossbowbolts_ammo_counter = ""
		local spears_ammo_counter = ""
		local nails_ammo_counter = ""
		
		local knives_ammo_counter = ""
		local metalsticks_ammo_counter = ""
		
		local shovels_ammo_counter = ""
		local syringes_ammo_counter = ""
		local fluid_ammo_counter = ""
		local energy_cells_counter = ""
		local grenades_ammo_counter = ""
		local rockets_ammo_counter = ""
		local mininukes_ammo_counter = ""
		local trash_ammo_counter = ""
		local fuel_ammo_counter = ""
		local throwable_weapons_ammo_counter = ""
		local throwable_explosives_ammo_counter = ""
		
		local crafting_parts_ammo_counter = ""
		local crafting_parts_weapon_counter = ""
		local crafting_parts_trinket_counter = ""
		
		local ingot_amethyst_counter = ""
		local ingot_copper_counter = ""
		local ingot_diamond_counter = ""
		local ingot_gold_counter = ""
		local ingot_iron_counter = ""
		local ingot_jade_counter = ""
		local ingot_purple_fluorite_counter = ""
		local ingot_ruby_counter = ""
		
		local ore_amethyst_counter = ""
		local ore_copper_counter = ""
		local ore_diamond_counter = ""
		local ore_gold_counter = ""
		local ore_iron_counter = ""
		local ore_jade_counter = ""
		local ore_purple_fluorite_counter = ""
		local ore_ruby_counter = ""

		if(getPlayerEntity() ~= nil) then
			if(renderCounter) then

				utility_title = "Utility items"		
				ammo_title = "Ammo"
				crafting_title = "Crafting"
				
				enemy_guts_counter = getPlayerEnemyGuts()
				slot_machines_counter = getPlayerSlotMachineChips()
				safe_keys_counter = getPlayerSafeKeys()
				chest_keys_counter = getPlayerChestKeys()
				miniboss_keys_counter = getPlayerMinibossKeys()
				
				pistol_ammo_counter = getPlayerAmmo("pistol_ammo")
				smg_ammo_counter = getPlayerAmmo("smg_ammo")
				revolver_ammo_counter = getPlayerAmmo("revolver_ammo")
				shotgun_ammo_counter = getPlayerAmmo("shotgun_ammo")
				ar_rifle_ammo_counter = getPlayerAmmo("ar_rifle_ammo")
				rifle_ammo_counter = getPlayerAmmo("rifle_ammo")
				elementalbullets_ammo_counter = getPlayerAmmo("elementalbullets_ammo")
				arrows_ammo_counter = getPlayerAmmo("arrows_ammo")
				crossbowbolts_ammo_counter = getPlayerAmmo("crossbowbolts_ammo")
				spears_ammo_counter = getPlayerAmmo("spears_ammo")
				nails_ammo_counter = getPlayerAmmo("nails_ammo")
				
				knives_ammo_counter = getPlayerAmmo("knives_ammo")
				metalsticks_ammo_counter = getPlayerAmmo("metalsticks_ammo")
				shovels_ammo_counter = getPlayerAmmo("shovels_ammo")
				syringes_ammo_counter = getPlayerAmmo("syringes_ammo")
				fluid_ammo_counter = getPlayerAmmo("fluid_ammo")
				energy_cells_counter = getPlayerAmmo("energy_cells")
				grenades_ammo_counter = getPlayerAmmo("grenades_ammo")
				rockets_ammo_counter = getPlayerAmmo("rockets_ammo")
				mininukes_ammo_counter = getPlayerAmmo("mininukes_ammo")
				trash_ammo_counter = getPlayerAmmo("trash_ammo")
				fuel_ammo_counter = getPlayerAmmo("fuel_ammo")
				throwable_weapons_ammo_counter = getPlayerAmmo("throwable_weapons_ammo")
				throwable_explosives_ammo_counter = getPlayerAmmo("throwable_explosives_ammo")
				
				crafting_parts_weapon_counter = getPlayerCraftingParts("crafting_parts_weapon")
				crafting_parts_ammo_counter = getPlayerCraftingParts("crafting_parts_ammo")
				crafting_parts_trinket_counter = getPlayerCraftingParts("crafting_parts_trinket")
				
				ingot_amethyst_counter = getPlayerCraftingParts("ingot_amethyst")
				ingot_copper_counter = getPlayerCraftingParts("ingot_copper")
				ingot_diamond_counter = getPlayerCraftingParts("ingot_diamond")
				ingot_gold_counter = getPlayerCraftingParts("ingot_gold")
				ingot_iron_counter = getPlayerCraftingParts("ingot_iron")
				ingot_jade_counter = getPlayerCraftingParts("ingot_jade")
				ingot_purple_fluorite_counter = getPlayerCraftingParts("ingot_purple_fluorite")
				ingot_ruby_counter = getPlayerCraftingParts("ingot_ruby")
				
				ore_amethyst_counter = getPlayerCraftingParts("ore_amethyst")
				ore_copper_counter = getPlayerCraftingParts("ore_copper")
				ore_diamond_counter = getPlayerCraftingParts("ore_diamond")
				ore_gold_counter = getPlayerCraftingParts("ore_gold")
				ore_iron_counter = getPlayerCraftingParts("ore_iron")
				ore_jade_counter = getPlayerCraftingParts("ore_jade")
				ore_purple_fluorite_counter = getPlayerCraftingParts("ore_purple_fluorite")
				ore_ruby_counter = getPlayerCraftingParts("ore_ruby")
			end
		end

		-- utility items gui
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("utility_title") );
		GuiText( gui, 0, 0, utility_title );
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("enemy_guts") );
		GuiText( gui, 0, 0, enemy_guts_counter );
		if(renderCounter) then
			GuiImage( gui, 10, -9, -9, "data/items_gfx/thumb_enemy_guts.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("slot_machine_chips") );
		GuiText( gui, 0, 0, slot_machines_counter );
		if(renderCounter) then
			GuiImage( gui, 11, -10, -9, "data/items_gfx/thumb_slot_machine_chip.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("safe_keys") );
		GuiText( gui, 0, 0, safe_keys_counter );
		if(renderCounter) then
			GuiImage( gui, 12, -11, -9, "data/items_gfx/thumb_safe_key.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("chest_keys") );
		GuiText( gui, 0, 0, chest_keys_counter );
		if(renderCounter) then
			GuiImage( gui, 13, -12, -9, "data/items_gfx/thumb_chest_key.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("miniboss_keys") );
		GuiText( gui, 0, 0, miniboss_keys_counter );
		if(renderCounter) then
			GuiImage( gui, 14, -13, -9, "data/items_gfx/thumb_miniboss_key.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		-- ammo counters first column
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("ammo_title") );
		GuiText( gui, 0, 0, ammo_title );
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("pistol_ammo") );
		GuiText( gui, 0, 0, pistol_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 15, -10, -10, "data/items_gfx/thumb_pistol_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("pistol_ammo")) then
				GuiImage( gui, 100, -20, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -20, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("smg_ammo") );
		GuiText( gui, 0, 0, smg_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 16, -10, -10, "data/items_gfx/thumb_smg_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("smg_ammo")) then
				GuiImage( gui, 100, -20, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -20, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("revolver_ammo") );
		GuiText( gui, 0, 0, revolver_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 17, -10, -10, "data/items_gfx/thumb_revolver_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("revolver_ammo")) then
				GuiImage( gui, 100, -20, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -20, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("shotgun_ammo") );
		GuiText( gui, 0, 0, shotgun_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 18, -10, -10, "data/items_gfx/thumb_shotgun_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("shotgun_ammo")) then
				GuiImage( gui, 100, -20, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -20, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("ar_rifle_ammo") );
		GuiText( gui, 0, 0, ar_rifle_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 18, -10, -10, "data/items_gfx/thumb_ar_rifle_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("ar_rifle_ammo")) then
				GuiImage( gui, 100, -20, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -20, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui,getTextCoordinates("rifle_ammo") );
		GuiText( gui, 0, 0, rifle_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 19, -10, -10, "data/items_gfx/thumb_rifle_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("rifle_ammo")) then
				GuiImage( gui, 100, -20, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -20, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("elementalbullets_ammo") );
		GuiText( gui, 0, 0, elementalbullets_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 20, -10, -10, "data/items_gfx/thumb_elementalbullets_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("elementalbullets_ammo")) then
				GuiImage( gui, 100, -20, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -20, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("arrows_ammo") );
		GuiText( gui, 0, 0, arrows_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 21, -10, -10, "data/items_gfx/thumb_arrows_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("arrows_ammo")) then
				GuiImage( gui, 100, -20, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -20, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("crossbowbolts_ammo") );
		GuiText( gui, 0, 0, crossbowbolts_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 22, -10, -10, "data/items_gfx/thumb_crossbowbolts_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("crossbowbolts_ammo")) then
				GuiImage( gui, 100, -20, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -20, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("spears_ammo") );
		GuiText( gui, 0, 0, spears_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 23, -10, -10, "data/items_gfx/thumb_spears_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("spears_ammo")) then
				GuiImage( gui, 100, -20, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -20, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("nails_ammo") );
		GuiText( gui, 0, 0, nails_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 24, -10, -10, "data/items_gfx/thumb_nails_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("nails_ammo")) then
				GuiImage( gui, 100, -20, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -20, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("throwable_weapons_ammo") );
		GuiText( gui, 0, 0, throwable_weapons_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 26, -10, -10, "data/items_gfx/thumb_throwable_weapons_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("throwable_weapons_ammo")) then
				GuiImage( gui, 100, -20, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -20, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		-- ammo counters second column
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("knives_ammo") );
		GuiText( gui, 0, 0, knives_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 27, -9, -9, "data/items_gfx/thumb_knives_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("knives_ammo")) then
				GuiImage( gui, 100, -19, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -19, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("metalsticks_ammo") );
		GuiText( gui, 0, 0, metalsticks_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 28, -9, -9, "data/items_gfx/thumb_metalsticks_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("metalsticks_ammo")) then
				GuiImage( gui, 100, -19, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -19, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("shovels_ammo") );
		GuiText( gui, 0, 0, shovels_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 29, -9, -9, "data/items_gfx/thumb_shovels_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("shovels_ammo")) then
				GuiImage( gui, 100, -19, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -19, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("syringes_ammo") );
		GuiText( gui, 0, 0, syringes_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 30, -9, -9, "data/items_gfx/thumb_syringes_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("syringes_ammo")) then
				GuiImage( gui, 100, -19, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -19, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("fluid_ammo") );
		GuiText( gui, 0, 0, fluid_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 31, -9, -9, "data/items_gfx/thumb_fluid_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("fluid_ammo")) then
				GuiImage( gui, 100, -19, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -19, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("energy_cells") );
		GuiText( gui, 0, 0, energy_cells_counter );
		if(renderCounter) then
			GuiImage( gui, 32, -9, -9, "data/items_gfx/thumb_energy_cells.png", 1, 1.2)
			if(isAmmoTypeActive("energy_cells")) then
				GuiImage( gui, 100, -19, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -19, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("grenades_ammo") );
		GuiText( gui, 0, 0, grenades_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 33, -9, -9, "data/items_gfx/thumb_grenades_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("grenades_ammo")) then
				GuiImage( gui, 100, -19, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -19, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("rockets_ammo") );
		GuiText( gui, 0, 0, rockets_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 34, -9, -9, "data/items_gfx/thumb_rockets_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("rockets_ammo")) then
				GuiImage( gui, 100, -19, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -19, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("mininukes_ammo") );
		GuiText( gui, 0, 0, mininukes_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 35, -9, -9, "data/items_gfx/thumb_mininukes_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("mininukes_ammo")) then
				GuiImage( gui, 100, -19, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -19, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("trash_ammo") );
		GuiText( gui, 0, 0, trash_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 36, -9, -9, "data/items_gfx/thumb_trash_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("trash_ammo")) then
				GuiImage( gui, 100, -19, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -19, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("fuel_ammo") );
		GuiText( gui, 0, 0, fuel_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 37, -9, -9, "data/items_gfx/thumb_fuel_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("fuel_ammo")) then
				GuiImage( gui, 100, -19, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -19, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("throwable_explosives_ammo") );
		GuiText( gui, 0, 0, throwable_explosives_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 38, -9, -9, "data/items_gfx/thumb_throwable_explosives_ammo.png", 1, 1.2)
			if(isAmmoTypeActive("throwable_explosives_ammo")) then
				GuiImage( gui, 100, -19, -7, "data/items_gfx/active_item_indicator.png", 1, 1.2)
			else
				GuiImage( gui, 100, -19, -7, "data/items_gfx/thumb_empty.png", 1, 1.2)
			end
		end
		GuiLayoutEnd( gui );
		
		-- crafting first column
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("crafting_title") );
		GuiText( gui, 0, 0, crafting_title );
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("ingot_amethyst") );
		GuiText( gui, 0, 0, ingot_amethyst_counter );
		if(renderCounter) then
			GuiImage( gui, 39, -8, -10, "data/items_gfx/thumb_ingot_amethyst.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("ingot_copper") );
		GuiText( gui, 0, 0, ingot_copper_counter );
		if(renderCounter) then
			GuiImage( gui, 40, -8, -10, "data/items_gfx/thumb_ingot_copper.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("ingot_diamond") );
		GuiText( gui, 0, 0, ingot_diamond_counter );
		if(renderCounter) then
			GuiImage( gui, 41, -8, -10, "data/items_gfx/thumb_ingot_diamond.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("ingot_gold") );
		GuiText( gui, 0, 0, ingot_gold_counter );
		if(renderCounter) then
			GuiImage( gui, 42, -8, -10, "data/items_gfx/thumb_ingot_gold.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("ingot_iron") );
		GuiText( gui, 0, 0, ingot_iron_counter );
		if(renderCounter) then
			GuiImage( gui, 43, -8, -10, "data/items_gfx/thumb_ingot_iron.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("ingot_jade") );
		GuiText( gui, 0, 0, ingot_jade_counter );
		if(renderCounter) then
			GuiImage( gui, 44, -8, -10, "data/items_gfx/thumb_ingot_jade.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("ingot_purple_fluorite") );
		GuiText( gui, 0, 0, ingot_purple_fluorite_counter );
		if(renderCounter) then
			GuiImage( gui, 45, -8, -10, "data/items_gfx/thumb_ingot_purple_fluorite.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("ingot_ruby") );
		GuiText( gui, 0, 0, ingot_ruby_counter );
		if(renderCounter) then
			GuiImage( gui, 46, -8, -10, "data/items_gfx/thumb_ingot_ruby.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		-- crafting second column
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("ore_amethyst") );
		GuiText( gui, 0, 0, ore_amethyst_counter );
		if(renderCounter) then
			GuiImage( gui, 47, -7, -10, "data/items_gfx/thumb_ore_amethyst.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("ore_copper") );
		GuiText( gui, 0, 0, ore_copper_counter );
		if(renderCounter) then
			GuiImage( gui, 48, -7, -10, "data/items_gfx/thumb_ore_copper.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("ore_diamond") );
		GuiText( gui, 0, 0, ore_diamond_counter );
		if(renderCounter) then
			GuiImage( gui, 49, -7, -10, "data/items_gfx/thumb_ore_diamond.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("ore_gold") );
		GuiText( gui, 0, 0, ore_gold_counter );
		if(renderCounter) then
			GuiImage( gui, 50, -7, -10, "data/items_gfx/thumb_ore_gold.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("ore_iron") );
		GuiText( gui, 0, 0, ore_iron_counter );
		if(renderCounter) then
			GuiImage( gui, 51, -7, -10, "data/items_gfx/thumb_ore_iron.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("ore_jade") );
		GuiText( gui, 0, 0, ore_jade_counter );
		if(renderCounter) then
			GuiImage( gui, 52, -7, -10, "data/items_gfx/thumb_ore_jade.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("ore_purple_fluorite") );
		GuiText( gui, 0, 0, ore_purple_fluorite_counter );
		if(renderCounter) then
			GuiImage( gui, 53, -7, -10, "data/items_gfx/thumb_ore_purple_fluorite.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("ore_ruby") );
		GuiText( gui, 0, 0, ore_ruby_counter );
		if(renderCounter) then
			GuiImage( gui, 54, -7, -10, "data/items_gfx/thumb_ore_ruby.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		-- crafting third column
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("crafting_parts_weapon") );
		GuiText( gui, 0, 0, crafting_parts_weapon_counter );
		if(renderCounter) then
			GuiImage( gui, 55, -9, -10, "data/items_gfx/thumb_crafting_parts_weapon.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("crafting_parts_ammo") );
		GuiText( gui, 0, 0, crafting_parts_ammo_counter );
		if(renderCounter) then
			GuiImage( gui, 56, -9, -10, "data/items_gfx/thumb_crafting_parts_ammo.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, getTextCoordinates("crafting_parts_trinket") );
		GuiText( gui, 0, 0, crafting_parts_trinket_counter );
		if(renderCounter) then
			GuiImage( gui, 57, -9, -10, "data/items_gfx/thumb_crafting_parts_trinket.png", 1, 1.2)
		end
		GuiLayoutEnd( gui );
		
		--[[

		GuiStartFrame(gui);
		GuiLayoutBeginVertical( gui, gui_x, gui_y ); 
		GuiText( gui, 0, 0, renderedText );
		GuiLayoutEnd( gui );
		]]
	end
end

-- function that controls the rendering of the crafting menu
function do_crafting_gui()
	if(not isInventoryOpen()) then
		
		local nextText = ""
		local previousText = ""
		local craftText = ""
		local craftingMenuText = ""
		local craftingMenuCost = ""
		
		local returnMessage = ""

		if(getPlayerEntity() ~= nil) then
		
			buttonNextText = "[>]"
			buttonPreviousText = "[<]"
			buttonCraftText = "[craft]"
			craftingMenuText = "Crafting Menu"
			craftingMenuCost = "Cost"
			craftingMenuAmmoType = "Ammo Type"
			
			-- obtains closest crafting station
			local craftingStationName, craftingStation_x, craftingStation_y = isPlayerInRangeofCraftingStation()
			
			if(craftingStationName == "gun_workshop") then -- weapon crafting menu
				
				local craftingMenuMaxIndexControl_weapon = getWandsCount()
				
				-- crafting menu title
				GuiStartFrame(gui_crafting_menu);
				GuiLayoutBeginVertical( gui_crafting_menu, 30, 26 );
				GuiText( gui_crafting_menu, 0, 0, craftingMenuText );
				GuiLayoutEnd( gui_crafting_menu );
				
				local buttons_y = 23
				
				-- buttons
				GuiStartFrame(crafting_menu_previous_button);
				GuiLayoutBeginVertical( crafting_menu_previous_button, 26, buttons_y );
				-- navigates to the previous wand in the list
				if(GuiButton( crafting_menu_previous_button, 26, buttons_y, buttonPreviousText, crafting_menu_previous_button_id )) then
					if(craftingMenuIndexControl_weapon == 1) then
						craftingMenuIndexControl_weapon = craftingMenuMaxIndexControl_weapon
					else
						craftingMenuIndexControl_weapon = craftingMenuIndexControl_weapon - 1
					end
				end
				GuiLayoutEnd( crafting_menu_previous_button );
				
				GuiStartFrame(crafting_menu_craft_button);
				GuiLayoutBeginVertical( crafting_menu_craft_button, 28, buttons_y );
				-- checks for required item and parts, deducts them from player, then spawns currentWand at player's position
				if(GuiButton( crafting_menu_craft_button, 28, buttons_y, buttonCraftText, crafting_menu_craft_button_id )) then
					if(checkCraftingMaterials(getWandByIndex(craftingMenuIndexControl_weapon).crafting_tier_item, "crafting_parts_weapon", getWandByIndex(craftingMenuIndexControl_weapon).crafting_parts_cost)) then
						spawnItemandDeductMaterials(getWandsBaseDir() .. getWandByIndex(craftingMenuIndexControl_weapon).file_name, getWandByIndex(craftingMenuIndexControl_weapon).crafting_tier_item, "crafting_parts_weapon", getWandByIndex(craftingMenuIndexControl_weapon).crafting_parts_cost)
						EntityLoad("data/entities/particles/image_emitters/chest_effect_green.xml", craftingStation_x, craftingStation_y)
						returnMessage = "You crafted a new wand!"
						GamePrintImportant( returnMessage, "" )
						GamePrint(returnMessage)
					else
						EntityLoad("data/entities/particles/image_emitters/chest_effect_bad.xml", craftingStation_x, craftingStation_y)
						returnMessage = "You lack required ingot or parts to craft this weapon"
						GamePrintImportant( returnMessage, "" )
						GamePrint(returnMessage)
					end
				end
				GuiLayoutEnd( crafting_menu_craft_button );
				
				GuiStartFrame(crafting_menu_next_button);
				GuiLayoutBeginVertical( crafting_menu_next_button, 32, buttons_y ); 
				-- navigates to the next wand in the list
				if(GuiButton( crafting_menu_next_button, 32, buttons_y, buttonNextText, crafting_menu_next_button_id )) then
					if(craftingMenuIndexControl_weapon == craftingMenuMaxIndexControl_weapon) then
						craftingMenuIndexControl_weapon = 1
					else
						craftingMenuIndexControl_weapon = craftingMenuIndexControl_weapon + 1
					end
				end
				GuiLayoutEnd( crafting_menu_next_button );
				
				local currentWand = getWandByIndex(craftingMenuIndexControl_weapon)
				
				-- cost and description text
				GuiStartFrame(gui_crafting_menu);
				GuiLayoutBeginVertical( gui_crafting_menu, 30, 32 );
				GuiText( gui_crafting_menu, 0, 0, craftingMenuCost );
				GuiImage( gui_crafting_menu, 200, 20, -9, "data/items_gfx/thumb_" .. currentWand.crafting_tier_item .. ".png", 1, 1.2)
				GuiLayoutEnd( gui_crafting_menu );
				
				GuiStartFrame(gui_crafting_menu);
				GuiLayoutBeginVertical( gui_crafting_menu, 37, 32 );
				GuiText( gui_crafting_menu, 0, 0, 'x' .. currentWand.crafting_parts_cost );
				GuiImage( gui_crafting_menu, 200, -10, -9, "data/items_gfx/thumb_crafting_parts_weapon.png", 1, 1.2)
				GuiLayoutEnd( gui_crafting_menu );
				
				GuiStartFrame(gui_crafting_menu);
				GuiLayoutBeginVertical( gui_crafting_menu, 30, 35 );
				GuiText( gui_crafting_menu, 0, 0, craftingMenuAmmoType );
				GuiImage( gui_crafting_menu, 200, 45, -9, "data/items_gfx/thumb_" .. currentWand.ammo_type.. ".png", 1, 1.2)
				GuiLayoutEnd( gui_crafting_menu );
				
				GuiStartFrame(gui_crafting_menu);
				GuiLayoutBeginVertical( gui_crafting_menu, 30, 38 );
				GuiText( gui_crafting_menu, 0, 0, currentWand.ui_name .. "\n" .. currentWand.description );
				GuiImage( gui_crafting_menu, 200, 5, 5, currentWand.thumbnail , 1, 1.0)
				GuiLayoutEnd( gui_crafting_menu );
				
			elseif(craftingStationName == "ammo_workshop") then -- ammo crafting menu
			
				local craftingMenuMaxIndexControl_ammo = getAmmoTypesCount()
				
				-- crafting menu title
				GuiStartFrame(gui_crafting_menu);
				GuiLayoutBeginVertical( gui_crafting_menu, 30, 26 );
				GuiText( gui_crafting_menu, 0, 0, craftingMenuText );
				GuiLayoutEnd( gui_crafting_menu );
				
				local buttons_y = 23
				
				-- buttons
				GuiStartFrame(crafting_menu_previous_button);
				GuiLayoutBeginVertical( crafting_menu_previous_button, 26, buttons_y );
				-- navigates to the previous ammo type in the list
				if(GuiButton( crafting_menu_previous_button, 26, buttons_y, buttonPreviousText, crafting_menu_previous_button_id )) then
					if(craftingMenuIndexControl_ammo == 1) then
						craftingMenuIndexControl_ammo = craftingMenuMaxIndexControl_ammo
					else
						craftingMenuIndexControl_ammo = craftingMenuIndexControl_ammo - 1
					end
				end
				GuiLayoutEnd( crafting_menu_previous_button );
				
				GuiStartFrame(crafting_menu_craft_button);
				GuiLayoutBeginVertical( crafting_menu_craft_button, 28, buttons_y );
				-- checks for required item and parts, deducts them from player, then spawns currentAmmoType at player's position
				if(GuiButton( crafting_menu_craft_button, 28, buttons_y, buttonCraftText, crafting_menu_craft_button_id )) then
					if(checkCraftingMaterials(getAmmoCraftingItem(), "crafting_parts_ammo", getAmmoCraftingPartsCost())) then
						spawnItemandDeductMaterials(getPickupItemsBaseDir() .. getAmmoTypeByIndex(craftingMenuIndexControl_ammo).name .. '.xml', getAmmoCraftingItem(), "crafting_parts_ammo", getAmmoCraftingPartsCost())
						EntityLoad("data/entities/particles/image_emitters/chest_effect_green.xml", craftingStation_x, craftingStation_y)
						returnMessage = "You crafted an ammo pickup!"
						GamePrintImportant( returnMessage, "" )
						GamePrint(returnMessage)
					else
						EntityLoad("data/entities/particles/image_emitters/chest_effect_bad.xml", craftingStation_x, craftingStation_y)
						returnMessage = "You lack required ingot or parts to craft ammo"
						GamePrintImportant( returnMessage, "" )
						GamePrint(returnMessage)
					end
				end
				GuiLayoutEnd( crafting_menu_craft_button );
				
				GuiStartFrame(crafting_menu_next_button);
				GuiLayoutBeginVertical( crafting_menu_next_button, 32, buttons_y ); 
				-- navigates to the next ammo type in the list
				if(GuiButton( crafting_menu_next_button, 32, buttons_y, buttonNextText, crafting_menu_next_button_id )) then
					if(craftingMenuIndexControl_ammo == craftingMenuMaxIndexControl_ammo) then
						craftingMenuIndexControl_ammo = 1
					else
						craftingMenuIndexControl_ammo = craftingMenuIndexControl_ammo + 1
					end
				end
				GuiLayoutEnd( crafting_menu_next_button );
				
				
				local currentAmmoType = getAmmoTypeByIndex(craftingMenuIndexControl_ammo)
				
				-- cost and description text
				GuiStartFrame(gui_crafting_menu);
				GuiLayoutBeginVertical( gui_crafting_menu, 30, 32 );
				GuiText( gui_crafting_menu, 0, 0, craftingMenuCost );
				GuiImage( gui_crafting_menu, 200, 20, -9, "data/items_gfx/thumb_" .. getAmmoCraftingItem() .. ".png", 1, 1.2)
				GuiLayoutEnd( gui_crafting_menu );
				
				GuiStartFrame(gui_crafting_menu);
				GuiLayoutBeginVertical( gui_crafting_menu, 37, 32 );
				GuiText( gui_crafting_menu, 0, 0, 'x' .. getAmmoCraftingPartsCost() );
				GuiImage( gui_crafting_menu, 200, -10, -9, "data/items_gfx/thumb_crafting_parts_ammo.png", 1, 1.2)
				GuiLayoutEnd( gui_crafting_menu );
				
				GuiStartFrame(gui_crafting_menu);
				GuiLayoutBeginVertical( gui_crafting_menu, 30, 38 );
				GuiText( gui_crafting_menu, 0, 0, currentAmmoType.ui_name .. ' ' .. currentAmmoType.desc );
				GuiImage( gui_crafting_menu, 200, 3, -20, "data/items_gfx/thumb_" .. currentAmmoType.related_variable .. ".png", 1, 1.2)
				GuiLayoutEnd( gui_crafting_menu );
			
			elseif(craftingStationName == "trinket_workshop") then -- trinket crafting menu
			
				local craftingMenuMaxIndexControl_trinket = getTrinketsCount()
				
				-- crafting menu title
				GuiStartFrame(gui_crafting_menu);
				GuiLayoutBeginVertical( gui_crafting_menu, 30, 26 );
				GuiText( gui_crafting_menu, 0, 0, craftingMenuText );
				GuiLayoutEnd( gui_crafting_menu );
				
				local buttons_y = 23
				
				-- buttons
				GuiStartFrame(crafting_menu_previous_button);
				GuiLayoutBeginVertical( crafting_menu_previous_button, 26, buttons_y );
				-- navigates to the previous ammo type in the list
				if(GuiButton( crafting_menu_previous_button, 26, buttons_y, buttonPreviousText, crafting_menu_previous_button_id )) then
					if(craftingMenuIndexControl_trinket == 1) then
						craftingMenuIndexControl_trinket = craftingMenuMaxIndexControl_trinket
					else
						craftingMenuIndexControl_trinket = craftingMenuIndexControl_trinket - 1
					end
				end
				GuiLayoutEnd( crafting_menu_previous_button );
				
				GuiStartFrame(crafting_menu_craft_button);
				GuiLayoutBeginVertical( crafting_menu_craft_button, 28, buttons_y );
				-- checks for required item and parts, deducts them from player, then spawns currentAmmoType at player's position
				if(GuiButton( crafting_menu_craft_button, 28, buttons_y, buttonCraftText, crafting_menu_craft_button_id )) then
					if(checkCraftingMaterials(getTrinketCraftingItem(), "crafting_parts_trinket", getTrinketCraftingPartsCost())) then
						spawnItemandDeductMaterials(getTrinketsBaseDir() .. getTrinketByIndex(craftingMenuIndexControl_trinket).name .. '.xml', getTrinketCraftingItem(), "crafting_parts_trinket", getTrinketCraftingPartsCost())
						EntityLoad("data/entities/particles/image_emitters/chest_effect_green.xml", craftingStation_x, craftingStation_y)
						returnMessage = "You crafted a trinket!"
						GamePrintImportant( returnMessage, "" )
						GamePrint(returnMessage)
					else
						EntityLoad("data/entities/particles/image_emitters/chest_effect_bad.xml", craftingStation_x, craftingStation_y)
						returnMessage = "You lack required ingot or parts to craft trinkets"
						GamePrintImportant( returnMessage, "" )
						GamePrint(returnMessage)
					end
				end
				GuiLayoutEnd( crafting_menu_craft_button );
				
				GuiStartFrame(crafting_menu_next_button);
				GuiLayoutBeginVertical( crafting_menu_next_button, 32, buttons_y ); 
				-- navigates to the next ammo type in the list
				if(GuiButton( crafting_menu_next_button, 32, buttons_y, buttonNextText, crafting_menu_next_button_id )) then
					if(craftingMenuIndexControl_trinket == craftingMenuMaxIndexControl_trinket) then
						craftingMenuIndexControl_trinket = 1
					else
						craftingMenuIndexControl_trinket = craftingMenuIndexControl_trinket + 1
					end
				end
				GuiLayoutEnd( crafting_menu_next_button );
				
				
				local currentTrinket = getTrinketByIndex(craftingMenuIndexControl_trinket)
				
				-- cost and description text
				GuiStartFrame(gui_crafting_menu);
				GuiLayoutBeginVertical( gui_crafting_menu, 30, 32 );
				GuiText( gui_crafting_menu, 0, 0, craftingMenuCost );
				GuiImage( gui_crafting_menu, 200, 20, -9, "data/items_gfx/thumb_" .. getTrinketCraftingItem() .. ".png", 1, 1.2)
				GuiLayoutEnd( gui_crafting_menu );
				
				GuiStartFrame(gui_crafting_menu);
				GuiLayoutBeginVertical( gui_crafting_menu, 37, 32 );
				GuiText( gui_crafting_menu, 0, 0, 'x' .. getTrinketCraftingPartsCost() );
				GuiImage( gui_crafting_menu, 200, -10, -9, "data/items_gfx/thumb_crafting_parts_trinket.png", 1, 1.2)
				GuiLayoutEnd( gui_crafting_menu );
				
				GuiStartFrame(gui_crafting_menu);
				GuiLayoutBeginVertical( gui_crafting_menu, 30, 38 );
				GuiText( gui_crafting_menu, 0, 0, currentTrinket.ui_name .. ' ' .. currentTrinket.effect_desc );
				GuiImage( gui_crafting_menu, 200, 3, -20, currentTrinket.thumbnail, 1, 1.2)
				GuiLayoutEnd( gui_crafting_menu );		
			end
		end
	end
end

if gui then 
	async_loop(
		function() 
			if gui then 
				do_gui()
				do_gui_button()
				
				do_gui_trinkets()
				do_gui_trinket_control_buttons()
				do_gui_button_trinkets()
				do_crafting_gui()
				
				autoHideToggleableMenus()

			end 
			wait(0)
		end
	)
end