dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/thearmory_utilities.lua")
dofile_once("mods/TheArmory/files/wands_list.lua")

function drop_random_reward( x, y, entity_id )
	
	SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	
	-- Verifies first if the player has a slot machine chip
	if (getPlayerChestKeys() >= 1) then
	
		addPlayerKeys(-1, "chestkeys")
		local spawn_coordinate_x = x + Random(-10,10)
		local spawn_coordinate_y = y - 4 + Random(-10,10)
			
		EntityLoad( "data/entities/items/" .. getRandomWand("exotic"), spawn_coordinate_x, spawn_coordinate_y)	
		
		return true
	else
		return false
	end
end

function on_open( entity_item )

	
	local x, y = EntityGetTransform( entity_item )
	local rand_x = x
	local rand_y = y

	-- PositionSeedComponent
	local position_comp = EntityGetFirstComponent( entity_item, "PositionSeedComponent" )
	if( position_comp ) then
		rand_x = tonumber(ComponentGetValue( position_comp, "pos_x") )
		rand_y = tonumber(ComponentGetValue( position_comp, "pos_y") )
	end

	SetRandomSeed( rand_x, rand_yy )

	local good_item_dropped = drop_random_reward( x, y, entity_item )
	
	if good_item_dropped then
		returnMessage = "You unlocked an Exotic Chest, random exotic tier wand dropped!"
		GamePrint(returnMessage)
		GamePrintImportant( returnMessage, "" )
		EntityLoad("data/entities/particles/image_emitters/chest_effect_blue.xml", x, y)
	else
		returnMessage = "You need a Chest Key to open this chest"
		GamePrint(returnMessage)
		GamePrintImportant( returnMessage, "" )
		EntityLoad("data/entities/particles/image_emitters/chest_effect_bad.xml", x, y)
		respawnEntity(entity_item, x, y)
	end
end

function item_pickup( entity_item, entity_who_picked, name )


	on_open( entity_item )
	
	EntityKill( entity_item )
end

function respawnEntity(entity_item, x, y)
	EntityKill(entity_item)
	EntityLoad( "data/entities/items/pickup/chest_armory_exotic.xml", x, y)
end