dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/TheArmory/files/wands_list.lua")

function drop_random_reward( x, y, entity_id )
	
	SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	
	local spawn_coordinate_x = x + Random(-10,10)
	local spawn_coordinate_y = y - 4 + Random(-10,10)
		
	EntityLoad( "data/entities/items/" .. getRandomWand("regular"), spawn_coordinate_x, spawn_coordinate_y)	
	
	return false
end

function on_open( entity_item )

	
	local x, y = EntityGetTransform( entity_item )
	local rand_x = x
	local rand_y = y

	-- PositionSeedComponent
	local position_comp = EntityGetFirstComponent( entity_item, "PositionSeedComponent" )
	if( position_comp ) then
		rand_x = tonumber(ComponentGetValue( position_comp, "pos_x") )
		rand_y = tonumber(ComponentGetValue( position_comp, "pos_y") )
	end

	SetRandomSeed( rand_x, rand_yy )

	local good_item_dropped = drop_random_reward( x, y, entity_item )
	
	if good_item_dropped then
		EntityLoad("data/entities/particles/image_emitters/chest_effect.xml", x, y)
	else
		EntityLoad("data/entities/particles/image_emitters/chest_effect_bad.xml", x, y)
	end
end

function item_pickup( entity_item, entity_who_picked, name )

	GamePrintImportant( "Armory Chest opened! Regular tier item dropped", "" )

	on_open( entity_item )
	
	EntityKill( entity_item )
end

function physics_body_modified( is_destroyed )

	local entity_item = GetUpdatedEntityID()
	
	on_open( entity_item )

	edit_component( entity_item, "ItemComponent", function(comp,vars)
		EntitySetComponentIsEnabled( entity_item, comp, false )
	end)
	
	EntityKill( entity_item )
end