dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/thearmory_utilities.lua")

function drop_random_reward( x, y, entity_id )
		
	local set_r = true
	if( set_r ) then
		SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	end
	
	local oresSmelted = 0
	
	-- Obtains all ore counts
	local ore_iron = getValueStorageComponent("ore_iron", entity_id, "value_int")
	local ore_copper = getValueStorageComponent("ore_copper", entity_id, "value_int")
	local ore_gold = getValueStorageComponent("ore_gold", entity_id, "value_int")
	local ore_jade = getValueStorageComponent("ore_jade", entity_id, "value_int")
	local ore_amethyst = getValueStorageComponent("ore_amethyst", entity_id, "value_int")
	local ore_diamond = getValueStorageComponent("ore_diamond", entity_id, "value_int")
	
	-- Obtains best place to spawn smelted ores
	local player_x, player_y = EntityGetTransform(getPlayerEntity())
	local furnace_x, furnace_y = EntityGetTransform(entity_id)
	
	local item_spawn_offset_x = 0
	
	-- determines whether the ingots must spawn right or left from the furnace based on
	-- a comparison between the coordinates of the player and the coordinates of the furnace
	if(furnace_x >= player_x) then
		item_spawn_offset_x = 10 * -1
	else
		item_spawn_offset_x = 10
	end
	
	local spawn_coordinate_x = furnace_x + item_spawn_offset_x
	local spawn_coordinate_y = furnace_y + 2
	
	-- Spawns ingots according to each ore count 
	if(ore_iron ~= 0) then
		for i=1,ore_iron do
			addItemtoPlayerInventory("data/entities/items/pickup/ingot_iron.xml", "inventory_full")
			oresSmelted = oresSmelted + 1
		end
	end
	
	if(ore_copper ~= 0) then
		for i=1,ore_copper do
			addItemtoPlayerInventory("data/entities/items/pickup/ingot_copper.xml", "inventory_full")
			oresSmelted = oresSmelted + 1
		end
	end
	
	if(ore_gold ~= 0) then
		for i=1,ore_gold do
			addItemtoPlayerInventory("data/entities/items/pickup/ingot_gold.xml", "inventory_full")
			oresSmelted = oresSmelted + 1
		end
	end
	
	if(ore_jade ~= 0) then
		for i=1,ore_jade do
			addItemtoPlayerInventory("data/entities/items/pickup/ingot_jade.xml", "inventory_full")
			oresSmelted = oresSmelted + 1
		end
	end
	
	if(ore_amethyst ~= 0) then
		for i=1,ore_amethyst do
			addItemtoPlayerInventory("data/entities/items/pickup/ingot_amethyst.xml", "inventory_full")
			oresSmelted = oresSmelted + 1
		end
	end
	
	if(ore_diamond ~= 0) then
		for i=1,ore_diamond do
			addItemtoPlayerInventory("data/entities/items/pickup/ingot_diamond.xml", "inventory_full")
			oresSmelted = oresSmelted + 1
		end
	end
	
	
	
	if (oresSmelted > 0) then
		return true
	else
		return false
	end
	
end

function on_open( entity_item )

	
	local x, y = EntityGetTransform( entity_item )
	local rand_x = x
	local rand_y = y

	-- PositionSeedComponent
	local position_comp = EntityGetFirstComponent( entity_item, "PositionSeedComponent" )
	if( position_comp ) then
		rand_x = tonumber(ComponentGetValue( position_comp, "pos_x") )
		rand_y = tonumber(ComponentGetValue( position_comp, "pos_y") )
	end

	SetRandomSeed( rand_x, rand_yy )

	local good_item_dropped = drop_random_reward( x, y, entity_item )
	
	local returnMessage = ""
	
	if good_item_dropped then
		returnMessage = "Ingots produced and added to your inventory"
		GamePrint(returnMessage)
		GamePrintImportant( returnMessage, "" )
		EntityLoad("data/entities/particles/image_emitters/chest_effect.xml", x, y)
		respawnEntity(entity_item, x, y)
	else
		returnMessage = "This furnace has no ore to smelt"
		GamePrint(returnMessage)
		GamePrintImportant( returnMessage, "" )
		EntityLoad("data/entities/particles/image_emitters/chest_effect_bad.xml", x, y)
		respawnEntity(entity_item, x, y)
	end
end

function item_pickup( entity_item, entity_who_picked, name )

	on_open( entity_item )
	
end

function respawnEntity(entity_item, x, y)
	EntityKill(entity_item)
	EntityLoad( "data/entities/items/pickup/furnace.xml", x, y)
end

