dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/thearmory_utilities.lua")
dofile_once("mods/TheArmory/files/recipes_list.lua")

function drop_random_reward( x, y, entity_id )
		
	local set_r = true
	if( set_r ) then
		SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	end
		
	-- Obtains all gun parts stored
	local tier_item_required = getValueStorageComponent("tier_item_required", entity_id, "value_string")
	local receiver_part = getValueStorageComponent("receiver_part", entity_id, "value_string")
	local mag_part = getValueStorageComponent("mag_part", entity_id, "value_string")
	local essential_part = getValueStorageComponent("essential_part", entity_id, "value_string")
	local elemental_part = getValueStorageComponent("elemental_part", entity_id, "value_string")
	local melee_part = getValueStorageComponent("melee_part", entity_id, "value_string")
	
	local recipeId = getGunFromRecipe(tier_item_required, receiver_part, mag_part, essential_part, elemental_part, melee_part)
	
	if (recipeId ~= "no_match") then
		-- Obtains best place to spawn crafted gun
		local player_x, player_y = EntityGetTransform(getPlayerEntity())
		local furnace_x, furnace_y = EntityGetTransform(entity_id)
		
		local item_spawn_offset_x = 0

		if(furnace_x >= player_x) then
			item_spawn_offset_x = 20 * -1
		else
			item_spawn_offset_x = 20
		end
		
		local spawn_coordinate_x = furnace_x + item_spawn_offset_x
		local spawn_coordinate_y = furnace_y + 2

		EntityLoad("data/entities/items/" .. recipeId .. ".xml", spawn_coordinate_x, spawn_coordinate_y)
		
		

		return true
	else
		return false
	end
	
end

function on_open( entity_item )

	
	local x, y = EntityGetTransform( entity_item )
	local rand_x = x
	local rand_y = y

	-- PositionSeedComponent
	local position_comp = EntityGetFirstComponent( entity_item, "PositionSeedComponent" )
	if( position_comp ) then
		rand_x = tonumber(ComponentGetValue( position_comp, "pos_x") )
		rand_y = tonumber(ComponentGetValue( position_comp, "pos_y") )
	end

	SetRandomSeed( rand_x, rand_yy )

	local recipeFound = drop_random_reward( x, y, entity_item )
	
	local returnMessage = ""
	
	if recipeFound then
		clearStoredGunParts(entity_item)
		returnMessage = "You have crafted a new wand!"
		GamePrint(returnMessage)
		GamePrintImportant( returnMessage, "" )
		EntityLoad("data/entities/particles/image_emitters/chest_effect.xml", x, y)
		respawnEntity(entity_item, x, y)
	else
		returnStoredGunParts(entity_item)
		returnMessage = "No recipe found for stored gun parts and ingot or this workshop is empty"
		GamePrint(returnMessage)
		GamePrintImportant( returnMessage, "If this workshop had materials stored, they've been returned to your inventory" )
		EntityLoad("data/entities/particles/image_emitters/chest_effect_bad.xml", x, y)
		respawnEntity(entity_item, x, y)
	end
end

function item_pickup( entity_item, entity_who_picked, name )

	on_open( entity_item )
	
end

function respawnEntity(entity_item, x, y)
	EntityKill(entity_item)
	EntityLoad( "data/entities/items/pickup/gun_workshop.xml", x, y)
end

function clearStoredGunParts(entity_item) 
	-- clears all parts from the workshop
	setValueStorageComponent("tier_item_required", "", entity_item, "value_string")
	setValueStorageComponent("receiver_part", "", entity_item, "value_string")
	setValueStorageComponent("mag_part", "", entity_item, "value_string")
	setValueStorageComponent("essential_part", "", entity_item, "value_string")
	setValueStorageComponent("elemental_part", "", entity_item, "value_string")
	setValueStorageComponent("melee_part", "", entity_item, "value_string")
end

function returnStoredGunParts(entity_item)

	-- Obtains best place to spawn returned parts
	local player_x, player_y = EntityGetTransform(getPlayerEntity())
	local furnace_x, furnace_y = EntityGetTransform(entity_item)
	
	local item_spawn_offset_x = 0

	if(furnace_x >= player_x) then
		item_spawn_offset_x = 30 * -1
	else
		item_spawn_offset_x = 30
	end
	
	local spawn_coordinate_x = furnace_x + item_spawn_offset_x
	local spawn_coordinate_y = furnace_y + 2

	-- Obtains and returns all items to the player	
	if(getValueStorageComponent("tier_item_required", entity_item, "value_string") ~= "") then
		addItemtoPlayerInventory("data/entities/items/pickup/" .. getValueStorageComponent("tier_item_required", entity_item, "value_string") .. ".xml", "inventory_full")
	end
	if(getValueStorageComponent("receiver_part", entity_item, "value_string") ~= "") then
		addItemtoPlayerInventory("data/entities/gunparts_receiver/gunpart_" .. getValueStorageComponent("receiver_part", entity_item, "value_string") .. ".xml", "inventory_full")
	end
	if(getValueStorageComponent("mag_part", entity_item, "value_string") ~= "") then
		addItemtoPlayerInventory("data/entities/gunparts_mag/gunpart_" .. getValueStorageComponent("mag_part", entity_item, "value_string") .. ".xml" ,"inventory_full")
	end
	if(getValueStorageComponent("essential_part", entity_item, "value_string") ~= "") then
		addItemtoPlayerInventory("data/entities/gunparts_essential/gunpart_" .. getValueStorageComponent("essential_part", entity_item, "value_string") .. ".xml" ,"inventory_full")
	end
	if(getValueStorageComponent("elemental_part", entity_item, "value_string") ~= "") then
		addItemtoPlayerInventory("data/entities/gunparts_elemental/gunpart_" .. getValueStorageComponent("elemental_part", entity_item, "value_string") .. ".xml" ,"inventory_full")
	end
	if(getValueStorageComponent("melee_part", entity_item, "value_string") ~= "") then
		addItemtoPlayerInventory("data/entities/gunparts_melee/gunpart_" .. getValueStorageComponent("melee_part", entity_item, "value_string") .. ".xml" ,"inventory_full")
	end
end

