dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/TheArmory/config.lua")

-- This file controls the spawning of pickup items, such as hearts, slot machine chips, enemy guts and ammo packs

function do_money_drop( amount_multiplier )	
	
	local entity = GetUpdatedEntityID()
	local x, y = EntityGetTransform( entity )
	
	-- Chances for each sort of item pickup
	local r_heart = math.random( 1, 8)
	local r_ammo_main = math.random(1, 3)
	local r_ammo_secondary = 0
	local r_firearm_ammo = 0
	local r_chip = math.random(1,10)
	local r_enemyguts  = math.random(1,8)
	local r_safekey = math.random(1,10)
	local r_chestkey = math.random(1,10)
	
	if ( GameGetIsTrailerModeEnabled() ) then return end

	if(spawn_hearts == 1) then -- this setting comes from config.lua
		-- Heart chances
		if(r_heart >= 1 and r_heart <= 3 ) then
			if(spawn_poisonous_hearts == 1) then -- this setting comes from config.lua
				EntityLoad( "data/entities/items/pickup/small_heart_poisonous.xml", x, y - 8 )
			end
		elseif(r_heart >= 4 and r_heart <= 5) then
			EntityLoad( "data/entities/items/pickup/small_heart.xml", x, y - 8 )
		elseif(r_heart == 6) then
			EntityLoad( "data/entities/items/pickup/small_heart_overtime.xml", x, y - 8 )
		elseif(r_heart == 7) then
			EntityLoad( "data/entities/items/pickup/small_heart_powerful.xml", x, y - 8 )
		end
	end
	
	-- Ammo chances
	if(r_ammo_main == 1) then
		r_ammo_secondary = math.random(1, 40)
		if(r_ammo_secondary >= 1 and r_ammo_secondary <= 3) then
			r_firearm_ammo = math.random(1, 6)
			if(r_firearm_ammo == 1) then
				EntityLoad( "data/entities/items/pickup/bullet_pistol_ammo.xml", x, y - 7 )
			elseif(r_firearm_ammo == 2) then
				EntityLoad( "data/entities/items/pickup/bullet_smg_ammo.xml", x, y - 7 )
			elseif(r_firearm_ammo == 3) then
				EntityLoad( "data/entities/items/pickup/bullet_shotgun_ammo.xml", x, y - 7 )
			elseif(r_firearm_ammo == 4) then
				EntityLoad( "data/entities/items/pickup/bullet_rifle_ammo.xml", x, y - 7 )
			elseif(r_firearm_ammo == 5) then
				EntityLoad( "data/entities/items/pickup/bullet_ar_rifle_ammo.xml", x, y - 7 )
			elseif(r_firearm_ammo == 6) then
				EntityLoad( "data/entities/items/pickup/bullet_revolver_ammo.xml", x, y - 7 )
			end
		elseif(r_ammo_secondary == 4) then
			EntityLoad( "data/entities/items/pickup/firearms_ammo_pack.xml", x, y - 7 )
		elseif(r_ammo_secondary >= 5 and r_ammo_secondary <= 7) then
			EntityLoad( "data/entities/items/pickup/energy_cell.xml", x, y - 7 )
		elseif(r_ammo_secondary == 8) then
			EntityLoad( "data/entities/items/pickup/energy_core.xml", x, y - 7 )
		elseif(r_ammo_secondary == 9) then
			EntityLoad( "data/entities/items/pickup/grenade_bundle.xml", x, y - 7 )
		elseif(r_ammo_secondary >= 10 and r_ammo_secondary <= 12) then
			EntityLoad( "data/entities/items/pickup/small_grenade_bundle.xml", x, y - 7 )
		elseif(r_ammo_secondary >= 12 and r_ammo_secondary <= 14) then
			EntityLoad( "data/entities/items/pickup/nails.xml", x, y - 7 )
		elseif(r_ammo_secondary == 15 and r_ammo_secondary == 16) then
			EntityLoad( "data/entities/items/pickup/metal_stick_bundle.xml", x, y - 7 )
		elseif(r_ammo_secondary == 17 and r_ammo_secondary == 18) then
			EntityLoad( "data/entities/items/pickup/small_fluid_ammo.xml", x, y - 7 )
		elseif(r_ammo_secondary == 19) then
			EntityLoad( "data/entities/items/pickup/fluid_ammo.xml", x, y - 7 )
		elseif(r_ammo_secondary >= 20 and r_ammo_secondary <= 22) then
			EntityLoad( "data/entities/items/pickup/elemental_bullets_bundle.xml", x, y - 7 )
		elseif(r_ammo_secondary == 23) then
			EntityLoad( "data/entities/items/pickup/rocket_box.xml", x, y - 7 )
		elseif(r_ammo_secondary >= 24 and r_ammo_secondary <= 26) then
			EntityLoad( "data/entities/items/pickup/knives_bundle.xml", x, y - 7 )
		elseif(r_ammo_secondary >= 27 and r_ammo_secondary <= 29) then
			EntityLoad( "data/entities/items/pickup/shovels_bundle.xml", x, y - 7 )
		elseif(r_ammo_secondary >= 30 and r_ammo_secondary <= 32) then
			EntityLoad( "data/entities/items/pickup/syringes_bundle.xml", x, y - 7 )
		elseif(r_ammo_secondary >= 33 and r_ammo_secondary <= 35) then
			EntityLoad( "data/entities/items/pickup/trash.xml", x, y - 7 )
		elseif(r_ammo_secondary >= 36 and r_ammo_secondary <= 38) then
			EntityLoad( "data/entities/items/pickup/quiver.xml", x, y - 7 )
		elseif(r_ammo_secondary >= 37 and r_ammo_secondary <= 39) then
			EntityLoad( "data/entities/items/pickup/boltsquiver.xml", x, y - 7 )
		elseif(r_ammo_secondary == 40) then
			EntityLoad( "data/entities/items/pickup/mininuke.xml", x, y - 7 )
		end
	end
	
	-- Slot Machine Chip chances
	if(r_chip == 1) then
		EntityLoad( "data/entities/items/pickup/slot_machine_chip.xml", x, y - 6 )
	end
	
	-- Enemy Guts chances
	if(r_enemyguts == 1) then
		EntityLoad( "data/entities/items/pickup/enemy_guts.xml", x, y - 5 )
	end
	
	-- Chest and Safe Keys
	if(r_safekey == 1) then
		EntityLoad( "data/entities/items/pickup/safe_key.xml", x, y - 5 )
	end
	if(r_chestkey == 1) then
		EntityLoad( "data/entities/items/pickup/chest_key.xml", x, y - 5 )
	end
end

function death( damage_type_bit_field, damage_message, entity_thats_responsible, drop_items )
	do_money_drop( 1 )
end