dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/thearmory_utilities.lua")
dofile_once("mods/TheArmory/files/containers_list.lua")
dofile_once("mods/TheArmory/files/wands_list.lua")

function drop_random_reward( x, y, entity_id )
	
	SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	
	-- Verifies first if the player has a slot machine chip
	if (getPlayerSafeKeys() >= 1) then
	
		addPlayerKeys(-1, "safekeys")
		local spawn_coordinate_x = x + Random(-10,10)
		local spawn_coordinate_y = y - 4 + Random(-10,10)
			
		local r = Random(1,6)

		if(r == 1) then
			EntityLoad( "data/entities/items/pickup/goldnugget_50.xml", spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( "data/entities/items/pickup/goldnugget_50.xml", spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( "data/entities/items/pickup/goldnugget_50.xml", spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( "data/entities/items/pickup/goldnugget_200.xml", spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( "data/entities/items/pickup/goldnugget_200.xml", spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( "data/entities/items/pickup/goldnugget_200.xml", spawn_coordinate_x, spawn_coordinate_y)
		elseif(r == 2) then
			EntityLoad( getContainersBaseDir() .. getRandomTieredChest(), spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( getContainersBaseDir() .. getRandomTieredChest(), spawn_coordinate_x, spawn_coordinate_y)
		elseif(r == 3) then
			EntityLoad( "data/entities/items/pickup/slot_machine_chip.xml", spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( "data/entities/items/pickup/slot_machine_chip.xml", spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( "data/entities/items/pickup/slot_machine_chip.xml", spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( "data/entities/items/pickup/slot_machine_chip.xml", spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( "data/entities/items/pickup/slot_machine_chip.xml", spawn_coordinate_x, spawn_coordinate_y)
		elseif(r == 4) then
			EntityLoad( getContainersBaseDir() .. getRandomAmmoBox(), spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( getContainersBaseDir() .. getRandomAmmoBox(), spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( getContainersBaseDir() .. getRandomAmmoBox(), spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( getContainersBaseDir() .. getRandomAmmoBox(), spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( getContainersBaseDir() .. getRandomAmmoBox(), spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( getContainersBaseDir() .. getRandomAmmoBox(), spawn_coordinate_x, spawn_coordinate_y)
		elseif(r == 5) then
			EntityLoad( "data/entities/items/" .. getRandomWand(), spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( "data/entities/items/" .. getRandomWand(), spawn_coordinate_x + 10, spawn_coordinate_y)
		elseif(r == 6) then
			EntityLoad( "data/entities/items/pickup/medium_heart_powerful.xml", spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( "data/entities/items/pickup/medium_heart_powerful.xml", spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( "data/entities/items/pickup/medium_heart_powerful.xml", spawn_coordinate_x, spawn_coordinate_y)
			EntityLoad( "data/entities/items/pickup/milk_bottle.xml", spawn_coordinate_x, spawn_coordinate_y)
		end
		
		
		return true
	else
		return false
	end
end

function on_open( entity_item )

	
	local x, y = EntityGetTransform( entity_item )
	local rand_x = x
	local rand_y = y

	-- PositionSeedComponent
	local position_comp = EntityGetFirstComponent( entity_item, "PositionSeedComponent" )
	if( position_comp ) then
		rand_x = tonumber(ComponentGetValue( position_comp, "pos_x") )
		rand_y = tonumber(ComponentGetValue( position_comp, "pos_y") )
	end

	SetRandomSeed( rand_x, rand_yy )

	local good_item_dropped = drop_random_reward( x, y, entity_item )
	
	if good_item_dropped then
		returnMessage = "You unlocked a Safe, random reward dropped!"
		GamePrint(returnMessage)
		GamePrintImportant( returnMessage, "" )
		EntityLoad("data/entities/particles/image_emitters/chest_effect_blue.xml", x, y)
	else
		returnMessage = "You need a Safe Key to open this safe"
		GamePrint(returnMessage)
		GamePrintImportant( returnMessage, "" )
		EntityLoad("data/entities/particles/image_emitters/chest_effect_bad.xml", x, y)
		respawnEntity(entity_item, x, y)
	end
end

function item_pickup( entity_item, entity_who_picked, name )


	on_open( entity_item )
	
	EntityKill( entity_item )
end

function respawnEntity(entity_item, x, y)
	EntityKill(entity_item)
	EntityLoad( "data/entities/items/pickup/safe.xml", x, y)
end