dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/thearmory_utilities.lua")
dofile_once("mods/TheArmory/files/containers_list.lua")

function drop_random_reward( x, y, entity_id )
		
	local set_r = true
	if( set_r ) then
		SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	end
	
	-- Verifies first if the player has a slot machine chip
	if (getPlayerSlotMachineChips() >= 1) then
	
		addPlayerSlotMachineChips(-1)
		
		local player_x, player_y = EntityGetTransform(getPlayerEntity())
		local vending_machine_x, vending_machine_y = EntityGetTransform(entity_id)
		
		local item_spawn_offset_x = 0
		
		-- determines whether the item must spawn right or left from the vending machine based on
		-- a comparison between the coordinates of the player and the coordinates of the vending machine
		-- (this is necessary to prevent the new item from spawning too close from the vending machine, with it consuming the item as if the player wanted to sell it)
		if(vending_machine_x >= player_x) then
			item_spawn_offset_x = 20 * -1
		else
			item_spawn_offset_x = 20
		end
		
		local spawn_coordinate_x = player_x + item_spawn_offset_x
		local spawn_coordinate_y = player_y + 2
		
		EntityLoad( getContainersBaseDir() .. getRandomTieredChest(), spawn_coordinate_x, spawn_coordinate_y)	
		
		return true
	else
		
		return false
	end
	
end

function on_open( entity_item )

	
	local x, y = EntityGetTransform( entity_item )
	local rand_x = x
	local rand_y = y

	-- PositionSeedComponent
	local position_comp = EntityGetFirstComponent( entity_item, "PositionSeedComponent" )
	if( position_comp ) then
		rand_x = tonumber(ComponentGetValue( position_comp, "pos_x") )
		rand_y = tonumber(ComponentGetValue( position_comp, "pos_y") )
	end

	SetRandomSeed( rand_x, rand_yy )

	local good_item_dropped = drop_random_reward( x, y, entity_item )
	
	local returnMessage = ""
	
	if good_item_dropped then
		returnMessage = "You tried your luck on the slot machine!"
		GamePrint(returnMessage)
		GamePrintImportant( returnMessage, "" )
		EntityLoad("data/entities/particles/image_emitters/chest_effect_blue.xml", x, y)
		respawnEntity(entity_item, x, y)
	else
		returnMessage = "You don't have a slot machine chip"
		GamePrint(returnMessage)
		GamePrintImportant( returnMessage, "" )
		EntityLoad("data/entities/particles/image_emitters/chest_effect_bad.xml", x, y)
		respawnEntity(entity_item, x, y)
	end
end

function item_pickup( entity_item, entity_who_picked, name )

	on_open( entity_item )
	
end

function respawnEntity(entity_item, x, y)
	EntityKill(entity_item)
	EntityLoad( "data/entities/items/pickup/slot_machine.xml", x, y)
end

