dofile_once("data/scripts/lib/utilities.lua")

function drop_random_reward( x, y, entity_id )

	local set_r = true
	if( set_r ) then
		SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	end
	
	local r = Random(1,6)
			
	if( r == 1 ) then
		EntityLoad( "data/entities/items/pickup/kunai.xml", x + Random(-10,10), y - 4 + Random(-10,10))
	elseif( r == 2 ) then
		EntityLoad( "data/entities/items/pickup/sai.xml", x + Random(-10,10), y - 4 + Random(-10,10))
	elseif( r == 3 ) then
		EntityLoad( "data/entities/items/pickup/ninja_star.xml", x + Random(-10,10), y - 4 + Random(-10,10))
	elseif( r == 4 ) then
		EntityLoad( "data/entities/items/pickup/kitchen_knife.xml", x + Random(-10,10), y - 4 + Random(-10,10))
	elseif( r == 5 ) then
		EntityLoad( "data/entities/items/pickup/hatchet.xml", x + Random(-10,10), y - 4 + Random(-10,10))
	elseif( r == 6 ) then
		EntityLoad( "data/entities/items/pickup/short_mace.xml", x + Random(-10,10), y - 4 + Random(-10,10))
	end
	
	return true
end

function on_open( entity_item )
	local x, y = EntityGetTransform( entity_item )
	local rand_x = x
	local rand_y = y

	-- PositionSeedComponent
	local position_comp = EntityGetFirstComponent( entity_item, "PositionSeedComponent" )
	if( position_comp ) then
		rand_x = tonumber(ComponentGetValue( position_comp, "pos_x") )
		rand_y = tonumber(ComponentGetValue( position_comp, "pos_y") )
	end

	SetRandomSeed( rand_x, rand_yy )

	local good_item_dropped = drop_random_reward( x, y, entity_item )
	
	if good_item_dropped then
		EntityLoad("data/entities/particles/image_emitters/chest_effect.xml", x, y)
	else
		EntityLoad("data/entities/particles/image_emitters/chest_effect_bad.xml", x, y)
	end
end

function item_pickup( entity_item, entity_who_picked, name )
	GamePrintImportant( "Throwable Weapons Box opened! Random throawble weapon dropped", "" )

	on_open( entity_item )
	
	EntityKill( entity_item )
end

function physics_body_modified( is_destroyed )

	local entity_item = GetUpdatedEntityID()
	
	on_open( entity_item )

	edit_component( entity_item, "ItemComponent", function(comp,vars)
		EntitySetComponentIsEnabled( entity_item, comp, false )
	end)
	
	EntityKill( entity_item )
end