dofile_once("data/scripts/game_helpers.lua" )
dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/TheArmory/files/throwables_list.lua")

function drop_items(entity_id)

	local internalName = EntityGetName(entity_id)
	local x, y = EntityGetTransform( entity_id )
	
	SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	
	local openMessage = ""
	
	if(internalName == "grenade_box") then -- Regular grenades box
		openMessage = "Grenade Box opened! Random grenades dropped"
		EntityLoad(getThrowablesBaseDir() .. getRandomThrowableItemBySubCategory("grenade_regular").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))
		EntityLoad(getThrowablesBaseDir() .. getRandomThrowableItemBySubCategory("grenade_regular").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))
		EntityLoad(getThrowablesBaseDir() .. getRandomThrowableItemBySubCategory("grenade_regular").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))

	elseif(internalName == "special_grenades_box") then -- Special grenades box
		openMessage = "Special Grenades Box opened! Random special grenades dropped"
		EntityLoad(getThrowablesBaseDir() .. getRandomThrowableItemBySubCategory("grenade_special").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))
		EntityLoad(getThrowablesBaseDir() .. getRandomThrowableItemBySubCategory("grenade_special").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))
		EntityLoad(getThrowablesBaseDir() .. getRandomThrowableItemBySubCategory("grenade_special").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))

	elseif(internalName == "throwable_weapons_box") then -- Throwable weapons box
		openMessage = "Throwable Weapons Box opened! Random throwable weapons dropped"
		EntityLoad(getThrowablesBaseDir() .. getRandomThrowableItem("melee", "").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))
		EntityLoad(getThrowablesBaseDir() .. getRandomThrowableItem("melee", "").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))
		EntityLoad(getThrowablesBaseDir() .. getRandomThrowableItem("melee", "").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))
	end
	
	GamePrint(openMessage)
	GamePrintImportant(openMessage, "" )
	EntityLoad("data/entities/particles/image_emitters/chest_effect.xml", x, y)
	
	EntityKill( entity_id )
end

function item_pickup( entity_item, entity_who_picked, item_name )

	drop_items(entity_item)
	
end

function physics_body_modified( is_destroyed )
	
	drop_items(GetUpdatedEntityID())
end