dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/thearmory_utilities.lua")
dofile_once("mods/TheArmory/files/wands_list.lua")

local vendingMachineCurrentPrice = 200

function drop_random_reward( x, y, entity_id )
	
	-- Verifies first if the player has the current amount of gold required
	if (getPlayerGold() >= vendingMachineCurrentPrice) then
		
		local player_x, player_y = EntityGetTransform(getPlayerEntity())
		local vending_machine_x, vending_machine_y = EntityGetTransform(entity_id)
		
		local item_spawn_offset_x = 0
		
		-- determines whether the wand must spawn right or left from the vending machine based on
		-- a comparison between the coordinates of the player and the coordinates of the vending machine
		-- (this is necessary to prevent the new item from spawning too close from the vending machine, with it consuming the item as if the player wanted to sell it)
		if(vending_machine_x >= player_x) then
			item_spawn_offset_x = 20 * -1
		else
			item_spawn_offset_x = 20
		end
		
		local spawn_coordinate_x = player_x + item_spawn_offset_x
		local spawn_coordinate_y = player_y + 2
		
		addPlayerGold(vendingMachineCurrentPrice * -1)

		-- Updates vending machine cost
		vendingMachineCurrentPrice = vendingMachineCurrentPrice + 200
		
		EntityLoad( "data/entities/items/" .. getRandomWand(), spawn_coordinate_x, spawn_coordinate_y)
		
		return true
	else
		
		return false
	end
	
end

function on_open( entity_item )

	
	local x, y = EntityGetTransform( entity_item )
	local rand_x = x
	local rand_y = y

	-- PositionSeedComponent
	local position_comp = EntityGetFirstComponent( entity_item, "PositionSeedComponent" )
	if( position_comp ) then
		rand_x = tonumber(ComponentGetValue( position_comp, "pos_x") )
		rand_y = tonumber(ComponentGetValue( position_comp, "pos_y") )
	end

	SetRandomSeed( rand_x, rand_yy )

	local good_item_dropped = drop_random_reward( x, y, entity_item )
	
	local returnMessage = ""
	
	if good_item_dropped then
		returnMessage = "You bought a new wand! Price has gone up"
		GamePrint(returnMessage)
		GamePrintImportant( returnMessage, "" )
		EntityLoad("data/entities/particles/image_emitters/chest_effect.xml", x, y)
		respawnEntity(entity_item, x, y)
	else
		returnMessage = vendingMachineCurrentPrice .. " Gold is required to buy a new wand"
		GamePrint(returnMessage)
		GamePrintImportant( returnMessage, "" )
		EntityLoad("data/entities/particles/image_emitters/chest_effect_bad.xml", x, y)
		respawnEntity(entity_item, x, y)
	end
end

function item_pickup( entity_item, entity_who_picked, name )

	on_open( entity_item )
	
end

function respawnEntity(entity_item, x, y)
	EntityKill(entity_item)
	EntityLoad( "data/entities/items/pickup/vending_machine.xml", x, y)
end

