-- This file controls the spawning of pickup items, such as hearts, slot machine chips, enemy guts and ammo packs, from dead enemies
-- and also deals with enemy kill counters related to some trinkets
dofile_once("data/scripts/lib/utilities.lua")

dofile_once("mods/TheArmory/files/smallpickups_list.lua")
dofile_once("mods/TheArmory/files/trinkets_list.lua")
dofile_once("mods/TheArmory/files/containers_list.lua")

-- dofile_once("data/scripts/thearmory_generic_functions.lua") -- referenced through trinkets_list.lua

function death( damage_type_bit_field, damage_message, entity_thats_responsible, drop_items )

	-- if player possesses any stackable bonuses trinkets, updates enemy kills counter, if the player was responsible for current enemy deathº
	if(playerHasStackableBonusesTrinkets()) then
		if(entity_thats_responsible == getPlayerEntity()) then
			local enemy_kills = getNumericValuePlayerStorageComp("enemy_kills")
			if(enemy_kills < 25) then
				enemy_kills = enemy_kills + 1
			end
			setNumericValuePlayerStorageComp("enemy_kills", enemy_kills)
			
			GamePrint(enemy_kills .. " enemies killed")
		end
	end
	
	local entity = GetUpdatedEntityID()
	
	-- Performs check for no_gold_drop tag first
	local no_gold_drop = false
	edit_component_with_tag( entity, "VariableStorageComponent", "no_gold_drop", function(comp,vars) no_gold_drop = true end )
	
	-- If tagged like so, drops nothing
	if not no_gold_drop then
	
		local x, y = EntityGetTransform( entity )
		
		EntityLoad( "data/entities/items/pickup/lootpack.xml", x, y - 8)

	end
	
end