dofile_once("data/scripts/game_helpers.lua" )
dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/TheArmory/files/smallpickups_list.lua")

function drop_items(entity_id)

	local internalName = EntityGetName(entity_id)
	local x, y = EntityGetTransform( entity_id )
	
	SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	
	local openMessage = ""
	local good = false
	
	if(internalName == "first_aid_box") then -- First Aid Box
	
		openMessage = "First Aid Box opened! Random healing items dropped"
		
		local r = Random(1,5)
			
		if( r == 1 ) then
			good = true
			EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "positive").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))
			EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "positive").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))
			EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "positive").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))
			EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "positive").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))
			EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "positive").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))
		elseif( r == 2 ) then
			good = true
			EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "overtime").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))
		elseif( r == 3 ) then
			good = false
			EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "negative").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))
		elseif( r == 4 ) then
			good = true
			EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "powerful").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))
			EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "powerful").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))
			EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "powerful").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))
		elseif( r == 5 ) then
			good = true
			local r_milk_bottle = Random(1,4)
			if(r_milk_bottle == 1) then
				EntityLoad("data/entities/items/one_time_use/milk_bottle.xml", x + Random(-10,10), y - 4 + Random(-10,10))
			else
				EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "overtime").name .. ".xml", x + Random(-10,10), y - 4 + Random(-10,10))
			end
		end

	end
	
	GamePrint(openMessage)
	GamePrintImportant(openMessage, "" )
	if (good) then
		EntityLoad("data/entities/particles/image_emitters/chest_effect.xml", x, y)
	else
		EntityLoad("data/entities/particles/image_emitters/chest_effect_bad.xml", x, y)
	end
	
	EntityKill( entity_id )
end

function item_pickup( entity_item, entity_who_picked, item_name )

	drop_items(entity_item)
	
end

function physics_body_modified( is_destroyed )
	
	drop_items(GetUpdatedEntityID())
end