dofile_once("data/scripts/lib/utilities.lua")

dofile_once("mods/TheArmory/files/smallpickups_list.lua")
dofile_once("mods/TheArmory/files/trinkets_list.lua")
dofile_once("mods/TheArmory/files/containers_list.lua")

function drop_items(entity_id)

	local internalName = EntityGetName(entity_id)
	local x, y = EntityGetTransform( entity_id )
	
	SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
	
	-- Chances for each sort of item pickup
	local r_heart = math.random( 1, 7)
	local r_ammo_main = math.random(1, 2)
	local r_ammo_secondary = 0
	local r_utility = math.random(1,2)
	local r_portal_spawner = math.random(1,5)

	-- Hearts
	if(ModSettingGet("TheArmory.spawn_hearts") == "enabled") then  -- this setting comes from settings.lua
		if(r_heart == 1) then
			if(ModSettingGet("TheArmory.spawn_poisonous_hearts") == "enabled") then  -- this setting comes from settings.lua
				EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "negative").name .. ".xml", x, y - 8 )
				
				-- trinket extra drop bonus
				if(applyTrinketsEffectsEnemyDrop_PickupItem()) then
					EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "negative").name .. ".xml", x, y - 8 )
				end
			end
		elseif(r_heart == 2) then
			EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "positive").name .. ".xml", x, y - 8 )
			
			-- trinket extra drop bonus
			if(applyTrinketsEffectsEnemyDrop_PickupItem()) then
				EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "positive").name .. ".xml", x, y - 8 )
			end
		elseif(r_heart == 3) then
			EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "overtime").name .. ".xml", x, y - 8 )
			
			-- trinket extra drop bonus
			if(applyTrinketsEffectsEnemyDrop_PickupItem()) then
				EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "overtime").name .. ".xml", x, y - 8 )
			end
		elseif(r_heart == 4) then
			EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "powerful").name .. ".xml", x, y - 8 )
			
			-- trinket extra drop bonus
			if(applyTrinketsEffectsEnemyDrop_PickupItem()) then
				EntityLoad( getPickupItemsBaseDir() .. getRandomPickupItem("healing", "powerful").name .. ".xml", x, y - 8 )
			end
		end
	end
	
	-- Ammo pickups
	if(r_ammo_main == 1) then
		r_ammo_secondary = math.random(1,2)
		if(r_ammo_secondary == 1) then
			EntityLoad(getPickupItemsBaseDir() .. getRandomPickupItem("ammo", "bullet").name .. ".xml", x, y - 8)
			
			-- trinket extra drop bonus
			if(applyTrinketsEffectsEnemyDrop_PickupItem()) then
				EntityLoad(getPickupItemsBaseDir() .. getRandomPickupItem("ammo", "bullet").name .. ".xml", x, y - 8)
			end
		end
	elseif(r_ammo_main == 2) then
		r_ammo_secondary = math.random(1,3)
		if(r_ammo_secondary == 1) then
			EntityLoad(getPickupItemsBaseDir() .. getRandomPickupItem("ammo", "special").name .. ".xml", x, y - 8)
			
			-- trinket extra drop bonus
			if(applyTrinketsEffectsEnemyDrop_PickupItem()) then
				EntityLoad(getPickupItemsBaseDir() .. getRandomPickupItem("ammo", "special").name .. ".xml", x, y - 8)
			end
		end
	elseif(r_ammo_main == 3) then
		r_ammo_secondary = math.random(1,2)
		if(r_ammo_secondary == 1) then
			EntityLoad(getPickupItemsBaseDir() .. getRandomPickupItem("ammo", "basic").name .. ".xml", x, y - 8)
			
			-- trinket extra drop bonus
			if(applyTrinketsEffectsEnemyDrop_PickupItem()) then
				EntityLoad(getPickupItemsBaseDir() .. getRandomPickupItem("ammo", "basic").name .. ".xml", x, y - 8)
			end
		end
	elseif(r_ammo_main == 4) then
		r_ammo_secondary = math.random(1,4)
		if(r_ammo_secondary == 1) then
			EntityLoad(getPickupItemsBaseDir() .. getRandomPickupItem("ammo", "explosive").name .. ".xml", x, y - 8)
			
			-- trinket extra drop bonus
			if(applyTrinketsEffectsEnemyDrop_PickupItem()) then
				EntityLoad(getPickupItemsBaseDir() .. getRandomPickupItem("ammo", "explosive").name .. ".xml", x, y - 8)
			end
		end
	end
	
	-- Utility pickup
	if(r_utility == 1) then
		EntityLoad(getPickupItemsBaseDir() .. getRandomPickupItem("utility", "").name .. ".xml", x, y - 8)
		
		-- trinket extra drop bonus
		if(applyTrinketsEffectsEnemyDrop_PickupItem()) then
			EntityLoad(getPickupItemsBaseDir() .. getRandomPickupItem("utility", "").name .. ".xml", x, y - 8)
		end
	end
	
	-- Portal spawners
	if(r_portal_spawner == 1) then
		EntityLoad(getOneTimeUseItemsBaseDir() .. getRandomPickupItem("one_time_use", "portal_spawner").name .. ".xml", x, y - 8)
	end
	
	-- trinket chest drop chance
	if(applyTrinketsEffectsEnemyDrop_ChestChance()) then
		local r_trinket_chest = math.random(1,10)
		if(r_trinket_chest == 1) then
			EntityLoad( getContainersBaseDir() .. getRandomTieredChest(), x, y - 8)
		end
	end
	
	-- trinket more gold drop chance
	if(applyTrinketsEffectsEnemyDrop_MoreGold()) then
		local r_trinket_moregold = math.random(1,2)
		if(r_trinket_moregold == 1) then
			EntityLoad( "data/entities/items/pickup/goldnugget_10.xml", x, y - 8)
			EntityLoad( "data/entities/items/pickup/goldnugget_10.xml", x, y - 8)
			EntityLoad( "data/entities/items/pickup/goldnugget_10.xml", x, y - 8)
		end
	end

	-- trinket gun part drop chance
	if(applyTrinketsEffectsEnemyDrop_GunPart()) then
		local r_trinket_craftingpartdrop = math.random(1,3)
		if(r_trinket_craftingpartdrop == 1) then
			local r_trinket_weaponpart = math.random(1,3)
			if(r_trinket_weaponpart == 1) then
				EntityLoad("data/entities/items/pickup/crafting_parts_ammo.xml", x, y - 8)
			elseif(r_trinket_weaponpart == 2) then
				EntityLoad("data/entities/items/pickup/crafting_parts_weapon.xml", x, y - 8)
			elseif(r_trinket_weaponpart == 3) then
				EntityLoad("data/entities/items/pickup/crafting_parts_trinket.xml", x, y - 8)
			end
		end
	end
	
	-- trinket ore drop chance
	if(applyTrinketsEffectsEnemyDrop_Ore()) then
		local r_trinket_oredrop = math.random(1,3)
		if(r_trinket_oredrop == 1) then
			r_ore_type = math.random(1,8)
			if(r_ore_type == 1) then
				EntityLoad("data/entities/items/pickup/ore_iron.xml", x, y - 8)
			elseif(r_ore_type == 2) then
				EntityLoad("data/entities/items/pickup/ore_copper.xml", x, y - 8)
			elseif(r_ore_type == 3) then
				EntityLoad("data/entities/items/pickup/ore_gold.xml", x, y - 8)
			elseif(r_ore_type == 4) then
				EntityLoad("data/entities/items/pickup/ore_jade.xml", x, y - 8)
			elseif(r_ore_type == 5) then
				EntityLoad("data/entities/items/pickup/ore_amethyst.xml", x, y - 8)
			elseif(r_ore_type == 6) then
				EntityLoad("data/entities/items/pickup/ore_diamond.xml", x, y - 8)
			elseif(r_ore_type == 7) then
				EntityLoad("data/entities/items/pickup/ore_ruby.xml", x, y - 8)
			elseif(r_ore_type == 8) then
				EntityLoad("data/entities/items/pickup/ore_purple_fluorite.xml", x, y - 8)
			end
		end
	end
	
	EntityLoad("data/entities/particles/image_emitters/chest_effect.xml", x, y)
	
	EntityKill( entity_id )
end

function item_pickup( entity_item, entity_who_picked, item_name )

	drop_items(entity_item)
	
end

function physics_body_modified( is_destroyed )
	
	drop_items(GetUpdatedEntityID())
end