dofile_once("mods/TheArmory/files/minibosses_list.lua")
dofile_once("data/scripts/thearmory_generic_functions.lua")

function item_pickup( entity_item, entity_who_picked, name )
	
	local x, y = EntityGetTransform(entity_item)
	SetRandomSeed( x, y )
	local x_variation = Random (-20,20)
	local spawn_coordinate_x = x + x_variation
	local spawn_coordinate_y = y - 20
	
	--GamePrint("X: " .. x .. " Y:" .. y)
	
	-- loads miniboss spawner
	local spawner_id = EntityLoad("data/entities/miniboss_spawner.xml", spawn_coordinate_x, spawn_coordinate_y)
	
	-- obtains and stores info about chosen miniboss
	local chosen_miniboss = getRandomMiniboss()
	local miniboss_path = getMinibossesBaseDir() .. chosen_miniboss
	local miniboss_description = getMinibossDescription(chosen_miniboss)
	-- tells spawner which boss has to be spawned
	setValueStorageComponent("miniboss_path", miniboss_path, spawner_id, "value_string")
	-- stores spawner coordinates for later use
	setValueStorageComponent("spawner_x", spawn_coordinate_x, spawner_id, "value_int")
	setValueStorageComponent("spawner_y", spawn_coordinate_y, spawner_id, "value_int")
	
	-- checks if miniboss obtained has a next form, if so, spawner needs to be told in order to adjust the miniboss entity when it spawns
	if(hasMinibossNextForm(chosen_miniboss)) then
		setValueStorageComponent("can_drop_gold", 0, spawner_id, "value_int") -- by default it is 1, so it sets to zero to turn it off
	end
	
	-- warns the player fight is about to start
	local message = "Prepare to fight " .. miniboss_description
	GamePrintImportant("You triggered a Miniboss fight!", message)
	GamePrint(message)
	
	EntityKill (entity_item)
end