-- this script handles reward drops and secondary form spawn instructions related to minibosses present at minibosses_list.lua

dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/TheArmory/files/minibosses_list.lua")

function death( damage_type_bit_field, damage_message, entity_thats_responsible, drop_items )
	local entity = GetUpdatedEntityID()
	local entity_name = EntityGetName( entity )
	local x, y = EntityGetTransform( entity )
	
	-- first, checks whether or not current miniboss has next form
	if(hasMinibossNextForm(entity_name)) then -- if current miniboss has next form, gives user audiovisual feedback and spawns next form of the miniboss
	
		-- Audiovisual feedback
		EntityLoad("data/entities/explosion_energy_wave_electricity.xml", x, y)
		EntityLoad("data/entities/particles/particle_explosion/main_small.xml", x, y)
		GamePlaySound( "data/audio/Desktop/misc.snd", "materials/electric_spark", x, y )

		-- Next form spawn
		EntityLoad(getMinibossesBaseDir() .. getMinibossNextForm(entity_name), x, y)
		
	else -- if current miniboss has no next form, gets and drops reward	
		
		GamePrintImportant("Congratulations, you defeated the boss, get your reward!", "")
		EntityLoad( getMinibossRewardsBaseDir() .. getMinibossReward(entity_name), x, y)
		
		-- Sets random seed
		local players = EntityGetWithTag("player_unit")
		SetRandomSeed( GameGetFrameNum(), x + y + players[1] + math.random(1,50))
		
		local minibosskey_chance = Random(1,4)
		if(minibosskey_chance == 1) then
			EntityLoad("data/entities/items/pickup/miniboss_key.xml", x, y)
		elseif(minibosskey_chance == 2) then
			EntityLoad("data/entities/items/pickup/miniboss_key.xml", x, y)
			EntityLoad("data/entities/items/pickup/miniboss_key.xml", x, y)
		end
	end
end