dofile_once("data/scripts/game_helpers.lua")
dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/TheArmory/files/smallpickups_list.lua")
dofile_once("data/scripts/thearmory_utilities.lua")

dofile_once("mods/TheArmory/files/trinkets_list.lua")

function item_pickup( entity_item, entity_who_picked, item_name )
	
	local uiName = name
	local internalName = EntityGetName(entity_item)
	local pos_x, pos_y = EntityGetTransform( entity_item )
	
	local item = getPickupItem(internalName)
	
	-- ammo pickups block
	if(item.category == "ammo") then
		if(item.name == "firearms_ammo_pack") then -- deals first with the exception, then normal ammo pickups
			rifleAmmo 		= getPickupItem("bullet_rifle_ammo")
			shotgunAmmo 	= getPickupItem("bullet_shotgun_ammo")
			smgAmmo 		= getPickupItem("bullet_smg_ammo")
			arAmmo			= getPickupItem("bullet_ar_rifle_ammo")
			pistolAmmo 		= getPickupItem("bullet_pistol_ammo")
			revolverAmmo	= getPickupItem("bullet_revolver_ammo")
			
			addPlayerAmmo(rifleAmmo.base_value + applyTrinketsEffectsAmmo(rifleAmmo.base_value), rifleAmmo.related_variable, rifleAmmo.ui_name)
			addPlayerAmmo(shotgunAmmo.base_value + applyTrinketsEffectsAmmo(shotgunAmmo.base_value), shotgunAmmo.related_variable, shotgunAmmo.ui_name)
			addPlayerAmmo(smgAmmo.base_value + applyTrinketsEffectsAmmo(smgAmmo.base_value), smgAmmo.related_variable, smgAmmo.ui_name)
			addPlayerAmmo(arAmmo.base_value + applyTrinketsEffectsAmmo(arAmmo.base_value), arAmmo.related_variable, arAmmo.ui_name)
			addPlayerAmmo(pistolAmmo.base_value + applyTrinketsEffectsAmmo(pistolAmmo.base_value), pistolAmmo.related_variable, pistolAmmo.ui_name)
			addPlayerAmmo(revolverAmmo.base_value + applyTrinketsEffectsAmmo(revolverAmmo.base_value), revolverAmmo.related_variable, revolverAmmo.ui_name)
		else
			addPlayerAmmo(item.base_value + applyTrinketsEffectsAmmo(item.base_value), item.related_variable, item.ui_name)
		end
	end
	
	-- healing pickups block
	if(item.category == "healing") then
		if(item.sub_category == "overtime") then -- deals first with the exception, then normal healing pickups
			GetGameEffectLoadTo( entity_who_picked, "REGENERATION", true )
		elseif(item.sub_category == "negative") then
			addPlayerHealth(item.base_value + applyTrinketsEffectsHearts_Purple(item.base_value), false) -- applies trinket bonus when purple heart trinket is possessed, negative hearts can't overheal so it's always false
		else
			addPlayerHealth(item.base_value + applyTrinketsEffectsHearts(item.base_value), applyTrinketsEffectsHearts_Diamond()) -- applies trinket bonus only to positive and powerful hearts, overhealing is controlled by the diamond heart trinket
		end
	end
	
	-- utility pickups block
	if(item.category == "utility") then
		
		if(item.name == "enemy_guts") then
			addPlayerEnemyGuts(item.base_value * applyTrinketsEffectsUtility())
		end
		if(item.name == "slot_machine_chip") then
			addPlayerSlotMachineChips(item.base_value * applyTrinketsEffectsUtility())
		end
		if(string.find(item.name, "_key")) then
			addPlayerKeys(item.base_value * applyTrinketsEffectsUtility(), item.related_variable)
		end
	end
	
	-- minibosses items block
	if(item.category == "miniboss_item") then
		if(string.find(item.name, "_key")) then
			addPlayerKeys(item.base_value * applyTrinketsEffectsUtility(), item.related_variable)
		end
	end
	
	-- crafting related items
	if(item.category == "crafting" ) then
		addPlayerCraftingParts(item.base_value * applyTrinketsEffectsUtility(), item.related_variable)	
	end

	shoot_projectile( entity_item, "data/entities/particles/gold_pickup.xml", pos_x, pos_y, 0, 0 )
	
	EntityKill( entity_item )
end