dofile_once("mods/TheArmory/files/trinkets_list.lua")

function item_pickup( entity_item, entity_who_picked, name )

	local internalName = EntityGetName(entity_item)
	local uiName = getTrinketUIName(internalName)
	local descripton = getTrinketDescription(internalName)
	
	local x, y = EntityGetTransform(entity_item)
	
	local returnMessage = ""
	
	-- first of all, verifiies if the trinket is not stackable and has been collected already
	if(playerHasTrinket(internalName) > 0 and (not isTrinketStackable(internalName))) then
		returnMessage = uiName .. " is non-stackable, can't pick this up"
		GamePrint(returnMessage)
		GamePrintImportant( returnMessage, "" )
		EntityLoad("data/entities/particles/image_emitters/chest_effect_bad.xml", x, y)
		
		-- respawns 
		EntityKill( entity_item )
		EntityLoad( getTrinketsBaseDir() .. internalName .. ".xml", x, y)
		
		-- returns to the caller
		return
	end
	
	-- then verifies if the trinket is already stacked twice
	if(playerHasTrinket(internalName) >= 2) then
		returnMessage = "You can stack " .. uiName .. " up to two times only, can't pick this up"
		GamePrint(returnMessage)
		GamePrintImportant( returnMessage, "" )
		EntityLoad("data/entities/particles/image_emitters/chest_effect_bad.xml", x, y)
		
		-- respawns 
		EntityKill( entity_item )
		EntityLoad( getTrinketsBaseDir() .. internalName .. ".xml", x, y)
		
		-- returns to the caller
		return
	end

	local added = addTrinket(internalName) -- tries to add the trinket to a free slot
	
	if(added) then -- successfully added trinket to a free slot, warns player and shows ui info
		returnMessage = "You got " .. uiName
		--GamePrint(returnMessage)
		GamePrintImportant( returnMessage, descripton )
		EntityLoad("data/entities/particles/image_emitters/chest_effect_blue.xml", x, y)
		
		EntityKill( entity_item )
	else -- no free slot available, warns player and respawns trinket
		returnMessage = "No free slot for this trinket, drop one first"
		--GamePrint(returnMessage)
		GamePrintImportant( returnMessage, "" )
		EntityLoad("data/entities/particles/image_emitters/chest_effect_bad.xml", x, y)
		
		-- respawns 
		EntityKill( entity_item )
		EntityLoad( getTrinketsBaseDir() .. internalName .. ".xml", x, y)
	end
	
	--GamePrint("trinket1: " .. getStringValuePlayerStorageComp("trinket1"))
	--GamePrint("trinket2: " .. getStringValuePlayerStorageComp("trinket2"))
	--GamePrint("trinket3: " .. getStringValuePlayerStorageComp("trinket3"))
	--GamePrint("trinket4: " .. getStringValuePlayerStorageComp("trinket4"))

end

