dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/thearmory_generic_functions.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )
local radius_check = 800

local worms = EntityGetInRadiusWithTag( x, y, radius_check, "worm" )

if ( #worms > 0 ) then
	for i,worm_id in ipairs( worms ) do
		EntityKill(worm_id)
	end
end


local portal_spawners = EntityGetInRadiusWithTag( x, y, radius_check, "portal_spawner" )

if ( #portal_spawners > 0 ) then
	for i,portal_spawner_id in ipairs( portal_spawners ) do
		if(isObjectDropped(portal_spawner_id)) then
			local pc_id = EntityGetFirstComponentIncludingDisabled(portal_spawner_id, "ProjectileComponent")
			EntityRemoveComponent(portal_spawner_id, pc_id)
			EntityKill(portal_spawner_id)
			GamePrintImportant("You cannot use portal spawners in the room", "Exit the room using the Green Portal to your right first")
		end
	end
end

--[[
local entry_portals = EntityGetInRadiusWithTag( x, y, radius_check, "room_entry_portal" )

if ( #entry_portals > 0 ) then
	for i,entry_portal_id in ipairs( entry_portals ) do
		EntityKill(entry_portal_id)
	end
end
]]