dofile_once("mods/TheArmory/files/trinkets_list.lua")
dofile_once("data/scripts/thearmory_utilities.lua")

function damage_received( damage, message, entity_thats_responsible, is_fatal, projectile_thats_responsible )

	--GamePrint("### damage taken from source: " .. message)
	--GamePrint("Entity " .. entity_thats_responsible .. " caused " .. damage .. " damage " .. " with projectile " .. projectile_thats_responsible)
	
	if(applyTrinketEffects_DarkMirror() > 0) then
		if(entity_thats_responsible ~= 0 or entity_thats_responsible == nil) then
			EntityInflictDamage( entity_thats_responsible, damage * (3 * applyTrinketEffects_DarkMirror()), "DAMAGE_MATERIAL", "trinket damage", "BLOOD_SPRAY", 0, 0)
			--[[
			comp_ids = EntityGetComponent( projectile_thats_responsible, "ProjectileComponent" )
			if( comp_ids ~= nil ) then
				local shooter_id = ComponentGetValue2( comp_ids[1], "mWhoShot")
				EntityInflictDamage( shooter_id, damage * (3 * applyTrinketEffects_DarkMirror()), "DAMAGE_MATERIAL", "trinket damage", "BLOOD_SPRAY", 0, 0)
			end
			]]
		end
	end

	
	-- if the player is in possession of any stackable bonuses trinkets, resets enemy kills counter when damage from explosions, projectiles or melee attacks is received
	if(message == "$damage_melee" or message == "$damage_projectile" or message == "$damage_explosion") then
		if(playerHasStackableBonusesTrinkets()) then
			setNumericValuePlayerStorageComp("enemy_kills", 0)
			
			GamePrint("Damage taken: enemy kills counter reset")
		end
	end
	
	-- if the player takes damage from materials while in possession of Halo Flask trinket, earns gold proportional to how many are owned
	if(string.find(message, "damage from material")) then
		if(applyTrinketEffects_HaloFlask() > 0) then
			addPlayerGold(5 * applyTrinketEffects_HaloFlask())
		end
	end
	
	-- if the player takes damage but owns Cursed Coin trinket, deducts 10 gold and readds health equivalent to damage, inflicts same amount of damage if less than 10 gold owned
	if(applyTrinketEffects_CursedCoin()) then
		if(getPlayerGold() > 10) then
			addPlayerGold(-10)
			addPlayerHealth(damage)
		end
	end
end

