dofile_once("mods/TheArmory/files/room_entity_map_list.lua")
dofile_once("data/scripts/thearmory_generic_functions.lua")

function teleported( from_x, from_y, to_x, to_y, portal_teleport )
	
	local last_portal_used = getValueStorageComponent("last_portal_used", getPlayerEntity(), "value_string")
	local last_biome_visited = getValueStorageComponent("last_biome_visited", getPlayerEntity(), "value_string")
	--GamePrint("## last portal used: " .. last_portal_used .. " on the " .. last_biome_visited .. " biome ##")
	
	-- kills entry portal if it was last used, then spawns exit portal pointing to the place where the player came from
	if(string.find(last_portal_used, "room_entry")) then
		EntityKill(EntityGetWithName(last_portal_used))
		spawnRoomExitPortal(from_x, from_y)
	end
	
	-- kills exit portal if it was last used
	if(string.find(last_portal_used, "room_exit")) then
		killRoomExitPortal()
	end
	
	-- miniboss room entry portal
	if(last_portal_used == "room_entry_portal_miniboss") then
		GamePrintImportant("Miniboss Room", "Summon a miniboss (Use the green portal to the right to return)")
		-- disables worms and non-exit portals in the vicinity
		toggleWormandPortalsDisablingCallback(true)
		-- spawns entities
		buildMinibossLayout()
	end
	
	-- donation room entry portal
	if(last_portal_used == "room_entry_portal_donation") then
		GamePrintImportant("Donation Room", "Make donations (Use the green portal to the right to return)")
		-- disables worms and non-exit portals in the vicinity
		toggleWormandPortalsDisablingCallback(true)
		-- spawns entities
		buildDonationLayout()
	end
	
	-- chest room entry portal
	if(last_portal_used == "room_entry_portal_chest") then
		GamePrintImportant("Chest Room", "Open chests to obtain weapons (Use the green portal to the right to return)")
		-- disables worms and non-exit portals in the vicinity
		toggleWormandPortalsDisablingCallback(true)
		-- spawns entities
		buildChestLayout(last_biome_visited, from_x, from_y)
	end
	
	-- chest room entry portal
	if(last_portal_used == "room_entry_portal_gambling") then
		GamePrintImportant("Gambling Room", "Try your luck (Use the green portal to the right to return)")
		-- disables worms and non-exit portals in the vicinity
		toggleWormandPortalsDisablingCallback(true)
		-- spawns entities
		buildGamblingLayout(from_x, from_y)
	end
	
	-- ammo box room entry portal
	if(last_portal_used == "room_entry_portal_ammo_box") then
		GamePrintImportant("Ammo Box Room", "Get ammo and healing items (Use the green portal to the right to return)")
		-- disables worms and non-exit portals in the vicinity
		toggleWormandPortalsDisablingCallback(true)
		-- spawns entities
		buildAmmoBoxLayout(from_x, from_y)
	end
	
	-- store room entry portal
	if(last_portal_used == "room_entry_portal_store") then
		GamePrintImportant("Store Room", "Sell or buy supplies and weapons (Use the green portal to the right to return)")
		-- disables worms and non-exit portals in the vicinity
		toggleWormandPortalsDisablingCallback(true)
		-- spawns entities
		buildStoreLayout()
	end
	
	-- crafting room entry portal
	if(last_portal_used == "room_entry_portal_crafting") then
		GamePrintImportant("Crafting Room", "Craft equipment (Use the green portal to the right to return)")
		-- disables worms and non-exit portals in the vicinity
		toggleWormandPortalsDisablingCallback(true)
		-- spawns entities
		buildCraftingLayout()
	end
	
	-- ore room entry portal
	if(last_portal_used == "room_entry_portal_ore") then
		GamePrintImportant("Ore Room", "Obtain ingots (Use the green portal to the right to return)")
		-- disables worms and non-exit portals in the vicinity
		toggleWormandPortalsDisablingCallback(true)
		-- spawns entities
		buildOreLayout(from_x, from_y)
	end

	if(last_portal_used == "room_exit_portal") then
		-- removes worm and non-entry portal disabling mechanic from player
		toggleWormandPortalsDisablingCallback(false)
	end
	
end

function toggleWormandPortalsDisablingCallback(flag)
	if(flag) then
		if (not entityHasLuaComponentWithScriptName(getPlayerEntity(), "disable_worms_and_portals.lua", "script_source_file")) then
			EntityAddComponent( getPlayerEntity(), "LuaComponent", 
			{ 
				script_source_file = "data/scripts/player/disable_worms_and_portals.lua",
				execute_every_n_frame = "15",
			})
		end
	else
		removeLuaComponentWithScriptName(getPlayerEntity(), "disable_worms_and_portals.lua", "script_source_file")
	end
	
end