dofile_once("data/scripts/thearmory_utilities.lua")
dofile_once("mods/TheArmory/files/wands_list.lua")

function wand_fired( gun_entity_id )
	
	local x, y, rotation = EntityGetTransform(gun_entity_id)
	local name, tag = getWandNameAndTagFromWandID(gun_entity_id)
	
	-- prevent vanilla wands from proceding through this script
	if(tag ~= "custom_wand" and tag ~= "boss_reward_wand") then
		return
	end
	
	local bullet_casing, bullet_casing_amount, empty_magazine, empty_magazine_amount = getWandBulletCasingEmptyMagazineConfig(name, tag)
	local ammo_type = getWandAmmoType(name, tag)
	
	-- melee weapons do not count, so when ammo_type is [none], returns to the caller
	if(ammo_type == "[none]") then
		return
	end
	
	if(not checkAmmoDepleted(ammo_type)) then
		
		-- sets seed to randomize ejection direction
		SetRandomSeed(x, y)
		
		-- obtains then deducts ammo capacity
		local vsc = EntityGetFirstComponentIncludingDisabled(gun_entity_id, "VariableStorageComponent")
		local ammo_left = ComponentGetValue2( vsc, "value_int" )
		ammo_left = ammo_left - 1
		--GamePrint(name .. " current ammo: " .. ammo_left)
		
		if(bullet_casing ~= "[none]") then
			for i=1,bullet_casing_amount do
				local casing_id = EntityLoad(bullet_casing, x, y - 5)
				if((rotation >= -1.5 and rotation <= 0.0) or (rotation >= 0.0 and rotation <= 1.5)) then
					PhysicsApplyForce( casing_id, Random(-3,-6), Random(-1,-5) )
					PhysicsApplyTorque( casing_id, 0.2)
				elseif((rotation <= -1.5 and rotation >= -3.15) or (rotation >= 1.5 and rotation <= 3.15))  then
					PhysicsApplyForce( casing_id, Random(3,6), Random(-1,-5) )
					PhysicsApplyTorque( casing_id, -0.2)
				end
			end
		end

		if(ammo_left == 0) then	
			
			local magazine_x = x
			local magazine_y = y
			
			--GamePrint("ammo capacity reached zero, reloading...")
			local abilityComp_id = EntityGetFirstComponentIncludingDisabled(gun_entity_id, "AbilityComponent")
			ammo_left = ComponentObjectGetValue2( abilityComp_id, "gun_config", "deck_capacity" )

			if(empty_magazine ~= "[none]") then
				for i=1,empty_magazine_amount do
					
					if(rotation > -1.5) then
						magazine_x = magazine_x + Random(1,5)
					elseif(rotation < -1.5) then
						magazine_x = magazine_x + Random(-1,-5)
					end
					
					local magazine_id = EntityLoad(empty_magazine, magazine_x, magazine_y + Random(5,7))
					if(rotation > -1.5) then
						PhysicsApplyForce( magazine_id, Random(3,6), Random(-1,-5) )
						PhysicsApplyTorque( magazine_id, 0.2)
					elseif(rotation < -1.5) then
						PhysicsApplyForce( magazine_id, Random(-3,-6), Random(-1,-5) )
						PhysicsApplyTorque( magazine_id, 0.2)
					end
				end
			end
		end
		
		ComponentSetValue2( vsc, "value_int", ammo_left )

	end
end