dofile_once("data/scripts/thearmory_generic_functions.lua")
dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local creature_hit_id = EntityGetRootEntity(entity_id)
local x, y = EntityGetTransform(creature_hit_id)
local projectile_id = EntityGetClosestWithTag( x, y, "stickable" )

if(not EntityHasTag( creature_hit_id, "enemy" )) then
	EntityKill(projectile_id)
	return
end

local projectile_component_id = EntityGetFirstComponent(projectile_id , "ProjectileComponent" )
local particle_emitter_id = EntityGetFirstComponent(projectile_id , "ParticleEmitterComponent" )

local projectile_x, projectile_y, rotation = EntityGetTransform(projectile_id)

-- Removes tag to allow other stickable projectiles to stick to the enemy
EntityRemoveTag( projectile_id, "stickable")

SetRandomSeed( x + math.random(0,50), y + math.random(0,50))

setValueStorageComponent("fixed_rotation", rotation, projectile_id, "value_float")
setValueStorageComponent("connected_enemy_id", creature_hit_id, projectile_id, "value_int")
setValueStorageComponent("last_pos_x", projectile_x, projectile_id, "value_int")
setValueStorageComponent("last_pos_y", projectile_y, projectile_id, "value_int")
setValueStorageComponent("offset_y_adjustment", Random(2,6), projectile_id, "value_int")

-- Strips projectile from its original settings, to prevent it from dealing additional damage
EntityRemoveComponent(projectile_id, projectile_component_id)
EntityRemoveComponent(projectile_id, particle_emitter_id)

-- Adds callback to keep it stuck to enemy struck
EntityAddComponent(projectile_id, "LuaComponent", {
	script_source_file="data/scripts/projectiles/stuck_projectile_updated_pos.lua",
	execute_every_n_frame="1"
})

