dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/lib/coroutines.lua")
dofile_once("data/scripts/thearmory_generic_functions.lua")

local entity_id = GetUpdatedEntityID()

-- obtains values stored at variables in the bomb projectile by store_projectile_vel_pos.lua script
local vel_x = getValueStorageComponent("projectile_vel_x", entity_id, "value_int")
local vel_y = getValueStorageComponent("projectile_vel_y", entity_id, "value_int")
local pos_x = getValueStorageComponent("projectile_pos_x", entity_id, "value_int")
local pos_y = getValueStorageComponent("projectile_pos_y", entity_id, "value_int")

SetRandomSeed( GameGetFrameNum(), pos_x + pos_y + entity_id)

local angle = 0 - math.atan2( vel_y, vel_x )
local length = 2000

local angles = {0.05, 0.1, 0.15, 0.2, 0.25}
local angles_count = 5

-- positive angled shots
for i=1,3 do
	local angle_up = angle + 3.1415 * angles[Random(1,angles_count)]
	
	vel_x = math.cos( angle_up ) * length
	vel_y = 0 - math.sin( angle_up ) * length
	
	local entity_id_projectile1 = EntityLoad( "data/entities/projectiles/nanoshrapnelprojectile_directional_overheated_acid.xml", pos_x, pos_y)
	comp_ids = EntityGetComponent( entity_id_projectile1, "VelocityComponent" )

	if( comp_ids ~= nil ) then
		ComponentSetValue(comp_ids[1], "mass", Random(4, 6))
		ComponentSetValueVector2( comp_ids[1], "mVelocity", vel_x, vel_y)
	end
end

-- straight shot
local angle_straight = angle + 3.1415 * 0.0001
vel_x = math.cos( angle_straight ) * length
vel_y = 0 - math.sin( angle_straight ) * length

local entity_id_projectile1 = EntityLoad( "data/entities/projectiles/nanoshrapnelprojectile_directional_overheated_acid.xml", pos_x, pos_y)
comp_ids = EntityGetComponent( entity_id_projectile1, "VelocityComponent" )

if( comp_ids ~= nil ) then
	ComponentSetValue(comp_ids[1], "mass", Random(4, 6))
	ComponentSetValueVector2( comp_ids[1], "mVelocity", vel_x, vel_y)
end

-- negative angled shots
for i=1,3 do
	local angle_down = angle - 3.1415 * angles[Random(1,angles_count)]
	
	vel_x = math.cos( angle_down ) * length
	vel_y = 0 - math.sin( angle_down ) * length
	
	local entity_id_projectile1 = EntityLoad( "data/entities/projectiles/nanoshrapnelprojectile_directional_overheated_acid.xml", pos_x, pos_y)
	comp_ids = EntityGetComponent( entity_id_projectile1, "VelocityComponent" )

	if( comp_ids ~= nil ) then
		ComponentSetValue(comp_ids[1], "mass", Random(4, 6))
		ComponentSetValueVector2( comp_ids[1], "mVelocity", vel_x, vel_y)
	end
end


