dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/thearmory_generic_functions.lua")

function collision_trigger(colliding_entity_id)

	comp_ids = EntityGetComponent( colliding_entity_id, "ProjectileComponent" )
	
	-- Checks if the projectile caught in the collision box was shot by the player, if so, returns to the caller
	if( comp_ids ~= nil ) then
		local shooter_id = ComponentGetValue2( comp_ids[1], "mWhoShot")
		if(shooter_id == getPlayerEntity()) then
			do return end
		end
	end

	local x, y = EntityGetTransform(colliding_entity_id)
	
	-- strips projectile from its ability to explode on death, then kills it
	edit_component( colliding_entity_id, "ProjectileComponent", function(comp,vars)
		vars.on_death_explode=false
	end)
	EntityKill(colliding_entity_id)
	
	-- Loads audiovisual feedback
	GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y )
	EntityLoad("data/entities/particles/particle_explosion/explosion_flare_small.xml", x, y)
	EntityLoad("data/entities/smoke_pocket_smaller.xml", x, y)
end