dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/thearmory_generic_functions.lua")

function collision_trigger(colliding_entity_id)
	
	-- deals with enemies caught in collision box
	if(EntityHasTag(colliding_entity_id, "enemy")) then
		-- First obtains velocity the player
		local entity_vel_x, entity_vel_y = 0
		edit_component( getPlayerEntity(), "VelocityComponent", function(comp,vars)
			entity_vel_x, entity_vel_y = ComponentGetValueVector2( comp, "mVelocity", vel_x, vel_y)
		end)
		
		-- then applies the same velocity to created caught
		comp_ids = EntityGetComponent( colliding_entity_id, "VelocityComponent" )
		if( comp_ids ~= nil ) then
			ComponentSetValueVector2( comp_ids[1], "mVelocity", entity_vel_x * 10, entity_vel_y * 10)
		end
		
		-- Loads audiovisual feedback
		GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y )
		EntityLoad("data/entities/particles/particle_explosion/explosion_flare_green_small.xml", x, y)
		EntityLoad("data/entities/smoke_pocket_smaller.xml", x, y)
		
		-- Deals damage to creature caught
		local damageThreshold = 0.05
		
		EntityInflictDamage( colliding_entity_id, damageThreshold, "DAMAGE_MELEE", "knocked back", "NORMAL", 0, 0)
	-- deals with projectiles caught in collision box
	elseif(EntityHasTag(colliding_entity_id, "projectile")) then
		comp_ids = EntityGetComponent( colliding_entity_id, "ProjectileComponent" )
		-- Checks if the projectile caught in the collision box was shot by the player, if so, returns to the caller
		if( comp_ids ~= nil ) then
			local shooter_id = ComponentGetValue2( comp_ids[1], "mWhoShot")
			if(shooter_id == getPlayerEntity()) then
				do return end
			end
		end
		
		local x, y = EntityGetTransform(colliding_entity_id)

		-- First checks if the projectile has already been deflected, returns to the caller if so
		for i, component in ipairs(EntityGetComponent(colliding_entity_id, "VariableStorageComponent") or {}) do
			if ComponentGetValue2(component, "name") == "deflected" then
				do return end
			end
		end
		
		-- Loads audiovisual feedback
		GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y )
		EntityLoad("data/entities/particles/particle_explosion/explosion_flare_small.xml", x, y)
		EntityLoad("data/entities/smoke_pocket_smaller.xml", x, y)
		
		local projectile_vel_x, projectile_vel_y = 0
		edit_component( colliding_entity_id, "VelocityComponent", function(comp,vars)
			projectile_vel_x, projectile_vel_y = ComponentGetValueVector2( comp, "mVelocity", vel_x, vel_y)
		end)
		
		-- Inverts projectile velocity, turning it back to the direction it came
		comp_ids = EntityGetComponent( colliding_entity_id, "VelocityComponent" )
		if( comp_ids ~= nil ) then
			--ComponentSetValue(comp_ids[1], "mass", Random(4, 6))
			ComponentSetValueVector2( comp_ids[1], "mVelocity", (projectile_vel_x * 1.5) * -1, (projectile_vel_y * 1.5) * -1)
		end
		
		-- Sets the shooter of the deflected projectile as the player, so it can damage the creature who shot it originally
		comp_ids = EntityGetComponent( colliding_entity_id, "ProjectileComponent" )
		if( comp_ids ~= nil ) then
			ComponentSetValue( comp_ids[1], "mWhoShot", getPlayerEntity())
			ComponentSetValue( comp_ids[1], "mShooterHerdId", getSpeciesFromEnemyEntity(getPlayerEntity()))
		end
		
		-- Flags projectile as deflected to prevent it from changing again due to this callback
		EntityAddComponent2(colliding_entity_id, "VariableStorageComponent", {
			name = "deflected"
		})
	end
end