dofile_once("data/scripts/lib/utilities.lua")

function collision_trigger(colliding_entity_id)
	
	local shooter_id = 0
	local entity_id = GetUpdatedEntityID()
	comp_ids = EntityGetComponent( entity_id, "ProjectileComponent" )
	
	if( comp_ids ~= nil ) then
		shooter_id = ComponentGetValue( comp_ids[1], "mWhoShot")
	end
	
	local pos_x, pos_y = EntityGetTransform(shooter_id)
	
	local projectile_velocity = 430
	local scatter = 0.1
	
	if EntityHasTag(colliding_entity_id, "enemy") then
		
		local enemy_x, enemy_y = EntityGetTransform(colliding_entity_id)
		-- check los
		if RaytraceSurfacesAndLiquiform(pos_x, pos_y, enemy_x, enemy_y) then return end

		-- direction
		local vel_x, vel_y = vec_sub(enemy_x, enemy_y, pos_x, pos_y)
		vel_x,vel_y = vec_normalize(vel_x, vel_y)

		-- scatter
		SetRandomSeed(pos_x + GameGetFrameNum(), pos_y)
		vel_x,vel_y = vec_rotate(vel_x,vel_y, rand(-scatter, scatter))

		-- apply velocity & shoot
		vel_x,vel_y = vec_mult(vel_x,vel_y, projectile_velocity)
		local eid = shoot_projectile( shooter_id, "data/entities/projectiles/laser_red.xml", pos_x, pos_y, vel_x, vel_y)
	end	
end