local entity_id = GetUpdatedEntityID()

-- adds particle emitter and light to signal arming
local pec_id = EntityAddComponent2(entity_id, "ParticleEmitterComponent", {
	emitted_material_name="spark_red",
	lifetime_min=0.4,
	lifetime_max=0.7,
	count_min=10,
	count_max=20,
	render_on_grid=true,
	fade_based_on_lifetime=true,
	cosmetic_force_create=false,
	airflow_force=1.5,
	airflow_time=1.9,
	airflow_scale=0.15,
	emission_interval_min_frames=1,
	emission_interval_max_frames=1,
	emit_cosmetic_particles=true,
	draw_as_long=true,
	x_vel_min=-1,
	x_vel_max=1,
	y_vel_min=-1,
	y_vel_max=1,
	is_emitting=true,
	velocity_always_away_from_center=200
})
ComponentSetValue2( pec_id, "gravity", 0.0, 0.0 )
ComponentSetValue2( pec_id, "area_circle_radius", 8, 8)

EntityAddComponent(entity_id, "LightComponent", {
    radius="150",
    r="255",
    g="0",
    b="0"
})

-- adds enemy detection callback
EntityAddComponent(entity_id, "LuaComponent", {
	script_source_file="data/scripts/projectiles/stickymine_detection_field.lua",
	execute_every_n_frame="1"
})

--GamePrint("## mine is armed ##")