dofile_once("data/scripts/thearmory_generic_functions.lua")

local entity_id = GetUpdatedEntityID()

-- obtains tick number
local ticks = getValueStorageComponent("ticks", entity_id, "value_int")
ticks = ticks + 1
setValueStorageComponent("ticks", ticks, entity_id, "value_int")

local emitterMaterial = ""

-- tick logic is as follows:
-- 1 2 3 4 5 6 7 8 9 10 11 12
-- *   *   *   *   *    *
-- tick indicator turns on on odd tick numbers and turns off on even numbers
-- until tick 8 the indicator emits yellow particles, from 9 onwards it switches to red particles indicating the mine is about to explode

if(ticks < 9) then
	emitterMaterial = "spark_yellow"
else
	emitterMaterial = "spark_red"
end

if(not (ticks % 2 == 0)) then
	local pec_id = EntityAddComponent2(entity_id, "ParticleEmitterComponent", {
		emitted_material_name=emitterMaterial,
		lifetime_min=0.4,
		lifetime_max=0.7,
		count_min=10,
		count_max=20,
		render_on_grid=true,
		fade_based_on_lifetime=true,
		cosmetic_force_create=false,
		airflow_force=1.5,
		airflow_time=1.9,
		airflow_scale=0.15,
		emission_interval_min_frames=1,
		emission_interval_max_frames=1,
		emit_cosmetic_particles=true,
		draw_as_long=true,
		x_vel_min=-1,
		x_vel_max=1,
		y_vel_min=-1,
		y_vel_max=1,
		is_emitting=true,
		velocity_always_away_from_center=200
	})
	ComponentSetValue2( pec_id, "gravity", 0.0, 0.0 )
	ComponentSetValue2( pec_id, "area_circle_radius", 8, 8)

	EntityAddComponent(entity_id, "LightComponent", {
		radius="150",
		r="255",
		g="0",
		b="0"
	})
else
	local pec_id = EntityGetFirstComponent( entity_id, "ParticleEmitterComponent" )
	local lc_id = EntityGetFirstComponent( entity_id, "LightComponent" )
	EntityRemoveComponent( entity_id, pec_id )
	EntityRemoveComponent( entity_id, lc_id )
end

if(ticks == 12) then
	EntityKill(entity_id)
end

