dofile_once("data/scripts/thearmory_generic_functions.lua")

local projectile_id = GetUpdatedEntityID()

-- obtains all necessary variables from projectile
local rotation = getValueStorageComponent("fixed_rotation", projectile_id, "value_float")
local connected_enemy_id = getValueStorageComponent("connected_enemy_id", projectile_id, "value_int")
local offset_y_adjustment = getValueStorageComponent("offset_y_adjustment", projectile_id, "value_int")

local last_pos_x = getValueStorageComponent("last_pos_x", projectile_id, "value_int")
local last_pos_y = getValueStorageComponent("last_pos_y", projectile_id, "value_int")

if(EntityGetIsAlive(connected_enemy_id)) then

	-- calculates offset so that the projectile gets stuck in the right position based on where it struck
	local enemy_x, enemy_y = EntityGetTransform(connected_enemy_id)
	
	local offset_x = enemy_x - last_pos_x
	local offset_y = enemy_y - last_pos_y
	
	-- updates projectile position
	local updated_x = last_pos_x + offset_x
	local updated_y = last_pos_y + offset_y - offset_y_adjustment
	
	-- transforms projectile with new position and rotation
	EntitySetTransform(projectile_id, updated_x, updated_y, rotation)
	
	-- sets variable values
	setValueStorageComponent("last_pos_x", updated_x, projectile_id, "value_int")
	setValueStorageComponent("last_pos_y", updated_y, projectile_id, "value_int")
else
	EntityKill(projectile_id)
end

