dofile_once("data/scripts/lib/utilities.lua")

dofile_once("mods/TheArmory/files/trinkets_list.lua")

function collision_trigger(colliding_entity_id)

	--GamePrint("player triggered mine")
	
	local entity_id = GetUpdatedEntityID()
	
	-- checks if the player has EMP Module trinket
	if(applyTrapEffect()) then
		
		-- if so, removes CollisionTriggerComponent to prevent trap from triggering in the presence of the player
		local components = EntityGetComponent( entity_id, "CollisionTriggerComponent" )
		for i,component_id in ipairs( components ) do
			EntityRemoveComponent( entity_id, component_id )
		end
		
		-- loads custom explosion sprite and plays sound
		local x, y = EntityGetTransform(entity_id)
		GamePlaySound( "data/audio/Desktop/misc.snd", "materials/electric_spark", x, y )
		EntityLoad("data/entities/explosion_trap_fried.xml", x, y)
		EntityLoad("data/entities/smoke_pocket_small.xml", x, y)
		return
		
	end
	
	--[[
	else
		-- otherwise, readds CollisionTriggerComponent so trap can trigger again	
		EntityAddComponent(entity_id, "LuaComponent", {
			execute_on_removed="0",
			execute_every_n_frame="99999999",
			script_damage_received="data/scripts/trap_trigger.lua",
			remove_after_executed="1"
		})
		EntityAddComponent(entity_id, "CollisionTriggerComponent", {
			width="40",
			height="40",
			radius="20",
			required_tag="player_unit",
			self_trigger="1",
			timer_for_destruction="30"
		})
	end
	]]
	
	--[[
	prevents explosion
	local components = EntityGetComponent( entity_id, "ExplosionComponent" )
	for i,component_id in ipairs( components ) do
		ComponentSetValue( component_id, "trigger", "" )
		EntityRemoveComponent( entity_id, component_id )
	end
	]]
	
	edit_component( colliding_entity_id, "CollisionTriggerComponent", function(comp,vars)
		local timer = ComponentGetValueInt( comp, "timer_for_destruction")
		vars.mTimer = timer * 5
	end)
end

function damage_received( damage, desc, entity_who_caused, is_fatal )
	if(getPlayerEntity() == entity_who_caused) then
		local entity_id = GetUpdatedEntityID()
		
		edit_component( entity_id, "CollisionTriggerComponent", function(comp,vars)
			local timer = ComponentGetValueInt( comp, "timer_for_destruction")
			vars.mTimer = timer * 5
		end)
	end
end

--[[
local entity_id = GetUpdatedEntityID()

edit_component( entity_id, "CollisionTriggerComponent", function(comp,vars)
	local timer = ComponentGetValueInt( comp, "timer_for_destruction")
	vars.mTimer = timer * 5
end)
]]