dofile_once("mods/TheArmory/files/traps_list.lua")
dofile_once("mods/TheArmory/files/enemies_list.lua")

RegisterSpawnFunction( 0xff3FCCA2, "spawn_trap" )
RegisterSpawnFunction( 0xff38C1BC, "spawn_enemy" )
RegisterSpawnFunction( 0xff3FC18B, "spawn_hanging_trap" )

-- This file controls the spawning of traps and custom enemies

function spawn_trap(x, y)
		
	if(getTrapSpawnChance(x, y) == 1) then
		
		if(getTrapSpawnConfig() == "MATERIAL_CONTAINERS_ONLY") then
			EntityLoad( "data/entities/props/material_container.xml", x, y)
		else
			EntityLoad( getTrapsBaseDir() .. getRandomTrap(), x, y)
		end

	end

end

function spawn_enemy(x, y)
	if(getEnemySpawnChance(x, y) == 1) then
		EntityLoad(getEnemiesBaseDir() .. getRandomEnemy(), x, y)
	end
end

function spawn_hanging_trap(x, y)
	
	EntityLoad( getTrapsBaseDir() .. getRandomHangingTrap(), x, y)

end

function getTrapSpawnChance(x, y)

	local configChance = -1
	
	SetRandomSeed( x, y )
	
	local how_often_traps_appear = getTrapSpawnConfig()
	
	if(how_often_traps_appear == "ALWAYS") then -- literally always, every spawn point will be used
		configChance = Random(1,1)
	elseif(how_often_traps_appear == "OFTEN" or how_often_traps_appear == "MATERIAL_CONTAINERS_ONLY") then -- 1 in 3 chance a trap may spawn
		configChance = Random(1,3)
	elseif(how_often_traps_appear == "RARELY") then --  1 in 10 chance a trap may spawn
		configChance = Random(1,10)
	elseif(how_often_traps_appear == "NEVER") then --  no spawns at all
		configChance = 0
	end
	
	return configChance
end

function getEnemySpawnChance(x, y)

	local configChance = -1
	
	SetRandomSeed( x, y )
	
	local how_often_enemies_appear = getEnemySpawnConfig()
	
	if(how_often_enemies_appear == "OFTEN") then -- 1 in 3 chance an enemy may spawn
		configChance = Random(1,5)
	elseif(how_often_enemies_appear == "RARELY") then --  1 in 10 chance an enemy may spawn
		configChance = Random(1,8)
	elseif(how_often_enemies_appear == "NEVER") then --  no spawns at all
		configChance = 0
	end
	
	return configChance
end

function getTrapSpawnConfig()
	return ModSettingGet("TheArmory.how_often_traps_appear") -- this setting comes from settings.lua
end

function getEnemySpawnConfig()
	return ModSettingGet("TheArmory.how_often_enemies_appear") -- this setting comes from settings.lua
end