dofile_once("data/scripts/lib/utilities.lua")
-- dofile_once("data/scripts/thearmory_generic_functions.lua") -- file below adds this already, so no need to explicitly include it
dofile_once("mods/TheArmory/files/trinkets_list.lua")
dofile_once("mods/TheArmory/files/wands_list.lua")

local render = applyTrinketsEffects_LaserSight()

local entity_id = GetUpdatedEntityID()
local spriteComponent = EntityGetFirstComponent(entity_id, "SpriteComponent")
local lightComponent = EntityGetFirstComponent(entity_id, "LightComponent")
local gun_id = getCurrentlyEquippedWandId()
local gun_name, gun_tag = getWandNameAndTagFromWandID(gun_id)


if render then -- makes pointer visible if render is true, makes it invisible otherwise
	ComponentSetValue(spriteComponent, "visible", 1)
	ComponentSetValue(lightComponent, "mAlpha", 1)
	
	-- laser pointer only renders when weapons from The Armory are equipped, and only on ranged weapons (not melee)
	if((EntityHasTag(gun_id, "custom_wand") or EntityHasTag(gun_id, "boss_reward_wand")) and not isMeleeWand(gun_name, gun_tag)) then
		-- Has to match the width of the sprite
		local SPRITE_PIXEL_LENGTH = 40

		-- Get coordinates of start and end points
		local gun_id_x, gun_id_y, rotation = EntityGetTransform(gun_id)
		local mouse_x, mouse_y = DEBUG_GetMouseWorld()
		
		--gun_id_x = gun_id_x + 1
		gun_id_y = gun_id_y - 1.75

		-- Get a visibility point, for cutting off the line. Essentially: "how far can we see".
		local did_hit, target_x, target_y = RaytracePlatforms(gun_id_x, gun_id_y, mouse_x, mouse_y)
		if (not did_hit) then
			target_x = mouse_x
			target_y = mouse_y
		end

		-- Set line length(x) and width(y)
		local length = - get_distance(gun_id_x, gun_id_y, target_x, target_y) / SPRITE_PIXEL_LENGTH
		local width = 1

		EntitySetTransform(entity_id, gun_id_x, gun_id_y, rotation, - length, width)
	else
		ComponentSetValue(spriteComponent, "visible", 0)
		ComponentSetValue(lightComponent, "mAlpha", 0)
	end
else
	ComponentSetValue(spriteComponent, "visible", 0)
	ComponentSetValue(lightComponent, "mAlpha", 0)
end