dofile_once("data/scripts/lib/utilities.lua")

local possible_actions_list =
{
	{ id = "THEARMORYACTIONS_TESTTUBE_ACID", description = "Test Tube filled with Acid" },
	{ id = "THEARMORYACTIONS_TESTTUBE_NITRO", description = "Test Tube filled with Nitroglycerin" },
	{ id = "THEARMORYACTIONS_TESTTUBE_AGITATED_NEUTRON_MASS", description = "Test Tube filled with Agitated Neutron Mass" },
	{ id = "THEARMORYACTIONS_TESTTUBE_OVERHEATED_ACID", description = "Test Tube filled with Overheated Acid" },
	{ id = "THEARMORYACTIONS_TESTTUBE_EXPLOSIUM", description = "Test Tube filled with Explosium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_ELECTRICIUM", description = "Test Tube filled with Electricium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_ANTI_POLYMORPHINE", description = "Test Tube filled with Anti Polymorphine" },
	{ id = "THEARMORYACTIONS_TESTTUBE_LIQUID_NITROGEN", description = "Test Tube filled with Liquid Nitrogen" },
	{ id = "THEARMORYACTIONS_TESTTUBE_ANTICOAGULANT", description = "Test Tube filled with Anticoagulant" },
	{ id = "THEARMORYACTIONS_TESTTUBE_SPITIUM", description = "Test Tube filled with Spitium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_CONCENTRATED_SPITIUM", description = "Test Tube filled with Concentrated Spitium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_FROGIUM", description = "Test Tube filled with Frogium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_GRAVITIUM", description = "Test Tube filled with Gravitium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_FERROFLUID", description = "Test Tube filled with Ferrofluid" },
	{ id = "THEARMORYACTIONS_TESTTUBE_TRITIUM", description = "Test Tube filled with Tritium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_SLAPIUM", description = "Test Tube filled with Slapium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_WATER", description = "Test Tube filled with Water" },
	{ id = "THEARMORYACTIONS_TESTTUBE_PROPANE_GAS", description = "Test Tube filled with Propane Gas" },
	{ id = "THEARMORYACTIONS_TESTTUBE_LIGHTNIUM", description = "Test Tube filled with Lightnium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_INFERNIUM", description = "Test Tube filled with Infernium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_THUNDERIUM", description = "Test Tube filled with Thunderium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_CHILLIUM", description = "Test Tube filled with Chillium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_TESLIUM", description = "Test Tube filled with Teslium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_SLASHIUM", description = "Test Tube filled with Slashium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_SLASHIUM_PURPLE", description = "Test Tube filled with Purple Slashium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_SLASHIUM_RED", description = "Test Tube filled with Red Slashium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_SLASHIUM_ORANGE", description = "Test Tube filled with Orange Slashium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_SLASHIUM_GREEN", description = "Test Tube filled with Green Slashium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_EXPLOSIUM_RED", description = "Test Tube filled with Red Explosium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_EXPLOSIUM_PURPLE", description = "Test Tube filled with Purple Explosium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_EXPLOSIUM_ORANGE", description = "Test Tube filled with Orange Explosium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_EXPLOSIUM_GREEN", description = "Test Tube filled with Green Explosium" },
	{ id = "THEARMORYACTIONS_TESTTUBE_CONCENTRATED_POISON_GAS", description = "Test Tube filled with Concentrated Poison Gas" },
	{ id = "THEARMORYACTIONS_TESTTUBE_EXPLODING_GAS_YELLOW", description = "Test Tube filled with Yellow Exploding Gas" },
	{ id = "THEARMORYACTIONS_TESTTUBE_EXPLODING_GAS_RED", description = "Test Tube filled with Red Exploding Gas" },
	{ id = "THEARMORYACTIONS_TESTTUBE_EXPLODING_GAS_GREEN", description = "Test Tube filled with Green Exploding Gas" },
	{ id = "THEARMORYACTIONS_TESTTUBE_EXPLODING_GAS_ORANGE", description = "Test Tube filled with Orange Exploding Gas" },
	{ id = "THEARMORYACTIONS_TESTTUBE_EXPLODING_GAS_PURPLE", description = "Test Tube filled with Purple Exploding Gas" },
}

function getPossibleActionsCount()
	local count = 0
	for i,element in ipairs(possible_actions_list) do
		count = count + 1
	end
	return count
end

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
local chosen_action = possible_actions_list[Random(1,getPossibleActionsCount())]

edit_component( entity_id, "AbilityComponent", function(comp,vars)
	vars.ui_name = chosen_action.description
end)

local action_id = CreateItemActionEntity(chosen_action.id)
EntityAddChild( entity_id, action_id)

