dofile_once("data/scripts/lib/utilities.lua")
-- dofile_once("data/scripts/thearmory_generic_functions.lua") -- file below adds this already, so no need to explicitly include it
dofile_once("mods/TheArmory/files/trinkets_list.lua")
dofile_once("mods/TheArmory/files/wands_list.lua")

local handler_id = GetUpdatedEntityID()

local gun_entity_id = getCurrentlyEquippedWandId()
local gun_name, gun_tag = getWandNameAndTagFromWandID(gun_entity_id)

local wielder_id = EntityGetRootEntity(gun_entity_id)
local wielder_x, wielder_y, wielder_rotation = EntityGetTransform(wielder_id)

local passiveShield = applyTrinketEffects_PassiveShield()

-- obtains stored id of shield handling entity
local vsc = EntityGetFirstComponentIncludingDisabled(handler_id, "VariableStorageComponent", "shield_handler")
local passive_shield_id = ComponentGetValue2( vsc, "value_int" )

--GamePrint("### passive shield id: " .. passive_shield_id)

if(passiveShield ~= "[none]") then
	-- passive shield only renders when weapons from The Armory are equipped, and only on ranged weapons (not melee)
	if((EntityHasTag(gun_entity_id, "custom_wand") or EntityHasTag(gun_entity_id, "boss_reward_wand")) and isMeleeWand(gun_name, gun_tag)) then
		if(passive_shield_id == 0) then
			passive_shield_id = EntityLoad( "data/entities/" .. passiveShield .. ".xml")
			ComponentSetValue2( vsc, "value_int", passive_shield_id )
		elseif(passive_shield_id ~= 0) then
			local gun_x, gun_y, gun_rotation = EntityGetTransform(gun_entity_id)
			EntitySetTransform(passive_shield_id, wielder_x, wielder_y - 6, gun_rotation)
		end
	else
		if(passive_shield_id ~= 0) then -- kills it only if it exists
			EntityKill(passive_shield_id)
			ComponentSetValue2( vsc, "value_int", 0 )
		end
	end
end

