local container_materials =
{	
	-- vanilla materials
	{ internal_name = "water", ui_name = "Water", puddle_entity_path="data/entities/water_pocket_medium.xml" },
	{ internal_name = "acid", ui_name = "Acid", puddle_entity_path="data/entities/acid_pocket_medium.xml" },
	{ internal_name = "radioactive_gas", ui_name = "Toxic Gas", puddle_entity_path="data/entities/radioactive_gas_pocket_medium.xml" },
	{ internal_name = "radioactive_liquid", ui_name = "Radioactive Liquid", puddle_entity_path="data/entities/radioactive_liquid_pocket_medium.xml" },
	{ internal_name = "magic_liquid_random_polymorph", ui_name = "Polymorphine", puddle_entity_path="data/entities/polymorphine_pocket_medium.xml" },
	{ internal_name = "magic_liquid_teleportation", ui_name = "Teleportatium", puddle_entity_path="data/entities/teleportatium_pocket_medium.xml" },
	{ internal_name = "poison", ui_name = "Poison", puddle_entity_path="data/entities/poison_pocket_medium.xml" },
	{ internal_name = "lava", ui_name = "Lava", puddle_entity_path="data/entities/lava_pocket_medium.xml" },
	{ internal_name = "magic_liquid_berserk", ui_name = "Berserkium", puddle_entity_path="data/entities/berserkium_pocket_medium.xml" },
	{ internal_name = "blood_cold_vapour", ui_name = "Freezing Gas", puddle_entity_path="data/entities/freezing_gas_pocket_medium.xml" },
	{ internal_name = "sand", ui_name = "Sand", puddle_entity_path="data/entities/sand_pocket_medium.xml" },
	
	-- custom materials, added by this mod
	{ internal_name = "nitroglycerin_unstable", ui_name = "Unstable Nitroglycerin", puddle_entity_path="data/entities/nitroglycerin_pocket_medium.xml" },
	{ internal_name = "nitroglycerin", ui_name = "Stable Nitroglycerin", puddle_entity_path="data/entities/nitroglycerin_stable_pocket_medium.xml" },
	{ internal_name = "white_phosphorous", ui_name = "White Phosphorous", puddle_entity_path="data/entities/white_phosphorous_pocket_medium.xml" },
	{ internal_name = "red_phosphorous", ui_name = "Red Phosphorous", puddle_entity_path="data/entities/red_phosphorous_pocket_medium.xml" },
	{ internal_name = "agitated_neutron_mass", ui_name = "Agitated Neutron Mass", puddle_entity_path="data/entities/agitated_neutron_mass_pocket_medium.xml" },
	{ internal_name = "uranium", ui_name = "Uranium Powder", puddle_entity_path="data/entities/uranium_pocket_medium.xml" },
	{ internal_name = "plutonium", ui_name = "Plutonium Powder", puddle_entity_path="data/entities/plutonium_pocket_medium.xml" },
	{ internal_name = "cesium_137", ui_name = "Cesium-137 Powder", puddle_entity_path="data/entities/cesium_137_pocket_medium.xml" },
	{ internal_name = "anti_polymorphine", ui_name = "Anti-polymorphine", puddle_entity_path="data/entities/antipoly_pocket_medium.xml" },
	{ internal_name = "overheated_acid", ui_name = "Overheated Acid", puddle_entity_path="data/entities/overheated_acid_pocket_medium.xml" },
	{ internal_name = "explosium", ui_name = "Explosium", puddle_entity_path="data/entities/explosium_pocket_medium.xml" },
	{ internal_name = "anticoagulant", ui_name = "Anticoagulant", puddle_entity_path="data/entities/anticoagulant_pocket_medium.xml" },
	{ internal_name = "liquid_nitrogen", ui_name = "Liquid Nitrogen", puddle_entity_path="data/entities/liquid_nitrogen_pocket_medium.xml" },
	{ internal_name = "spitium", ui_name = "Spitium", puddle_entity_path="data/entities/spitium_pocket_medium.xml" },
	{ internal_name = "concentrated_spitium", ui_name = "Concentrated Spitium", puddle_entity_path="data/entities/concentrated_spitium_pocket_medium.xml" },
	{ internal_name = "electricium", ui_name = "Electricium", puddle_entity_path="data/entities/electricium_pocket_medium.xml" },
	{ internal_name = "wavium", ui_name = "Wavium", puddle_entity_path="data/entities/wavium_pocket_medium.xml" },
	{ internal_name = "concentrated_poison_gas", ui_name = "Concentrated Poison Gas", puddle_entity_path="data/entities/concentrated_poison_gas_pocket_medium.xml" },
	{ internal_name = "tritium", ui_name = "Tritium", puddle_entity_path="data/entities/tritium_pocket_medium.xml" },
	{ internal_name = "frogium", ui_name = "Frogium", puddle_entity_path="data/entities/frogium_pocket_medium.xml" },
	{ internal_name = "slapium", ui_name = "Slapium", puddle_entity_path="data/entities/slapium_pocket_medium.xml" },
	{ internal_name = "gravitium", ui_name = "Gravitium", puddle_entity_path="data/entities/gravitium_pocket_medium.xml" },
	{ internal_name = "clonium", ui_name = "Clonium", puddle_entity_path="data/entities/clonium_pocket_medium.xml" },
	{ internal_name = "ferrofluid", ui_name = "Ferrofluid", puddle_entity_path="data/entities/ferrofluid_pocket_medium.xml" },
	{ internal_name = "deuterium", ui_name = "Deuterium", puddle_entity_path="data/entities/deuterium_pocket_medium.xml" },
	{ internal_name = "freon_gas", ui_name = "Freon Gas", puddle_entity_path="data/entities/freon_gas_pocket_medium.xml" },
	{ internal_name = "propane_gas", ui_name = "Propane Gas", puddle_entity_path="data/entities/propane_gas_pocket_medium.xml" },
	{ internal_name = "neon_gas", ui_name = "Neon Gas", puddle_entity_path="data/entities/neon_gas_pocket_medium.xml" },
	{ internal_name = "repellium", ui_name = "Repellium", puddle_entity_path="data/entities/repellium_pocket_medium.xml" },
	{ internal_name = "sulfur_gas", ui_name = "Sulfur Gas", puddle_entity_path="data/entities/sulfur_gas_pocket_medium.xml" },
	{ internal_name = "lightnium", ui_name = "Lightnium", puddle_entity_path="data/entities/lightnium_pocket_medium.xml" },
	{ internal_name = "infernium", ui_name = "Infernium", puddle_entity_path="data/entities/infernium_pocket_medium.xml" },
	{ internal_name = "thunderium", ui_name = "Thunderium", puddle_entity_path="data/entities/thunderium_pocket_medium.xml" },
	{ internal_name = "chillium", ui_name = "Chillium", puddle_entity_path="data/entities/chillium_pocket_medium.xml" },
	{ internal_name = "teslium", ui_name = "Teslium", puddle_entity_path="data/entities/teslium_pocket_medium.xml" },
	{ internal_name = "dropium", ui_name = "Dropium", puddle_entity_path="data/entities/dropium_pocket_medium.xml" },
	{ internal_name = "slashium", ui_name = "Slashium", puddle_entity_path="data/entities/slashium_pocket_medium.xml" },
	{ internal_name = "slashium_red", ui_name = "Red Slashium", puddle_entity_path="data/entities/slashium_red_pocket_medium.xml" },
	{ internal_name = "slashium_orange", ui_name = "Orange Slashium", puddle_entity_path="data/entities/slashium_orange_pocket_medium.xml" },
	{ internal_name = "slashium_purple", ui_name = "Purple Slashium", puddle_entity_path="data/entities/slashium_purple_pocket_medium.xml" },
	{ internal_name = "slashium_green", ui_name = "Green Slashium", puddle_entity_path="data/entities/slashium_green_pocket_medium.xml" },
	{ internal_name = "explosium_red", ui_name = "Red Explosium", puddle_entity_path="data/entities/explosium_red_pocket_medium.xml" },
	{ internal_name = "explosium_green", ui_name = "Green Explosium", puddle_entity_path="data/entities/explosium_green_pocket_medium.xml" },
	{ internal_name = "explosium_orange", ui_name = "Orange Explosium", puddle_entity_path="data/entities/explosium_orange_pocket_medium.xml" },
	{ internal_name = "explosium_purple", ui_name = "Purple Explosium", puddle_entity_path="data/entities/explosium_purple_pocket_medium.xml" },
	{ internal_name = "exploding_gas_yellow", ui_name = "Yellow Exploding Gas", puddle_entity_path="data/entities/exploding_gas_yellow_pocket_medium.xml" },
	{ internal_name = "exploding_gas_red", ui_name = "Red Exploding Gas", puddle_entity_path="data/entities/exploding_gas_red_pocket_medium.xml" },
	{ internal_name = "exploding_gas_orange", ui_name = "Orange Exploding Gas", puddle_entity_path="data/entities/exploding_gas_orange_pocket_medium.xml" },
	{ internal_name = "exploding_gas_purple", ui_name = "Purple Exploding Gas", puddle_entity_path="data/entities/exploding_gas_purple_pocket_medium.xml" },
	{ internal_name = "exploding_gas_green", ui_name = "Green Exploding Gas", puddle_entity_path="data/entities/exploding_gas_green_pocket_medium.xml" },
}

function getContainerMaterialsCount()
	local count = 0
	for i,element in ipairs(container_materials) do
		count = count + 1
	end
	return count
end

function getRandomContainerMaterial()
	local chosen_material = container_materials[Random(1,getContainerMaterialsCount())]
	return chosen_material.internal_name, chosen_material.ui_name, chosen_material.puddle_entity_path
end