-- This file contains the list of all item spawning containers
-- Every new container or tiered chest must be included here should new ones be added to the mod
ammo_boxes_list =
{
	"basic_ammo_box.xml",
	"explosive_ammo_box.xml",
	"special_ammo_box.xml",
	"bullet_ammo_box.xml"
}
--[[
throwables_boxes_list =
{
	"special_grenades_box.xml",
	"grenade_box.xml",
	"throwable_weapons_box.xml"
}
]]
general_boxes_list =
{
	"first_aid_box.xml",
}

tiered_chests_list =
{
	"chest_armory_regular.xml",
	"chest_armory_exquisite.xml",
	"chest_armory_special.xml",
	"chest_armory_rare.xml",
	"chest_armory_legendary.xml",
	"chest_armory_epic.xml",
	"chest_armory_exotic.xml",
	"chest_armory_trinkets.xml",
	"chest_armory_miniboss.xml",
	"safe.xml",
}

-- Tiered chests handlers
function getTieredChestsCount()
	local count = 0
	for i,element in pairs(tiered_chests_list) do
		count = count + 1
	end
	return count
end

function getRandomTieredChest()

	-- Sets random seed
	local players = EntityGetWithTag("player_unit")
	local x, y = EntityGetTransform(players[1])
	SetRandomSeed( GameGetFrameNum(), x + y + players[1] + math.random(1,50))
	
	-- returns the file name for a random trap
	return tiered_chests_list[Random(1,getTieredChestsCount())]
	
end

function getTieredChestByBiome(biomeName, x, y) -- returns a tiered chest according to the biome provided, x and y coordinates are provided for the random seed used internally
	SetRandomSeed(x, y)
	biome_odds = Random(1,3) -- this is used to control the odds of a better tiered chest spawning in detriment of a lower tier one
	
	if(biomeName == "$biome_coalmine") then -- Mines
	
		if(biome_odds == 1) then
			return "chest_armory_regular.xml"
		else
			return "chest_armory_exquisite.xml"
		end
		
	elseif(biomeName == "$biome_coalmine_alt") then -- Collapsed Mines 
	
		return "chest_armory_exquisite.xml"
		
	elseif(biomeName == "$biome_excavationsite") then -- Coal Mines
	
		if(biome_odds == 1) then
			return "chest_armory_exquisite.xml"
		else
			return "chest_armory_special.xml"
		end
	
	elseif(biomeName == "$biome_fungicave") then -- Fungal Caverns
		
		if(biome_odds == 1) then
			return "chest_armory_rare.xml"
		elseif(biome_odds == 2) then
			return "chest_armory_legendary.xml"
		elseif(biome_odds == 3) then
			return "chest_armory_epic.xml"
		end
	
	elseif(biomeName == "$biome_snowcave") then -- Snowy Depths
	
		if(biome_odds == 1) then
			return "chest_armory_special.xml"
		else
			return "chest_armory_rare.xml"
		end
	
	elseif(biomeName == "$biome_snowcastle") then -- Hiisi Base
		if(biome_odds == 1) then
			return "chest_armory_rare.xml"
		else
			return "chest_armory_legendary.xml"
		end	
	
	elseif(biomeName == "$biome_rainforest") then -- Underground Jungle
	
		if(biome_odds == 1) then
			return "chest_armory_legendary.xml"
		else
			return "chest_armory_epic.xml"
		end	
		
	elseif(biomeName == "$biome_vault") then -- The Vault
	
		return "chest_armory_epic.xml" 
		
	elseif(biomeName == "$biome_wandcave") then -- Magical Temple
	
		if(biome_odds == 1) then
			return "chest_armory_rare.xml"
		elseif(biome_odds == 2) then
			return "chest_armory_legendary.xml"
		elseif(biome_odds == 3) then
			return "chest_armory_epic.xml"
		end
	
	elseif(biomeName == "$biome_crypt") then -- Temple of the Art
	
		if(biome_odds == 1) then
			return "chest_armory_rare.xml"
		elseif(biome_odds == 2) then
			return "chest_armory_legendary.xml"
		elseif(biome_odds == 3) then
			return "chest_armory_epic.xml"
		end
	
	elseif(biomeName == "$biome_pyramid") then -- Pyramid
	
		if(biome_odds == 1) then
			return "chest_armory_rare.xml"
		elseif(biome_odds == 2) then
			return "chest_armory_legendary.xml"
		elseif(biome_odds == 3) then
			return "chest_armory_epic.xml"
		end
	
	end
end

-- General boxes handlers
function getGeneralBoxesCount()
	local count = 0
	for i,element in pairs(general_boxes_list) do
		count = count + 1
	end
	return count
end

function getRandomGeneralBox()

	-- Sets random seed
	local players = EntityGetWithTag("player_unit")
	local x, y = EntityGetTransform(players[1])
	SetRandomSeed( GameGetFrameNum(), x + y + players[1] + math.random(1,50))
	
	-- returns the file name for a random trap
	return general_boxes_list[Random(1,getGeneralBoxesCount())]
	
end

-- Ammo boxes handlers
function getAmmoBoxesCount()
	local count = 0
	for i,element in pairs(ammo_boxes_list) do
		count = count + 1
	end
	return count
end

function getRandomAmmoBox()

	-- Sets random seed
	local players = EntityGetWithTag("player_unit")
	local x, y = EntityGetTransform(players[1])
	SetRandomSeed( GameGetFrameNum(), x + y + players[1] + math.random(1,50))
	
	-- returns the file name for a random trap
	return ammo_boxes_list[Random(1,getAmmoBoxesCount())]
	
end

-- Throwables boxes handlers
--[[
function getThrowableBoxesCount()
	local count = 0
	for i,element in pairs(throwables_boxes_list) do
		count = count + 1
	end
	return count
end

function getRandomThrowableBox()

	-- Sets random seed
	local players = EntityGetWithTag("player_unit")
	local x, y = EntityGetTransform(players[1])
	SetRandomSeed( GameGetFrameNum(), x + y + players[1] + math.random(1,50))
	
	-- returns the file name for a random trap
	return throwables_boxes_list[Random(1,getThrowableBoxesCount())]
end
]]

function getContainersBaseDir()
	return "data/entities/items/pickup/"
end