-- this file controls everything related to throwable physics items, such as frag grenades and throwable melee weapons

throwables_list =
{
	-- melee throwables
	{	
		name			= "kunai",
		ui_name			= "Kunai",
		category		= "melee",
		sub_category	= "slice"
	},
	{	
		name			= "sai",
		ui_name			= "Sai",
		category		= "melee",
		sub_category	= "slice"
	},
	{	
		name			= "short_mace",
		ui_name			= "Short Mace",
		category		= "melee",
		sub_category	= "melee"
	},
	{	
		name			= "kitchen_knife",
		ui_name			= "Kitcheb Knife",
		category		= "melee",
		sub_category	= "slice"
	},
	{	
		name			= "ninja_star",
		ui_name			= "Ninja Star",
		category		= "melee",
		sub_category	= "slice"
	},
	{	
		name			= "hatchet",
		ui_name			= "Hatchet",
		category		= "melee",
		sub_category	= "slice"
	},
	
	-- breakable throwables
	
	{	
		name			= "milk_bottle",
		ui_name			= "Milk Bottle",
		category		= "breakable",
		sub_category	= "healing"
	},
	{	
		name			= "molotov",
		ui_name			= "Molotov",
		category		= "breakable",
		sub_category	= "grenade_special"
	},
	{	
		name			= "nitroglycerin_testtube",
		ui_name			= "Nitroglycerin Test Tube",
		category		= "breakable",
		sub_category	= "grenade_special"
	},
	{	
		name			= "agitated_neutron_mass_testtube",
		ui_name			= "Agitated Neutro Mass Test Tube",
		category		= "breakable",
		sub_category	= "grenade_special"
	},
	{	
		name			= "anti_polymorphine_testtube",
		ui_name			= "Anti-Polymorphine Test Tube",
		category		= "breakable",
		sub_category	= "grenade_special"
	},
	{	
		name			= "overheated_acid_testtube",
		ui_name			= "Overheated Acid Test Tube",
		category		= "breakable",
		sub_category	= "grenade_special"
	},
	{	
		name			= "explosium_testtube",
		ui_name			= "Explosium Test Tube",
		category		= "breakable",
		sub_category	= "grenade_special"
	},
	{	
		name			= "liquid_nitrogen_testtube",
		ui_name			= "Liquid Nitrogen Test Tube",
		category		= "breakable",
		sub_category	= "grenade_special"
	},
	{	
		name			= "anticoagulant_testtube",
		ui_name			= "Anticoagulant Test Tube",
		category		= "breakable",
		sub_category	= "grenade_special"
	},
	{	
		name			= "concentrated_spitium_testtube",
		ui_name			= "Concentrated Spitium Test Tube",
		category		= "breakable",
		sub_category	= "grenade_special"
	},
	{	
		name			= "spitium_testtube",
		ui_name			= "Spitium Test Tube",
		category		= "breakable",
		sub_category	= "grenade_special"
	},
	{	
		name			= "electricium_testtube",
		ui_name			= "Electricium Test Tube",
		category		= "breakable",
		sub_category	= "grenade_special"
	},
	{	
		name			= "spitium_testtube",
		ui_name			= "Spitium Test Tube",
		category		= "breakable",
		sub_category	= "grenade_special"
	},
	{	
		name			= "frogium_testtube",
		ui_name			= "Frogium Test Tube",
		category		= "breakable",
		sub_category	= "grenade_special"
	},
	{	
		name			= "ferrofluid_testtube",
		ui_name			= "Ferrofluid Test Tube",
		category		= "breakable",
		sub_category	= "grenade_special"
	},
	{	
		name			= "gravitium_testtube",
		ui_name			= "Gravitium Test Tube",
		category		= "breakable",
		sub_category	= "grenade_special"
	},
	{	
		name			= "slapium_testtube",
		ui_name			= "Slapium Test Tube",
		category		= "breakable",
		sub_category	= "grenade_special"
	},
	{	
		name			= "tritium_testtube",
		ui_name			= "Tritium Test Tube",
		category		= "breakable",
		sub_category	= "grenade_special"
	},
	
	
	-- grenade throwables
	
	{	
		name			= "hand_grenade",
		ui_name			= "Hand Grenade",
		category		= "grenade",
		sub_category	= "grenade_regular"
	},
	{	
		name			= "handgranate_43",
		ui_name			= "Handgranate 43",
		category		= "grenade",
		sub_category	= "grenade_regular"
	},
	{	
		name			= "frag_grenade",
		ui_name			= "Fragmentation Grenade",
		category		= "grenade",
		sub_category	= "grenade_regular"
	},
	{	
		name			= "cluster_grenade",
		ui_name			= "Cluster Grenade",
		category		= "grenade",
		sub_category	= "grenade_special"
	},
	{	
		name			= "gas_grenade",
		ui_name			= "Gas Grenade",
		category		= "grenade",
		sub_category	= "grenade_special"
	},
	{	
		name			= "concentrated_poison_gas_grenade",
		ui_name			= "Concentrated Poison Gas Grenade",
		category		= "grenade",
		sub_category	= "grenade_special"
	},
}

-- returns element from throwables_list that matches provided itemName
function getThrowableItem(itemName)
	local foundThrowable = nil
	for i,throwable in ipairs(throwables_list) do
		if(throwable.name == itemName) then
			foundThrowable = throwable
			break
		end
	end
	return foundThrowable
end

-- returns a random throwable item based on the category and sub_category
-- category is required, sub_category can be omitted with an empty string
function getRandomThrowableItem(category, sub_category)

	-- Sets random seed
	local players = EntityGetWithTag("player_unit")
	local x, y = EntityGetTransform(players[1])
	SetRandomSeed( GameGetFrameNum(), x + y + players[1] + math.random(1,50))
	
	local eligible_item_count = 0
	
	local eligible_items = {}
	for i,item in ipairs(throwables_list) do
		if(sub_category ~= "") then
			if(item.category == category and item.sub_category == sub_category) then
				table.insert(eligible_items, item)
			end
		else
			if(item.category == category) then
				table.insert(eligible_items, item)
			end
		end
		
	end
	
	for i,element in ipairs(eligible_items) do
		eligible_item_count = eligible_item_count + 1
	end
	
	return eligible_items[Random(1, eligible_item_count)]
end

-- returns a random throwable item based on the sub_category provided
function getRandomThrowableItemBySubCategory(sub_category)

	-- Sets random seed
	local players = EntityGetWithTag("player_unit")
	local x, y = EntityGetTransform(players[1])
	SetRandomSeed( GameGetFrameNum(), x + y + players[1] + math.random(1,50))
	
	local eligible_item_count = 0
	
	local eligible_items = {}
	for i,item in ipairs(throwables_list) do
		if(item.sub_category == sub_category) then
			table.insert(eligible_items, item)
		end
	end
	
	for i,element in ipairs(eligible_items) do
		eligible_item_count = eligible_item_count + 1
	end
	
	return eligible_items[Random(1, eligible_item_count)]
end


-- Utility function to return base dir for commmon entities used in this script
function getThrowablesBaseDir()
	return "data/entities/items/pickup/"
end