dofile_once("mods/TheArmory/files/containers_list.lua")

spawn_points_list = 
{
	-- main platform middle
	platform_middle_center = {x = -1535, y = -1019},
	platform_middle_left = {x = -1583, y = -1019},
	platform_middle_right = {x = -1488, y = -1019},
	ground_middle = {x = -1535, y = -888},
	
	-- right side platforms
	platform_right_upper = {x = -1393, y = -1068},
	platform_right_lower = {x = -1393, y = -956},
	ground_right = {x = -1393, y = -880},
	
	-- left side platforms
	platform_left_upper = {x = -1677, y = -1073},
	platform_left_lower = {x = -1675, y = -963},
	ground_left = {x = -1675, y = -885},
	
	-- portal locations
	portal_entry = {x = -1783, y = -1089},
	portal_exit = {x = -1315, y = -1083}
	--portal_exit = {x = -1315, y = -883}
}

-- entity control variables
entityId_platform_middle_center = 0
entityId_platform_middle_left = 0
entityId_platform_middle_right = 0
entityId_ground_middle = 0

entityId_platform_right_upper = 0
entityId_platform_right_lower = 0
entityId_ground_right = 0

entityId_platform_left_upper = 0
entityId_platform_left_lower = 0
entityId_ground_left = 0

-- portal entities
exit_portal_id = 0

function getPlatformMiddleCenterCoordinates()
	return spawn_points_list.platform_middle_center.x, spawn_points_list.platform_middle_center.y
end
function getPlatformMiddleLeftCoordinates()
	return spawn_points_list.platform_middle_left.x, spawn_points_list.platform_middle_left.y
end
function getPlatformMiddleRightCoordinates()
	return spawn_points_list.platform_middle_right.x, spawn_points_list.platform_middle_right.y
end
function getGroundMiddleCoordinates()
	return spawn_points_list.ground_middle.x, spawn_points_list.ground_middle.y
end
function getPlatformRightUpperCoordinates()
	return spawn_points_list.platform_right_upper.x, spawn_points_list.platform_right_upper.y
end
function getPlatformRightLowerCoordinates()
	return spawn_points_list.platform_right_lower.x, spawn_points_list.platform_right_lower.y
end
function getGroundRightCoordinates()
	return spawn_points_list.ground_right.x, spawn_points_list.ground_right.y
end
function getPlatformLeftUpperCoordinates()
	return spawn_points_list.platform_left_upper.x, spawn_points_list.platform_left_upper.y
end
function getPlatformLeftLowerCoordinates()
	return spawn_points_list.platform_left_lower.x, spawn_points_list.platform_left_lower.y
end
function getGroundLeftCoordinates()
	return spawn_points_list.ground_left.x, spawn_points_list.ground_left.y
end

function getEntryPortalCoordinates()
	return spawn_points_list.portal_entry.x, spawn_points_list.portal_entry.y
end

function getExitPortalCoordinates()
	return spawn_points_list.portal_exit.x, spawn_points_list.portal_exit.y
end

-- spawns necessary assets on Miniboss Room layout
function buildMinibossLayout()
	entityId_platform_middle_center = EntityLoad("data/entities/items/pickup/miniboss_beacon.xml", getPlatformMiddleCenterCoordinates())
end

-- spawns necessary assets on Donation Room layout
function buildDonationLayout()
	entityId_platform_middle_center = EntityLoad("data/entities/items/pickup/justice_machine.xml", getPlatformMiddleCenterCoordinates())
	entityId_platform_middle_left = EntityLoad("data/entities/items/pickup/health_for_ammo_machine.xml", getPlatformMiddleLeftCoordinates())
	entityId_platform_middle_right = EntityLoad("data/entities/items/pickup/blood_machine_gold.xml", getPlatformMiddleRightCoordinates())

	entityId_platform_right_upper = EntityLoad("data/entities/items/pickup/blood_machine_gun.xml", getPlatformRightUpperCoordinates())
	entityId_platform_right_lower = EntityLoad("data/entities/items/pickup/blood_machine_keys.xml", getPlatformRightLowerCoordinates())
	entityId_ground_right = EntityLoad("data/entities/items/pickup/blood_machine_ammo.xml", getGroundRightCoordinates())

	entityId_platform_left_upper = EntityLoad("data/entities/items/pickup/health_for_gold_machine.xml", getPlatformLeftUpperCoordinates())
	entityId_platform_left_lower = EntityLoad("data/entities/items/pickup/health_for_gun_machine.xml", getPlatformLeftLowerCoordinates())
	entityId_ground_left = EntityLoad("data/entities/items/pickup/health_for_keys_machine.xml", getGroundLeftCoordinates())
end

-- spawns necessary assets on Chest Room layout
function buildChestLayout(biome, x, y)
	SetRandomSeed( x, y )
	entityId_platform_middle_center = EntityLoad( getContainersBaseDir() .. getTieredChestByBiome(biome, x + Random(-50,50), y + Random(-50,50)), getPlatformMiddleCenterCoordinates())
	entityId_platform_middle_left = EntityLoad( getContainersBaseDir() .. getTieredChestByBiome(biome, x + Random(-50,50), y + Random(-50,50)), getPlatformMiddleLeftCoordinates())
	entityId_platform_middle_right = EntityLoad( getContainersBaseDir() .. getTieredChestByBiome(biome, x + Random(-50,50), y + Random(-50,50)), getPlatformMiddleRightCoordinates())
end

-- spawns necessary assets on Gambling Room layout
function buildGamblingLayout(x, y)
	SetRandomSeed( x, y )
	local extraContainerChanceLeft = Random (1,5)
	local extraContainerChanceRight = Random (1,5)
	
	entityId_platform_middle_center = EntityLoad("data/entities/items/pickup/slot_machine.xml", getPlatformMiddleCenterCoordinates())

	if(extraContainerChanceLeft == 1) then
		entityId_platform_middle_left = EntityLoad( "data/entities/items/pickup/chest_armory_exotic.xml", getPlatformMiddleLeftCoordinates())
	elseif(extraContainerChanceLeft == 2) then
		entityId_platform_middle_left = EntityLoad( "data/entities/items/pickup/chest_armory_trinkets.xml", getPlatformMiddleLeftCoordinates())
	elseif(extraContainerChanceLeft == 3) then
		entityId_platform_middle_left = EntityLoad( "data/entities/items/pickup/safe.xml", getPlatformMiddleLeftCoordinates())
	elseif(extraContainerChanceLeft == 4) then
		entityId_platform_middle_left = EntityLoad( "data/entities/items/pickup/chest_armory_miniboss.xml", getPlatformMiddleLeftCoordinates())
	elseif(extraContainerChanceLeft == 5) then
		local rainbowChestChance = Random(1,5)
		if(rainbowChestChance == 1) then
			entityId_platform_middle_left = EntityLoad( "data/entities/items/pickup/chest_armory_rainbow.xml", getPlatformMiddleLeftCoordinates())
		end
	end
	
	if(extraContainerChanceRight == 1) then
		entityId_platform_middle_right = EntityLoad( "data/entities/items/pickup/chest_armory_exotic.xml", getPlatformMiddleRightCoordinates())
	elseif(extraContainerChanceRight == 2) then
		entityId_platform_middle_right = EntityLoad( "data/entities/items/pickup/chest_armory_trinkets.xml", getPlatformMiddleRightCoordinates())
	elseif(extraContainerChanceRight == 3) then
		entityId_platform_middle_right = EntityLoad( "data/entities/items/pickup/safe.xml", getPlatformMiddleRightCoordinates())
	elseif(extraContainerChanceRight == 4) then
		entityId_platform_middle_right = EntityLoad( "data/entities/items/pickup/chest_armory_miniboss.xml", getPlatformMiddleRightCoordinates())
	elseif(extraContainerChanceRight == 5) then
		local rainbowChestChance = Random(1,5)
		if(rainbowChestChance == 1) then
			entityId_platform_middle_right = EntityLoad( "data/entities/items/pickup/chest_armory_rainbow.xml", getPlatformMiddleRightCoordinates())
		end
	end
end

-- spawns necessary assets on Ammo Box Room layout
function buildAmmoBoxLayout(x, y)
	SetRandomSeed( x, y )
	
	local spawnChance = Random(1,3)
	if(spawnChance == 1) then
		entityId_platform_middle_center = EntityLoad( getContainersBaseDir() .. getRandomGeneralBox(), getPlatformMiddleCenterCoordinates())
	elseif(spawnChance == 2 or spawnChance == 3) then
		entityId_platform_middle_center = EntityLoad( getContainersBaseDir() .. getRandomAmmoBox(), getPlatformMiddleCenterCoordinates())
	end
	
	spawnChance = Random(1,3)
	if(spawnChance == 1) then
		entityId_platform_middle_left = EntityLoad( getContainersBaseDir() .. getRandomGeneralBox(), getPlatformMiddleLeftCoordinates())
	elseif(spawnChance == 2 or spawnChance == 3) then
		entityId_platform_middle_left = EntityLoad( getContainersBaseDir() .. getRandomAmmoBox(), getPlatformMiddleLeftCoordinates())
	end
	
	spawnChance = Random(1,3)
	if(spawnChance == 1) then
		entityId_platform_middle_right = EntityLoad( getContainersBaseDir() .. getRandomGeneralBox(), getPlatformMiddleRightCoordinates())
	elseif(spawnChance == 2 or spawnChance == 3) then
		entityId_platform_middle_right = EntityLoad( getContainersBaseDir() .. getRandomAmmoBox(), getPlatformMiddleRightCoordinates())
	end
	
	spawnChance = Random(1,3)
	if(spawnChance == 1) then
		entityId_platform_right_upper = EntityLoad( getContainersBaseDir() .. getRandomGeneralBox(), getPlatformRightUpperCoordinates())
	elseif(spawnChance == 2 or spawnChance == 3) then
		entityId_platform_right_upper = EntityLoad( getContainersBaseDir() .. getRandomAmmoBox(), getPlatformRightUpperCoordinates())
	end
	
	spawnChance = Random(1,3)
	if(spawnChance == 1) then
		entityId_platform_right_lower = EntityLoad( getContainersBaseDir() .. getRandomGeneralBox(), getPlatformRightLowerCoordinates())
	elseif(spawnChance == 2 or spawnChance == 3) then
		entityId_platform_right_lower = EntityLoad( getContainersBaseDir() .. getRandomAmmoBox(), getPlatformRightLowerCoordinates())
	end
	
	spawnChance = Random(1,3)
	if(spawnChance == 1) then
		entityId_platform_left_upper = EntityLoad( getContainersBaseDir() .. getRandomGeneralBox(), getPlatformLeftUpperCoordinates())
	elseif(spawnChance == 2 or spawnChance == 3) then
		entityId_platform_left_upper = EntityLoad( getContainersBaseDir() .. getRandomAmmoBox(), getPlatformLeftUpperCoordinates())
	end
	
	spawnChance = Random(1,3)
	if(spawnChance == 1) then
		entityId_platform_left_lower = EntityLoad( getContainersBaseDir() .. getRandomGeneralBox(), getPlatformLeftLowerCoordinates())
	elseif(spawnChance == 2 or spawnChance == 3) then
		entityId_platform_left_lower = EntityLoad( getContainersBaseDir() .. getRandomAmmoBox(), getPlatformLeftLowerCoordinates())
	end

end

-- spawns necessary assets on Chest Room layout
function buildStoreLayout()
	entityId_platform_middle_center = EntityLoad("data/entities/items/pickup/vending_machine.xml", getPlatformMiddleCenterCoordinates())
	entityId_platform_middle_left = EntityLoad("data/entities/items/pickup/ammo_vending_machine.xml", getPlatformMiddleLeftCoordinates())
	entityId_platform_middle_right = EntityLoad("data/entities/items/pickup/medical_supplies_vending_machine.xml", getPlatformMiddleRightCoordinates())
end

function buildCraftingLayout(x, y)
	SetRandomSeed( x, y )

	local craftingStationChance = Random(1,3)
	if(craftingStationChance == 1) then
		entityId_platform_middle_center = EntityLoad( "data/entities/props/gun_workshop.xml", getPlatformMiddleCenterCoordinates())
	elseif(craftingStationChance == 2) then
		entityId_platform_middle_center = EntityLoad( "data/entities/props/ammo_workshop.xml", getPlatformMiddleCenterCoordinates())
	elseif(craftingStationChance == 3) then
		entityId_platform_middle_center = EntityLoad( "data/entities/props/trinket_workshop.xml", getPlatformMiddleCenterCoordinates())
	end
	
	local middle_x, middle_y = getPlatformMiddleCenterCoordinates()
	EntityLoad( "data/entities/items/crowbar.xml", middle_x + 20, middle_y)
	
	entityId_platform_middle_left = EntityLoad("data/entities/props/supply_box.xml", getPlatformMiddleLeftCoordinates())
	entityId_platform_middle_right = EntityLoad("data/entities/props/supply_box.xml", getPlatformMiddleRightCoordinates())
	entityId_platform_right_upper = EntityLoad("data/entities/props/supply_box.xml", getPlatformRightUpperCoordinates())
	entityId_platform_right_lower = EntityLoad("data/entities/props/supply_box.xml", getPlatformRightLowerCoordinates())
	entityId_platform_left_upper = EntityLoad("data/entities/props/supply_box.xml", getPlatformLeftUpperCoordinates())
	entityId_platform_left_lower = EntityLoad("data/entities/props/supply_box.xml", getPlatformLeftLowerCoordinates())

end

function buildOreLayout(x, y)
	SetRandomSeed( x, y )

	entityId_platform_middle_center = EntityLoad( "data/entities/items/pickup/furnace.xml", getPlatformMiddleCenterCoordinates())

	local middle_x, middle_y = getPlatformMiddleCenterCoordinates()
	EntityLoad( "data/entities/items/pickaxe.xml", middle_x + 20, middle_y)
	
	local oreStoneChance = Random(1,8)
	if(oreStoneChance == 1) then
		entityId_platform_middle_left = EntityLoad( "data/entities/props/stone_iron.xml", getPlatformMiddleLeftCoordinates())
	elseif(oreStoneChance == 2) then
		entityId_platform_middle_left = EntityLoad( "data/entities/props/stone_copper.xml", getPlatformMiddleLeftCoordinates())
	elseif(oreStoneChance == 3) then
		entityId_platform_middle_left = EntityLoad( "data/entities/props/stone_gold.xml", getPlatformMiddleLeftCoordinates())
	elseif(oreStoneChance == 4) then
		entityId_platform_middle_left = EntityLoad( "data/entities/props/stone_jade.xml", getPlatformMiddleLeftCoordinates())
	elseif(oreStoneChance == 5) then
		entityId_platform_middle_left = EntityLoad( "data/entities/props/stone_amethyst.xml", getPlatformMiddleLeftCoordinates())
	elseif(oreStoneChance == 6) then
		entityId_platform_middle_left = EntityLoad( "data/entities/props/stone_diamond.xml", getPlatformMiddleLeftCoordinates())
	elseif(oreStoneChance == 7) then
		entityId_platform_middle_left = EntityLoad( "data/entities/props/stone_ruby.xml", getPlatformMiddleLeftCoordinates())
	elseif(oreStoneChance == 8) then
		entityId_platform_middle_left = EntityLoad( "data/entities/props/stone_purple_fluorite.xml", getPlatformMiddleLeftCoordinates())
	end
	
	oreStoneChance = Random(1,8)
	if(oreStoneChance == 1) then
		entityId_platform_middle_right = EntityLoad( "data/entities/props/stone_iron.xml", getPlatformMiddleRightCoordinates())
	elseif(oreStoneChance == 2) then
		entityId_platform_middle_right = EntityLoad( "data/entities/props/stone_copper.xml", getPlatformMiddleRightCoordinates())
	elseif(oreStoneChance == 3) then
		entityId_platform_middle_right = EntityLoad( "data/entities/props/stone_gold.xml", getPlatformMiddleRightCoordinates())
	elseif(oreStoneChance == 4) then
		entityId_platform_middle_right = EntityLoad( "data/entities/props/stone_jade.xml", getPlatformMiddleRightCoordinates())
	elseif(oreStoneChance == 5) then
		entityId_platform_middle_right = EntityLoad( "data/entities/props/stone_amethyst.xml", getPlatformMiddleRightCoordinates())
	elseif(oreStoneChance == 6) then
		entityId_platform_middle_right = EntityLoad( "data/entities/props/stone_diamond.xml", getPlatformMiddleRightCoordinates())
	elseif(oreStoneChance == 7) then
		entityId_platform_middle_right = EntityLoad( "data/entities/props/stone_ruby.xml", getPlatformMiddleRightCoordinates())
	elseif(oreStoneChance == 8) then
		entityId_platform_middle_right = EntityLoad( "data/entities/props/stone_purple_fluorite.xml", getPlatformMiddleRightCoordinates())
	end
	
	oreStoneChance = Random(1,8)
	if(oreStoneChance == 1) then
		entityId_platform_right_upper = EntityLoad( "data/entities/props/stone_iron.xml", getPlatformRightUpperCoordinates())
	elseif(oreStoneChance == 2) then
		entityId_platform_right_upper = EntityLoad( "data/entities/props/stone_copper.xml", getPlatformRightUpperCoordinates())
	elseif(oreStoneChance == 3) then
		entityId_platform_right_upper = EntityLoad( "data/entities/props/stone_gold.xml", getPlatformRightUpperCoordinates())
	elseif(oreStoneChance == 4) then
		entityId_platform_right_upper = EntityLoad( "data/entities/props/stone_jade.xml", getPlatformRightUpperCoordinates())
	elseif(oreStoneChance == 5) then
		entityId_platform_right_upper = EntityLoad( "data/entities/props/stone_amethyst.xml", getPlatformRightUpperCoordinates())
	elseif(oreStoneChance == 6) then
		entityId_platform_right_upper = EntityLoad( "data/entities/props/stone_diamond.xml", getPlatformRightUpperCoordinates())
	elseif(oreStoneChance == 7) then
		entityId_platform_right_upper = EntityLoad( "data/entities/props/stone_ruby.xml", getPlatformRightUpperCoordinates())
	elseif(oreStoneChance == 8) then
		entityId_platform_right_upper = EntityLoad( "data/entities/props/stone_purple_fluorite.xml", getPlatformRightUpperCoordinates())
	end
	
	oreStoneChance = Random(1,8)
	if(oreStoneChance == 1) then
		entityId_platform_right_lower = EntityLoad( "data/entities/props/stone_iron.xml", getPlatformRightLowerCoordinates())
	elseif(oreStoneChance == 2) then
		entityId_platform_right_lower = EntityLoad( "data/entities/props/stone_copper.xml", getPlatformRightLowerCoordinates())
	elseif(oreStoneChance == 3) then
		entityId_platform_right_lower = EntityLoad( "data/entities/props/stone_gold.xml", getPlatformRightLowerCoordinates())
	elseif(oreStoneChance == 4) then
		entityId_platform_right_lower = EntityLoad( "data/entities/props/stone_jade.xml", getPlatformRightLowerCoordinates())
	elseif(oreStoneChance == 5) then
		entityId_platform_right_lower = EntityLoad( "data/entities/props/stone_amethyst.xml", getPlatformRightLowerCoordinates())
	elseif(oreStoneChance == 6) then
		entityId_platform_right_lower = EntityLoad( "data/entities/props/stone_diamond.xml", getPlatformRightLowerCoordinates())
	elseif(oreStoneChance == 7) then
		entityId_platform_right_lower = EntityLoad( "data/entities/props/stone_ruby.xml", getPlatformRightLowerCoordinates())
	elseif(oreStoneChance == 8) then
		entityId_platform_right_lower = EntityLoad( "data/entities/props/stone_purple_fluorite.xml", getPlatformRightLowerCoordinates())
	end
	
	oreStoneChance = Random(1,8)
	if(oreStoneChance == 1) then
		entityId_platform_left_upper = EntityLoad( "data/entities/props/stone_iron.xml", getPlatformLeftUpperCoordinates())
	elseif(oreStoneChance == 2) then
		entityId_platform_left_upper = EntityLoad( "data/entities/props/stone_copper.xml", getPlatformLeftUpperCoordinates())
	elseif(oreStoneChance == 3) then
		entityId_platform_left_upper = EntityLoad( "data/entities/props/stone_gold.xml", getPlatformLeftUpperCoordinates())
	elseif(oreStoneChance == 4) then
		entityId_platform_left_upper = EntityLoad( "data/entities/props/stone_jade.xml", getPlatformLeftUpperCoordinates())
	elseif(oreStoneChance == 5) then
		entityId_platform_left_upper = EntityLoad( "data/entities/props/stone_amethyst.xml", getPlatformLeftUpperCoordinates())
	elseif(oreStoneChance == 6) then
		entityId_platform_left_upper = EntityLoad( "data/entities/props/stone_diamond.xml", getPlatformLeftUpperCoordinates())
	elseif(oreStoneChance == 7) then
		entityId_platform_left_upper = EntityLoad( "data/entities/props/stone_ruby.xml", getPlatformLeftUpperCoordinates())
	elseif(oreStoneChance == 8) then
		entityId_platform_left_upper = EntityLoad( "data/entities/props/stone_purple_fluorite.xml", getPlatformLeftUpperCoordinates())
	end
	
	oreStoneChance = Random(1,8)
	if(oreStoneChance == 1) then
		entityId_platform_left_lower = EntityLoad( "data/entities/props/stone_iron.xml", getPlatformLeftLowerCoordinates())
	elseif(oreStoneChance == 2) then
		entityId_platform_left_lower = EntityLoad( "data/entities/props/stone_copper.xml", getPlatformLeftLowerCoordinates())
	elseif(oreStoneChance == 3) then
		entityId_platform_left_lower = EntityLoad( "data/entities/props/stone_gold.xml", getPlatformLeftLowerCoordinates())
	elseif(oreStoneChance == 4) then
		entityId_platform_left_lower = EntityLoad( "data/entities/props/stone_jade.xml", getPlatformLeftLowerCoordinates())
	elseif(oreStoneChance == 5) then
		entityId_platform_left_lower = EntityLoad( "data/entities/props/stone_amethyst.xml", getPlatformLeftLowerCoordinates())
	elseif(oreStoneChance == 6) then
		entityId_platform_left_lower = EntityLoad( "data/entities/props/stone_diamond.xml", getPlatformLeftLowerCoordinates())
	elseif(oreStoneChance == 7) then
		entityId_platform_left_lower = EntityLoad( "data/entities/props/stone_ruby.xml", getPlatformLeftLowerCoordinates())
	elseif(oreStoneChance == 8) then
		entityId_platform_left_lower = EntityLoad( "data/entities/props/stone_purple_fluorite.xml", getPlatformLeftLowerCoordinates())
	end

end

-- unloads all entities
function clearRoom()
	if(entityId_platform_middle_center ~= 0) then
		EntityKill(entityId_platform_middle_center)
	end
	if(entityId_platform_middle_left ~= 0) then
		EntityKill(entityId_platform_middle_left)
	end
	if(entityId_platform_middle_right ~= 0) then
		EntityKill(entityId_platform_middle_right)
	end
	if(entityId_ground_middle ~= 0) then
		EntityKill(entityId_ground_middle)
	end
	if(entityId_platform_right_upper ~= 0) then
		EntityKill(entityId_platform_right_upper)
	end
	if(entityId_platform_right_lower ~= 0) then
		EntityKill(entityId_platform_right_lower)
	end
	if(entityId_ground_right ~= 0) then
		EntityKill(entityId_ground_right)
	end
	if(entityId_platform_left_upper ~= 0) then
		EntityKill(entityId_platform_left_upper)
	end
	if(entityId_platform_left_lower ~= 0) then
		EntityKill(entityId_platform_left_lower)
	end
	if(entityId_ground_left ~= 0) then
		EntityKill(entityId_ground_left)
	end
end

function rebuildRoom()
	reloadRoom()
	removeMaterialsfromRoom()
end

function removeMaterialsfromRoom()
	EntityLoad("data/entities/room_cleaner.xml", getPlatformMiddleCenterCoordinates())
end

function reloadRoom()
	-- temporarily loads original pixel scene to clear the trash
	--LoadPixelScene( "data/biome_impl/spliced/tree/temp_0.png", "data/biome_impl/spliced/tree/temp_0_visual.png", -2016, -1324, "", true)
	--LoadPixelScene( "data/biome_impl/spliced/tree/temp_4.png", "data/biome_impl/spliced/tree/temp_4_visual.png", -1536, -1323, "", true)
	-- loads modified scenes again
	LoadPixelScene( "data/biome_impl/spliced/tree/0.png", "data/biome_impl/spliced/tree/0_visual.png", -2016, -1324, "", true)
	LoadPixelScene( "data/biome_impl/spliced/tree/4.png", "data/biome_impl/spliced/tree/4_visual.png", -1536, -1323, "", true)
end

-- creates the exit portal inside the room, with the target set according to destination_x and destination_y
function spawnRoomExitPortal(destination_x, destination_y)
	exit_portal_id = EntityLoad("data/entities/room_exit_portal.xml", getExitPortalCoordinates())

	local tc = EntityAddComponent2(exit_portal_id, "TeleportComponent", {
		target_x_is_absolute_position=true,
		target_y_is_absolute_position=true
	})
	ComponentSetValue2( tc, "target", destination_x, destination_y)

end

-- unloads exit portal
function killRoomExitPortal()
	if(exit_portal_id ~= 0) then
		EntityKill(exit_portal_id)
	end
end