-- this file controls everything related to small pickup items, such as ammo and healing items

-- full list of all small pickup items
-- name is the xml file name
-- ui_name is the name shown onscreen to the player
-- desc is an extended description of the item
-- has_value determines whether or not the item was a workable value, 1 for yes, 0 for no
-- base_value is the workable base value of this item, such as how much it heals for a healing item or how much ammo it yields for an ammo item
-- category describes what is the type of the item, i.e. healing, ammo, etc
-- related_variable is the name of the variable present on VariableStorageComponent of the player that should be updated when the item is collected
pickups_list =
{
	-- Healing items
	{
		name 				= "small_heart_overtime", -- only exception among healing items, it applies the REGENERATION status on the player instead of having a fixed base value for healing power
		ui_name				= "Overtime Heal Small Heart",
		desc				= "",
		has_value			= 0,
		base_value			= 0,
		category			= "healing",
		sub_category		= "overtime",
		related_variable 	= ""
	},
	{
		name 				= "small_heart",
		ui_name				= "Small Heart",
		desc				= "(+2 Health)",
		has_value			= 1,
		base_value			= 2,
		category			= "healing",
		sub_category		= "positive",
		related_variable 	= ""
	},
	{
		name 				= "small_heart_powerful",
		ui_name				= "Powerful Small Heart",
		desc				= "(+10 Health)",
		has_value			= 1,
		base_value			= 10,
		category			= "healing",
		sub_category		= "powerful",
		related_variable 	= ""
	},
	{
		name 				= "small_heart_poisonous",
		ui_name				= "Poisonous Small Heart",
		desc				= "(-10 Health)",
		has_value			= 1,
		base_value			= -10,
		category			= "healing",
		sub_category		= "negative",
		related_variable 	= ""
	},
	{
		name 				= "medium_heart",
		ui_name				= "Medium Heart",
		desc				= "(+12 Health)",
		has_value			= 1,
		base_value			= 12,
		category			= "healing",
		sub_category		= "positive",
		related_variable 	= ""
	},
	{
		name 				= "medium_heart_powerful",
		ui_name				= "Powerful Medium Heart",
		desc 				= "(+25 Health)",
		has_value			= 1,
		base_value			= 25,
		category			= "healing",
		sub_category		= "powerful",
		related_variable 	= ""
	},
	{
		name 				= "medium_heart_poisonous",
		ui_name				= "Poisonous Medium Heart",
		desc 				= "(-25 Health)",
		has_value			= 1,
		base_value			= -25,
		category			= "healing",
		sub_category		= "negative",
		related_variable 	= ""
	},
	
	-- Ammo items
	{
		name 				= "firearms_ammo_pack", -- only exception among ammo items, it gives many ammo types at once
		ui_name				= "Firearms Ammo Pack",
		desc 				= "",
		has_value			= 0,
		base_value			= 0,
		category			= "ammo",
		sub_category		= "bullet",
		related_variable 	= ""
	},
	{
		name 				= "bullet_pistol_ammo",
		ui_name				= "Pistol Ammo",
		desc 				= "(+10)",
		has_value			= 1,
		base_value			= 10,
		category			= "ammo",
		sub_category		= "bullet",
		related_variable 	= "pistol_ammo"
	},
	{
		name 				= "bullet_revolver_ammo",
		ui_name				= "Revolver Ammo",
		desc 				= "(+10)",
		has_value			= 1,
		base_value			= 10,
		category			= "ammo",
		sub_category		= "bullet",
		related_variable 	= "revolver_ammo"
	},
	{
		name 				= "bullet_smg_ammo",
		ui_name				= "SMG Ammo",
		desc 				= "(+15)",
		has_value			= 1,
		base_value			= 15,
		category			= "ammo",
		sub_category		= "bullet",
		related_variable 	= "smg_ammo"
	},
	{
		name 				= "bullet_shotgun_ammo",
		ui_name				= "Shotgun Shells",
		desc 				= "(+5)",
		has_value			= 1,
		base_value			= 5,
		category			= "ammo",
		sub_category		= "bullet",
		related_variable 	= "shotgun_ammo"
	},
	{
		name 				= "bullet_ar_rifle_ammo",
		ui_name				= "Assault Rifle Ammo",
		desc 				= "(+10)",
		has_value			= 1,
		base_value			= 10,
		category			= "ammo",
		sub_category		= "bullet",
		related_variable 	= "ar_rifle_ammo"
	},
	{
		name 				= "bullet_rifle_ammo",
		ui_name				= "Rifle Ammo",
		desc 				= "(+10)",
		has_value			= 1,
		base_value			= 10,
		category			= "ammo",
		sub_category		= "bullet",
		related_variable 	= "rifle_ammo"
	},
	{
		name 				= "energy_cell",
		ui_name				= "Energy Cells",
		desc 				= "(+5)",
		has_value			= 1,
		base_value			= 5,
		category			= "ammo",
		sub_category		= "special",
		related_variable 	= "energy_cells"
	},
	{
		name 				= "energy_core",
		ui_name				= "Energy Cells",
		desc 				= "(+15)",
		has_value			= 1,
		base_value			= 15,
		category			= "ammo",
		sub_category		= "special",
		related_variable 	= "energy_cells"
	},
	{
		name 				= "small_grenade_bundle",
		ui_name				= "Grenades",
		desc 				= "(+4)",
		has_value			= 1,
		base_value			= 4,
		category			= "ammo",
		sub_category		= "explosive",
		related_variable 	= "grenades_ammo"
	},
	{
		name 				= "grenade_bundle",
		ui_name				= "Grenades",
		desc 				= "(+8)",
		has_value			= 1,
		base_value			= 8,
		category			= "ammo",
		sub_category		= "explosive",
		related_variable 	= "grenades_ammo"
	},
	{
		name 				= "small_fluid_ammo",
		ui_name				= "Fluid Ammo",
		desc 				= "(+10)",
		has_value			= 1,
		base_value			= 10,
		category			= "ammo",
		sub_category		= "special",
		related_variable 	= "fluid_ammo"
	},
	{
		name 				= "fluid_ammo",
		ui_name				= "Fluid Ammo",
		desc 				= "(+20)",
		has_value			= 1,
		base_value			= 20,
		category			= "ammo",
		sub_category		= "special",
		related_variable 	= "fluid_ammo"
	},
	{
		name 				= "nails",
		ui_name				= "Nails",
		desc 				= "(+20)",
		has_value			= 1,
		base_value			= 20,
		category			= "ammo",
		sub_category		= "basic",
		related_variable 	= "nails_ammo"
	},
	{
		name 				= "mininuke",
		ui_name				= "Mininukes",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "ammo",
		sub_category		= "explosive",
		related_variable 	= "mininukes_ammo"
	},
	{
		name 				= "elemental_bullets_bundle",
		ui_name				= "Elemental Bullets Ammo",
		desc 				= "(+20)",
		has_value			= 1,
		base_value			= 20,
		category			= "ammo",
		sub_category		= "special",
		related_variable 	= "elementalbullets_ammo"
	},
	{
		name 				= "metal_stick_bundle",
		ui_name				= "Metal Sticks",
		desc 				= "(+15)",
		has_value			= 1,
		base_value			= 15,
		category			= "ammo",
		sub_category		= "basic",
		related_variable 	= "metalsticks_ammo"
	},
	{
		name 				= "knives_bundle",
		ui_name				= "Knives",
		desc 				= "(+15)",
		has_value			= 1,
		base_value			= 15,
		category			= "ammo",
		sub_category		= "basic",
		related_variable 	= "knives_ammo"
	},
	{
		name 				= "shovels_bundle",
		ui_name				= "Shovels",
		desc 				= "(+15)",
		has_value			= 1,
		base_value			= 15,
		category			= "ammo",
		sub_category		= "basic",
		related_variable 	= "shovels_ammo"
	},
	{
		name 				= "syringes_bundle",
		ui_name				= "Syringes",
		desc 				= "(+10)",
		has_value			= 1,
		base_value			= 10,
		category			= "ammo",
		sub_category		= "basic",
		related_variable 	= "syringes_ammo"
	},
	{
		name 				= "rocket_box",
		ui_name				= "Rockets",
		desc 				= "(+15)",
		has_value			= 1,
		base_value			= 15,
		category			= "ammo",
		sub_category		= "explosive",
		related_variable 	= "rockets_ammo"
	},
	{
		name 				= "trash",
		ui_name				= "Trash Ammo",
		desc 				= "(+10)",
		has_value			= 1,
		base_value			= 10,
		category			= "ammo",
		sub_category		= "basic",
		related_variable 	= "trash_ammo"
	},
	{
		name 				= "boltsquiver",
		ui_name				= "Crossbow Bolts",
		desc 				= "(+10)",
		has_value			= 1,
		base_value			= 10,
		category			= "ammo",
		sub_category		= "basic",
		related_variable 	= "crossbowbolts_ammo"
	},
	{
		name 				= "quiver",
		ui_name				= "Arrows",
		desc 				= "(+10)",
		has_value			= 1,
		base_value			= 10,
		category			= "ammo",
		sub_category		= "basic",
		related_variable 	= "arrows_ammo"
	},
	{
		name 				= "spearbundle",
		ui_name				= "Spears",
		desc 				= "(+10)",
		has_value			= 1,
		base_value			= 10,
		category			= "ammo",
		sub_category		= "basic",
		related_variable 	= "spears_ammo"
	},
	{
		name 				= "fuel_small",
		ui_name				= "Small Fuel Tank",
		desc 				= "(+50)",
		has_value			= 1,
		base_value			= 50,
		category			= "ammo",
		sub_category		= "special",
		related_variable 	= "fuel_ammo"
	},
	{
		name 				= "fuel_big",
		ui_name				= "Big Fuel Tank",
		desc 				= "(+150)",
		has_value			= 1,
		base_value			= 150,
		category			= "ammo",
		sub_category		= "special",
		related_variable 	= "fuel_ammo"
	},
	
	{
		name 				= "throwable_weapons_pack",
		ui_name				= "Throwable Weapons Pack",
		desc 				= "(+5)",
		has_value			= 1,
		base_value			= 5,
		category			= "ammo",
		sub_category		= "special",
		related_variable 	= "throwable_weapons_ammo"
	},
	{
		name 				= "throwable_explosives_pack",
		ui_name				= "Throwable Explosives Pack",
		desc 				= "(+5)",
		has_value			= 1,
		base_value			= 5,
		category			= "ammo",
		sub_category		= "special",
		related_variable 	= "throwable_explosives_ammo"
	},
	
	-- Utility items
	{
		name 				= "slot_machine_chip",
		ui_name				= "Slot Machine Chip",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "utility",
		sub_category		= "",
		related_variable 	= "slotmachinechips"
	},
	{
		name 				= "enemy_guts",
		ui_name				= "Enemy Guts",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "utility",
		sub_category		= "",
		related_variable 	= "enemyguts"
	},
	{
		name 				= "safe_key",
		ui_name				= "Safe Key",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "utility",
		sub_category		= "key",
		related_variable 	= "safekeys"
	},
	{
		name 				= "chest_key",
		ui_name				= "Chest Key",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "utility",
		sub_category		= "key",
		related_variable 	= "chestkeys"
	},
	{
		name 				= "miniboss_key",
		ui_name				= "Miniboss Key",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "miniboss_item",
		sub_category		= "key",
		related_variable 	= "minibosskeys"
	},
	{
		name 				= "crafting_parts_ammo",
		ui_name				= "Ammo Crafting Parts",
		desc 				= "(+10)",
		has_value			= 1,
		base_value			= 10,
		category			= "crafting",
		sub_category		= "ammo",
		related_variable 	= "crafting_parts_ammo"
	},
	{
		name 				= "crafting_parts_weapon",
		ui_name				= "Weapon Crafting Parts",
		desc 				= "(+10)",
		has_value			= 1,
		base_value			= 10,
		category			= "crafting",
		sub_category		= "weapon",
		related_variable 	= "crafting_parts_weapon"
	},
	{
		name 				= "crafting_parts_trinket",
		ui_name				= "Trinket Crafting Parts",
		desc 				= "(+10)",
		has_value			= 1,
		base_value			= 10,
		category			= "crafting",
		sub_category		= "trinket",
		related_variable 	= "crafting_parts_trinket"
	},
	{
		name 				= "ingot_amethyst",
		ui_name				= "Amethyst Ingot",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "crafting",
		sub_category		= "ingot",
		related_variable 	= "ingot_amethyst"
	},
	{
		name 				= "ingot_copper",
		ui_name				= "Copper Ingot",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "crafting",
		sub_category		= "ingot",
		related_variable 	= "ingot_copper"
	},
	{
		name 				= "ingot_diamond",
		ui_name				= "Diamond Ingot",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "crafting",
		sub_category		= "ingot",
		related_variable 	= "ingot_diamond"
	},
	{
		name 				= "ingot_gold",
		ui_name				= "Gold Ingot",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "crafting",
		sub_category		= "ingot",
		related_variable 	= "ingot_gold"
	},
	{
		name 				= "ingot_iron",
		ui_name				= "Iron Ingot",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "crafting",
		sub_category		= "ingot",
		related_variable 	= "ingot_iron"
	},
	{
		name 				= "ingot_jade",
		ui_name				= "Jade Ingot",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "crafting",
		sub_category		= "ingot",
		related_variable 	= "ingot_jade"
	},
	{
		name 				= "ingot_purple_fluorite",
		ui_name				= "Purple Fluorite Ingot",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "crafting",
		sub_category		= "ingot",
		related_variable 	= "ingot_purple_fluorite"
	},
	{
		name 				= "ingot_ruby",
		ui_name				= "Ruby Ingot",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "crafting",
		sub_category		= "ingot",
		related_variable 	= "ingot_ruby"
	},
	{
		name 				= "ore_amethyst",
		ui_name				= "Amethyst Ore",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "crafting",
		sub_category		= "ore",
		related_variable 	= "ore_amethyst"
	},
	{
		name 				= "ore_copper",
		ui_name				= "Copper Ore",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "crafting",
		sub_category		= "ore",
		related_variable 	= "ore_copper"
	},
	{
		name 				= "ore_diamond",
		ui_name				= "Diamond Ore",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "crafting",
		sub_category		= "ore",
		related_variable 	= "ore_diamond"
	},
	{
		name 				= "ore_gold",
		ui_name				= "Gold Ore",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "crafting",
		sub_category		= "ore",
		related_variable 	= "ore_gold"
	},
	{
		name 				= "ore_iron",
		ui_name				= "Iron Ore",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "crafting",
		sub_category		= "ore",
		related_variable 	= "ore_iron"
	},
	{
		name 				= "ore_jade",
		ui_name				= "Jade Ore",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "crafting",
		sub_category		= "ore",
		related_variable 	= "ore_jade"
	},
	{
		name 				= "ore_purple_fluorite",
		ui_name				= "Purple Fluorite Ore",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "crafting",
		sub_category		= "ore",
		related_variable 	= "ore_purple_fluorite"
	},
	{
		name 				= "ore_ruby",
		ui_name				= "Ruby Ore",
		desc 				= "(+1)",
		has_value			= 1,
		base_value			= 1,
		category			= "crafting",
		sub_category		= "ore",
		related_variable 	= "ore_ruby"
	},
	{
		name 				= "room_portal_spawner_ammo_box",
		ui_name				= "Ammo Box Room Portal Spawner",
		desc 				= "",
		has_value			= 0,
		base_value			= 0,
		category			= "one_time_use",
		sub_category		= "portal_spawner",
		related_variable 	= ""
	},
	{
		name 				= "room_portal_spawner_chest",
		ui_name				= "Chest Room Portal Spawner",
		desc 				= "",
		has_value			= 0,
		base_value			= 0,
		category			= "one_time_use",
		sub_category		= "portal_spawner",
		related_variable 	= ""
	},
	{
		name 				= "room_portal_spawner_crafting",
		ui_name				= "Crafting Room Portal Spawner",
		desc 				= "",
		has_value			= 0,
		base_value			= 0,
		category			= "one_time_use",
		sub_category		= "portal_spawner",
		related_variable 	= ""
	},
	{
		name 				= "room_portal_spawner_donation",
		ui_name				= "Donation Room Portal Spawner",
		desc 				= "",
		has_value			= 0,
		base_value			= 0,
		category			= "one_time_use",
		sub_category		= "portal_spawner",
		related_variable 	= ""
	},
	{
		name 				= "room_portal_spawner_gambling",
		ui_name				= "Gambling Room Portal Spawner",
		desc 				= "",
		has_value			= 0,
		base_value			= 0,
		category			= "one_time_use",
		sub_category		= "portal_spawner",
		related_variable 	= ""
	},
	{
		name 				= "room_portal_spawner_miniboss",
		ui_name				= "Miniboss Room Portal Spawner",
		desc 				= "",
		has_value			= 0,
		base_value			= 0,
		category			= "one_time_use",
		sub_category		= "portal_spawner",
		related_variable 	= ""
	},
	{
		name 				= "room_portal_spawner_ore",
		ui_name				= "Ore Room Portal Spawner",
		desc 				= "",
		has_value			= 0,
		base_value			= 0,
		category			= "one_time_use",
		sub_category		= "portal_spawner",
		related_variable 	= ""
	},
	{
		name 				= "room_portal_spawner_store",
		ui_name				= "Store Room Portal Spawner",
		desc 				= "",
		has_value			= 0,
		base_value			= 0,
		category			= "one_time_use",
		sub_category		= "portal_spawner",
		related_variable 	= ""
	},
}

-- this table isolates all ammo types so that crafting system can obtain them individually
ammo_types_table = {
	"pistol_ammo",
	"smg_ammo",
	"revolver_ammo",
	"shotgun_ammo",
	"ar_rifle_ammo",
	"rifle_ammo",
	"elementalbullets_ammo",
	"arrows_ammo",
	"crossbowbolts_ammo",
	"spears_ammo",
	"nails_ammo",
	"knives_ammo",
	"metalsticks_ammo",
	"shovels_ammo",
	"syringes_ammo",
	"fluid_ammo",
	"energy_cells",
	"grenades_ammo",
	"rockets_ammo",
	"mininukes_ammo",
	"trash_ammo",
	"fuel_ammo",
	"throwable_weapons_ammo",
	"throwable_explosives_ammo"
}

-- returns ammo_types_table to the caller
function getAmmoTypes()
	return ammo_types_table
end

-- returns ammo by index, by first finding it in ammo_types_table, then returning the corresponding object from the main pickups_list
function getAmmoTypeByIndex(index)
	ammo_variable_name = ammo_types_table[index]
	
	local foundPickup = nil
	for i,pickup in ipairs(pickups_list) do
		if(pickup.related_variable == ammo_variable_name) then
			foundPickup = pickup
			break
		end
	end
	return foundPickup
end

-- Ingot and ammo cost for ammo pickups
local ammo_crafting_parts_cost = 15
local ammo_crafting_item = "ingot_copper"
-- Returns ammo crafting cost
function getAmmoCraftingPartsCost()
	return ammo_crafting_parts_cost
end
-- Returns ammo crafting item
function getAmmoCraftingItem()
	return ammo_crafting_item
end

-- Returns the amount of basic ammo types
function getAmmoTypesCount()
	local count = 0
	for i,element in ipairs(ammo_types_table) do
		count = count + 1
	end
	return count
end

-- returns element from pickups_list that matches provided itemName
function getPickupItem(itemName)
	local foundPickup = nil
	for i,pickup in ipairs(pickups_list) do
		if(pickup.name == itemName) then
			foundPickup = pickup
			break
		end
	end
	return foundPickup
end

-- returns a random pickup item based on the category and sub_category provided
-- category is required, sub_category can be omitted with an empty string 
function getRandomPickupItem(category, sub_category)

	-- Sets random seed
	local players = EntityGetWithTag("player_unit")
	local x, y = EntityGetTransform(players[1])
	SetRandomSeed( GameGetFrameNum(), x + y + players[1] + math.random(1,50))
	
	local eligible_item_count = 0
	
	local eligible_items = {}
	for i,item in ipairs(pickups_list) do
		if(sub_category ~= "") then
			if(item.category == category and item.sub_category == sub_category) then
				table.insert(eligible_items, item)
			end
		else
			if(item.category == category) then
				table.insert(eligible_items, item)
			end
		end
	end
	
	for i,element in ipairs(eligible_items) do
		eligible_item_count = eligible_item_count + 1
	end
	
	return eligible_items[Random(1, eligible_item_count)]
end

-- Utility function to return base dirs for commmon entities used in this script
function getPickupItemsBaseDir()
	return "data/entities/items/pickup/"
end

-- Utility function to return base dir for one time use items
function getOneTimeUseItemsBaseDir()
	return "data/entities/items/one_time_use/"
end