-- This file controls every trap added to this mod
-- Every new trap must be registered in this list, each item is the file name for the entity related to new traps
traps_list =
{	
	"trap_barrel_radioactive.xml",
	"trap_barrel_unstable.xml",
	"overweight_dude_leaking.xml",
	"overweight_dude.xml",
	"chill_mine.xml",
	"cluster_mine.xml",
	"incendiary_mine.xml",
	"cluster_mine_radioactivegas.xml",
	"cluster_mine_freezinggas.xml",
	"cluster_mine_incendiary.xml",
	"trap_tnt.xml",
	"gunpowder_keg.xml",
	"nitroglycerin_barrel.xml",
	"propane_gas_tank.xml",	
	"shrapnel_mine.xml",
	"giftbox.xml",
	"laser_mine.xml",
	"tesla_mine.xml",
	"drill_mine.xml",
	"spikeball_mine.xml",
	"icespear_mine.xml",
	"grinder_mine.xml",
	"bubbletrap_mine.xml",
	"energywave_mine.xml",
	"blackhole_mine.xml",
	"acid_barrel.xml",
	"poison_barrel.xml",
	"overheated_acid_barrel.xml",
	"nanoshrapnel_mine.xml",
	"sodium_acetate_mine.xml",
}

random_material_traps_list =
{
	"material_container.xml",
	"material_proximity_mine.xml"
}

hanging_traps_list =
{
	"hanging_nitro_tank.xml",
	"hanging_gunpowder_keg.xml",
	"hanging_flamespike_bomb.xml",
	"hanging_icespike_bomb.xml",
	"hanging_acid_crystal.xml",
	"hanging_lava_crystal.xml",
	"hanging_poison_crystal.xml",
	"hanging_drill_bomb.xml",
	"hanging_overheated_acid_crystal.xml",
	"hanging_water_crystal.xml",
}

-- Returns the amount of registered regular traps
function getTrapsCount()
	local count = 0
	for i,element in pairs(traps_list) do
		count = count + 1
	end
	return count
end

-- Returns the amount of registered random material traps
function getRandomMaterialTrapsCount()
	local count = 0
	for i,element in pairs(random_material_traps_list) do
		count = count + 1
	end
	return count
end

-- Returns the amount of registered hanging traps
function getHangingTrapsCount()
	local count = 0
	for i,element in pairs(hanging_traps_list) do
		count = count + 1
	end
	return count
end

function getRandomTrap()

	-- Sets random seed
	local players = EntityGetWithTag("player_unit")
	local x, y = EntityGetTransform(players[1])
	SetRandomSeed( GameGetFrameNum(), x + y + players[1] + math.random(1,50))
	
	local trap_type_chance = Random(1,2)
	
	-- returns the file name for a random trap
	if(trap_type_chance == 1) then
		return traps_list[Random(1,getTrapsCount())]
	elseif(trap_type_chance == 2) then
		return random_material_traps_list[Random(1,getRandomMaterialTrapsCount())]
	end
end

function getRandomHangingTrap()

	-- Sets random seed
	local players = EntityGetWithTag("player_unit")
	local x, y = EntityGetTransform(players[1])
	SetRandomSeed( GameGetFrameNum(), x + y + players[1] + math.random(1,50))
	
	-- returns the file name for a random trap
	return hanging_traps_list[Random(1,getHangingTrapsCount())]
	
end

function getTrapsBaseDir()
	return "data/entities/props/"
end