-- this file controls everything related to trinkets

dofile_once("data/scripts/thearmory_generic_functions.lua")

-- full trinkets list
-- name is the file name sans extension
-- ui_name is the trinket name shown in GUI
-- effect_desc is the description of all effects caused by the trinket to be shown in GUI
trinkets_list =
{
	{
		name 		= "trinket_hitman_ring",
		thumbnail	= "data/trinkets_gfx/trinket_hitman_ring_thumb.png",
		ui_name 	= "Hitman's Ring",
		effect_desc = "(+15 Critical Chance -10 Fire Rate - Single Shot/Regular)",
		category	= "single_shot_regular",
		is_stackable = true
	},
	{
		name 		= "trinket_ambiguity_ring",
		thumbnail	= "data/trinkets_gfx/trinket_ambiguity_ring_thumb.png",
		ui_name 	= "Ambiguity Ring",
		effect_desc = "(50% Chance to shoot Extra Projectile +5 Spread - Single Shot/Regular)",
		category	= "single_shot_regular",
		is_stackable = true
	},
	{
		name 		= "trinket_berzerker_ring",
		thumbnail	= "data/trinkets_gfx/trinket_berzerker_ring_thumb.png",
		ui_name 	= "Berzerker Ring",
		effect_desc = "(+0.3 Damage -10 Fire Rate - Single Shot/Regular)",
		category	= "single_shot_regular",
		is_stackable = true
	},
	{
		name 		= "trinket_surgeon_ring",
		thumbnail	= "data/trinkets_gfx/trinket_surgeon_ring_thumb.png",
		ui_name 	= "Surgeon Ring",
		effect_desc = "(+15 Blood Spill - Single Shot/Regular)",
		category	= "single_shot_regular",
		is_stackable = true
	},
	{
		name 		= "trinket_bomber_ring",
		thumbnail	= "data/trinkets_gfx/trinket_bomber_ring_thumb.png",
		ui_name 	= "Bomber Ring",
		effect_desc = "(33% Chance to Shoot Firebomb +5 Spread - Single Shot/Regular)",
		category	= "single_shot_regular",
		is_stackable = true
	},
	{
		name 		= "trinket_hunter_ring",
		thumbnail	= "data/trinkets_gfx/trinket_hunter_ring_thumb.png",
		ui_name 	= "Hunter's Ring",
		effect_desc = "(+5 Firerate +0.2 Damage - Single Shot/Regular)",
		category	= "single_shot_regular",
		is_stackable = true
	},
	{
		name 		= "trinket_bear_charm",
		thumbnail	= "data/trinkets_gfx/trinket_bear_charm_thumb.png",
		ui_name 	= "Bear Charm",
		effect_desc = "(+10 Critical Chance +10 Spread - Scatter Shot/Regular)",
		category	= "scatter_shot_regular",
		is_stackable = true
	},
	{
		name 		= "trinket_eagle_charm",
		thumbnail	= "data/trinkets_gfx/trinket_eagle_charm_thumb.png",
		ui_name 	= "Eagle Charm",
		effect_desc = "(-10 Spread -0.1 Damage - Scatter Shot/Regular)",
		category	= "scatter_shot_regular",
		is_stackable = true
	},
	{
		name 		= "trinket_hound_charm",
		thumbnail	= "data/trinkets_gfx/trinket_hound_charm_thumb.png",
		ui_name 	= "Hound Charm",
		effect_desc = "(+0.3 Damage +20 Spread - Scatter Shot/Regular)",
		category	= "scatter_shot_regular",
		is_stackable = true
	},
	{
		name 		= "trinket_rat_charm",
		thumbnail	= "data/trinkets_gfx/trinket_rat_charm_thumb.png",
		ui_name 	= "Rat Charm",
		effect_desc = "(+5 Critical Chance +20 Blood Spill - Scatter Shot/Regular)",
		category	= "scatter_shot_regular",
		is_stackable = true
	},
	{
		name 		= "trinket_turtle_charm",
		thumbnail	= "data/trinkets_gfx/trinket_turtle_charm_thumb.png",
		ui_name 	= "Turtle Charm",
		effect_desc = "(50% Chance to shoot 2 Extra Projectiles -10 Critical Chance - Scatter Shot/Regular)",
		category	= "scatter_shot_regular",
		is_stackable = true
	},
	{
		name 		= "trinket_dino_charm",
		thumbnail	= "data/trinkets_gfx/trinket_dino_charm_thumb.png",
		ui_name 	= "Dino Charm",
		effect_desc = "(+5 Firerate +5 Critical Damage - Scatter Shot/Regular)",
		category	= "scatter_shot_regular",
		is_stackable = true
	},
	{
		name 		= "trinket_zoom_ring",
		thumbnail	= "data/trinkets_gfx/trinket_zoom_ring_thumb.png",
		ui_name 	= "Zoom's Ring",
		effect_desc = "(+0.5 Speed +5 Spread - Single Shot/Regular)",
		category	= "single_shot_regular",
		is_stackable = true
	},
	{
		name 		= "trinket_kangaroo_charm",
		thumbnail	= "data/trinkets_gfx/trinket_kangaroo_charm_thumb.png",
		ui_name 	= "Kangaroo Charm",
		effect_desc = "(+0.5 Speed +0.2 Damage - Scatter Shot/Regular)",
		category	= "scatter_shot_regular",
		is_stackable = true
	},
	{
		name 		= "trinket_power_module",
		thumbnail	= "data/trinkets_gfx/trinket_power_module_thumb.png",
		ui_name 	= "Power Module",
		effect_desc = "(+0.2 Damage +5 Critical Chance - Energy Shots)",
		category	= "energy",
		is_stackable = true
	},
	{
		name 		= "trinket_large_battery",
		thumbnail	= "data/trinkets_gfx/trinket_large_battery_thumb.png",
		ui_name 	= "Large Battery",
		effect_desc = "(+5 Firerate +0.5 Speed - Energy Shots)",
		category	= "energy",
		is_stackable = true
	},
	{
		name 		= "trinket_spare_generator",
		thumbnail	= "data/trinkets_gfx/trinket_spare_generator_thumb.png",
		ui_name 	= "Spare Generator",
		effect_desc = "(50% Chance to shoot 2 Extra Projectiles +10 Spread - Energy Shots)",
		category	= "energy",
		is_stackable = true
	},
	{
		name 		= "trinket_overloaded_circuitry",
		thumbnail	= "data/trinkets_gfx/trinket_overloaded_circuitry_thumb.png",
		ui_name 	= "Overloaded Circuitry",
		effect_desc = "(+0.5 Damage -30 Firerate - Energy Shots)",
		category	= "energy",
		is_stackable = true
	},
	{
		name 		= "trinket_switcher",
		thumbnail	= "data/trinkets_gfx/trinket_switcher_thumb.png",
		ui_name 	= "Switcher",
		effect_desc = "(+10 Firerate +10 Spread - Energy Shots)",
		category	= "energy",
		is_stackable = true
	},
	{
		name 		= "trinket_necklace_ruby",
		thumbnail	= "data/trinkets_gfx/trinket_necklace_ruby_thumb.png",
		ui_name 	= "Ruby Necklace",
		effect_desc = "(+10 Critical Chance - Elemental Shots)",
		category	= "elemental",
		is_stackable = true
	},
	{
		name 		= "trinket_necklace_lazulite",
		thumbnail	= "data/trinkets_gfx/trinket_necklace_lazulite_thumb.png",
		ui_name 	= "Lazulite Necklace",
		effect_desc = "(+1 Projectile +3 Spread - Elemental Shots)",
		category	= "elemental",
		is_stackable = true
	},
	{
		name 		= "trinket_necklace_emerald",
		thumbnail	= "data/trinkets_gfx/trinket_necklace_emerald_thumb.png",
		ui_name 	= "Emerald Necklace",
		effect_desc = "(+5 Firerate - Elemental Shots)",
		category	= "elemental",
		is_stackable = true
	},
	{
		name 		= "trinket_necklace_citrine",
		thumbnail	= "data/trinkets_gfx/trinket_necklace_citrine_thumb.png",
		ui_name 	= "Citrine Necklace",
		effect_desc = "(+0.1 Damage - Elemental Shots)",
		category	= "elemental",
		is_stackable = true
	},
	{
		name 		= "trinket_necklace_fluorite",
		thumbnail	= "data/trinkets_gfx/trinket_necklace_fluorite_thumb.png",
		ui_name 	= "Fluorite Necklace",
		effect_desc = "(+0.5 Speed - Elemental Shots)",
		category	= "elemental",
		is_stackable = true
	},
	{
		name 		= "trinket_sharpening_wheel",
		thumbnail	= "data/trinkets_gfx/trinket_sharpening_wheel_thumb.png",
		ui_name 	= "Sharpening Wheel",
		effect_desc = "(+5 Critical Chance - Melee)",
		category	= "melee",
		is_stackable = true
	},
	{
		name 		= "trinket_anvil",
		thumbnail	= "data/trinkets_gfx/trinket_anvil_thumb.png",
		ui_name 	= "Anvil",
		effect_desc = "(+0.2 Damage - Melee)",
		category	= "melee",
		is_stackable = true
	},
	{
		name 		= "trinket_mystic_stone",
		thumbnail	= "data/trinkets_gfx/trinket_mystic_stone_thumb.png",
		ui_name 	= "Mystic Stone",
		effect_desc = "(50% Chance to shoot Mystic Projectile - Melee)",
		category	= "melee",
		is_stackable = true
	},
	{
		name 		= "trinket_bomb_dispenser",
		thumbnail	= "data/trinkets_gfx/trinket_bomb_dispenser_thumb.png",
		ui_name 	= "Bomb Dispenser",
		effect_desc = "(50% Chance to shoot Microbomb - Melee)",
		category	= "melee",
		is_stackable = true
	},
	{
		name 		= "trinket_scrap_metal",
		thumbnail	= "data/trinkets_gfx/trinket_scrap_metal_thumb.png",
		ui_name 	= "Scrap Metal",
		effect_desc = "(+0.1 Damage +2 Critical Chance - Melee)",
		category	= "melee",
		is_stackable = true
	},
	{
		name 		= "trinket_short_fuse_bomb",
		thumbnail	= "data/trinkets_gfx/trinket_short_fuse_bomb_thumb.png",
		ui_name 	= "Short Fuse Bomb",
		effect_desc = "(+0.5 Explosion Damage -30 Lifetime - Explosive)",
		category	= "explosive",
		is_stackable = true
	},
	{
		name 		= "trinket_remote_detonator",
		thumbnail	= "data/trinkets_gfx/trinket_remote_detonator_thumb.png",
		ui_name 	= "Remote Detonator",
		effect_desc = "(+5 Speed +15 Explosion Radius - Explosive)",
		category	= "explosive",
		is_stackable = true
	},
	{
		name 		= "trinket_plastic_explosive_payload",
		thumbnail	= "data/trinkets_gfx/trinket_plastic_explosive_payload_thumb.png",
		ui_name 	= "Plastic Explosive Payload",
		effect_desc = "(+10 Explosion Radius +1 Explosion Damage -30 Reload Speed - Explosive)",
		category	= "explosive",
		is_stackable = true
	},
	{
		name 		= "trinket_electronic_trigger",
		thumbnail	= "data/trinkets_gfx/trinket_electronic_trigger_thumb.png",
		ui_name 	= "Electronic Trigger",
		effect_desc = "(+5 Speed +5 Firerate - Explosive)",
		category	= "explosive",
		is_stackable = true
	},
	{
		name 		= "trinket_explosion_container",
		thumbnail	= "data/trinkets_gfx/trinket_explosion_container_thumb.png",
		ui_name 	= "Explosion Container",
		effect_desc = "(+1 Explosion Damage -5 Explosion Radius - Explosive)",
		category	= "explosive",
		is_stackable = true
	},
	{
		name 		= "trinket_emp_module",
		thumbnail	= "data/trinkets_gfx/trinket_emp_module_thumb.png",
		ui_name 	= "EMP Module",
		effect_desc = "(Fries proximity traps circuitry, preventing them from triggering)",
		category	= "object_trap",
		is_stackable = false
		
	},
	{
		name 		= "trinket_bronze_heart",
		thumbnail	= "data/trinkets_gfx/trinket_bronze_heart_thumb.png",
		ui_name 	= "Bronze Heart",
		effect_desc = "(+20% Healing Power - Hearts)",
		category	= "object_heart",
		is_stackable = true
	},
	{
		name 		= "trinket_golden_heart",
		thumbnail	= "data/trinkets_gfx/trinket_golden_heart_thumb.png",
		ui_name 	= "Golden Heart",
		effect_desc = "(+30% Healing Power - Hearts)",
		category	= "object_heart",
		is_stackable = true
	},
	{
		name 		= "trinket_key_chain",
		thumbnail	= "data/trinkets_gfx/trinket_key_chain_thumb.png",
		ui_name 	= "Key Chain",
		effect_desc = "(Twice as much Enemy Guts, Slot Machine Chips and Keys)",
		category	= "object_utility",
		is_stackable = true
	},
	{
		name 		= "trinket_silver_bullet",
		thumbnail	= "data/trinkets_gfx/trinket_silver_bullet_thumb.png",
		ui_name 	= "Silver Bullet",
		effect_desc = "(+20% Ammo Obtained from Pickups)",
		category	= "object_ammo",
		is_stackable = true
	},
	{
		name 		= "trinket_golden_bullet",
		thumbnail	= "data/trinkets_gfx/trinket_golden_bullet_thumb.png",
		ui_name 	= "Golden Bullet",
		effect_desc = "(+30% Ammo Obtained from Pickups)",
		category	= "object_ammo",
		is_stackable = true
	},
	{
		name 		= "trinket_hiisi_spine",
		thumbnail	= "data/trinkets_gfx/trinket_hiisi_spine_thumb.png",
		ui_name 	= "Hiisi Spine",
		effect_desc = "(+1 Drop from Dead Enemies)",
		category	= "object_enemydrop",
		is_stackable = false
	},
	{
		name 		= "trinket_treasure_chest",
		thumbnail	= "data/trinkets_gfx/trinket_treasure_chest_thumb.png",
		ui_name 	= "Treasure Chest",
		effect_desc = "(Tiered Chest drop chance from Dead Enemies)",
		category	= "object_enemydrop",
		is_stackable = false
	},
	{
		name 		= "trinket_golden_hiisi_statue",
		thumbnail	= "data/trinkets_gfx/trinket_golden_hiisi_statue_thumb.png",
		ui_name 	= "Golden Hiisi Statue",
		effect_desc = "(50% Extra gold drop chance from Dead Enemies)",
		category	= "object_enemydrop",
		is_stackable = false
	},
	{
		name 		= "trinket_miner_helmet",
		thumbnail	= "data/trinkets_gfx/trinket_miner_helmet_thumb.png",
		ui_name 	= "Miner Helmet",
		effect_desc = "(33% Ore drop chance from Dead Enemies)",
		category	= "object_enemydrop",
		is_stackable = false
	},
	{
		name 		= "trinket_monkey_wrench",
		thumbnail	= "data/trinkets_gfx/trinket_monkey_wrench_thumb.png",
		ui_name 	= "Monkey Wrench",
		effect_desc = "(33% Crafting part drop chance from Dead Enemies)",
		category	= "object_enemydrop",
		is_stackable = false
	},
	{
		name 		= "trinket_enlightenment_ring",
		thumbnail	= "data/trinkets_gfx/trinket_enlightenment_ring_thumb.png",
		ui_name 	= "Enlightenment Ring",
		effect_desc = "(+10 Firerate +10 Spread - Single Shot/Regular)",
		category	= "single_shot_regular",
		is_stackable = true
	},
	{
		name 		= "trinket_hastiness_ring",
		thumbnail	= "data/trinkets_gfx/trinket_hastiness_ring_thumb.png",
		ui_name 	= "Hastiness Ring",
		effect_desc = "(+1 Speed +5 Firerate - Single Shot/Regular)",
		category	= "single_shot_regular",
		is_stackable = true
	},
	{
		name 		= "trinket_purple_heart",
		thumbnail	= "data/trinkets_gfx/trinket_purple_heart_thumb.png",
		ui_name 	= "Purple Heart",
		effect_desc = "(Poisonous hearts now heal for 30% of their damaging amount)",
		category	= "object_heart",
		is_stackable = false
	},
	{
		name 		= "trinket_laser_sight",
		thumbnail	= "data/trinkets_gfx/trinket_laser_sight_thumb.png",
		ui_name 	= "Laser Sight",
		effect_desc = "(Adds a laser pointer to all weapons you equip)",
		category	= "object_wand",
		is_stackable = false
	},
	{
		name 		= "trinket_diamond_heart",
		thumbnail	= "data/trinkets_gfx/trinket_diamond_heart_thumb.png",
		ui_name 	= "Diamond Heart",
		effect_desc = "(Positive hearts overheal you)",
		category	= "object_heart",
		is_stackable = false
	},
	{
		name 		= "trinket_wooden_bullet",
		thumbnail	= "data/trinkets_gfx/trinket_wooden_bullet_thumb.png",
		ui_name 	= "Wooden Bullet",
		effect_desc = "(50% chance of not consuming ammo when firing any weapon)",
		category	= "object_ammo",
		is_stackable = false
	},
	{
		name 		= "trinket_passive_shield",
		thumbnail	= "data/trinkets_gfx/trinket_passive_shield_thumb.png",
		ui_name 	= "Passive Shield",
		effect_desc = "(You wield a projectile blocking shield when holding melee weapons)",
		category	= "object_wand",
		is_stackable = false
	},
	{
		name 		= "trinket_passive_deflecting_shield",
		thumbnail	= "data/trinkets_gfx/trinket_passive_deflecting_shield_thumb.png",
		ui_name 	= "Passive Deflecting Shield",
		effect_desc = "(You wield a projectile deflecting shield when holding melee weapons)",
		category	= "object_wand",
		is_stackable = false
	},
	{
		name 		= "trinket_skull_flask",
		thumbnail	= "data/trinkets_gfx/trinket_skull_flask_thumb.png",
		ui_name 	= "Skull Flask",
		effect_desc = "(5x damage multiplier on material effects - applies to enemies and you)",
		category	= "materials",
		is_stackable = true
	},
	{
		name 		= "trinket_diamond_dagger",
		thumbnail	= "data/trinkets_gfx/trinket_diamond_dagger_thumb.png",
		ui_name 	= "Diamong Dagger",
		effect_desc = "(+1 Projectile every 5 kills, stacks up to 5x, taking damage resets it - Ranged Weapons)",
		category	= "stackable_bonus",
		is_stackable = false
	},
	{
		name 		= "trinket_passive_harmful_shield",
		thumbnail	= "data/trinkets_gfx/trinket_passive_harmful_shield_thumb.png",
		ui_name 	= "Passive Harmful Shield",
		effect_desc = "(You wield a shield that deflects projectiles and damages enemies when holding melee weapons)",
		category	= "object_wand",
		is_stackable = false
	},
	{
		name 		= "trinket_knuckles",
		thumbnail	= "data/trinkets_gfx/trinket_knuckles_thumb.png",
		ui_name 	= "Knuckles",
		effect_desc = "(+1 Bonus Damage every 5 Kills, stacks up to 5x, taking damage resets it - Melee Weapons)",
		category	= "stackable_bonus",
		is_stackable = false
	},
	{
		name 		= "trinket_brick_hammer",
		thumbnail	= "data/trinkets_gfx/trinket_brick_hammer_thumb.png",
		ui_name 	= "Brick Hammer",
		effect_desc = "(+2 Critical Bonus every 5 Kills, stacks up to 5x, taking damage resets it - Ranged Weapons)",
		category	= "stackable_bonus",
		is_stackable = false
	},
	{
		name 		= "trinket_screwdriver",
		thumbnail	= "data/trinkets_gfx/trinket_screwdriver_thumb.png",
		ui_name 	= "Screwdriver",
		effect_desc = "(+5 Critical Bonus every 5 Kills, stacks up to 5x, taking damage resets it - Melee Weapons)",
		category	= "stackable_bonus",
		is_stackable = false
	},
	{
		name 		= "trinket_halo_flask",
		thumbnail	= "data/trinkets_gfx/trinket_halo_flask_thumb.png",
		ui_name 	= "Halo Flask",
		effect_desc = "(You earn 5 Gold each time you take direct damage from materials)",
		category	= "materials",
		is_stackable = true
	},
	{
		name 		= "trinket_cursed_coin",
		thumbnail	= "data/trinkets_gfx/trinket_cursed_coin_thumb.png",
		ui_name 	= "Cursed Coin",
		effect_desc = "(Upon taking damage, if 10 gold it is deducted and lost health is replenished)",
		category	= "player_stats",
		is_stackable = false
	},
	{
		name 		= "trinket_dark_mirror",
		thumbnail	= "data/trinkets_gfx/trinket_dark_mirror_thumb.png",
		ui_name 	= "Dark Mirror",
		effect_desc = "(When damaged by enemies, they take triple the damage you took)",
		category	= "player_stats",
		is_stackable = true
	},
}

-- All trinkets use these values when crafted
local trinket_crafting_parts_cost = 40
local trinket_crafting_item = "ingot_purple_fluorite"
-- Returns trinket crafting cost
function getTrinketCraftingPartsCost()
	return trinket_crafting_parts_cost
end
-- Returns trinket crafting item
function getTrinketCraftingItem()
	return trinket_crafting_item
end

-- returns trinket by index
function getTrinketByIndex(index)
	return trinkets_list[index]
end

-- Traps functions
-- ===============
-- Functions in this category are all related to traps, and are therefore linked to data/scripts/trap_trigger.lua

function applyTrapEffect()
	if(playerHasTrinket("trinket_emp_module") > 0) then
		return true
	else
		return false
	end
end


-- Items functions
-- ===============
-- Functions in this category are all related to pickup items
-- Effects stack for duplicate trinkets

-- Heart pickups
function applyTrinketsEffectsHearts(baseValue)

	local bonus = 0
	local threshold = 0
	
	if(playerHasTrinket("trinket_bronze_heart") > 0) then
		
		threshold = 20 * playerHasTrinket("trinket_bronze_heart")

		bonus = bonus + math.floor(baseValue * threshold / 100)
		if(bonus > 0) then
			GamePrint("+" .. bonus .. " trinket healing bonus")
		end
	end
	
	if(playerHasTrinket("trinket_golden_heart") > 0) then
		
		threshold = 30 * playerHasTrinket("trinket_golden_heart")

		bonus = bonus + math.floor(baseValue * threshold / 100)
		if(bonus > 0) then
			GamePrint("+" .. bonus .. " trinket healing bonus")
		end
	end
	
	return bonus
end

-- Utility pickups
function applyTrinketsEffectsUtility()
	
	local multiplier = 0
	
	if(playerHasTrinket("trinket_key_chain") > 0) then
		multiplier = multiplier + (playerHasTrinket("trinket_key_chain") * 2)
	else
		multiplier = 1
	end
	
	if(multiplier > 1) then
		GamePrint(multiplier .. "x utility item multiplier trinket bonus")
	end
	
	return multiplier
end

-- Ammo pickups
function applyTrinketsEffectsAmmo(baseValue)

	local bonus = 0
	local threshold = 0
	
	if(playerHasTrinket("trinket_silver_bullet") > 0) then
		
		threshold = 20 * playerHasTrinket("trinket_silver_bullet")

		bonus = bonus + math.floor(baseValue * threshold / 100)
		if(bonus > 0) then
			GamePrint("+" .. bonus .. " trinket ammo bonus")
		end
	end
	
	if(playerHasTrinket("trinket_golden_bullet") > 0) then
		
		threshold = 30 * playerHasTrinket("trinket_golden_bullet")

		bonus = bonus + math.floor(baseValue * threshold / 100)
		if(bonus > 0) then
			GamePrint("+" .. bonus .. " trinket ammo bonus")
		end
	end
	
	return bonus
end

function applyTrinketsEffectsAmmo_Consumption(amountDeducted)
	if(playerHasTrinket("trinket_wooden_bullet") > 0) then
		randomSeed()
		if(Random(1,2) == 1) then
			return 0
		else
			return amountDeducted
		end
	else
		return amountDeducted
	end
end

-- Enemy drops
function applyTrinketsEffectsEnemyDrop_PickupItem()
	if(playerHasTrinket("trinket_hiisi_spine") > 0) then
		return true
	else
		return false
	end
end

function applyTrinketsEffectsEnemyDrop_ChestChance()
	if(playerHasTrinket("trinket_treasure_chest") > 0) then
		return true
	else
		return false
	end
end

function applyTrinketsEffectsEnemyDrop_MoreGold()
	if(playerHasTrinket("trinket_golden_hiisi_statue") > 0) then
		return true
	else
		return false
	end
end

function applyTrinketsEffectsEnemyDrop_GunPart()
	if(playerHasTrinket("trinket_monkey_wrench") > 0) then
		return true
	else
		return false
	end
end

function applyTrinketsEffectsEnemyDrop_Ore()
	if(playerHasTrinket("trinket_miner_helmet") > 0) then
		return true
	else
		return false
	end
end

function applyTrinketsEffectsHearts_Purple(baseValue)
	local bonus = 0
	local convertedPlusBase = 0
	local threshold = 30
	
	if(playerHasTrinket("trinket_purple_heart") > 0) then
		bonus = bonus + math.floor((baseValue * -1) * threshold / 100)
		convertedPlusBase = (baseValue * -1) + bonus
		if(bonus > 0) then
			GamePrint("+" .. bonus .. " damaging converted to healing trinket bonus")
		end
	end
	
	return convertedPlusBase
end

function applyTrinketsEffectsHearts_Diamond()
	if(playerHasTrinket("trinket_diamond_heart") > 0) then
		return true
	else
		return false
	end
end

-- General trinkets
function applyTrinketsEffects_LaserSight()
	if(playerHasTrinket("trinket_laser_sight") > 0) then
		return true
	else
		return false
	end
end


function applyTrinketEffects_PassiveShield()
	-- as multiple shield related trinkets exist, one of them must take priority over others based on which trinkets are currently owned
	-- valid passive shield strings are:
	-- - passive_deflecting_shield
	-- - passive_harmful_shield
	-- - passive_shield
	local priority_shield = "[none]"

	if(playerHasTrinket("trinket_passive_shield") > 0 and playerHasTrinket("trinket_passive_deflecting_shield") > 0 and playerHasTrinket("trinket_passive_harmful_shield") > 0) then
		priority_shield = "passive_harmful_shield"
	elseif(playerHasTrinket("trinket_passive_shield") == 0 and playerHasTrinket("trinket_passive_deflecting_shield") > 0 and playerHasTrinket("trinket_passive_harmful_shield") > 0) then
		priority_shield = "passive_harmful_shield"
	elseif(playerHasTrinket("trinket_passive_shield") == 0 and playerHasTrinket("trinket_passive_deflecting_shield") == 0 and playerHasTrinket("trinket_passive_harmful_shield") > 0) then
		priority_shield = "passive_harmful_shield"
	elseif(playerHasTrinket("trinket_passive_shield") == 0 and playerHasTrinket("trinket_passive_deflecting_shield") > 0 and playerHasTrinket("trinket_passive_harmful_shield") == 0) then
		priority_shield = "passive_deflecting_shield"
	elseif(playerHasTrinket("trinket_passive_shield") > 0 and playerHasTrinket("trinket_passive_deflecting_shield") > 0 and playerHasTrinket("trinket_passive_harmful_shield") == 0) then
		priority_shield = "passive_deflecting_shield"
	elseif(playerHasTrinket("trinket_passive_shield") > 0 and playerHasTrinket("trinket_passive_deflecting_shield") == 0 and playerHasTrinket("trinket_passive_harmful_shield") == 0) then
		priority_shield = "passive_shield"
	end
	
	return priority_shield
end

function applyTrinketsEffects_SkullFlask()
	local multiplier = 1
	if(playerHasTrinket("trinket_skull_flask") > 0) then
		multiplier = 5 * playerHasTrinket("trinket_skull_flask")
	end
	
	return multiplier
end

function applyTrinketEffects_HaloFlask()
	return playerHasTrinket("trinket_halo_flask")
end

function applyTrinketEffects_CursedCoin()
	if(playerHasTrinket("trinket_cursed_coin") > 0) then
		return true
	else
		return false
	end
end

function applyTrinketEffects_DarkMirror()
	return playerHasTrinket("trinket_dark_mirror")
end


-- Weapon effects functions
-- ========================
-- All functions in this category are called from actions.lua file when a projectile is added within an Action function
-- Effects stack for duplicate trinkets

-- effects for single shot regular spells
function applyTrinketsEffectsWeapons_SingleShotRegular(projectileName)

	randomSeed()
	
	if(playerHasTrinket("trinket_hitman_ring") > 0) then
		c.damage_critical_chance = c.damage_critical_chance + (15 * playerHasTrinket("trinket_hitman_ring"))
		c.fire_rate_wait = c.fire_rate_wait + (10 * playerHasTrinket("trinket_hitman_ring"))
	end
	
	if(playerHasTrinket("trinket_ambiguity_ring") > 0) then
		for i = playerHasTrinket("trinket_ambiguity_ring"),1,-1 do
			if(Random(1,2) == 1) then
				add_projectile("data/entities/projectiles/" .. projectileName)
			end
		end
		c.spread_degrees = c.spread_degrees + (5 * playerHasTrinket("trinket_ambiguity_ring"))
	end
	
	if(playerHasTrinket("trinket_berzerker_ring") > 0) then
		c.damage_projectile_add = c.damage_projectile_add + (0.3 * playerHasTrinket("trinket_berzerker_ring"))
		c.fire_rate_wait = c.fire_rate_wait + (10 * playerHasTrinket("trinket_berzerker_ring"))
	end
	
	if(playerHasTrinket("trinket_surgeon_ring") > 0) then
		c.gore_particles = c.gore_particles + 25
	end
	
	if(playerHasTrinket("trinket_bomber_ring") > 0) then
		for i = playerHasTrinket("trinket_bomber_ring"),1,-1 do
			if(Random(1,3) == 1) then
				add_projectile("data/entities/projectiles/spitbomb_fire.xml")
			end
		end
		c.spread_degrees = c.spread_degrees + (5 * playerHasTrinket("trinket_bomber_ring"))
	end
	
	if(playerHasTrinket("trinket_hunter_ring") > 0) then
		c.damage_projectile_add = c.damage_projectile_add + (0.2 * playerHasTrinket("trinket_hunter_ring"))
		c.fire_rate_wait = c.fire_rate_wait - (5 * playerHasTrinket("trinket_hunter_ring"))
	end
	
	if(playerHasTrinket("trinket_zoom_ring") > 0) then
		c.speed_multiplier = c.speed_multiplier + (0.5 * playerHasTrinket("trinket_zoom_ring"))
		c.spread_degrees = c.spread_degrees + (5 * playerHasTrinket("trinket_zoom_ring"))
	end
	
	if(playerHasTrinket("trinket_enlightenment_ring") > 0) then
		c.spread_degrees = c.spread_degrees + (10 * playerHasTrinket("trinket_enlightenment_ring"))
		c.fire_rate_wait = c.fire_rate_wait - (10 * playerHasTrinket("trinket_enlightenment_ring"))
	end
	
	if(playerHasTrinket("trinket_hastiness_ring") > 0) then
		c.speed_multiplier = c.speed_multiplier + (1 * playerHasTrinket("trinket_hastiness_ring"))
		c.fire_rate_wait = c.fire_rate_wait - (5 * playerHasTrinket("trinket_hastiness_ring"))
	end

end

-- effects for scatter shot regular spells
function applyTrinketsEffectsWeapons_ScatterShotRegular(projectileName)
	
	randomSeed()
	
	if(playerHasTrinket("trinket_bear_charm") > 0) then
		c.damage_critical_chance = c.damage_critical_chance + (10 * playerHasTrinket("trinket_bear_charm"))
		c.spread_degrees = c.spread_degrees + (10 * playerHasTrinket("trinket_bear_charm"))
	end
	
	if(playerHasTrinket("trinket_eagle_charm") > 0) then
		c.spread_degrees = c.spread_degrees - (10 * playerHasTrinket("trinket_eagle_charm"))
		c.damage_projectile_add = c.damage_projectile_add - (0.1 * playerHasTrinket("trinket_eagle_charm"))
	end
	
	if(playerHasTrinket("trinket_hound_charm") > 0) then
		c.spread_degrees = c.spread_degrees + (20 * playerHasTrinket("trinket_hound_charm"))
		c.damage_projectile_add = c.damage_projectile_add + (0.3 * playerHasTrinket("trinket_hound_charm"))
	end
	
	if(playerHasTrinket("trinket_rat_charm") > 0) then
		c.damage_critical_chance = c.damage_critical_chance + (5 * playerHasTrinket("trinket_rat_charm"))
		c.gore_particles = c.gore_particles + 20
	end
	
	if(playerHasTrinket("trinket_turtle_charm") > 0) then
		for i = playerHasTrinket("trinket_turtle_charm"),1,-1 do
			if(Random(1,2) == 1) then
				add_projectile("data/entities/projectiles/" .. projectileName)
				add_projectile("data/entities/projectiles/" .. projectileName)
			end
		end
		c.damage_critical_chance = c.damage_critical_chance - (10 * playerHasTrinket("trinket_bear_charm"))
	end
	
	if(playerHasTrinket("trinket_dino_charm") > 0) then
		c.damage_critical_chance = c.damage_critical_chance + (5 * playerHasTrinket("trinket_dino_charm"))
		c.fire_rate_wait = c.fire_rate_wait - (5 * playerHasTrinket("trinket_dino_charm"))
	end
	
	if(playerHasTrinket("trinket_kangaroo_charm") > 0) then
		c.speed_multiplier = c.speed_multiplier + (0.5 * playerHasTrinket("trinket_kangaroo_charm"))
		c.damage_projectile_add = c.damage_projectile_add + (0.2 * playerHasTrinket("trinket_kangaroo_charm"))
	end
end

-- effects for energy consuming spells
function applyTrinketsEffectsWeapons_Energy(projectileName)
	
	randomSeed()
	
	if(playerHasTrinket("trinket_power_module") > 0) then
		c.damage_critical_chance = c.damage_critical_chance + (5 * playerHasTrinket("trinket_power_module"))
		c.damage_projectile_add = c.damage_projectile_add + (0.2 * playerHasTrinket("trinket_power_module"))
	end
	
	if(playerHasTrinket("trinket_large_battery") > 0) then
		c.speed_multiplier = c.speed_multiplier + (0.5 * playerHasTrinket("trinket_large_battery"))
		c.fire_rate_wait = c.fire_rate_wait - (5 * playerHasTrinket("trinket_large_battery"))
	end
	
	if(playerHasTrinket("trinket_spare_generator") > 0) then
		for i = playerHasTrinket("trinket_spare_generator"),1,-1 do
			if(Random(1,2) == 1) then
				add_projectile("data/entities/projectiles/" .. projectileName)
				add_projectile("data/entities/projectiles/" .. projectileName)
			end
		end
		c.spread_degrees = c.spread_degrees + (10 * playerHasTrinket("trinket_spare_generator"))
	end
	
	if(playerHasTrinket("trinket_overloaded_circuitry") > 0) then
		c.fire_rate_wait = c.fire_rate_wait + (30 * playerHasTrinket("trinket_overloaded_circuitry"))
		c.damage_projectile_add = c.damage_projectile_add + (0.5 * playerHasTrinket("trinket_overloaded_circuitry"))
	end
	
	if(playerHasTrinket("trinket_switcher") > 0) then
		c.fire_rate_wait = c.fire_rate_wait - (10 * playerHasTrinket("trinket_switcher"))
		c.spread_degrees = c.spread_degrees + (10 * playerHasTrinket("trinket_switcher"))
	end
end

-- effects for spells that include elemental damage or materials
function applyTrinketsEffectsWeapons_Elemental(projectileName)
	
	randomSeed()
	
	if(playerHasTrinket("trinket_necklace_ruby") > 0) then
		c.damage_critical_chance = c.damage_critical_chance + (10 * playerHasTrinket("trinket_necklace_ruby"))
	end
	
	if(playerHasTrinket("trinket_necklace_lazulite") > 0) then
		for i = playerHasTrinket("trinket_necklace_lazulite"),1,-1 do
			if(Random(1,2) == 1) then
				add_projectile("data/entities/projectiles/" .. projectileName)
			end
		end
		
		c.spread_degrees = c.spread_degrees + (3 * playerHasTrinket("trinket_necklace_lazulite"))
	end
	
	if(playerHasTrinket("trinket_necklace_emerald") > 0) then
		c.fire_rate_wait = c.fire_rate_wait - (5 * playerHasTrinket("trinket_necklace_emerald"))
	end
	
	if(playerHasTrinket("trinket_necklace_citrine") > 0) then
		c.damage_projectile_add = c.damage_projectile_add + (0.1 * playerHasTrinket("trinket_necklace_citrine"))
	end
	
	if(playerHasTrinket("trinket_necklace_fluorite") > 0) then
		c.speed_multiplier = c.speed_multiplier + (0.5 * playerHasTrinket("trinket_necklace_fluorite"))
	end
	
end

-- effects for melee spells
function applyTrinketsEffectsWeapons_Melee()

	randomSeed()

	if(playerHasTrinket("trinket_sharpening_wheel") > 0) then
		c.damage_critical_chance = c.damage_critical_chance + (5 * playerHasTrinket("trinket_sharpening_wheel"))
	end
	
	if(playerHasTrinket("trinket_anvil") > 0) then
		c.damage_projectile_add = c.damage_projectile_add + (0.2 * playerHasTrinket("trinket_anvil"))
	end
	
	if(playerHasTrinket("trinket_mystic_stone") > 0) then
		for i = playerHasTrinket("trinket_mystic_stone"),1,-1 do
			if(Random(1,2) == 1) then
				add_projectile("data/entities/projectiles/mysticprojectile.xml")
			end
		end
	end
	
	if(playerHasTrinket("trinket_bomb_dispenser") > 0) then
		for i = playerHasTrinket("trinket_bomb_dispenser"),1,-1 do
			if(Random(1,2) == 1) then
				add_projectile("data/entities/projectiles/microbomb_trinket.xml")
			end
		end
	end
	
	if(playerHasTrinket("trinket_scrap_metal") > 0) then
		c.damage_projectile_add = c.damage_projectile_add + (0.1 * playerHasTrinket("trinket_scrap_metal"))
		c.damage_critical_chance = c.damage_critical_chance + (2 * playerHasTrinket("trinket_scrap_metal"))
	end
	
end

-- effects for explosive spells
function applyTrinketsEffectsWeapons_Explosive()

	if(playerHasTrinket("trinket_short_fuse_bomb") > 0) then
		c.lifetime_add = c.lifetime_add - (30 * playerHasTrinket("trinket_short_fuse_bomb"))
		c.damage_explosion_add = c.damage_explosion_add + (0.5 * playerHasTrinket("trinket_short_fuse_bomb"))
	end
	
	if(playerHasTrinket("trinket_remote_detonator") > 0) then
		c.explosion_radius = c.explosion_radius + (15 * playerHasTrinket("trinket_remote_detonator"))
		c.speed_multiplier = c.speed_multiplier + (5 * playerHasTrinket("trinket_remote_detonator"))
	end
	
	if(playerHasTrinket("trinket_plastic_explosive_payload") > 0) then
		c.explosion_radius = c.explosion_radius + (10 * playerHasTrinket("trinket_plastic_explosive_payload"))
		c.damage_explosion_add = c.damage_explosion_add + (1 * playerHasTrinket("trinket_plastic_explosive_payload"))
		current_reload_time = current_reload_time + (30 * playerHasTrinket("trinket_plastic_explosive_payload"))
	end
	
	if(playerHasTrinket("trinket_electronic_trigger") > 0) then
		c.fire_rate_wait = c.fire_rate_wait - (5 * playerHasTrinket("trinket_electronic_trigger"))
		c.speed_multiplier = c.speed_multiplier + (5 * playerHasTrinket("trinket_electronic_trigger"))
	end
	
	if(playerHasTrinket("trinket_explosion_container") > 0) then
		c.explosion_radius = c.explosion_radius - (5 * playerHasTrinket("trinket_explosion_container"))
		c.damage_explosion_add = c.damage_explosion_add + (1 * playerHasTrinket("trinket_explosion_container"))
	end
	
end

function applyTrinketsEffectsWeapons_StackableBonusesRanged(projectileName)

	if(playerHasTrinket("trinket_diamond_dagger") > 0) then
		enemy_kills = getNumericValuePlayerStorageComp("enemy_kills")
		extra_projectiles = math.floor(enemy_kills / 5)
		-- GamePrint("### diamond dagger bonus: +" .. extra_projectiles)
		if(extra_projectiles ~= 0) then
			for i=1,extra_projectiles do
				add_projectile("data/entities/projectiles/" .. projectileName)
				c.spread_degrees = c.spread_degrees + 5
			end
		end
	end
	
	if(playerHasTrinket("trinket_brick_hammer") > 0) then
		enemy_kills = getNumericValuePlayerStorageComp("enemy_kills")
		extra_critical_bonuses = math.floor(enemy_kills / 5)
		if(extra_critical_bonuses ~= 0) then
			for i=1,extra_critical_bonuses do
				c.damage_critical_chance = c.damage_critical_chance + 2
			end
		end
	end
	
end

function applyTrinketsEffectsWeapons_StackableBonusesMelee()
	
	if(playerHasTrinket("trinket_knuckles") > 0) then
		enemy_kills = getNumericValuePlayerStorageComp("enemy_kills")
		extra_damage_bonuses = math.floor(enemy_kills / 5)
		if(extra_damage_bonuses ~= 0) then
			for i=1,extra_damage_bonuses do
				c.damage_projectile_add = c.damage_projectile_add + 1
			end
		end
	end
	
	if(playerHasTrinket("trinket_screwdriver") > 0) then
		enemy_kills = getNumericValuePlayerStorageComp("enemy_kills")
		extra_critical_bonuses = math.floor(enemy_kills / 5)
		if(extra_critical_bonuses ~= 0) then
			for i=1,extra_critical_bonuses do
				c.damage_critical_chance = c.damage_critical_chance + 5
			end
		end
	end
	
end

-- Interactions functions
-- ======================

-- function that returns true if the player is in possession of any trinket that adds stackable bonuses to the player
function playerHasStackableBonusesTrinkets()
	local flag = false
	
	if(playerHasTrinket("trinket_diamond_dagger") > 0 or playerHasTrinket("trinket_knuckles") > 0 or playerHasTrinket("trinket_brick_hammer") > 0 or playerHasTrinket("trinket_screwdriver") > 0) then
		flag = true
	end
	
	return flag
end

-- function to check whether or not the player is in possession of a given trinket
-- verifying each of the four slots
-- returns the amount of instances of the trinket found, or 0 if none
function playerHasTrinket(trinketName)
	local amount = 0
	if(getStringValuePlayerStorageComp("trinket1") == trinketName) then
		amount = amount + 1
	end
	if(getStringValuePlayerStorageComp("trinket2") == trinketName) then
		amount = amount + 1
	end
	if(getStringValuePlayerStorageComp("trinket3") == trinketName) then
		amount = amount + 1
	end
	if(getStringValuePlayerStorageComp("trinket4") == trinketName) then
		amount = amount + 1
	end
	
	return amount
end

-- function to add a trinket to a free trinket slot
-- checks, from slot 1 to 4, for empty slots and places it in the first empty one found
-- if there is no free slot, returns false and does nothing else
function addTrinket(trinketName)
	local slotsAvailable = true
	if(getStringValuePlayerStorageComp("trinket1") == "") then
		setStringValuePlayerStorageComp("trinket1", trinketName)
	elseif(getStringValuePlayerStorageComp("trinket2") == "") then
		setStringValuePlayerStorageComp("trinket2", trinketName)
	elseif(getStringValuePlayerStorageComp("trinket3") == "") then
		setStringValuePlayerStorageComp("trinket3", trinketName)
	elseif(getStringValuePlayerStorageComp("trinket4") == "") then
		setStringValuePlayerStorageComp("trinket4", trinketName)
	else
		slotsAvailable = false
	end
	
	return slotsAvailable
end

-- function to remove a trinket from player's possession
-- it will always assume at least one slot contains the specified trinket
-- removes the trinket from the first slot it is found on, return command is used to prevent duplicated trinkets from being removed at once
function removeTrinketByName(trinketName)
	if(getStringValuePlayerStorageComp("trinket1") == trinketName) then
		setStringValuePlayerStorageComp("trinket1", "")
		return
	elseif(getStringValuePlayerStorageComp("trinket2") == trinketName) then
		setStringValuePlayerStorageComp("trinket2", "")
		return
	elseif(getStringValuePlayerStorageComp("trinket3") == trinketName) then
		setStringValuePlayerStorageComp("trinket3", "")
		return
	elseif(getStringValuePlayerStorageComp("trinket4") == trinketName) then
		setStringValuePlayerStorageComp("trinket4", "")
		return
	end
end

-- function to remove a trinket from a specific slot
-- it assumes supplied slot number does contain a trinket
-- will only remove the trinket contained in the supplied slot
function removeTrinketBySlotNumber(slotNumber)
	
	-- builds variable name
	local slot = "trinket" .. slotNumber
	
	-- obtains trinket assigned to provided slot number, then drops removed trinket at the player's feet
	local x, y = EntityGetTransform(getPlayerEntity())
	EntityLoad(getTrinketsBaseDir() .. getStringValuePlayerStorageComp(slot) .. ".xml", x, y - 10)
	
	-- if trinket being dropped is of stackable_bonus category, kill counts is reset
	--[[
	if(getTrinketCategory(getStringValuePlayerStorageComp(slot)) == "stackable_bonus") then
		setNumericValuePlayerStorageComp("enemy_kills", 0)
	end
	]]
	
	-- removes trinket from variable storage
	setStringValuePlayerStorageComp(slot, "")
	
end

-- Verifies if a trinket is present in provided slot
function checkTrinketSlot(slotNumber)

	-- builds variable name
	local slot = "trinket" .. slotNumber
	
	if(getStringValuePlayerStorageComp(slot) ~= "") then
		return true
	else
		return false
	end
end


-- Utility functions
-- =================

-- Returns true if the trinket is stackable, false otherwise
function isTrinketStackable(trinketName)
	local stackable = false
	for i,trinket in ipairs(trinkets_list) do
		if(trinket.name == trinketName) then
			stackable = trinket.is_stackable
			break
		end
	end
	
	return stackable
end

-- Returns the UI Name of a trinket
function getTrinketUIName(trinketName)
	local trinketUiName = ""
	for i,trinket in ipairs(trinkets_list) do
		if(trinket.name == trinketName) then
			trinketUiName = trinket.ui_name
			break
		end
	end
	
	return trinketUiName
end

-- Returns the Description of a trinket
function getTrinketDescription(trinketName)
	local trinketDescription = ""
	for i,trinket in ipairs(trinkets_list) do
		if(trinket.name == trinketName) then
			trinketDescription = trinket.effect_desc
			break
		end
	end
	
	return trinketDescription
end

-- Returns the Category of a trinket
function getTrinketCategory(trinketName)
	local trinketCategory = ""
	for i,trinket in ipairs(trinkets_list) do
		if(trinket.name == trinketName) then
			trinketCategory = trinket.category
			break
		end
	end
	
	return trinketCategory
end

-- Returns the thumbnail location of a trinket
function getTrinketThumbnailPath(trinketName)
	local trinketThumbnailPath = ""
	for i,trinket in ipairs(trinkets_list) do
		if(trinket.name == trinketName) then
			trinketThumbnailPath = trinket.thumbnail
			break
		end
	end
	
	return trinketThumbnailPath
end

-- Returns the amount of registered trinkets
function getTrinketsCount()
	local count = 0
	for i,element in ipairs(trinkets_list) do
		count = count + 1
	end
	return count
end

-- Returns a random trinket
function getRandomTrinket()

	randomSeed()
	
	-- returns the file name for a random trinket
	return trinkets_list[Random(1,getTrinketsCount())].name
	
end

-- Utility functions to return base dirs for commmon entities used in this script
function getTrinketsBaseDir()
	return "data/entities/items/pickup/"
end

function randomSeed()

	SetRandomSeed( GameGetFrameNum(), math.random(1,50))
end