dofile_once("mods/TheArmory/files/trinkets_list.lua")

local LOAD_KEY = "THEARMORY_NEWGAME_FLAG"

function OnPlayerSpawned(player)
	
	-- Initializes gui elements
	EntityLoad('data/entities/gui_counters.xml')
	
	if GlobalsGetValue(LOAD_KEY, "0") == "1" then
		return
	end
	GlobalsSetValue(LOAD_KEY, "1")
	
	-- Shows intro text
	GamePrintImportant("Welcome to The Armory Mod", "Find special weapons in chests scattered through the World. Keep an eye in the counters above to keep track of collected items and ammo.")
	
	-- Configures new damaging materials to player damage model
	EntitySetDamageFromMaterial( player, "overheated_acid", 0.004 )
	EntitySetDamageFromMaterial( player, "persistent_poison", 0.002 ) 
	
	-- Initializes ammo count as a new VariableStorageComponents on the player entity
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "pistol_ammo",
	  value_int = 15
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "shotgun_ammo",
	  value_int = 10
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "smg_ammo",
	  value_int = 15
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "ar_rifle_ammo",
	  value_int = 15
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "rifle_ammo",
	  value_int = 15
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "revolver_ammo",
	  value_int = 10
	})
	EntitySetComponentIsEnabled(player, component_id, true)

	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "energy_cells",
	  value_int = 10
	})
	EntitySetComponentIsEnabled(player, component_id, true)

	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "grenades_ammo",
	  value_int = 5
	})
	EntitySetComponentIsEnabled(player, component_id, true)

	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "nails_ammo",
	  value_int = 15
	})
	EntitySetComponentIsEnabled(player, component_id, true)

	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "fluid_ammo",
	  value_int = 5
	})
	EntitySetComponentIsEnabled(player, component_id, true)

	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "mininukes_ammo",
	  value_int = 1
	})
	EntitySetComponentIsEnabled(player, component_id, true)

	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "elementalbullets_ammo",
	  value_int = 5
	})
	EntitySetComponentIsEnabled(player, component_id, true)

	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "knives_ammo",
	  value_int = 5
	})
	EntitySetComponentIsEnabled(player, component_id, true)

	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "metalsticks_ammo",
	  value_int = 5
	})
	EntitySetComponentIsEnabled(player, component_id, true)

	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "rockets_ammo",
	  value_int = 5
	})
	EntitySetComponentIsEnabled(player, component_id, true)

	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "shovels_ammo",
	  value_int = 5
	})
	EntitySetComponentIsEnabled(player, component_id, true)

	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "syringes_ammo",
	  value_int = 5
	})
	EntitySetComponentIsEnabled(player, component_id, true)

	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "trash_ammo",
	  value_int = 5
	})
	EntitySetComponentIsEnabled(player, component_id, true)

	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "arrows_ammo",
	  value_int = 10
	})
	EntitySetComponentIsEnabled(player, component_id, true)

	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "crossbowbolts_ammo",
	  value_int = 10
	})
	EntitySetComponentIsEnabled(player, component_id, true)

	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "spears_ammo",
	  value_int = 10
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "fuel_ammo",
	  value_int = 50
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "throwable_weapons_ammo",
	  value_int = 2
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "throwable_explosives_ammo",
	  value_int = 5
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	-- Initializes slot machine count as a new VariableStorageComponent on the player entity
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "slotmachinechips",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	-- Initializes enemy guts count as a new VariableStorageComponent on the player entity
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "enemyguts",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	-- Initializes safe keys count as a new VariableStorageComponent on the player entity
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "safekeys",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	-- Initializes chest keys count as a new VariableStorageComponent on the player entity
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "chestkeys",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	-- Initializes miniboss keys count as a new VariableStorageComponent on the player entity
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "minibosskeys",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	-- Initializes crafting parts counts
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "crafting_parts_ammo",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "crafting_parts_weapon",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "crafting_parts_trinket",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	-- Initializes ore counts
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "ore_amethyst",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "ore_copper",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "ore_diamond",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "ore_gold",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "ore_iron",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "ore_jade",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "ore_purple_fluorite",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "ore_ruby",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	-- Initializes ingot counts
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "ingot_amethyst",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "ingot_copper",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "ingot_diamond",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "ingot_gold",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "ingot_iron",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "ingot_jade",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "ingot_purple_fluorite",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "ingot_ruby",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	-- Initializes cloned object as a new VariableStorageComponent on the player entity
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "clonedobject",
	  value_string = ""
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	-- Initializes trinkets as new VariableStorageComponents on the player entity
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "trinket1",
	  value_string = ""
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "trinket2",
	  value_string = ""
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "trinket3",
	  value_string = ""
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "trinket4",
	  value_string = ""
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	-- adds teleportation listener to the player
	component_id = EntityAddComponent(player, "LuaComponent", {
	  script_teleported="data/scripts/player/teleport_room_listener.lua",
	  execute_every_n_frame="-1",
	  remove_after_executed="0"
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	-- room/portal config variables
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "last_portal_used",
	  value_string = ""
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "last_biome_visited",
	  value_string = ""
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	-- trinket related variables
	component_id = EntityAddComponent(player, "VariableStorageComponent", {
	  name = "enemy_kills",
	  value_int = 0
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	-- attaches laser sight entity to player, so it may be activated with a trinket
	EntityAddChild(player, EntityLoad("data/entities/laser_sight.xml"))
	--EntityAddChild(player, EntityLoad("data/entities/laser_sight_particle_emitter.xml"))
	
	-- attaches passive shield handler entity to player, so it may be activated with a trinket
	EntityAddChild(player, EntityLoad("data/entities/passive_shield_handler.xml"))
	
	-- attaches wand fired callback for advanced wand behaviors
	component_id = EntityAddComponent(player, "LuaComponent", {
	  script_wand_fired = "data/scripts/player/weapon_fired_handler.lua",
	  remove_after_executed = "0",
	  execute_every_n_frame = "5"
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	-- attaches damage received callback to allow for some trinket bonuses
	component_id = EntityAddComponent(player, "LuaComponent", {
	  script_damage_received = "data/scripts/player/player_damage_received.lua",
	  remove_after_executed = "0",
	  execute_every_n_frame = "5"
	})
	EntitySetComponentIsEnabled(player, component_id, true)
	
	-- if spawn_random_chest_beginning is enabled, spawns a random chest at the entrance of Mines, this setting comes from settings.lua
	if(ModSettingGet("TheArmory.spawn_random_chest_beginning") == "enabled") then
		GamePrint("Random chest spawned")
		local chest_x = 716
		local chest_y = -95
		SetRandomSeed( x, y )
		local spawnChance = Random(1,8)
		
		if (spawnChance == 1) then
			EntityLoad( "data/entities/items/pickup/chest_armory_regular.xml", chest_x, chest_y)
		elseif(spawnChance == 2) then
			EntityLoad( "data/entities/items/pickup/chest_armory_exquisite.xml", chest_x, chest_y)
		elseif(spawnChance == 3) then
			EntityLoad( "data/entities/items/pickup/chest_armory_special.xml", chest_x, chest_y)
		elseif(spawnChance == 4) then
			EntityLoad( "data/entities/items/pickup/chest_armory_rare.xml", chest_x, chest_y)
		elseif(spawnChance == 5) then
			EntityLoad( "data/entities/items/pickup/chest_armory_legendary.xml", chest_x, chest_y)
		elseif(spawnChance == 6) then
			EntityLoad( "data/entities/items/pickup/chest_armory_epic.xml", chest_x, chest_y)
		elseif(spawnChance == 7) then
			EntityLoad( "data/entities/items/pickup/chest_armory_exotic_unlocked.xml", chest_x, chest_y)
		elseif(spawnChance == 8) then
			EntityLoad( "data/entities/items/pickup/chest_armory_rainbow.xml", chest_x, chest_y)
		end
	end
	
	-- if spawn_random_trinket_beginning is enabled, spawns a random trinket at the entrance of Mines, this setting comes from settings.lua
	if(ModSettingGet("TheArmory.spawn_random_trinket_beginning") == "enabled") then
		local trinket_x = 746
		local trinket_y = -95
		EntityLoad( getTrinketsBaseDir() .. getRandomTrinket() .. ".xml", trinket_x, trinket_y)
	end
	
	SetRandomSeed( x, y )
	local slimeContainerChance = Random(1,3)
	if(slimeContainerChance == 1) then
		local slimeContainer_x = 766
		local slimeContainer_y = -95
		EntityLoad( "data/entities/items/one_time_use/slime_compound_container.xml", slimeContainer_x, slimeContainer_y)
	end
	
	-- this is used to test wands and other entities added
	local x, y = EntityGetTransform(player)
	
end

-- Initializes custom materials and reactions
ModMaterialsFileAdd("data/custom_materials_others.xml" )
ModMaterialsFileAdd("data/custom_materials_reactions.xml" )
ModMaterialsFileAdd("data/custom_materials_powders.xml" )
ModMaterialsFileAdd("data/custom_materials_liquids.xml" )
ModMaterialsFileAdd("data/custom_materials_gases.xml" )
ModMaterialsFileAdd("data/custom_materials_solids.xml" )

-- Initializes custom status effects
ModLuaFileAppend( "data/scripts/status_effects/status_list.lua", "data/scripts/custom_status_effects.lua" )

-- Appends custom actions
ModLuaFileAppend( "data/scripts/gun/gun_actions.lua", "mods/TheArmory/files/actions.lua" )

-- Traps spawning in biomes appends (using custom wang color)
ModLuaFileAppend('data/scripts/biomes/coalmine.lua', 'data/scripts/traps_and_enemies_spawn.lua')
ModLuaFileAppend('data/scripts/biomes/coalmine_alt.lua', 'data/scripts/traps_and_enemies_spawn.lua')
ModLuaFileAppend('data/scripts/biomes/excavationsite.lua', 'data/scripts/traps_and_enemies_spawn.lua')
ModLuaFileAppend('data/scripts/biomes/crypt.lua', 'data/scripts/traps_and_enemies_spawn.lua')
ModLuaFileAppend('data/scripts/biomes/wandcave.lua', 'data/scripts/traps_and_enemies_spawn.lua')
ModLuaFileAppend('data/scripts/biomes/fungicave.lua', 'data/scripts/traps_and_enemies_spawn.lua')
ModLuaFileAppend('data/scripts/biomes/rainforest.lua', 'data/scripts/traps_and_enemies_spawn.lua')
ModLuaFileAppend('data/scripts/biomes/sandcave.lua', 'data/scripts/traps_and_enemies_spawn.lua')
ModLuaFileAppend('data/scripts/biomes/snowcave.lua', 'data/scripts/traps_and_enemies_spawn.lua')
ModLuaFileAppend('data/scripts/biomes/snowcastle.lua', 'data/scripts/traps_and_enemies_spawn.lua')
ModLuaFileAppend('data/scripts/biomes/vault.lua', 'data/scripts/traps_and_enemies_spawn.lua')
ModLuaFileAppend('data/scripts/biomes/pyramid.lua', 'data/scripts/traps_and_enemies_spawn.lua')
ModLuaFileAppend('data/scripts/biomes/wizardcave.lua', 'data/scripts/traps_and_enemies_spawn.lua')