# this script creates all files required for a trinket, the only requirement before running it is creating the image file at 
# \TheArmory\data\trinkets_gfx\
# file name must be trinket_<word1>_<word2>.png
# trinket must also be added to trinkets_list.lua file in order to effectively add it to the mod

Param (
	[string]$pngBaseFileName = $(Read-Host "PNG file name, without extension"),
	[string]$uiName = $(Read-Host "Trinket UI Name")
)

$path_gfx = "C:\Program Files (x86)\Steam\steamapps\common\Noita\mods\TheArmory\data\trinkets_gfx\"
$path_gfx_imageThumbDummy = $path_gfx + "dummy_thumb.png"
$path_gfx_xmlThumbDummy = $path_gfx + "dummy_thumb.xml"

# Copies thumbnail and xml from dummy files
$imageFilePath = $path_gfx + $pngBaseFileName + "_thumb.png"
$xmlFilePath = $path_gfx + $pngBaseFileName + "_thumb.xml"
$pngBaseFileNameThumbEntity = $pngBaseFileName + "_thumb"
Copy-Item $path_gfx_imageThumbDummy -Destination $imageFilePath
Copy-Item $path_gfx_xmlThumbDummy -Destination $xmlFilePath

# changes file name within xml file
((Get-Content -path $xmlFilePath -Raw) -replace 'dummy', $pngBaseFileNameThumbEntity) | Set-Content -Path $xmlFilePath

<#
# Copies thumbnail entity file from dummy
$path_thumb_entity = "C:\Program Files (x86)\Steam\steamapps\common\Noita\mods\TheArmory\data\entities\trinkets_thumbnails\"
$path_thumb_entity_dummy = $path_thumb_entity + "trinket_dummy.xml"
$xmlFilePath_thumb_entity = $path_thumb_entity + $pngBaseFileName + ".xml"
Copy-Item $path_thumb_entity_dummy -Destination $xmlFilePath_thumb_entity

# changes file name within xml file
((Get-Content -path $xmlFilePath_thumb_entity -Raw) -replace 'dummy', $pngBaseFileNameThumbEntity) | Set-Content -Path $xmlFilePath_thumb_entity
#>

# Copies entity file from dummy
$path_entity = "C:\Program Files (x86)\Steam\steamapps\common\Noita\mods\TheArmory\data\entities\items\pickup\"
$path_entity_dummy = $path_entity + "trinket_dummy.xml"
$xmlPath_entity = $path_entity + $pngBaseFileName + ".xml"
Copy-Item $path_entity_dummy -Destination $xmlPath_entity

# changes file name within xml file
((Get-Content -path $xmlPath_entity -Raw) -replace 'dummy_ui_name', $uiName) | Set-Content -Path $xmlPath_entity
((Get-Content -path $xmlPath_entity -Raw) -replace 'dummy', $pngBaseFileName) | Set-Content -Path $xmlPath_entity

<#
$files = Get-ChildItem -Path "C:\Program Files (x86)\Steam\steamapps\common\Noita\mods\TheArmory\data\trinkets_gfx\"
foreach($file in $files) {
	if((!($file.Name -match "(dummy.*|createTrinket.*)")) -and ($file.Extension -ne ".png")) {
		$fileBaseName = $file.BaseName
		$path_gfx = "C:\Program Files (x86)\Steam\steamapps\common\Noita\mods\TheArmory\data\trinkets_gfx\" + $file.Name
		
		((Get-Content -path $path_gfx -Raw) -replace 'trinket_hitman_ring_thumb', $fileBaseName) | Set-Content -Path $path_gfx
	}
}
#>
