$wandFiles = Get-ChildItem 'C:\Program Files (x86)\Steam\steamapps\common\Noita\mods\TheArmory\data\entities\items' | Where-Object { !$_.PSIsContainer }
$wandThumbsPath = 'C:\Program Files (x86)\Steam\steamapps\common\Noita\mods\TheArmory\data\entities\wand_thumbnails\'
$dummyPath = 'C:\Program Files (x86)\Steam\steamapps\common\Noita\mods\TheArmory\data\entities\wand_thumbnails\wand_dummy.xml'
# sprite_file="data/items_gfx/aa12.xml"

foreach($wandFile in $wandFiles) {
	$query = Select-String -Path $wandFile.FullName -Pattern 'sprite_file=.*' | Select-Object -ExpandProperty Line
	$queryParts = $query.Split('=').Replace('"', '')
	
	Write-Host("Wand: " + $wandFile.Name + " Sprite: " + $queryParts[1])
	
	$newWandThumbPath = $wandThumbsPath + $wandFile.Name
	
	Copy-Item $dummyPath -Destination $newWandThumbPath
	
	((Get-Content -path $newWandThumbPath -Raw) -replace 'dummy', $queryParts[1]) | Set-Content -Path $newWandThumbPath
}

Write-Host "Done" -f "green"