$actionsFile = "C:\Program Files (x86)\Steam\steamapps\common\Noita\mods\TheArmory\files\actions.lua"

$parameter = '= "SPITBOMB_LIQUID_NITROGEN",'

$lineNumber = 1

$blockEndMarkFound = $false
$block = ''

$trinketTypes = [System.Text.StringBuilder]::new()

do {
	Select-String -Path $actionsFile -Pattern $parameter -Context 0,$lineNumber | ForEach-Object {
		$blockEndQuery = $_.Context.PostContext | Select-String -Pattern '} \)'
		if($blockEndQuery -ne $null) {
			$blockEndMarkFound = $true
			$block = $_.Context.PostContext	
		} else {
			$lineNumber++
		}
	}
} while(!$blockEndMarkFound)

Write-Host $block -f "green"

$ammoTypeQuery = $block | Select-String -Pattern 'checkPlayerAmmo\(1, "(.*)", ".*"\)'
Write-Host ("ammo type		- " + $ammoTypeQuery.Matches.Groups[1].Value) -f "yellow"

$trinket_singleShotQuery = $block | Select-String -Pattern 'applyTrinketsEffectsWeapons_SingleShotRegular'
$trinket_scatterShotQuery = $block | Select-String -Pattern 'applyTrinketsEffectsWeapons_ScatterShotRegular'
$trinket_energyQuery = $block | Select-String -Pattern 'applyTrinketsEffectsWeapons_Energy'
$trinket_elementalQuery = $block | Select-String -Pattern 'applyTrinketsEffectsWeapons_Elemental'
$trinket_meleeQuery = $block | Select-String -Pattern 'applyTrinketsEffectsWeapons_Melee'
$trinket_explosiveQuery = $block | Select-String -Pattern 'applyTrinketsEffectsWeapons_Explosive'

if($trinket_singleShotQuery -ne $null) {
	[void]$trinketTypes.Append('single_shot_regular,')
}
if($trinket_scatterShotQuery -ne $null) {
	[void]$trinketTypes.Append('scatter_shot_regular,')
}
if($trinket_energyQuery -ne $null) {
	[void]$trinketTypes.Append('energy,')
}
if($trinket_elementalQuery -ne $null) {
	[void]$trinketTypes.Append('elemental,')
}
if($trinket_meleeQuery -ne $null) {
	[void]$trinketTypes.Append('melee,')
}
if($trinket_explosiveQuery -ne $null) {
	[void]$trinketTypes.Append('explosive,')
}

Write-Host ("trinket types		- " + $trinketTypes.ToString()) -f "yellow"


<#
$actionsFile = "C:\Program Files (x86)\Steam\steamapps\common\Noita\mods\TheArmory\files\actions.lua"

$parameter = '= "HEAVYGRINDER",'

Select-String -Path $actionsFile -Pattern $parameter -Context 0,15 | ForEach-Object {
	
	Write-Host $_.Context.PostContext
	$line = $_.Context.PostContext.Trim() | Select-String -Pattern 'checkPlayerAmmo\(1, "(.*)", ".*"\)'
	$line.Matches.Groups[1].Value
	
}

Write-Host "done" -f "green"
#>