$actionsFile = "C:\Program Files (x86)\Steam\steamapps\common\Noita\mods\TheArmory\files\actions.lua"
$wandsListFile = "C:\Program Files (x86)\Steam\steamapps\common\Noita\mods\TheArmory\files\wands_list.lua"
$wandFiles = Get-ChildItem 'C:\Program Files (x86)\Steam\steamapps\common\Noita\mods\TheArmory\data\entities\items' | Where-Object { !$_.PSIsContainer }

# Counter for files found within $wandFiles
$fileCount = 0

# line break with carriage return characters
$lineBreak = "`r`n"

$ammoType = ''
$trinketTypes = ''
$wandName = ''

foreach($wandFile in $wandFiles) {

	$wandName = $wandFile.BaseName
	
	# Obtains individual action from wand file
	$query = Select-String -Path $wandFile.FullName -Pattern 'add_these_child_actions=(.*)' | Select-Object -ExpandProperty Line
	$queryParts = $query.Split('=').Replace('"', '') # separates prop name from value
	$actionsList = $queryParts[1] # obtains list of actions bound to the wand
	$actionName = ""
	$actionGUIName = ""
	$actionDescription = ""
	if($actionsList.Contains(',')) 
	{
		$actionsListParts = $actionsList.Split(',') # separates repeated actions so that just one can be obtained
		$actionName = $actionsListParts[1]
	} else {
		$actionName = $actionsList
	}
	
	Write-Host ($wandFile.Name) -f "cyan" -NoNewLine
	Write-Host  " action " -NoNewLine
	Write-Host ($actionName) -f "yellow"
	
	# Obtains name and description from actions.lua corresponding to $actionName
	
	$actionNamePattern = 'id          = "' + $actionName + '",'
	
	$lineNumber = 1

	$blockEndMarkFound = $false
	$block = ''

	$trinketTypesStrBuilder = [System.Text.StringBuilder]::new()
	
	$searchPattern = 'description = "(.*)",'
	do {
		Select-String -Path $actionsFile -Pattern $actionNamePattern -Context 0,$lineNumber | ForEach-Object {
			$blockEndQuery = $_.Context.PostContext | Select-String -Pattern $searchPattern
			if($blockEndQuery -ne $null) {
				$blockEndMarkFound = $true
				$block = $_.Context.PostContext	
			} else {
				$lineNumber++
			}
		}
	} while(!$blockEndMarkFound)
	
	# Write-Host $block -f "white"
	
	$actionDescriptionQuery = $block | Select-String -Pattern 'description = "(.*)",'
	if($actionDescriptionQuery -ne $null) {
		$actionDescription = $actionDescriptionQuery.Matches.Groups[1].Value
	}
	
	$actionGUINameQuery = $block | Select-String -Pattern 'name.*= "(.*)",'
	if($actionGUINameQuery -ne $null) {
		$actionGUIName = $actionGUINameQuery.Matches.Groups[1].Value
	}
	
	# Write-Host ("action name: " + $actionGUIName) -f "white"
	# Write-Host ("action desc: " + $actionDescription) -f "white"
	
	$wandDescription = ""
	
	if($actionGUIName -eq $actionDescription) {
		$wandDescription = 'description = "Comes with ' + $actionGUIName + ' Spell",'
	} else {
		$wandDescription = 'description = "Comes with ' + $actionGUIName + ' Spell - ' + $actionDescription + '",'
	}
	
	
	Write-Host $wandDescription -f "cyan"
	
    $replacePattern = 'description = "' + $wandFile.Name + '",'
	((Get-Content -path $wandsListFile -Raw) -replace $replacePattern, $wandDescription) | Set-Content -Path $wandsListFile
	
	$fileCount++
}

Write-Host $fileCount -f "green"