dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/lib/coroutines.lua")
dofile_once("data/scripts/thearmory_utilities.lua")

dofile_once("mods/TheArmory/files/trinkets_list.lua")

table.insert( actions,
{
	id          = "THEARMORYACTIONS_556AMMO",
	name 		= "5.56 ammo",
	description = "5.56x45mm NATO",
	sprite 		= "mods/TheArmory/files/actions/556ammo.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 556AMMO
	spawn_probability                 = "0", -- 556AMMO
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "ar_rifle_ammo", "Assault Rifle Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_556.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_556.xml")

				add_projectile("data/entities/projectiles/bulletammo_556.xml")
				shot_effects.recoil_knockback = shot_effects.recoil_knockback + 10
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "ar_rifle_ammo", "Assault Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_556AMMO_EXPLOSIVE",
	name 		= "5.56 explosive ammo",
	description = "5.56x45mm NATO, explosive",
	sprite 		= "mods/TheArmory/files/actions/556ammo_explosive.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 556AMMO_EXPLOSIVE
	spawn_probability                 = "0", -- 556AMMO_EXPLOSIVE
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "ar_rifle_ammo", "Assault Rifle Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_556_explosive.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_556_explosive.xml")

				add_projectile("data/entities/projectiles/bulletammo_556_explosive.xml")
				shot_effects.recoil_knockback = shot_effects.recoil_knockback + 10
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "ar_rifle_ammo", "Assault Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_545AMMO",
	name 		= "5.45x39mm ammo",
	description = "5.45x39mm ammo",
	sprite 		= "mods/TheArmory/files/actions/545.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 762AMMO
	spawn_probability                 = "0", -- 762AMMO
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "smg_ammo", "Submachine Gun Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_545.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_545.xml")

				add_projectile("data/entities/projectiles/bulletammo_545.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "smg_ammo", "Submachine Gun Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_762AMMO",
	name 		= "7.62 ammo",
	description = "7.62x51mm NATO",
	sprite 		= "mods/TheArmory/files/actions/762ammo.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 762AMMO
	spawn_probability                 = "0", -- 762AMMO
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "ar_rifle_ammo", "Assault Rifle Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_762.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_762.xml")

				add_projectile("data/entities/projectiles/bulletammo_762.xml")
				shot_effects.recoil_knockback = shot_effects.recoil_knockback + 15
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "ar_rifle_ammo", "Assault Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_76254R",
	name 		= "7.62x54R ammo",
	description = "7.62x54R ammo",
	sprite 		= "mods/TheArmory/files/actions/76254r.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 76254R
	spawn_probability                 = "0", -- 76254R
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rifle_ammo", "Rifle Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_76254r.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_76254r.xml")

				add_projectile("data/entities/projectiles/bulletammo_76254r.xml")
				shot_effects.recoil_knockback = shot_effects.recoil_knockback + 20
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rifle_ammo", "Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_762RUSSIAN",
	name 		= "7.62x54mmR Russian Ammo",
	description = "7.62x54mmR Russian Ammo",
	sprite 		= "mods/TheArmory/files/actions/762russian.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 762RUSSIAN
	spawn_probability                 = "0", -- 762RUSSIAN
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rifle_ammo", "Rifle Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_762russian.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_762russian.xml")

				add_projectile("data/entities/projectiles/bulletammo_762russian.xml")
				shot_effects.recoil_knockback = shot_effects.recoil_knockback + 10
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rifle_ammo", "Rifle Ammo")
			end
		end
		
	end,
} )



table.insert( actions,
{
	id          = "THEARMORYACTIONS_303BRITISH",
	name 		= ".303 British Ammo",
	description = ".303 British AKA 7.7x56mmR",
	sprite 		= "mods/TheArmory/files/actions/303british.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 303BRITISH
	spawn_probability                 = "0", -- 303BRITISH
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rifle_ammo", "Rifle Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_303british.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_303british.xml")

				add_projectile("data/entities/projectiles/bulletammo_303british.xml")
				shot_effects.recoil_knockback = shot_effects.recoil_knockback + 10
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rifle_ammo", "Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_792MAUSER",
	name 		= "7.92x57mm Mauser Ammo",
	description = "7.92x57mm Mauser Ammo",
	sprite 		= "mods/TheArmory/files/actions/792mauser.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 303BRITISH
	spawn_probability                 = "0", -- 303BRITISH
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rifle_ammo", "Rifle Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_792mauser.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_792mauser.xml")

				add_projectile("data/entities/projectiles/bulletammo_792mauser.xml")
				shot_effects.recoil_knockback = shot_effects.recoil_knockback + 10
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rifle_ammo", "Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_30_06SPRINGFIELD",
	name 		= ".30-06 Springfield ammo",
	description = ".30-06 Springfield ammo",
	sprite 		= "mods/TheArmory/files/actions/30_06springfield.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 30_06SPRINGFIELD
	spawn_probability                 = "0", -- 30_06SPRINGFIELD
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rifle_ammo", "Rifle Ammo")) then
					
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_3006springfield.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_3006springfield.xml")

				add_projectile("data/entities/projectiles/bulletammo_3006springfield.xml")
				shot_effects.recoil_knockback = shot_effects.recoil_knockback + 10
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rifle_ammo", "Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_30_06SPRINGFIELD_MG",
	name 		= ".30-06 Springfield ammo",
	description = ".30-06 Springfield ammo",
	sprite 		= "mods/TheArmory/files/actions/30_06springfield.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 30_06SPRINGFIELD_MG
	spawn_probability                 = "0", -- 30_06SPRINGFIELD_MG
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rifle_ammo", "Rifle Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_3006springfield_mg.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_3006springfield_mg.xml")

				add_projectile("data/entities/projectiles/bulletammo_3006springfield_mg.xml")
				shot_effects.recoil_knockback = shot_effects.recoil_knockback + 15
				c.spread_degrees = 3
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rifle_ammo", "Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_357MAGNUM",
	name 		= ".357 Magnum",
	description = ".357 Magnum",
	sprite 		= "mods/TheArmory/files/actions/357magnum.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 357MAGNUM
	spawn_probability                 = "0", -- 357MAGNUM
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "revolver_ammo", "Revolver Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_357magnum.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_357magnum.xml")

				add_projectile("data/entities/projectiles/bulletammo_357magnum.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "revolver_ammo", "Revolver Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_44MAGNUM",
	name 		= ".44 Magnum",
	description = ".44 Magnum",
	sprite 		= "mods/TheArmory/files/actions/44magnum.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 44MAGNUM
	spawn_probability                 = "0", -- 44MAGNUM
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "revolver_ammo", "Revolver Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_44magnum.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_44magnum.xml")

				add_projectile("data/entities/projectiles/bulletammo_44magnum.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "revolver_ammo", "Revolver Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_45_70",
	name 		= ".45-70 ammo",
	description = ".45-70 ammo",
	sprite 		= "mods/TheArmory/files/actions/45_70.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 45_70
	spawn_probability                 = "0", -- 45_70
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rifle_ammo", "Rifle Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_4570.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_4570.xml")

				add_projectile("data/entities/projectiles/bulletammo_4570.xml")
				shot_effects.recoil_knockback = shot_effects.recoil_knockback + 10
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rifle_ammo", "Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_45_70_REVOLVER",
	name 		= ".45-70 ammo",
	description = ".45-70 ammo",
	sprite 		= "mods/TheArmory/files/actions/45_70.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 45_70
	spawn_probability                 = "0", -- 45_70
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "revolver_ammo", "Revolver Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_4570.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_4570.xml")

				add_projectile("data/entities/projectiles/bulletammo_4570.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "revolver_ammo", "Revolver Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_30CARBINE",
	name 		= ".30 Carbine Ammo",
	description = ".30 Carbine Ammo",
	sprite 		= "mods/TheArmory/files/actions/30carbine.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 30CARBINE
	spawn_probability                 = "0", -- 30CARBINE
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rifle_ammo", "Rifle Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_30carbine.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_30carbine.xml")

				add_projectile("data/entities/projectiles/bulletammo_30carbine.xml")
				shot_effects.recoil_knockback = shot_effects.recoil_knockback + 10
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rifle_ammo", "Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_556AMMO_MICROGUN",
	name 		= "5.56 ammo",
	description = "5.56x45mm NATO",
	sprite 		= "mods/TheArmory/files/actions/556ammo.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 556AMMO
	spawn_probability                 = "0", -- 556AMMO
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "ar_rifle_ammo", "Assault Rifle Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_556.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_556.xml")

				add_projectile("data/entities/projectiles/bulletammo_556.xml")
				shot_effects.recoil_knockback = shot_effects.recoil_knockback + 10
				c.spread_degrees = 10
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "ar_rifle_ammo", "Assault Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_762AMMO_MINIGUN",
	name 		= "7.62 ammo",
	description = "7.62x51mm NATO",
	sprite 		= "mods/TheArmory/files/actions/762ammo.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 762AMMO_MINIGUN
	spawn_probability                 = "0", -- 762AMMO_MINIGUN
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "ar_rifle_ammo", "Assault Rifle Ammo")) then
				
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_762.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_762.xml")

				add_projectile("data/entities/projectiles/bulletammo_762.xml")
				shot_effects.recoil_knockback = shot_effects.recoil_knockback + 15
				c.spread_degrees = 7		
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "ar_rifle_ammo", "Assault Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_762AMMO_MINIGUN_EXPLOSIVE",
	name 		= "7.62 explosive ammo",
	description = "7.62x51mm NATO, explosive",
	sprite 		= "mods/TheArmory/files/actions/762ammo_explosive.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 762AMMO_MINIGUN_EXPLOSIVE
	spawn_probability                 = "0", -- 762AMMO_MINIGUN_EXPLOSIVE
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "ar_rifle_ammo", "Assault Rifle Ammo")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_762_explosive.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_762_explosive.xml")

				add_projectile("data/entities/projectiles/bulletammo_762_explosive.xml")

				shot_effects.recoil_knockback = shot_effects.recoil_knockback + 20
				c.spread_degrees = 10
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "ar_rifle_ammo", "Assault Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_762AMMO_EXPLOSIVE",
	name 		= "7.62 explosive ammo",
	description = "7.62x51mm NATO, explosive",
	sprite 		= "mods/TheArmory/files/actions/762ammo_explosive.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 762AMMO_EXPLOSIVE
	spawn_probability                 = "0", -- 762AMMO_EXPLOSIVE
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "ar_rifle_ammo", "Assault Rifle Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_762_explosive.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_762_explosive.xml")

				add_projectile("data/entities/projectiles/bulletammo_762_explosive.xml")
				shot_effects.recoil_knockback = shot_effects.recoil_knockback + 15
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "ar_rifle_ammo", "Assault Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHOTGUNSHELL_EXPLOSIVE",
	name 		= "Explosive Shotgun Shell",
	description = "Explosive 12 Gauge Shotgun Shell",
	sprite 		= "mods/TheArmory/files/actions/shotgunshell_explosive.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- EXPLOSIVE_SHOTGUNSHELL
	spawn_probability                 = "0", -- EXPLOSIVE_SHOTGUNSHELL
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "shotgun_ammo", "Shotgun Shells")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_ScatterShotRegular("bulletammo_buckshot_pellet_explosive.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_buckshot_pellet_explosive.xml")

				add_projectile("data/entities/projectiles/bulletammo_buckshot_pellet_explosive.xml")
				add_projectile("data/entities/projectiles/bulletammo_buckshot_pellet_explosive.xml")
				add_projectile("data/entities/projectiles/bulletammo_buckshot_pellet_explosive.xml")
				add_projectile("data/entities/projectiles/bulletammo_buckshot_pellet_explosive.xml")
				add_projectile("data/entities/projectiles/bulletammo_buckshot_pellet_explosive.xml")

				c.spread_degrees = 22 
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "shotgun_ammo", "Shotgun Shells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHOTGUNSHELL",
	name 		= "Shotgun Shell",
	description = "12 Gauge Shotgun Shell",
	sprite 		= "mods/TheArmory/files/actions/shotgunshell.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHOTGUNSHELL
	spawn_probability                 = "0", -- SHOTGUNSHELL
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "shotgun_ammo", "Shotgun Shells")) then
			
				applyTrinketsEffectsWeapons_ScatterShotRegular("bulletammo_buckshot_pellet.xml")
			
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_buckshot_pellet.xml")

				add_projectile("data/entities/projectiles/bulletammo_buckshot_pellet.xml")
				add_projectile("data/entities/projectiles/bulletammo_buckshot_pellet.xml")
				add_projectile("data/entities/projectiles/bulletammo_buckshot_pellet.xml")
				add_projectile("data/entities/projectiles/bulletammo_buckshot_pellet.xml")
				add_projectile("data/entities/projectiles/bulletammo_buckshot_pellet.xml")

				c.spread_degrees = 35
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "shotgun_ammo", "Shotgun Shells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SLUG_SHELL",
	name 		= "Slug Shell",
	description = "12 Gauge Slug Shell",
	sprite 		= "mods/TheArmory/files/actions/slug_shell.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SLUG_SHELL
	spawn_probability                 = "0", -- SLUG_SHELL
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "shotgun_ammo", "Shotgun Shells")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_slug.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_slug.xml")

				add_projectile("data/entities/projectiles/bulletammo_slug.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "shotgun_ammo", "Shotgun Shells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_DRAGONS_BREATH_SHELL",
	name 		= "Dragon's Breath Shell",
	description = "12 Gauge Shotgun Shell with Magnesium Pellets",
	sprite 		= "mods/TheArmory/files/actions/dragons_breath_shell.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- DRAGONS_BREATH_SHELL
	spawn_probability                 = "0", -- DRAGONS_BREATH_SHELL
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "shotgun_ammo", "Shotgun Shells")) then
				
				applyTrinketsEffectsWeapons_Elemental("bulletammo_magnesium_pellet.xml")
			
				applyTrinketsEffectsWeapons_ScatterShotRegular("bulletammo_magnesium_pellet.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_magnesium_pellet.xml")

				add_projectile("data/entities/projectiles/bulletammo_magnesium_pellet.xml")
				add_projectile("data/entities/projectiles/bulletammo_magnesium_pellet.xml")
				add_projectile("data/entities/projectiles/bulletammo_magnesium_pellet.xml")
				add_projectile("data/entities/projectiles/bulletammo_magnesium_pellet.xml")
				add_projectile("data/entities/projectiles/bulletammo_magnesium_pellet.xml")

				c.spread_degrees = 12
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "shotgun_ammo", "Shotgun Shells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHOTGUNSHELL_BIRDSHOT",
	name 		= "Birdshot Shotgun Shell",
	description = "Birdshot Shotgun Shell",
	sprite 		= "mods/TheArmory/files/actions/shotgunshell_birdshot.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHOTGUNSHELL_BIRDSHOT
	spawn_probability                 = "0", -- SHOTGUNSHELL_BIRDSHOT
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "shotgun_ammo", "Shotgun Shells")) then
				
				applyTrinketsEffectsWeapons_ScatterShotRegular("bulletammo_birdshot_pellet.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_birdshot_pellet.xml")

				add_projectile("data/entities/projectiles/bulletammo_birdshot_pellet.xml")
				add_projectile("data/entities/projectiles/bulletammo_birdshot_pellet.xml")
				add_projectile("data/entities/projectiles/bulletammo_birdshot_pellet.xml")
				add_projectile("data/entities/projectiles/bulletammo_birdshot_pellet.xml")
				add_projectile("data/entities/projectiles/bulletammo_birdshot_pellet.xml")
				
				c.spread_degrees = 14
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "shotgun_ammo", "Shotgun Shells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_40MMGRENADE",
	name 		= "40MM GRENADE",
	description = "FLOMP!",
	sprite 		= "mods/TheArmory/files/actions/40mmgrenade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 40MMGRENADE
	spawn_probability                 = "0", -- 40MMGRENADE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_40mm_grenade.xml")

				add_projectile("data/entities/projectiles/bulletammo_40mm_grenade.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_45ACP",
	name 		= ".45 ACP AMMO",
	description = ".45 ACP ammo",
	sprite 		= "mods/TheArmory/files/actions/45acp.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 45ACP
	spawn_probability                 = "0", -- 45ACP
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "pistol_ammo", "Pistol Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_45acp.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_45acp.xml")

				add_projectile("data/entities/projectiles/bulletammo_45acp.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "pistol_ammo", "Pistol Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_45ACP_SMG",
	name 		= ".45 ACP AMMO",
	description = ".45 ACP ammo",
	sprite 		= "mods/TheArmory/files/actions/45acp.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 45ACP
	spawn_probability                 = "0", -- 45ACP
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "smg_ammo", "Submachine Gun Ammo")) then
				
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_45acp.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_45acp.xml")

				add_projectile("data/entities/projectiles/bulletammo_45acp.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "smg_ammo", "Submachine Gun Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_45LC",
	name 		= ".45 Long Colt ammo",
	description = ".45 Long Colt ammo",
	sprite 		= "mods/TheArmory/files/actions/45lc.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 45ACP
	spawn_probability                 = "0", -- 45ACP
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "revolver_ammo", "Revolver Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_45lc.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_45lc.xml")

				add_projectile("data/entities/projectiles/bulletammo_45lc.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "revolver_ammo", "Revolver Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_44BALL",
	name 		= ".44 LEAD BALL",
	description = ".44 Lead Ball",
	sprite 		= "mods/TheArmory/files/actions/44leadball.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 44BALL
	spawn_probability                 = "0", -- 44BALL
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "revolver_ammo", "Revolver Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_leadball.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_leadball.xml")

				add_projectile("data/entities/projectiles/bulletammo_leadball.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "revolver_ammo", "Revolver Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_9MM",
	name 		= "9mm ammo",
	description = "9mm ammo",
	sprite 		= "mods/TheArmory/files/actions/9mm.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 9MM
	spawn_probability                 = "0", -- 9MM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "pistol_ammo", "Pistol Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_9mm.xml")
			
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_9mm.xml")

				add_projectile("data/entities/projectiles/bulletammo_9mm.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "pistol_ammo", "Pistol Ammo")
			end
		end
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_9MM_SMG",
	name 		= "9mm ammo",
	description = "9mm ammo",
	sprite 		= "mods/TheArmory/files/actions/9mm.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 9MM
	spawn_probability                 = "0", -- 9MM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "smg_ammo", "Submachine Gun Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_9mm.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_9mm.xml")

				add_projectile("data/entities/projectiles/bulletammo_9mm.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "smg_ammo", "Submachine Gun Ammo")
			end
		end
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_762TOKAREV",
	name 		= "7.62x25mm Tokarev",
	description = "7.62x25mm Tokarev",
	sprite 		= "mods/TheArmory/files/actions/762tokarev.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 762TOKAREV
	spawn_probability                 = "0", -- 762TOKAREV
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "pistol_ammo", "Pistol Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_762tokarev.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_762tokarev.xml")

				add_projectile("data/entities/projectiles/bulletammo_762tokarev.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "pistol_ammo", "Pistol Ammo")
			end
		end
	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_THUNDERBOLT",
	name 		= "THUNDERBOLT",
	description = "A bolt of concentrated electricity",
	sprite 		= "mods/TheArmory/files/actions/thunderbolt.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THUNDERBOLT
	spawn_probability                 = "0", -- THUNDERBOLT
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Elemental("thunderbolt.xml")
			
				applyTrinketsEffectsWeapons_Energy("thunderbolt.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("thunderbolt.xml")

				add_projectile("data/entities/projectiles/thunderbolt.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_THUNDERBOLT_SCATTER",
	name 		= "THUNDERBOLT SCATTER",
	description = "Scattered bolts of concentrated electricity",
	sprite 		= "mods/TheArmory/files/actions/thunderbolt_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THUNDERBOLT_SCATTER
	spawn_probability                 = "0", -- THUNDERBOLT_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("thunderbolt.xml")
				
				applyTrinketsEffectsWeapons_Energy("thunderbolt.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("thunderbolt.xml")

				add_projectile("data/entities/projectiles/thunderbolt.xml")
				add_projectile("data/entities/projectiles/thunderbolt.xml")
				add_projectile("data/entities/projectiles/thunderbolt.xml")
				add_projectile("data/entities/projectiles/thunderbolt.xml")
				c.spread_degrees = 40
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESLASPHERE",
	name 		= "TESLA SPHERE",
	description = "An electrified sphere that releases thunders while mid-air",
	sprite 		= "mods/TheArmory/files/actions/teslasphere.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESLASPHERE
	spawn_probability                 = "0", -- TESLASPHERE
	price = 600,
	mana = 20,
	action 		= function()
	
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Elemental("teslasphere.xml")
				
				applyTrinketsEffectsWeapons_Energy("teslasphere.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("teslasphere.xml")

				add_projectile("data/entities/projectiles/teslasphere.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESLAPROJECTILE",
	name 		= "TESLA PROJECTILE",
	description = "Concentrated electricity that releases thunders upon hit",
	sprite 		= "mods/TheArmory/files/actions/teslaprojectile.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESLAPROJECTILE
	spawn_probability                 = "0", -- TESLAPROJECTILE
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("teslaprojectile.xml")
				
				applyTrinketsEffectsWeapons_Energy("teslaprojectile.xml")
				
				add_projectile("data/entities/projectiles/teslaprojectile.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_HEATEDSTICK",
	name 		= "HEATEDSTICK",
	description = "A metal stick at melting point",
	sprite 		= "mods/TheArmory/files/actions/heatedstick.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- HEATEDSTICK
	spawn_probability                 = "0", -- HEATEDSTICK
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "metalsticks_ammo", "Metal Sticks")) then
				
				applyTrinketsEffectsWeapons_Elemental("heatedstick.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("heatedstick.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("heatedstick.xml")

				add_projectile("data/entities/projectiles/heatedstick.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "metalsticks_ammo", "Metal Sticks")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NAIL",
	name 		= "NAIL",
	description = "A makeshift bullet",
	sprite 		= "mods/TheArmory/files/actions/nail.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- NAIL
	spawn_probability                 = "0", -- NAIL
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "nails_ammo", "Nails")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("nail.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nail.xml")

				add_projectile("data/entities/projectiles/nail.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "nails_ammo", "Nails")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LONG_ARROW",
	name 		= "LONG ARROW",
	description = "A long arrow prepared to pierce through enemies.",
	sprite 		= "mods/TheArmory/files/actions/long_arrow.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LONG_ARROW
	spawn_probability                 = "0", -- LONG_ARROW
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "arrows_ammo", "Arrows")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("long_arrow.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("long_arrow.xml")

				add_projectile("data/entities/projectiles/long_arrow.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "arrows_ammo", "Arrows")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_STEEL_TIPPED_ARROW",
	name 		= "STEEL TIPPED ARROW",
	description = "A piercing arrow that deals great damage.",
	sprite 		= "mods/TheArmory/files/actions/steel_tipped_arrow.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- STEEL_TIPPED_ARROW
	spawn_probability                 = "0", -- STEEL_TIPPED_ARROW
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "arrows_ammo", "Arrows")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("steel_tipped_arrow.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("steel_tipped_arrow.xml")

				add_projectile("data/entities/projectiles/steel_tipped_arrow.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "arrows_ammo", "Arrows")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_EXPLOSIVE_ARROW",
	name 		= "EXPLOSIVE ARROW",
	description = "An arrow that explodes on contact, releasing shrapnel.",
	sprite 		= "mods/TheArmory/files/actions/explosive_arrow.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- EXPLOSIVE_ARROW
	spawn_probability                 = "0", -- EXPLOSIVE_ARROW
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "arrows_ammo", "Arrows")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("explosive_arrow.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("explosive_arrow.xml")

				add_projectile("data/entities/projectiles/explosive_arrow.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "arrows_ammo", "Arrows")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_INCENDIARY_ARROW",
	name 		= "INCENDIARY ARROW",
	description = "An arrow that burns on touch.",
	sprite 		= "mods/TheArmory/files/actions/incendiary_arrow.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- INCENDIARY_ARROW
	spawn_probability                 = "0", -- INCENDIARY_ARROW
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "arrows_ammo", "Arrows")) then
				
				applyTrinketsEffectsWeapons_Elemental("incendiary_arrow.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("incendiary_arrow.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("incendiary_arrow.xml")

				add_projectile("data/entities/projectiles/incendiary_arrow.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "arrows_ammo", "Arrows")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_WATER_ARROW",
	name 		= "WATER ARROW",
	description = "A magic arrow that spawns water on contact.",
	sprite 		= "mods/TheArmory/files/actions/water_arrow.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- WATER_ARROW
	spawn_probability                 = "0", -- WATER_ARROW
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "arrows_ammo", "Arrows")) then
			
				applyTrinketsEffectsWeapons_Elemental("water_arrow.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("water_arrow.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("water_arrow.xml")

				add_projectile("data/entities/projectiles/water_arrow.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "arrows_ammo", "Arrows")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ACID_ARROW",
	name 		= "ACID ARROW",
	description = "A magic arrow that spawns acid on contact.",
	sprite 		= "mods/TheArmory/files/actions/acid_arrow.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ACID_ARROW
	spawn_probability                 = "0", -- ACID_ARROW
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "arrows_ammo", "Arrows")) then
				
				applyTrinketsEffectsWeapons_Elemental("acid_arrow.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("acid_arrow.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("acid_arrow.xml")

				add_projectile("data/entities/projectiles/acid_arrow.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "arrows_ammo", "Arrows")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NITROGLYCERIN_ARROW",
	name 		= "NITROGLYCERIN ARROW",
	description = "A magic arrow that spawns unstable nitroglycerin on contact.",
	sprite 		= "mods/TheArmory/files/actions/nitroglycerin_arrow.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- NITROGLYCERIN_ARROW
	spawn_probability                 = "0", -- NITROGLYCERIN_ARROW
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "arrows_ammo", "Arrows")) then
				
				applyTrinketsEffectsWeapons_Elemental("nitroglycerin_arrow.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("nitroglycerin_arrow.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nitroglycerin_arrow.xml")

				add_projectile("data/entities/projectiles/nitroglycerin_arrow.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "arrows_ammo", "Arrows")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_KNIFE",
	name 		= "KNIFE",
	description = "A razor-sharp knife that causes bleeding on enemies hit by it",
	sprite 		= "mods/TheArmory/files/actions/knife.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- KNIFE
	spawn_probability                 = "0", -- KNIFE
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "knives_ammo", "Knives")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("knife.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("knife.xml")

				add_projectile("data/entities/projectiles/knife.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "knives_ammo", "Knives")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_BOOZE",
	name 		= "SYRINGE FILLED WITH BOOZE",
	description = "Injects enemies with alcohol",
	sprite 		= "mods/TheArmory/files/actions/syringe_booze.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_BOOZE
	spawn_probability                 = "0", -- SYRINGE_BOOZE
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_booze.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_booze.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_booze.xml")

				add_projectile("data/entities/projectiles/syringe_booze.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_WATER",
	name 		= "SYRINGE FILLED WITH WATER",
	description = "Injects enemies with water",
	sprite 		= "mods/TheArmory/files/actions/syringe_water.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_WATER
	spawn_probability                 = "0", -- SYRINGE_WATER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_water.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_water.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_water.xml")

				add_projectile("data/entities/projectiles/syringe_water.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_POISON",
	name 		= "SYRINGE FILLED WITH POISON",
	description = "Injects enemies with poison",
	sprite 		= "mods/TheArmory/files/actions/syringe_poison.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_POISON
	spawn_probability                 = "0", -- SYRINGE_POISON
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_poison.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_poison.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_poison.xml")

				add_projectile("data/entities/projectiles/syringe_poison.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_POLYMORPHINE",
	name 		= "SYRINGE FILLED WITH POLYMORPHINE",
	description = "Injects enemies with polymorphine",
	sprite 		= "mods/TheArmory/files/actions/syringe_polymorphine.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_POLYMORPHINE
	spawn_probability                 = "0", -- SYRINGE_POLYMORPHINE
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
			
				applyTrinketsEffectsWeapons_Elemental("syringe_polymorphine.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_polymorphine.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_polymorphine.xml")

				add_projectile("data/entities/projectiles/syringe_polymorphine.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_CHARM",
	name 		= "SYRINGE FILLED WITH CHARMING LIQUID",
	description = "Injects enemies with charming liquid",
	sprite 		= "mods/TheArmory/files/actions/syringe_charm.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_CHARM
	spawn_probability                 = "0", -- SYRINGE_CHARM
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
			
				applyTrinketsEffectsWeapons_Elemental("syringe_charm.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_charm.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_charm.xml")

				add_projectile("data/entities/projectiles/syringe_charm.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_NITRO",
	name 		= "SYRINGE FILLED WITH NITROGLYCERIN",
	description = "Injects enemies with nitroglycerin",
	sprite 		= "mods/TheArmory/files/actions/syringe_nitro.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_NITRO
	spawn_probability                 = "0", -- SYRINGE_NITRO
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_nitro.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_nitro.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_nitro.xml")

				add_projectile("data/entities/projectiles/syringe_nitro.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
		 
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_ACID",
	name 		= "SYRINGE FILLED WITH ACID",
	description = "Injects enemies with acid",
	sprite 		= "mods/TheArmory/files/actions/syringe_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_ACID
	spawn_probability                 = "0", -- SYRINGE_ACID
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_acid.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_acid.xml")

				add_projectile("data/entities/projectiles/syringe_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
		 
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FROZENKRAKEN",
	name 		= "FROZEN KRAKEN",
	description = "Sticky and freezy",
	sprite 		= "mods/TheArmory/files/actions/frozenkraken.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FROZENKRAKEN
	spawn_probability                 = "0", -- FROZENKRAKEN
	price = 600,
	mana = 20,
	action 		= function()
		
		--draw_actions(3, true)
		--c.pattern_degrees = 25
		applyTrinketsEffectsWeapons_Elemental("tentacle_freezing.xml")
			
		applyTrinketsEffectsWeapons_StackableBonusesRanged("tentacle_freezing.xml")
		
		add_projectile("data/entities/projectiles/tentacle_freezing.xml")
		add_projectile("data/entities/projectiles/tentacle_freezing.xml")
		add_projectile("data/entities/projectiles/tentacle_freezing.xml")
		add_projectile("data/entities/projectiles/tentacle_freezing.xml")
		c.spread_degrees = 25
		
		--[[		
		-- Freeze
		c.damage_projectile_add = c.damage_projectile_add + 0.2
		c.game_effect_entities = c.game_effect_entities .. "data/entities/misc/effect_frozen.xml,"
		c.extra_entities = c.extra_entities .. "data/entities/particles/freeze_charge.xml,"
		draw_actions( 1, true )
		-- Star Shape
		draw_actions(8, true)
		c.pattern_degrees = 180
		-- Tentacles
		add_projectile("data/entities/projectiles/deck/tentacle.xml")
		add_projectile("data/entities/projectiles/deck/tentacle.xml")
		add_projectile("data/entities/projectiles/deck/tentacle.xml")
		add_projectile("data/entities/projectiles/deck/tentacle.xml")
		add_projectile("data/entities/projectiles/deck/tentacle.xml")
		add_projectile("data/entities/projectiles/deck/tentacle.xml")
		add_projectile("data/entities/projectiles/deck/tentacle.xml")
		add_projectile("data/entities/projectiles/deck/tentacle.xml")
		-- Modifiers
		c.damage_projectile_add = c.damage_projectile_add + 10
		c.damage_critical_chance = c.damage_critical_chance + 15
		--]]

	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_HELLFIREPROJECTILE",
	name 		= "HELLFIRE PROJECTILE",
	description = "A firestarting tool",
	sprite 		= "mods/TheArmory/files/actions/hellfireprojectile.png",
	type 		= ACTION_TYPE_DRAW_MANY,
	spawn_level                       = "0", -- HELLFIREPROJECTILE
	spawn_probability                 = "0", -- HELLFIREPROJECTILE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Elemental("hellfireprojectile.xml")
			
				applyTrinketsEffectsWeapons_Energy("hellfireprojectile.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("hellfireprojectile.xml")

				add_projectile("data/entities/projectiles/hellfireprojectile.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
				
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_STUNPROJECTILE",
	name 		= "STUN PROJECTILE",
	description = "Shots fired!",
	sprite 		= "mods/TheArmory/files/actions/stunprojectile.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- STUNPROJECTILE
	spawn_probability                 = "0", -- STUNPROJECTILE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "elementalbullets_ammo", "Elemental Bullets Ammo")) then
				
				applyTrinketsEffectsWeapons_Elemental("stunprojectile.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("stunprojectile.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("stunprojectile.xml")

				add_projectile("data/entities/projectiles/stunprojectile.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "elementalbullets_ammo", "Elemental Bullets Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TELEPORTINGPROJECTILE",
	name 		= "TELEPORTING PROJECTILE",
	description = "Sends foes to the future",
	sprite 		= "mods/TheArmory/files/actions/teleportingprojectile.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TELEPORTINGPROJECTILE
	spawn_probability                 = "0", -- TELEPORTINGPROJECTILE
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "elementalbullets_ammo", "Elemental Bullets Ammo")) then
				
				applyTrinketsEffectsWeapons_Elemental("teleportingprojectile.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("teleportingprojectile.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("teleportingprojectile.xml")

				add_projectile("data/entities/projectiles/teleportingprojectile.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "elementalbullets_ammo", "Elemental Bullets Ammo")
			end
		end
			
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BLUEWAVE",
	name 		= "BLUE WAVE",
	description = "Leaves small pieces of nothing behind",
	sprite 		= "mods/TheArmory/files/actions/bluewave.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BLUEWAVE
	spawn_probability                 = "0", -- BLUEWAVE
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				-- Angled shot config
				draw_actions(20, true)
				c.pattern_degrees = 22.5
				
				-- Projetiles
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				add_projectile("data/entities/projectiles/deck/bullet_slow.xml")
				
				-- Modifiers		
				c.speed_multiplier = c.speed_multiplier + 0.5
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHOVELPROJECTILE",
	name 		= "SHOVEL PROJECTILE",
	description = "It digs anything",
	sprite 		= "mods/TheArmory/files/actions/shovelprojectile.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHOVELPROJECTILE
	spawn_probability                 = "0", -- SHOVELPROJECTILE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "shovels_ammo", "Shovels")) then
				
				applyTrinketsEffectsWeapons_SingleShotRegular("shovelprojectile.xml")

				applyTrinketsEffectsWeapons_StackableBonusesRanged("shovelprojectile.xml")

				add_projectile("data/entities/projectiles/shovelprojectile.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "shovels_ammo", "Shovels")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MOLTENPROJECTILE",
	name 		= "MOLTEN PROJECTILE",
	description = "It comes on fire",
	sprite 		= "mods/TheArmory/files/actions/moltenprojectile.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MOLTENPROJECTILE
	spawn_probability                 = "0", -- MOLTENPROJECTILE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "elementalbullets_ammo", "Elemental Bullets Ammo")) then
			
				applyTrinketsEffectsWeapons_Elemental("moltenprojectile.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("moltenprojectile.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("moltenprojectile.xml")

				add_projectile("data/entities/projectiles/moltenprojectile.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "elementalbullets_ammo", "Elemental Bullets Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MININUKE",
	name 		= "MINI NUKE",
	description = "Uranium powered",
	sprite 		= "mods/TheArmory/files/actions/mininuke.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MININUKE
	spawn_probability                 = "0", -- MININUKE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "mininukes_ammo", "Mininukes")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("mininuke.xml")

				add_projectile("data/entities/projectiles/mininuke.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "mininukes_ammo", "Mininukes")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MININUKE_MIRV",
	name 		= "MINI NUKE (MIRV)",
	description = "Breaks down into smaller nukes mid-air",
	sprite 		= "mods/TheArmory/files/actions/mininuke_mirv.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MININUKE_MIRV
	spawn_probability                 = "0", -- MININUKE_MIRV
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "mininukes_ammo", "Mininukes")) then
				
				add_projectile("data/entities/projectiles/mininuke_mirv_launcher.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "mininukes_ammo", "Mininukes")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CRYOPROJECTILE",
	name 		= "CRYO PROJECTILE",
	description = "Freeze!",
	sprite 		= "mods/TheArmory/files/actions/cryoprojectile.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CRYOPROJECTILE
	spawn_probability                 = "0", -- CRYOPROJECTILE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "elementalbullets_ammo", "Elemental Bullets Ammo")) then
			
				applyTrinketsEffectsWeapons_Elemental("cryoprojectile.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("cryoprojectile.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("cryoprojectile.xml")

				add_projectile("data/entities/projectiles/cryoprojectile.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "elementalbullets_ammo", "Elemental Bullets Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_DYNAMITEBUNDLE",
	name 		= "DYNAMITE BUNDLE",
	description = "Allahu akbar!",
	sprite 		= "mods/TheArmory/files/actions/dynamitebundle.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- DYNAMITEBUNDLE
	spawn_probability                 = "0", -- DYNAMITEBUNDLE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("deck/tnt.xml")

				add_projectile("data/entities/projectiles/deck/tnt.xml")
				add_projectile("data/entities/projectiles/deck/tnt.xml")
				add_projectile("data/entities/projectiles/deck/tnt.xml")
				add_projectile("data/entities/projectiles/deck/tnt.xml")
				add_projectile("data/entities/projectiles/deck/tnt.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ACIDBOLT",
	name 		= "ACID BOLT",
	description = "Corrodes your soul",
	sprite 		= "mods/TheArmory/files/actions/acidbolt.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ACIDBOLT
	spawn_probability                 = "0", -- ACIDBOLT
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "fluid_ammo", "Fluid Ammo")) then
				
				applyTrinketsEffectsWeapons_Elemental("acidbolt.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("acidbolt.xml")

				add_projectile("data/entities/projectiles/acidbolt.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "fluid_ammo", "Fluid Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LAVABOLT",
	name 		= "LAVA BOLT",
	description = "A portable vulcan",
	sprite 		= "mods/TheArmory/files/actions/lavabolt.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LAVABOLT
	spawn_probability                 = "0", -- LAVABOLT
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "fluid_ammo", "Fluid Ammo")) then
				
				applyTrinketsEffectsWeapons_Elemental("lavabolt.xml")

				applyTrinketsEffectsWeapons_StackableBonusesRanged("lavabolt.xml")

				add_projectile("data/entities/projectiles/lavabolt.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "fluid_ammo", "Fluid Ammo")
			end
		end
	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_GREEN_SABERBLADE",
	name 		= "GREEN LIGHTSABER BLADE",
	description = "Cauterizes the wound",
	sprite 		= "mods/TheArmory/files/actions/saberblade_jedi.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- GREEN_SABERBLADE
	spawn_probability                 = "0", -- GREEN_SABERBLADE
	price = 600,
	mana = 20,
	--sound_loop_tag = "sound_digger",
	--custom_xml_file = "mods/TheArmory/data/entities/energy_shield_singleblade.xml",
	action 		= function()
		
		add_projectile("data/entities/projectiles/saberblade_jedi.xml")
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_RED_SABERBLADE",
	name 		= "Cauterizes the wound",
	sprite 		= "mods/TheArmory/files/actions/saberblade_sith.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- RED_SABERBLADE
	spawn_probability                 = "0", -- RED_SABERBLADE
	price = 600,
	mana = 20,
	--sound_loop_tag = "sound_digger",
	--custom_xml_file = "mods/TheArmory/data/entities/energy_shield_singleblade.xml",
	action 		= function()
		
		add_projectile("data/entities/projectiles/saberblade_sith.xml")
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_DOUBLE_SABERBLADE",
	name 		= "DOUBLE LIGHTSABER BLADE",
	description = "Double the fun",
	sprite 		= "mods/TheArmory/files/actions/saberblade_double.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- DOUBLE_SABERBLADE
	spawn_probability                 = "0", -- DOUBLE_SABERBLADE
	price = 600,
	mana = 20,
	--sound_loop_tag = "sound_digger",
	--custom_xml_file = "mods/TheArmory/data/entities/energy_shield_doubleblade.xml",
	action 		= function()
		
		c.pattern_degrees = 180
		add_projectile("data/entities/projectiles/saberblade_sith.xml")
		add_projectile("data/entities/projectiles/saberblade_sith.xml")
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BLUE_SABERBLADE",
	name 		= "BLUE LIGHTSABER BLADE",
	description = "Cauterizes the wound",
	sprite 		= "mods/TheArmory/files/actions/saberblade_jedi2.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BLUE_SABERBLADE
	spawn_probability                 = "0", -- BLUE_SABERBLADE
	price = 600,
	mana = 20,
	--sound_loop_tag = "sound_digger",
	--custom_xml_file = "mods/TheArmory/data/entities/energy_shield_singleblade.xml",
	action 		= function()
		
		add_projectile("data/entities/projectiles/saberblade_jedi2.xml")
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SEISMIC_PROJECTILE",
	name 		= "SEISMIC PROJECTILE",
	description = "Produces earthquakes wherever it hits",
	sprite 		= "mods/TheArmory/files/actions/seismicprojectile.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SEISMIC_PROJECTILE
	spawn_probability                 = "0", -- SEISMIC_PROJECTILE
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("seismicprojectile.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("seismicprojectile.xml")

				add_projectile("data/entities/projectiles/seismicprojectile.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TRAPDISARMER",
	name 		= "TRAP DISARMER",
	description = "Disarms traps and converts them into grenades ammo",
	sprite 		= "mods/TheArmory/files/actions/trapdisarmer.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TRAPDISARMER
	spawn_probability                 = "0", -- TRAPDISARMER
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				add_projectile("data/entities/projectiles/trapdisarmer.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CHESTSHUFFLER",
	name 		= "CHEST SHUFFLER",
	description = "Shuffles tiered chests",
	sprite 		= "mods/TheArmory/files/actions/chestshuffler.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CHESTSHUFFLER
	spawn_probability                 = "0", -- CHESTSHUFFLER
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				add_projectile("data/entities/projectiles/chestshuffler.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CLONER",
	name 		= "CLONER",
	description = "Clones certain objects",
	sprite 		= "mods/TheArmory/files/actions/cloner.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CLONER
	spawn_probability                 = "0", -- CLONER
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				add_projectile("data/entities/projectiles/cloner.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_PRINTER",
	name 		= "PRINTER",
	description = "Prints cloned objects",
	sprite 		= "mods/TheArmory/files/actions/printer.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- PRINTER
	spawn_probability                 = "0", -- PRINTER
	price = 600,
	mana = 20,
	action 		= function()
	
		local projectilePath = getStringValuePlayerStorageComp("clonedobject")
	
		if(projectilePath == "") then
			GamePrint("You haven't clonned an object yet, use the Cloner Device to clone an object")
		end
		
		if(getPlayerEntity() ~= nil and projectilePath ~= "") then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				--add_projectile("data/entities/projectiles/printer.xml")
				
				add_projectile(projectilePath)
				c.speed_multiplier = 12
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_PLASMABOLT",
	name 		= "PLASMA BOLT",
	description = "A bolt of plasma energy that leaves toxic waste puddles on hit",
	sprite 		= "mods/TheArmory/files/actions/plasmabolt.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- PLASMABOLT
	spawn_probability                 = "0", -- PLASMABOLT
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Elemental("plasmabolt.xml")
				
				applyTrinketsEffectsWeapons_Energy("plasmabolt.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("plasmabolt.xml")

				add_projectile("data/entities/projectiles/plasmabolt.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_PLASMABOLT_SCATTER",
	name 		= "PLASMA BOLT SCATTER",
	description = "Scattered plasma bolts",
	sprite 		= "mods/TheArmory/files/actions/plasmabolt_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- PLASMABOLT_SCATTER
	spawn_probability                 = "0", -- PLASMABOLT_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("plasmabolt.xml")
			
				applyTrinketsEffectsWeapons_Energy("plasmabolt.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("plasmabolt.xml")

				add_projectile("data/entities/projectiles/plasmabolt.xml")
				add_projectile("data/entities/projectiles/plasmabolt.xml")
				add_projectile("data/entities/projectiles/plasmabolt.xml")
				c.spread_degrees = 15
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FREEZINGLASERBOLT",
	name 		= "FREEZING LASER BOLT",
	description = "A beam of concentrated light, freezes enemies it touches",
	sprite 		= "mods/TheArmory/files/actions/freezinglaserbolt.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FREEZINGLASERBOLT
	spawn_probability                 = "0", -- FREEZINGLASERBOLT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Elemental("laser_freezing.xml")
			
				applyTrinketsEffectsWeapons_Energy("laser_freezing.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("laser_freezing.xml")

				add_projectile("data/entities/projectiles/laser_freezing.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FREEZINGLASERBOLT_SCATTER",
	name 		= "FREEZING LASER BOLT SCATTER",
	description = "Scattered freezing laser bolts",
	sprite 		= "mods/TheArmory/files/actions/freezinglaserbolt_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- REDLASERBOLT_SCATTER
	spawn_probability                 = "0", -- REDLASERBOLT_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("laser_freezing.xml")
			
				applyTrinketsEffectsWeapons_Energy("laser_freezing.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("laser_freezing.xml")

				add_projectile("data/entities/projectiles/laser_freezing.xml")
				add_projectile("data/entities/projectiles/laser_freezing.xml")
				add_projectile("data/entities/projectiles/laser_freezing.xml")
				add_projectile("data/entities/projectiles/laser_freezing.xml")
				c.spread_degrees = 15
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_REDLASERBOLT",
	name 		= "RED LASER BOLT",
	description = "A beam of concentrated light, burns on hit",
	sprite 		= "mods/TheArmory/files/actions/redlaserbolt.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- REDLASERBOLT
	spawn_probability                 = "0", -- REDLASERBOLT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("laser_red.xml")
				
				applyTrinketsEffectsWeapons_Energy("laser_red.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("laser_red.xml")

				add_projectile("data/entities/projectiles/laser_red.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_REDLASERBOLT_SCATTER",
	name 		= "RED LASER BOLT SCATTER",
	description = "Scattered laser bolts",
	sprite 		= "mods/TheArmory/files/actions/redlaserbolt_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- REDLASERBOLT_SCATTER
	spawn_probability                 = "0", -- REDLASERBOLT_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("laser_red.xml")
				
				applyTrinketsEffectsWeapons_Energy("laser_red.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("laser_red.xml")

				add_projectile("data/entities/projectiles/laser_red.xml")
				add_projectile("data/entities/projectiles/laser_red.xml")
				add_projectile("data/entities/projectiles/laser_red.xml")
				add_projectile("data/entities/projectiles/laser_red.xml")
				c.spread_degrees = 15
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ALIENBOLT",
	name 		= "ALIEN BOLT",
	description = "Mutates stuff",
	sprite 		= "mods/TheArmory/files/actions/alienbolt.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ALIENBOLT
	spawn_probability                 = "0", -- ALIENBOLT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Elemental("alienbolt.xml")
				
				applyTrinketsEffectsWeapons_Energy("alienbolt.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("alienbolt.xml")

				add_projectile("data/entities/projectiles/alienbolt.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_WATERBOLT",
	name 		= "WATER BOLT",
	description = "Washes everything",
	sprite 		= "mods/TheArmory/files/actions/waterbolt.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- WATERBOLT
	spawn_probability                 = "0", -- WATERBOLT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "fluid_ammo", "Fluid Ammo")) then
				
				applyTrinketsEffectsWeapons_Elemental("waterbolt.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("waterbolt.xml")

				add_projectile("data/entities/projectiles/waterbolt.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "fluid_ammo", "Fluid Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CHILLNADE",
	name 		= "CHILLNADE",
	description = "Just chill!",
	sprite 		= "mods/TheArmory/files/actions/chillnade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESLANADE
	spawn_probability                 = "0", -- TESLANADE
	price = 600,
	mana = 20,
	action 		= function()

		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("chillnade.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("chillnade.xml")

				add_projectile("data/entities/projectiles/chillnade.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESLANADE",
	name 		= "TESLANADE",
	description = "Would make Tesla proud!",
	sprite 		= "mods/TheArmory/files/actions/teslanade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESLANADE
	spawn_probability                 = "0", -- TESLANADE
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("teslanade.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("teslanade.xml")

				add_projectile("data/entities/projectiles/teslanade.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ACIDNADE",
	name 		= "ACIDNADE",
	description = "An explosions of acid!",
	sprite 		= "mods/TheArmory/files/actions/acidnade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LAVANADE
	spawn_probability                 = "0", -- LAVANADE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("acidnade.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("acidnade.xml")

				add_projectile("data/entities/projectiles/acidnade.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NITRONADE",
	name 		= "NITRONADE",
	description = "An explosions of nitroglycerin!",
	sprite 		= "mods/TheArmory/files/actions/nitronade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LAVANADE
	spawn_probability                 = "0", -- LAVANADE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("nitronade.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nitronade.xml")

				add_projectile("data/entities/projectiles/nitronade.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LAVANADE",
	name 		= "LAVANADE",
	description = "An explosions of lava!",
	sprite 		= "mods/TheArmory/files/actions/lavanade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LAVANADE
	spawn_probability                 = "0", -- LAVANADE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("lavanade.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("lavanade.xml")

				add_projectile("data/entities/projectiles/lavanade.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_QUADROCKETS",
	name 		= "QUADROCKETS",
	description = "Deliver the freedum",
	sprite 		= "mods/TheArmory/files/actions/quadrockets.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- QUADROCKETS
	spawn_probability                 = "0", -- QUADROCKETS
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rockets_ammo", "Rockets")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("rocket_tiny_custom.xml")

				add_projectile("data/entities/projectiles/rocket_tiny_custom.xml")
				add_projectile("data/entities/projectiles/rocket_tiny_custom.xml")
				add_projectile("data/entities/projectiles/rocket_tiny_custom.xml")
				add_projectile("data/entities/projectiles/rocket_tiny_custom.xml")
				c.spread_degrees = 15
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rockets_ammo", "Rockets")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ROCKET_REGULAR",
	name 		= "REGULAR ROCKET",
	description = "A portable form of freedom!",
	sprite 		= "mods/TheArmory/files/actions/rocket_regular.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- QUADROCKETS
	spawn_probability                 = "0", -- QUADROCKETS
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rockets_ammo", "Rockets")) then
				
				applyTrinketsEffectsWeapons_Explosive()

				applyTrinketsEffectsWeapons_StackableBonusesRanged("rocket_tank_custom.xml")

				add_projectile("data/entities/projectiles/rocket_tank_custom.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rockets_ammo", "Rockets")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FREEZINGGASBOMB",
	name 		= "FREEZINGGASBOMB",
	description = "Releases freezing gas",
	sprite 		= "mods/TheArmory/files/actions/freezinggasbomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FREEZINGGASBOMB
	spawn_probability                 = "0", -- FREEZINGGASBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_freezinggas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_freezinggas.xml")

				add_projectile("data/entities/projectiles/bomb_freezinggas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FREEZINGGASBOMB_SCATTER",
	name 		= "FREEZINGGASBOMB SCATTER",
	description = "Releases even more freezing gas",
	sprite 		= "mods/TheArmory/files/actions/freezinggasbomb_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FREEZINGGASBOMB_SCATTER
	spawn_probability                 = "0", -- FREEZINGGASBOMB_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_freezinggas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_freezinggas.xml")

				add_projectile("data/entities/projectiles/bomb_freezinggas.xml")
				add_projectile("data/entities/projectiles/bomb_freezinggas.xml")
				add_projectile("data/entities/projectiles/bomb_freezinggas.xml")
				add_projectile("data/entities/projectiles/bomb_freezinggas.xml")
				c.spread_degrees = 20
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FREEZINGGASBOMB_LAYER",
	name 		= "FREEZINGGASBOMB LAYER",
	description = "Lays freezing gas bombs while it arcs",
	sprite 		= "mods/TheArmory/files/actions/freezinggasbomb_layer.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FREEZINGGASBOMB_LAYER
	spawn_probability                 = "0", -- FREEZINGGASBOMB_LAYER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then	
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Elemental("bomb_layer_freezinggas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_layer_freezinggas.xml")

				add_projectile("data/entities/projectiles/bomb_layer_freezinggas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FREEZINGGASBOMB_CLUSTER",
	name 		= "FREEZINGGASBOMB CLUSTER",
	description = "Releases freezing gas bombs on hit",
	sprite 		= "mods/TheArmory/files/actions/freezinggasbomb_cluster.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FREEZINGGASBOMB_CLUSTER
	spawn_probability                 = "0", -- FREEZINGGASBOMB_CLUSTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_cluster_freezinggas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_cluster_freezinggas.xml")

				add_projectile("data/entities/projectiles/bomb_cluster_freezinggas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_RADIOACTIVEGASBOMB",
	name 		= "RADIOACTIVEGASBOMB",
	description = "Releases toxic gas",
	sprite 		= "mods/TheArmory/files/actions/radioactivegasbomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- RADIOACTIVEGASBOMB
	spawn_probability                 = "0", -- RADIOACTIVEGASBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_radioactivegas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_radioactivegas.xml")

				add_projectile("data/entities/projectiles/bomb_radioactivegas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_RADIOACTIVEGASBOMB_SCATTER",
	name 		= "RADIOACTIVEGASBOMB SCATTER",
	description = "Releases even more toxic gas",
	sprite 		= "mods/TheArmory/files/actions/radioactivegasbomb_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- RADIOACTIVEGASBOMB_SCATTER
	spawn_probability                 = "0", -- RADIOACTIVEGASBOMB_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_radioactivegas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_radioactivegas.xml")

				add_projectile("data/entities/projectiles/bomb_radioactivegas.xml")
				add_projectile("data/entities/projectiles/bomb_radioactivegas.xml")
				add_projectile("data/entities/projectiles/bomb_radioactivegas.xml")
				add_projectile("data/entities/projectiles/bomb_radioactivegas.xml")
				c.spread_degrees = 20
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_RADIOACTIVEGASBOMB_LAYER",
	name 		= "RADIOACTIVEGASBOMB LAYER",
	description = "Lays radioactive gas bombs while it arcs",
	sprite 		= "mods/TheArmory/files/actions/radioactivegasbomb_layer.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- RADIOACTIVEGASBOMB_LAYER
	spawn_probability                 = "0", -- RADIOACTIVEGASBOMB_LAYER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_layer_radioactivegas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_layer_radioactivegas.xml")

				add_projectile("data/entities/projectiles/bomb_layer_radioactivegas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_RADIOACTIVEGASBOMB_CLUSTER",
	name 		= "RADIOACTIVEGASBOMB CLUSTER",
	description = "Releases toxic gas bombs on hit",
	sprite 		= "mods/TheArmory/files/actions/radioactivegasbomb_cluster.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- RADIOACTIVEGASBOMB_CLUSTER
	spawn_probability                 = "0", -- RADIOACTIVEGASBOMB_CLUSTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Elemental("bomb_cluster_radioactivegas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_cluster_radioactivegas.xml")

				add_projectile("data/entities/projectiles/bomb_cluster_radioactivegas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LAVABOMB",
	name 		= "LAVABOMB",
	description = "Explodes in a ball of lava",
	sprite 		= "mods/TheArmory/files/actions/lavabomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LAVABOMB
	spawn_probability                 = "0", -- LAVABOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_lava.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_lava.xml")

				add_projectile("data/entities/projectiles/bomb_lava.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LAVABOMB_SCATTER",
	name 		= "LAVABOMB SCATTER",
	description = "Explodes in many balls of lava",
	sprite 		= "mods/TheArmory/files/actions/lavabomb_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LAVABOMB_SCATTER
	spawn_probability                 = "0", -- LAVABOMB_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_lava.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_lava.xml")

				add_projectile("data/entities/projectiles/bomb_lava.xml")
				add_projectile("data/entities/projectiles/bomb_lava.xml")
				add_projectile("data/entities/projectiles/bomb_lava.xml")
				add_projectile("data/entities/projectiles/bomb_lava.xml")
				c.spread_degrees = 20
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LAVABOMB_LAYER",
	name 		= "LAVABOMB LAYER",
	description = "Lays lava bombs while it arcs",
	sprite 		= "mods/TheArmory/files/actions/lavabomb_layer.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LAVABOMB_LAYER
	spawn_probability                 = "0", -- LAVABOMB_LAYER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_layer_lava.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_layer_lava.xml")

				add_projectile("data/entities/projectiles/bomb_layer_lava.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LAVABOMB_CLUSTER",
	name 		= "LAVABOMB CLUSTER",
	description = "Releases lava bombs on hit",
	sprite 		= "mods/TheArmory/files/actions/lavabomb_cluster.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LAVABOMB_CLUSTER
	spawn_probability                 = "0", -- LAVABOMB_CLUSTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_cluster_lava.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_cluster_lava.xml")

				add_projectile("data/entities/projectiles/bomb_cluster_lava.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_WATERBOMB",
	name 		= "WATERBOMB",
	description = "Explodes in a ball of water",
	sprite 		= "mods/TheArmory/files/actions/waterbomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- WATERBOMB
	spawn_probability                 = "0", -- WATERBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_water.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_water.xml")

				add_projectile("data/entities/projectiles/bomb_water.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_WATERBOMB_SCATTER",
	name 		= "WATERBOMB SCATTER",
	description = "Explodes in many balls of water",
	sprite 		= "mods/TheArmory/files/actions/waterbomb_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- WATERBOMB_SCATTER
	spawn_probability                 = "0", -- WATERBOMB_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_water.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_water.xml")

				add_projectile("data/entities/projectiles/bomb_water.xml")
				add_projectile("data/entities/projectiles/bomb_water.xml")
				add_projectile("data/entities/projectiles/bomb_water.xml")
				add_projectile("data/entities/projectiles/bomb_water.xml")
				c.spread_degrees = 20
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_WATERBOMB_LAYER",
	name 		= "WATERBOMB LAYER",
	description = "Lays water bombs while it arcs",
	sprite 		= "mods/TheArmory/files/actions/waterbomb_layer.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- WATERBOMB_LAYER
	spawn_probability                 = "0", -- WATERBOMB_LAYER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_layer_water.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_layer_water.xml")

				add_projectile("data/entities/projectiles/bomb_layer_water.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_WATERBOMB_CLUSTER",
	name 		= "WATERBOMB CLUSTER",
	description = "Releases water bombs on hit",
	sprite 		= "mods/TheArmory/files/actions/waterbomb_cluster.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- WATERBOMB_CLUSTER
	spawn_probability                 = "0", -- WATERBOMB_CLUSTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_cluster_water.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_cluster_water.xml")

				add_projectile("data/entities/projectiles/bomb_cluster_water.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ACIDBOMB",
	name 		= "ACIDBOMB",
	description = "Explodes in a ball of acid",
	sprite 		= "mods/TheArmory/files/actions/acidbomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ACIDBOMB
	spawn_probability                 = "0", -- ACIDBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_acid.xml")

				add_projectile("data/entities/projectiles/bomb_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ACIDBOMB_SCATTER",
	name 		= "ACIDBOMB SCATTER",
	description = "Explodes in many balls of acid",
	sprite 		= "mods/TheArmory/files/actions/acidbomb_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ACIDBOMB_SCATTER
	spawn_probability                 = "0", -- ACIDBOMB_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_acid.xml")

				add_projectile("data/entities/projectiles/bomb_acid.xml")
				add_projectile("data/entities/projectiles/bomb_acid.xml")
				add_projectile("data/entities/projectiles/bomb_acid.xml")
				add_projectile("data/entities/projectiles/bomb_acid.xml")
				c.spread_degrees = 20
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ACIDBOMB_LAYER",
	name 		= "ACIDBOMB LAYER",
	description = "Lays acid bombs while it arcs",
	sprite 		= "mods/TheArmory/files/actions/acidbomb_layer.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ACIDBOMB_LAYER
	spawn_probability                 = "0", -- ACIDBOMB_LAYER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_layer_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_layer_acid.xml")

				add_projectile("data/entities/projectiles/bomb_layer_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ACIDBOMB_CLUSTER",
	name 		= "ACIDBOMB CLUSTER",
	description = "Releases acid bombs on hit",
	sprite 		= "mods/TheArmory/files/actions/acidbomb_cluster.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ACIDBOMB_CLUSTER
	spawn_probability                 = "0", -- ACIDBOMB_CLUSTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_cluster_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_cluster_acid.xml")

				add_projectile("data/entities/projectiles/bomb_cluster_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )


table.insert( actions,
{
	id          = "THEARMORYACTIONS_INCENDIARYBOMB",
	name 		= "INCENDIARYBOMB",
	description = "Explodes in a ball of fire",
	sprite 		= "mods/TheArmory/files/actions/incendiarybomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- INCENDIARYBOMB
	spawn_probability                 = "0", -- INCENDIARYBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_incendiary.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_incendiary.xml")

				add_projectile("data/entities/projectiles/bomb_incendiary.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_INCENDIARYBOMB_SCATTER",
	name 		= "INCENDIARYBOMB SCATTER",
	description = "Explodes in many balls of fire",
	sprite 		= "mods/TheArmory/files/actions/incendiarybomb_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- INCENDIARYBOMB_SCATTER
	spawn_probability                 = "0", -- INCENDIARYBOMB_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_incendiary.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_incendiary.xml")

				add_projectile("data/entities/projectiles/bomb_incendiary.xml")
				add_projectile("data/entities/projectiles/bomb_incendiary.xml")
				add_projectile("data/entities/projectiles/bomb_incendiary.xml")
				add_projectile("data/entities/projectiles/bomb_incendiary.xml")
				c.spread_degrees = 20
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_INCENDIARYBOMB_LAYER",
	name 		= "INCENDIARYBOMB LAYER",
	description = "Lays incendiary bombs while it arcs",
	sprite 		= "mods/TheArmory/files/actions/incendiarybomb_layer.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- INCENDIARYBOMB_LAYER
	spawn_probability                 = "0", -- INCENDIARYBOMB_LAYER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_layer_incendiary.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_layer_incendiary.xml")

				add_projectile("data/entities/projectiles/bomb_layer_incendiary.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_INCENDIARYBOMB_CLUSTER",
	name 		= "INCENDIARYBOMB CLUSTER",
	description = "Releases incendiary bombs on hit",
	sprite 		= "mods/TheArmory/files/actions/incendiarybomb_cluster.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- INCENDIARYBOMB_CLUSTER
	spawn_probability                 = "0", -- INCENDIARYBOMB_CLUSTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_cluster_incendiary.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_cluster_incendiary.xml")

				add_projectile("data/entities/projectiles/bomb_cluster_incendiary.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CHILLBOMB",
	name 		= "CHILLBOMB",
	description = "Chills",
	sprite 		= "mods/TheArmory/files/actions/chillbomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CHILLBOMB
	spawn_probability                 = "0", -- CHILLBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_chill.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_chill.xml")

				add_projectile("data/entities/projectiles/bomb_chill.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CHILLBOMB_SCATTER",
	name 		= "CHILLBOMB SCATTER",
	description = "More chills",
	sprite 		= "mods/TheArmory/files/actions/chillbomb_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CHILLBOMB_SCATTER
	spawn_probability                 = "0", -- CHILLBOMB_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_chill.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_chill.xml")

				add_projectile("data/entities/projectiles/bomb_chill.xml")
				add_projectile("data/entities/projectiles/bomb_chill.xml")
				add_projectile("data/entities/projectiles/bomb_chill.xml")
				add_projectile("data/entities/projectiles/bomb_chill.xml")
				c.spread_degrees = 20
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CHILLBOMB_LAYER",
	name 		= "CHILLBOMB LAYER",
	description = "Lays chill bombs while it arcs",
	sprite 		= "mods/TheArmory/files/actions/chillbomb_layer.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CHILLBOMB_LAYER
	spawn_probability                 = "0", -- CHILLBOMB_LAYER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_layer_chill.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_layer_chill.xml")

				add_projectile("data/entities/projectiles/bomb_layer_chill.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CHILLBOMB_CLUSTER",
	name 		= "CHILLBOMB CLUSTER",
	description = "Releases chill bombs on hit",
	sprite 		= "mods/TheArmory/files/actions/chillbomb_cluster.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CHILLBOMB_CLUSTER
	spawn_probability                 = "0", -- CHILLBOMB_CLUSTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_cluster_chill.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_cluster_chill.xml")

				add_projectile("data/entities/projectiles/bomb_cluster_chill.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESLABOMB",
	name 		= "TESLABOMB",
	description = "Explodes in a ball of electricity",
	sprite 		= "mods/TheArmory/files/actions/teslabomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESLABOMB
	spawn_probability                 = "0", -- TESLABOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_tesla.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_tesla.xml")

				add_projectile("data/entities/projectiles/bomb_tesla.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESLABOMB_SCATTER",
	name 		= "TESLABOMB SCATTER",
	description = "Explodes in many balls of electricity",
	sprite 		= "mods/TheArmory/files/actions/teslabomb_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESLABOMB_SCATTER
	spawn_probability                 = "0", -- TESLABOMB_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_tesla.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_tesla.xml")

				add_projectile("data/entities/projectiles/bomb_tesla.xml")
				add_projectile("data/entities/projectiles/bomb_tesla.xml")
				add_projectile("data/entities/projectiles/bomb_tesla.xml")
				add_projectile("data/entities/projectiles/bomb_tesla.xml")
				c.spread_degrees = 20
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESLABOMB_LAYER",
	name 		= "TESLABOMB LAYER",
	description = "Lays tesla bombs while it arcs",
	sprite 		= "mods/TheArmory/files/actions/teslabomb_layer.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESLABOMB_LAYER
	spawn_probability                 = "0", -- TESLABOMB_LAYER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_layer_tesla.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_layer_tesla.xml")

				add_projectile("data/entities/projectiles/bomb_layer_tesla.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESLABOMB_CLUSTER",
	name 		= "TESLABOMB CLUSTER",
	description = "Releases tesla bombs on hit",
	sprite 		= "mods/TheArmory/files/actions/teslabomb_cluster.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESLABOMB_CLUSTER
	spawn_probability                 = "0", -- TESLABOMB_CLUSTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("bomb_cluster_tesla.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_cluster_tesla.xml")

				add_projectile("data/entities/projectiles/bomb_cluster_tesla.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SMARTMINE",
	name 		= "SMARTMINE",
	description = "A smart proximity mine, triggers only when enemies get close",
	sprite 		= "mods/TheArmory/files/actions/smartmine.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SMARTMINE
	spawn_probability                 = "0", -- SMARTMINE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("smartmine.xml")

				add_projectile("data/entities/projectiles/smartmine.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SMARTMINE_SHRAPNEL",
	name 		= "SHRAPNEL SMARTMINE",
	description = "A smart shrapnel proximity mine, triggers only when enemies get close",
	sprite 		= "mods/TheArmory/files/actions/smartmine_shrapnel.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SMARTMINE_SHRAPNEL
	spawn_probability                 = "0", -- SMARTMINE_SHRAPNEL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("smartmine_shrapnel.xml")

				add_projectile("data/entities/projectiles/smartmine_shrapnel.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SMARTMINE_SHRAPNEL_SCATTER",
	name 		= "SHRAPNEL SCATTER SMARTMINE",
	description = "Shoots many shrapnel smartmines that trigger only when enemies get close",
	sprite 		= "mods/TheArmory/files/actions/smartmine_shrapnel_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SMARTMINE_SHRAPNEL_SCATTER
	spawn_probability                 = "0", -- SMARTMINE_SHRAPNEL_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("smartmine_shrapnel.xml")

				add_projectile("data/entities/projectiles/smartmine_shrapnel.xml")
				add_projectile("data/entities/projectiles/smartmine_shrapnel.xml")
				add_projectile("data/entities/projectiles/smartmine_shrapnel.xml")
				add_projectile("data/entities/projectiles/smartmine_shrapnel.xml")
				add_projectile("data/entities/projectiles/smartmine_shrapnel.xml")
				c.spread_degrees = 20
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NANOMINE",
	name 		= "NANOMINE",
	description = "Proximity mine, explodes if you get close",
	sprite 		= "mods/TheArmory/files/actions/nanomine.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- NANOMINE
	spawn_probability                 = "0", -- NANOMINE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nanomine.xml")

				add_projectile("data/entities/projectiles/nanomine.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NANOMINE_SCATTER",
	name 		= "NANOMINE SCATTER",
	description = "Proximity mine, explodes if you get close",
	sprite 		= "mods/TheArmory/files/actions/nanomine_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- NANOMINE
	spawn_probability                 = "0", -- NANOMINE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nanomine.xml")

				add_projectile("data/entities/projectiles/nanomine.xml")
				add_projectile("data/entities/projectiles/nanomine.xml")
				add_projectile("data/entities/projectiles/nanomine.xml")
				add_projectile("data/entities/projectiles/nanomine.xml")
				c.spread_degrees = 20
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NANOMINE_SCATTER_CLUSTER",
	name 		= "NANOMINE_SCATTER_CLUSTER",
	description = "Proximity mine, explodes if you get close",
	sprite 		= "mods/TheArmory/files/actions/nanomine_scatter_cluster.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- NANOMINE
	spawn_probability                 = "0", -- NANOMINE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nanomine_cluster.xml")

				add_projectile("data/entities/projectiles/nanomine_cluster.xml")
				add_projectile("data/entities/projectiles/nanomine_cluster.xml")
				add_projectile("data/entities/projectiles/nanomine_cluster.xml")
				add_projectile("data/entities/projectiles/nanomine_cluster.xml")
				c.spread_degrees = 20
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NANOMINE_CLUSTER",
	name 		= "NANOMINE CLUSTER",
	description = "Proxymity cluster mine, releases cluster bombs when explodes",
	sprite 		= "mods/TheArmory/files/actions/nanomine_cluster.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- NANOMINE_CLUSTER
	spawn_probability                 = "0", -- NANOMINE_CLUSTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nanomine_cluster.xml")

				add_projectile("data/entities/projectiles/nanomine_cluster.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end	
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NANOMINE_LAYER",
	name 		= "NANOMINE LAYER",
	description = "A mine that lays mines while it arcs in the air",
	sprite 		= "mods/TheArmory/files/actions/nanomine_layer.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- NANOMINE_CLUSTER
	spawn_probability                 = "0", -- NANOMINE_CLUSTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nanomine_layer.xml")

				add_projectile("data/entities/projectiles/nanomine_layer.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NANOMINE_LAYER_PROX",
	name 		= "NANOMINE LAYER PROX",
	description = "A mine that lays proximity nanomines while it arcs in the air",
	sprite 		= "mods/TheArmory/files/actions/nanomine_layer.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- NANOMINE_LAYER_PROX
	spawn_probability                 = "0", -- NANOMINE_LAYER_PROX
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nanomine_layer_prox.xml")

				add_projectile("data/entities/projectiles/nanomine_layer_prox.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NANOMINE_LAYER_CLUSTER",
	name 		= "NANOMINE LAYER CLUSTER",
	description = "A mine that lays cluster nanomines while it arcs in the air",
	sprite 		= "mods/TheArmory/files/actions/nanomine_layer.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- NANOMINE_LAYER_CLUSTER
	spawn_probability                 = "0", -- NANOMINE_LAYER_CLUSTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nanomine_layer_cluster.xml")

				add_projectile("data/entities/projectiles/nanomine_layer_cluster.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CHAKRAM",
	name 		= "CHAKRAM",
	description = "A sharp boomerang blade",
	sprite 		= "mods/TheArmory/files/actions/chakram.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CHAKRAM
	spawn_probability                 = "0", -- CHAKRAM
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("chakram.xml")
		
		add_projectile("data/entities/projectiles/chakram.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_IGNEOUS_CHAKRAM",
	name 		= "IGNEOUS CHAKRAM",
	description = "A sharp boomerang blade that burns everything",
	sprite 		= "mods/TheArmory/files/actions/igneous_chakram.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- IGNEOUS_CHAKRAM
	spawn_probability                 = "0", -- IGNEOUS_CHAKRAM
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_Elemental("igneous_chakram.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("igneous_chakram.xml")
		
		add_projectile("data/entities/projectiles/igneous_chakram.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FROST_CHAKRAM",
	name 		= "FROST CHAKRAM",
	description = "A sharp boomerang blade that freezes enemies it touches",
	sprite 		= "mods/TheArmory/files/actions/frost_chakram.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FROST_CHAKRAM
	spawn_probability                 = "0", -- FROST_CHAKRAM
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()

		applyTrinketsEffectsWeapons_Elemental("frost_chakram.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("frost_chakram.xml")
		
		add_projectile("data/entities/projectiles/frost_chakram.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELECTRORANG",
	name 		= "ELECTRORANG",
	description = "A boomerang that electrocutes enemies",
	sprite 		= "mods/TheArmory/files/actions/electrorang.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ELECTRORANG
	spawn_probability                 = "0", -- ELECTRORANG
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()

		applyTrinketsEffectsWeapons_Elemental("electrorang.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("electrorang.xml")
		
		add_projectile("data/entities/projectiles/electrorang.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NITRORANG",
	name 		= "NITRORANG",
	description = "A boomerang that releases unstable nitroglycerin when it hits an enemy",
	sprite 		= "mods/TheArmory/files/actions/nitrorang.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- NITRORANG
	spawn_probability                 = "0", -- NITRORANG
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_Elemental("nitrorang.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("nitrorang.xml")
	
		add_projectile("data/entities/projectiles/nitrorang.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MOLTENRANG",
	name 		= "MOLTENRANG",
	description = "A boomerang that releases lava when it hits an enemy",
	sprite 		= "mods/TheArmory/files/actions/moltenrang.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MOLTENRANG
	spawn_probability                 = "0", -- MOLTENRANG
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()

		applyTrinketsEffectsWeapons_Elemental("moltenrang.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("moltenrang.xml")
		
		add_projectile("data/entities/projectiles/moltenrang.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MAGICKNIFE",
	name 		= "MAGIC KNIFE",
	description = "A magic knife that goes back and forth",
	sprite 		= "mods/TheArmory/files/actions/magicknife.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MAGICKNIFE
	spawn_probability                 = "0", -- MAGICKNIFE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("magicknife.xml")
		
		add_projectile("data/entities/projectiles/magicknife.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MAGICKNIFE_ACID",
	name 		= "MAGIC KNIFE (ACID)",
	description = "A magic knife that goes back and forth, releasing acid when it touches an enemy",
	sprite 		= "mods/TheArmory/files/actions/magicknife_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MAGICKNIFE_ACID
	spawn_probability                 = "0", -- MAGICKNIFE_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_Elemental("magicknife_acid.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("magicknife_acid.xml")
		
		add_projectile("data/entities/projectiles/magicknife_acid.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MAGICKNIFE_POLY",
	name 		= "MAGIC KNIFE (POLYMORPHINE)",
	description = "A magic knife that goes back and forth, mutating enemies it touches",
	sprite 		= "mods/TheArmory/files/actions/magicknife_poly.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MAGICKNIFE_POLY
	spawn_probability                 = "0", -- MAGICKNIFE_POLY
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()

		applyTrinketsEffectsWeapons_Elemental("magicknife_poly.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("magicknife_poly.xml")
		
		add_projectile("data/entities/projectiles/magicknife_poly.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_PICKAXE",
	name 		= "PICKAXE",
	description = "Mines ores",
	sprite 		= "mods/TheArmory/files/actions/pickaxe.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- PICKAXE
	spawn_probability                 = "0", -- PICKAXE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/pickaxe.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CROWBAR",
	name 		= "CROWBAR",
	description = "Can open supply boxes",
	sprite 		= "mods/TheArmory/files/actions/crowbar.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CROWBAR
	spawn_probability                 = "0", -- CROWBAR
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/crowbar.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ICECKLE_BLADE",
	name 		= "ICECKLE BLADE",
	description = "Just chill",
	sprite 		= "mods/TheArmory/files/actions/iceckle_blade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ICECKLE_BLADE
	spawn_probability                 = "0", -- ICECKLE_BLADE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/iceckle.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_EXPLOSIVEPIKE_BLADE",
	name 		= "EXPLOSIVEPIKE BLADE",
	description = "Explodes on touch",
	sprite 		= "mods/TheArmory/files/actions/explosivepike_blade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- EXPLOSIVEPIKE_BLADE
	spawn_probability                 = "0", -- EXPLOSIVEPIKE_BLADE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/explosivepike.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_MORNINGSTAR",
	name 		= "FLAIL (MORNING STAR)",
	description = "Shiny and deadly",
	sprite 		= "mods/TheArmory/files/actions/flail_morningstar.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_MORNINGSTAR
	spawn_probability                 = "0", -- FLAIL_MORNINGSTAR
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_morningstar.xml")
		
		add_projectile("data/entities/projectiles/flail_morningstar.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_FROZENSCYTHE",
	name 		= "FLAIL (FROZENSCYTHE)",
	description = "Pulls and freezes things",
	sprite 		= "mods/TheArmory/files/actions/flail_frozenscythe.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_FROZENSCYTHE
	spawn_probability                 = "0", -- FLAIL_FROZENSCYTHE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_Elemental("flail_frozenscythe.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_frozenscythe.xml")
		
		add_projectile("data/entities/projectiles/flail_frozenscythe.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_SOLARFURY",
	name 		= "FLAIL (SOLARFURY)",
	description = "A small sun",
	sprite 		= "mods/TheArmory/files/actions/flail_solarfury.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_SOLARFURY
	spawn_probability                 = "0", -- FLAIL_SOLARFURY
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
	
		applyTrinketsEffectsWeapons_Elemental("flail_solarfury.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_solarfury.xml")
		
		add_projectile("data/entities/projectiles/flail_solarfury.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_JADEBLADE",
	name 		= "FLAIL (JADEBLADE)",
	description = "Long range sharpness, with lots of acid",
	sprite 		= "mods/TheArmory/files/actions/flail_jadeblade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_JADEBLADE
	spawn_probability                 = "0", -- FLAIL_JADEBLADE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_Elemental("flail_jadeblade.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_jadeblade.xml")
		
		add_projectile("data/entities/projectiles/flail_jadeblade.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_SPARKSPEAR",
	name 		= "FLAIL (SPARKSPEAR)",
	description = "A chained tasing weapon",
	sprite 		= "mods/TheArmory/files/actions/flail_sparkspear.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_SPARKSPEAR
	spawn_probability                 = "0", -- FLAIL_SPARKSPEAR
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_Elemental("flail_sparkspear.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_sparkspear.xml")
		
		add_projectile("data/entities/projectiles/flail_sparkspear.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_SPEAR",
	name 		= "FLAIL (SPEAR)",
	description = "Long range sharpness",
	sprite 		= "mods/TheArmory/files/actions/flail_spear.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_SPEAR
	spawn_probability                 = "0", -- FLAIL_SPEAR
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_spear.xml")
		
		add_projectile("data/entities/projectiles/flail_spear.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_BLADE",
	name 		= "FLAIL (BLADE)",
	description = "Long range sharpness",
	sprite 		= "mods/TheArmory/files/actions/flail_blade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_BLADE
	spawn_probability                 = "0", -- FLAIL_BLADE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_blade.xml")
		
		add_projectile("data/entities/projectiles/flail_blade.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_HOOK",
	name 		= "FLAIL (HOOK)",
	description = "Pulls things",
	sprite 		= "mods/TheArmory/files/actions/flail_hook.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_HOOK
	spawn_probability                 = "0", -- FLAIL_HOOK
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_hook.xml")
		
		add_projectile("data/entities/projectiles/flail_hook.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ATOMICSLEDGE",
	name 		= "ATOMIC SLEDGE",
	description = "Instant fallout!",
	sprite 		= "mods/TheArmory/files/actions/atomicsledge.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ATOMICSLEDGE
	spawn_probability                 = "0", -- ATOMICSLEDGE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/atomicsledge.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_EMPAXE_BLADE",
	name 		= "EMPAXE BLADE",
	description = "Electrified justice",
	sprite 		= "mods/TheArmory/files/actions/empaxe_blade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- EMPAXE_BLADE
	spawn_probability                 = "0", -- EMPAXE_BLADE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/empaxe.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELECTROPOLE_BLADE",
	name 		= "ELECTROPOLE BLADE",
	description = "Long range electricity",
	sprite 		= "mods/TheArmory/files/actions/electropole_blade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ELECTROPOLE_BLADE
	spawn_probability                 = "0", -- ELECTROPOLE_BLADE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/electropole.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CORRODAGGER_BLADE",
	name 		= "CORRODAGGER BLADE",
	description = "A magic blade that releases acid on anything it touches!",
	sprite 		= "mods/TheArmory/files/actions/corrodagger_blade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CORRODAGGER_BLADE
	spawn_probability                 = "0", -- CORRODAGGER_BLADE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/corrodagger.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHISHKEBAB_BLADE",
	name 		= "SHISHKEBAB BLADE",
	description = "It creates intense flames",
	sprite 		= "mods/TheArmory/files/actions/shishkebab_blade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHISHKEBAB_BLADE
	spawn_probability                 = "0", -- SHISHKEBAB_BLADE
	price = 600,
	mana = 20,
	action 		= function()
		
		--[[
		local shishkebab = nil
		
		if(getPlayerEntity() ~= nil) then

			local player_children = EntityGetAllChildren( getPlayerEntity() )
			for i,player_children_id in ipairs(player_children) do
			
				if(EntityGetName(player_children_id) == "inventory_quick") then
					local inventory_children = EntityGetAllChildren( player_children_id )
					for i,inventory_children_id in ipairs(inventory_children) do
						if(EntityHasTag(inventory_children_id, "shishkebab")) then
							shishkebab = inventory_children_id
						end
					end
				end
			end
			
			edit_all_components( shishkebab, "SpriteComponent", function(comp,vars)
				vars.rect_animation = "active"
			end)
			
		end
		]]
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/shishkebab.xml")
		
		--[[
		edit_all_components( shishkebab, "SpriteComponent", function(comp,vars)
			vars.rect_animation = "inactive"
		end)
		]]
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TRASH", 
	name 		= "TRASH",
	description = "Various discarded items, weaponized!",
	sprite 		= "mods/TheArmory/files/actions/trash.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TRASH
	spawn_probability                 = "0", -- TRASH
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "trash_ammo", "Trash Ammo")) then
				
				math.randomseed(tonumber(StatsGetValue("playtime")))
				local r = math.random(1,10)
				
				if r == 1 then
					applyTrinketsEffectsWeapons_SingleShotRegular("smallcan.xml")
					applyTrinketsEffectsWeapons_StackableBonusesRanged("smallcan.xml")

					add_projectile("data/entities/projectiles/smallcan.xml")
				end
				if r == 2 then
					applyTrinketsEffectsWeapons_SingleShotRegular("bigcan.xml")
					applyTrinketsEffectsWeapons_StackableBonusesRanged("bigcan.xml")

					add_projectile("data/entities/projectiles/bigcan.xml")
				end
				if r == 3 then
					applyTrinketsEffectsWeapons_SingleShotRegular("jerrycan.xml")
					applyTrinketsEffectsWeapons_StackableBonusesRanged("jerrycan.xml")

					add_projectile("data/entities/projectiles/jerrycan.xml")
				end
				if r == 4 then
					applyTrinketsEffectsWeapons_SingleShotRegular("teddybear.xml")
					applyTrinketsEffectsWeapons_StackableBonusesRanged("teddybear.xml")

					add_projectile("data/entities/projectiles/teddybear.xml")
				end
				if r == 5 then
					applyTrinketsEffectsWeapons_SingleShotRegular("lightbulb.xml")
					add_projectile("data/entities/projectiles/lightbulb.xml")
				end
				if r == 6 then
					applyTrinketsEffectsWeapons_SingleShotRegular("baseball.xml")
					applyTrinketsEffectsWeapons_StackableBonusesRanged("baseball.xml")

					add_projectile("data/entities/projectiles/baseball.xml")
				end
				if r == 7 then
					applyTrinketsEffectsWeapons_SingleShotRegular("polymorphinecontainer.xml")
					applyTrinketsEffectsWeapons_StackableBonusesRanged("polymorphinecontainer.xml")

					add_projectile("data/entities/projectiles/polymorphinecontainer.xml")
				end
				if r == 8 then
					applyTrinketsEffectsWeapons_SingleShotRegular("booze.xml")
					applyTrinketsEffectsWeapons_StackableBonusesRanged("booze.xml")

					add_projectile("data/entities/projectiles/booze.xml")
				end
				if r == 9 then
					applyTrinketsEffectsWeapons_SingleShotRegular("butcherknife.xml")
					c.damage_critical_chance = c.damage_critical_chance + 15
					applyTrinketsEffectsWeapons_StackableBonusesRanged("butcherknife.xml")

					add_projectile("data/entities/projectiles/butcherknife.xml")
				end
				if r == 10 then
					applyTrinketsEffectsWeapons_SingleShotRegular("waterpipe.xml")
					applyTrinketsEffectsWeapons_StackableBonusesRanged("waterpipe.xml")

					add_projectile("data/entities/projectiles/waterpipe.xml")
				end
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "trash_ammo", "Trash Ammo")
			end
		end

	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_DOUBLE_SABERBLADE_FREEZE",
	name 		= "DOUBLE LIGHTSABER FREEZING BLADE",
	description = "Double the fun, double the chill",
	sprite 		= "mods/TheArmory/files/actions/saberblade_double_freeze.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- DOUBLE_SABERBLADE_FREEZE
	spawn_probability                 = "0", -- DOUBLE_SABERBLADE_FREEZE
	price = 600,
	mana = 20,
	--sound_loop_tag = "sound_digger",
	--custom_xml_file = "mods/TheArmory/data/entities/energy_shield_doubleblade.xml",
	action 		= function()
		
		c.pattern_degrees = 180
		add_projectile("data/entities/projectiles/saberblade_freeze.xml")
		add_projectile("data/entities/projectiles/saberblade_freeze.xml")
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_DOUBLE_SABERBLADE_SHOCK",
	name 		= "ELECTRIFIED DOUBLE LIGHTSABER BLADE",
	description = "Double the fun, double the shock",
	sprite 		= "mods/TheArmory/files/actions/saberblade_double_shock.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- DOUBLE_SABERBLADE_SHOCK
	spawn_probability                 = "0", -- DOUBLE_SABERBLADE_SHOCK
	price = 600,
	mana = 20,
	--sound_loop_tag = "sound_digger",
	--custom_xml_file = "mods/TheArmory/data/entities/energy_shield_doubleblade.xml",
	action 		= function()
		
		c.pattern_degrees = 180
		add_projectile("data/entities/projectiles/saberblade_shock.xml")
		add_projectile("data/entities/projectiles/saberblade_shock.xml")
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_REDSTAR",
	name 		= "RED STAR",
	description = "A projectile that releases liquid fire balls when it hits something",
	sprite 		= "mods/TheArmory/files/actions/redstar.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- REDSTAR
	spawn_probability                 = "0", -- REDSTAR
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("redstar.xml")
				
				applyTrinketsEffectsWeapons_Energy("redstar.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("redstar.xml")

				add_projectile("data/entities/projectiles/redstar.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_GREENSTAR",
	name 		= "GREEN STAR",
	description = "A projectile that releases gas balls when it hits something",
	sprite 		= "mods/TheArmory/files/actions/greenstar.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- GREENSTAR
	spawn_probability                 = "0", -- GREENSTAR
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("greenstar.xml")
				
				applyTrinketsEffectsWeapons_Energy("greenstar.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("greenstar.xml")

				add_projectile("data/entities/projectiles/greenstar.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_CLAW",
	name 		= "FLAIL (CLAW)",
	description = "A weaponized robot claw",
	sprite 		= "mods/TheArmory/files/actions/flail_claw.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_CLAW
	spawn_probability                 = "0", -- FLAIL_CLAW
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_claw.xml")
		
		add_projectile("data/entities/projectiles/flail_claw.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_BOXINGGLOVE",
	name 		= "FLAIL (BOXING GLOVE)",
	description = "A spring loaded boxing glove",
	sprite 		= "mods/TheArmory/files/actions/flail_boxingglove.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_BOXINGGLOVE
	spawn_probability                 = "0", -- FLAIL_BOXINGGLOVE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_boxingglove.xml")
		
		add_projectile("data/entities/projectiles/flail_boxingglove.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_EXPLOSIVE_REDLASERBOLT",
	name 		= "EXPLOSIVE RED LASER BOLT",
	description = "A powerful red laser bolt that explodes on a ball of fire on contact",
	sprite 		= "mods/TheArmory/files/actions/explosive_redlaserbolt.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- EXPLOSIVE_REDLASERBOLT
	spawn_probability                 = "0", -- EXPLOSIVE_REDLASERBOLT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Energy("laserbolt.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("laserbolt.xml")

				add_projectile("data/entities/projectiles/laserbolt.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_EXPLOSIVE_PURPLELASERBOLT",
	name 		= "EXPLOSIVE PURPLE LASER BOLT",
	description = "A powerful purple laser bolt that explodes on a on contact and inflicts enemies it hits with poison damage",
	sprite 		= "mods/TheArmory/files/actions/explosive_purplelaserbolt.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- EXPLOSIVE_PURPLELASERBOLT
	spawn_probability                 = "0", -- EXPLOSIVE_PURPLELASERBOLT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Energy("purplelaserbolt.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("purplelaserbolt.xml")

				add_projectile("data/entities/projectiles/purplelaserbolt.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_EXPLOSIVE_PLASMABOLT",
	name 		= "EXPLOSIVE PLASMA BOLT",
	description = "A powerful plasma bolt that explodes on contact and freezes what survives the explosion",
	sprite 		= "mods/TheArmory/files/actions/explosive_plasmabolt.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- EXPLOSIVE_PLASMABOLT
	spawn_probability                 = "0", -- EXPLOSIVE_PLASMABOLT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Energy("plasmabolt_cyan.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("plasmabolt_cyan.xml")

				add_projectile("data/entities/projectiles/plasmabolt_cyan.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_GUNPOWDER_ROCKET",
	name 		= "GUNPOWDER LOADED ROCKET",
	description = "A rocket that explodes releasing unstable gunpowder on impact",
	sprite 		= "mods/TheArmory/files/actions/rocket_gunpowder.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- GUNPOWDER_ROCKET
	spawn_probability                 = "0", -- GUNPOWDER_ROCKET
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rockets_ammo", "Rockets")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("rocket_gunpowder.xml")

				add_projectile("data/entities/projectiles/rocket_gunpowder.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rockets_ammo", "Rockets")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHOTGUN",
	name 		= "SHOTGUN",
	description = "A shotgun that shoots shotgun pellets when it hits something",
	sprite 		= "mods/TheArmory/files/actions/shotgun.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHOTGUN
	spawn_probability                 = "0", -- SHOTGUN
	price = 600,
	mana = 20,
	action 		= function()
		add_projectile("data/entities/projectiles/shotgun.xml")
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHOTGUN_ENHANCED",
	name 		= "ENHANCED SHOTGUN",
	description = "A shotgun that shoots shotgun pellets while it travels midair",
	sprite 		= "mods/TheArmory/files/actions/shotgun_enhanced.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHOTGUN_ENHANCED
	spawn_probability                 = "0", -- SHOTGUN_ENHANCED
	price = 600,
	mana = 20,
	action 		= function()
		add_projectile("data/entities/projectiles/shotgun_enhanced.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_PISTOL",
	name 		= "PISTOL",
	description = "A pistol that shoots pistol rounds when it hits something",
	sprite 		= "mods/TheArmory/files/actions/pistol.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- PISTOL
	spawn_probability                 = "0", -- PISTOL
	price = 600,
	mana = 20,
	action 		= function()
		add_projectile("data/entities/projectiles/pistol.xml")
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_PISTOL_ENHANCED",
	name 		= "ENHANCED PISTOL",
	description = "A pistol that shoots pistol rounds while it travels midair",
	sprite 		= "mods/TheArmory/files/actions/pistol_enhanced.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- PISTOL_ENHANCED
	spawn_probability                 = "0", -- PISTOL_ENHANCED
	price = 600,
	mana = 20,
	action 		= function()
		add_projectile("data/entities/projectiles/pistol_enhanced.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ASSAULTRIFLE",
	name 		= "ASSAULT RIFLE",
	description = "An assault rifle that shoots rifle rounds when it hits something",
	sprite 		= "mods/TheArmory/files/actions/assaultrifle.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ASSAULTRIFLE
	spawn_probability                 = "0", -- ASSAULTRIFLE
	price = 600,
	mana = 20,
	action 		= function()
		add_projectile("data/entities/projectiles/assaultrifle.xml")
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ASSAULTRIFLE_ENHANCED",
	name 		= "ENHANCED ASSAULT RIFLE",
	description = "An assault rifle that shoots rifle rounds while it travels midair",
	sprite 		= "mods/TheArmory/files/actions/assaultrifle_enhanced.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ASSAULTRIFLE_ENHANCED
	spawn_probability                 = "0", -- ASSAULTRIFLE_ENHANCED
	price = 600,
	mana = 20,
	action 		= function()
		add_projectile("data/entities/projectiles/assaultrifle_enhanced.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ARTILLERY_ORB",
	name 		= "ARTILLERY ORB",
	description = "An orb that shoots rifle bullets in a clock wise sequence",
	sprite 		= "mods/TheArmory/files/actions/artillery_orb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ARTILERY_ORB
	spawn_probability                 = "0", -- ARTILERY_ORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rockets_ammo", "Rockets")) then
				
				add_projectile("data/entities/projectiles/artillery_orb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rockets_ammo", "Rockets")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_KATANA_RED",
	name 		= "RED BLADE KATANA",
	description = "An energy blade that releases liquid fire on enemies it touches",
	sprite 		= "mods/TheArmory/files/actions/katana_red.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- KATANA_RED
	spawn_probability                 = "0", -- KATANA_RED
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/katana_red.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_KATANA_GREEN",
	name 		= "GREEN BLADE KATANA",
	description = "An energy blade that releases radioactive gas on enemies it touches",
	sprite 		= "mods/TheArmory/files/actions/katana_green.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- KATANA_GREEN
	spawn_probability                 = "0", -- KATANA_GREEN
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/katana_green.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BLUE_WAVE_PROJECTILE",
	name 		= "BLUE WAVE PROJECTILE",
	description = "A projectile that periodically releases thunderbolts as it travels",
	sprite 		= "mods/TheArmory/files/actions/bluewaveprojectile.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BLUE_WAVE_PROJECTILE
	spawn_probability                 = "0", -- BLUE_WAVE_PROJECTILE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Elemental("bluewave.xml")
				
				applyTrinketsEffectsWeapons_Energy("bluewave.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bluewave.xml")

				add_projectile("data/entities/projectiles/bluewave.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CYAN_WAVE_PROJECTILE",
	name 		= "CYAN WAVE PROJECTILE",
	description = "A projectile that creates a freeze trail as it travels",
	sprite 		= "mods/TheArmory/files/actions/cyanwaveprojectile.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CYAN_WAVE_PROJECTILE
	spawn_probability                 = "0", -- CYAN_WAVE_PROJECTILE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Elemental("cyanwave.xml")
				
				applyTrinketsEffectsWeapons_Energy("cyanwave.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("cyanwave.xml")

				add_projectile("data/entities/projectiles/cyanwave.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CROSSBOW_BOLT",
	name 		= "CROSSBOW BOLT",
	description = "A bolt prepared for use with a crossbow",
	sprite 		= "mods/TheArmory/files/actions/crossbowbolt.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CROSSBOW_BOLT
	spawn_probability                 = "0", -- CROSSBOW_BOLT
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "crossbowbolts_ammo", "Crossbow Bolts")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("crossbowbolt.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("crossbowbolt.xml")

				add_projectile("data/entities/projectiles/crossbowbolt.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "crossbowbolts_ammo", "Crossbow Bolts")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_WHIP",
	name 		= "WHIP",
	description = "Portable way to break the sound barrier",
	sprite 		= "mods/TheArmory/files/actions/flail_whip.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_WHIP
	spawn_probability                 = "0", -- FLAIL_WHIP
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_whip.xml")
		
		add_projectile("data/entities/projectiles/flail_whip.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_DRILL",
	name 		= "DRILL",
	description = "Causes controlled cave ins where it hits",
	sprite 		= "mods/TheArmory/files/actions/drill.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- DRILL
	spawn_probability                 = "0", -- DRILL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("drill.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("drill.xml")

				add_projectile("data/entities/projectiles/drill.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SANDBOMB",
	name 		= "SANDBOMB",
	description = "A bomb that releases sand on impact",
	sprite 		= "mods/TheArmory/files/actions/sandbomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SANDBOMB
	spawn_probability                 = "0", -- SANDBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_sand.xml")

				add_projectile("data/entities/projectiles/bomb_sand.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FIREWORK_STICKS",
	name 		= "FIREWORK STICKS ",
	description = "A bundle of firework sticks launched together",
	sprite 		= "mods/TheArmory/files/actions/firework_sticks.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FIREWORK_STICKS
	spawn_probability                 = "0", -- FIREWORK_STICKS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rockets_ammo", "Rockets")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fireworks_red.xml")

				add_projectile("data/entities/projectiles/fireworks_red.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fireworks_green.xml")

				add_projectile("data/entities/projectiles/fireworks_green.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fireworks_blue.xml")

				add_projectile("data/entities/projectiles/fireworks_blue.xml")
				c.spread_degrees = 12
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rockets_ammo", "Rockets")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NAPALM",
	name 		= "NAPALM",
	description = "A bomb that breaks down into incendiary bombs mid-air",
	sprite 		= "mods/TheArmory/files/actions/napalm.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MININUKE
	spawn_probability                 = "0", -- MININUKE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "mininukes_ammo", "Mininukes")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("mininuke.xml")

				add_projectile("data/entities/projectiles/napalm.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "mininukes_ammo", "Mininukes")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FIREWORKSBOMB",
	name 		= "FIREWORKSBOMB",
	description = "A bomb that releases unstable gunpowder on impact",
	sprite 		= "mods/TheArmory/files/actions/fireworksbomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SANDBOMB
	spawn_probability                 = "0", -- SANDBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_fireworks.xml")

				add_projectile("data/entities/projectiles/bomb_fireworks.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FIREWORKSBOMB_SCATTER",
	name 		= "FIREWORKSBOMB SCATTER",
	description = "A volley of fireworks bombs",
	sprite 		= "mods/TheArmory/files/actions/fireworksbomb_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ACIDBOMB_SCATTER
	spawn_probability                 = "0", -- ACIDBOMB_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bomb_fireworks.xml")

				add_projectile("data/entities/projectiles/bomb_fireworks.xml")
				add_projectile("data/entities/projectiles/bomb_fireworks.xml")
				add_projectile("data/entities/projectiles/bomb_fireworks.xml")
				add_projectile("data/entities/projectiles/bomb_fireworks.xml")
				c.spread_degrees = 20
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MOLTENBALL",
	name 		= "MOLTENBALL",
	description = "A ball of explosive molten rock",
	sprite 		= "mods/TheArmory/files/actions/moltenball.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MOLTENBALL
	spawn_probability                 = "0", -- MOLTENBALL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Elemental("fireball_custom.xml")
				
				applyTrinketsEffectsWeapons_Energy("fireball_custom.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fireball_custom.xml")

				add_projectile("data/entities/projectiles/fireball_custom.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BALLISTIC_ORB",
	name 		= "BALLISTIC ORB",
	description = "An orb that shoots rifle bullets horizontally",
	sprite 		= "mods/TheArmory/files/actions/ballisticorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BALLISTIC_ORB
	spawn_probability                 = "0", -- BALLISTIC_ORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				add_projectile("data/entities/projectiles/ballisticorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LASER_ORB",
	name 		= "LASER ORB",
	description = "An orb that shoots laser bolts in a clockwise pattern",
	sprite 		= "mods/TheArmory/files/actions/laserorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LASER_ORB
	spawn_probability                 = "0", -- LASER_ORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("laserorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("laserorb.xml")

				add_projectile("data/entities/projectiles/laserorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_PLASMA_ORB",
	name 		= "PLASMA ORB",
	description = "An orb that shoots plasma bolts in a clockwise pattern",
	sprite 		= "mods/TheArmory/files/actions/plasmaorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- PLASMA_ORB
	spawn_probability                 = "0", -- PLASMA_ORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("plasmaorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("plasmaorb.xml")

				add_projectile("data/entities/projectiles/plasmaorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_THUNDERBOLT_BOMB",
	name 		= "THUNDERBOLT BOMB",
	description = "A bomb that releases thunderbolts on impact",
	sprite 		= "mods/TheArmory/files/actions/thunderboltbomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- PLASMA_ORB
	spawn_probability                 = "0", -- PLASMA_ORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("thunderboltbomb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("thunderboltbomb.xml")

				add_projectile("data/entities/projectiles/thunderboltbomb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_THUNDERBOLT_BOMB_SCATTER",
	name 		= "THUNDERBOLT BOMB_SCATTER",
	description = "Launches many thunderbolt bombs",
	sprite 		= "mods/TheArmory/files/actions/thunderboltbomb_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THUNDERBOLT_BOMB_SCATTER
	spawn_probability                 = "0", -- THUNDERBOLT_BOMB_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("thunderboltbomb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("thunderboltbomb.xml")

				add_projectile("data/entities/projectiles/thunderboltbomb.xml")
				add_projectile("data/entities/projectiles/thunderboltbomb.xml")
				add_projectile("data/entities/projectiles/thunderboltbomb.xml")
				c.spread_degrees = 25
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FISSION_BOMB",
	name 		= "FISSION BOMB",
	description = "A bomb that combines radioactive isotopes with a payload of agitated neutron mass",
	sprite 		= "mods/TheArmory/files/actions/fissionbomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FISSION_BOMB
	spawn_probability                 = "0", -- FISSION_BOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("fissionbomb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fissionbomb.xml")

				add_projectile("data/entities/projectiles/fissionbomb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_STATUE",
	name 		= "STATUE",
	description = "A weaponized statue",
	sprite 		= "mods/TheArmory/files/actions/statue.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FISSION_BOMB
	spawn_probability                 = "0", -- FISSION_BOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_SingleShotRegular("statue.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("statue.xml")

				add_projectile("data/entities/projectiles/statue.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPEARPROJECTILE",
	name 		= "SPEAR",
	description = "A spear that stickis to enemies",
	sprite 		= "mods/TheArmory/files/actions/spearprojectile.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPEAR
	spawn_probability                 = "0", -- SPEAR
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "spears_ammo", "Spears")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spearprojectile.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spearprojectile.xml")

				add_projectile("data/entities/projectiles/spearprojectile.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "spears_ammo", "Spears")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHOVELPROJECTILE_ENHANCED",
	name 		= "SHOVEL PROJECTILE (ENHANCED)",
	description = "It digs anything, and keeps going!",
	sprite 		= "mods/TheArmory/files/actions/shovelprojectile_enhanced.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHOVELPROJECTILE_ENHANCED
	spawn_probability                 = "0", -- SHOVELPROJECTILE_ENHANCED
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "shovels_ammo", "Shovels")) then
				
				applyTrinketsEffectsWeapons_SingleShotRegular("shovelprojectile_enhanced.xml")

				applyTrinketsEffectsWeapons_StackableBonusesRanged("shovelprojectile_enhanced.xml")

				add_projectile("data/entities/projectiles/shovelprojectile_enhanced.xml")

				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "shovels_ammo", "Shovels")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ANCHOR",
	name 		= "ANCHOR",
	description = "Transforms enemies it touches into fish!",
	sprite 		= "mods/TheArmory/files/actions/anchor.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ANCHOR
	spawn_probability                 = "0", -- ANCHOR
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("anchor.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("anchor.xml")

				add_projectile("data/entities/projectiles/anchor.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTAL_BUBBLES",
	name 		= "ELEMENTAL BUBBLES",
	description = "Random elemental bubbles",
	sprite 		= "mods/TheArmory/files/actions/elementalbubbles.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ANCHOR
	spawn_probability                 = "0", -- ANCHOR
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "fluid_ammo", "Fluid Ammo")) then
				
				math.randomseed(tonumber(StatsGetValue("playtime")))
				local r = math.random(1,4)
				
				if(r == 1) then
					applyTrinketsEffectsWeapons_Elemental("bubble_acid.xml")
					applyTrinketsEffectsWeapons_StackableBonusesRanged("bubble_acid.xml")

					add_projectile("data/entities/projectiles/bubble_acid.xml")
				elseif(r == 2) then
					applyTrinketsEffectsWeapons_Elemental("bubble_lava.xml")
					applyTrinketsEffectsWeapons_StackableBonusesRanged("bubble_lava.xml")

					add_projectile("data/entities/projectiles/bubble_lava.xml")
				elseif(r == 3) then
					applyTrinketsEffectsWeapons_Elemental("bubble_teleportium.xml")
					applyTrinketsEffectsWeapons_StackableBonusesRanged("bubble_teleportium.xml")

					add_projectile("data/entities/projectiles/bubble_teleportium.xml")
				elseif(r == 4) then
					applyTrinketsEffectsWeapons_Elemental("bubble_polymorphine.xml")
					applyTrinketsEffectsWeapons_StackableBonusesRanged("bubble_polymorphine.xml")

					add_projectile("data/entities/projectiles/bubble_polymorphine.xml")
				end
				--c.spread_degrees = 15
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "fluid_ammo", "Fluid Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPIKEBALL",
	name 		= "SPIKEBALL",
	description = "A spiked ball that releases flaming spikes on impact",
	sprite 		= "mods/TheArmory/files/actions/spikeball.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPIKEBALL
	spawn_probability                 = "0", -- SPIKEBALL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spikeball.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spikeball.xml")

				add_projectile("data/entities/projectiles/spikeball.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ICESPEAR",
	name 		= "ICE SPEAR",
	description = "A spear made of ice that explodes into ice spikes on impact",
	sprite 		= "mods/TheArmory/files/actions/icespear.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ICESPEAR
	spawn_probability                 = "0", -- ICESPEAR
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Elemental("icespear.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("icespear.xml")

				add_projectile("data/entities/projectiles/icespear.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_INFERNALSPEAR",
	name 		= "INFERNAL SPEAR",
	description = "A spear that explodes into liquid fire on impact",
	sprite 		= "mods/TheArmory/files/actions/infernalspear.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ICESPEAR
	spawn_probability                 = "0", -- ICESPEAR
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Elemental("infernalspear.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("infernalspear.xml")

				add_projectile("data/entities/projectiles/infernalspear.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MUTATING_SCYTHE",
	name 		= "MUTATING SCYTHE",
	description = "Mutates enemies it touches",
	sprite 		= "mods/TheArmory/files/actions/mutatingscythe.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MUTATING_SCYTHE
	spawn_probability                 = "0", -- MUTATING_SCYTHE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/mutatingscythe.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CROSSBOW_BOLT_POISON",
	name 		= "CROSSBOW BOLT (POISON)",
	description = "A crossbow bolt that releases poison on impact",
	sprite 		= "mods/TheArmory/files/actions/crossbowbolt_poison.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CROSSBOW_BOLT_POISON
	spawn_probability                 = "0", -- CROSSBOW_BOLT_POISON
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "crossbowbolts_ammo", "Crossbow Bolts")) then
			
				applyTrinketsEffectsWeapons_Elemental("crossbowbolt_poison.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("crossbowbolt_poison.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("crossbowbolt_poison.xml")

				add_projectile("data/entities/projectiles/crossbowbolt_poison.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "crossbowbolts_ammo", "Crossbow Bolts")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CROSSBOW_BOLT_ACID",
	name 		= "CROSSBOW BOLT (ACID)",
	description = "A crossbow bolt that releases acid on impact",
	sprite 		= "mods/TheArmory/files/actions/crossbowbolt_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CROSSBOW_BOLT_ACID
	spawn_probability                 = "0", -- CROSSBOW_BOLT_ACID
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "crossbowbolts_ammo", "Crossbow Bolts")) then
				
				applyTrinketsEffectsWeapons_Elemental("crossbowbolt_acid.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("crossbowbolt_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("crossbowbolt_acid.xml")

				add_projectile("data/entities/projectiles/crossbowbolt_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "crossbowbolts_ammo", "Crossbow Bolts")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CANISTER_ACID",
	name 		= "CANISTER (ACID)",
	description = "A canister that periodically releases small streams of acid while it travels mid-air",
	sprite 		= "mods/TheArmory/files/actions/canister_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CANISTER_ACID
	spawn_probability                 = "0", -- CANISTER_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Elemental("canister_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("canister_acid.xml")

				add_projectile("data/entities/projectiles/canister_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CANISTER_POISON",
	name 		= "CANISTER (POISON)",
	description = "A canister that periodically releases small streams of poison while it travels mid-air",
	sprite 		= "mods/TheArmory/files/actions/canister_poison.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CANISTER_POISON
	spawn_probability                 = "0", -- CANISTER_POISON
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("canister_poison.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("canister_poison.xml")

				add_projectile("data/entities/projectiles/canister_poison.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAMES",
	name 		= "FLAMES",
	description = "Disaster girl feelings",
	sprite 		= "mods/TheArmory/files/actions/flames.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- WATERBOLT
	spawn_probability                 = "0", -- WATERBOLT
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "fuel_ammo", "Fuel")) then
			
				add_projectile("data/entities/projectiles/materialline_long_flames.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "fuel_ammo", "Fuel")
			end
		end

	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPIKEBALL_SMALL",
	name 		= "SMALL SPIKEBALL",
	description = "A spiked ball that releases fire lines at random directions",
	sprite 		= "mods/TheArmory/files/actions/spikeball_small.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPIKEBALL
	spawn_probability                 = "0", -- SPIKEBALL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_SingleShotRegular("spikeball_small.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spikeball_small.xml")

				add_projectile("data/entities/projectiles/spikeball_small.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPIKEBALL_SMALL_SCATTER",
	name 		= "SMALL SPIKEBALL (SCATTER)",
	description = "Shoots multiple small spikeballs",
	sprite 		= "mods/TheArmory/files/actions/spikeball_small_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPIKEBALL_SMALL_SCATTER
	spawn_probability                 = "0", -- SPIKEBALL_SMALL_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_ScatterShotRegular("spikeball_small.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spikeball_small.xml")

				add_projectile("data/entities/projectiles/spikeball_small.xml")
				add_projectile("data/entities/projectiles/spikeball_small.xml")
				add_projectile("data/entities/projectiles/spikeball_small.xml")
				add_projectile("data/entities/projectiles/spikeball_small.xml")
				c.spread_degrees = 25
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_WARDROBE",
	name 		= "WARDROBE",
	description = "A wardrobe that releases clothes on impact",
	sprite 		= "mods/TheArmory/files/actions/wardrobe.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- WARDROBE
	spawn_probability                 = "0", -- WARDROBE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then	
				
				applyTrinketsEffectsWeapons_SingleShotRegular("wardrobe.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("wardrobe.xml")

				add_projectile("data/entities/projectiles/wardrobe.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CRYSTALPROJECTILE_ACID",
	name 		= "ACID CRYSTAL",
	description = "A crystal that explodes into shards on impact",
	sprite 		= "mods/TheArmory/files/actions/crystalprojectile_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CRYSTALPROJECTILE_ACID
	spawn_probability                 = "0", -- CRYSTALPROJECTILE_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("crystalprojectile_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("crystalprojectile_acid.xml")

				add_projectile("data/entities/projectiles/crystalprojectile_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CANISTER_NITRO",
	name 		= "CANISTER (NITROGLYCERIN)",
	description = "A canister that periodically releases small streams of nitroglycerin while it travels mid-air",
	sprite 		= "mods/TheArmory/files/actions/canister_nitro.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CANISTER_NITRO
	spawn_probability                 = "0", -- CANISTER_NITRO
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("canister_nitro.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("canister_nitro.xml")

				add_projectile("data/entities/projectiles/canister_nitro.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CRYSTALPROJECTILE_POLY",
	name 		= "POLYMORPHINE CRYSTAL",
	description = "A crystal that explodes into shards on impact",
	sprite 		= "mods/TheArmory/files/actions/crystalprojectile_poly.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CRYSTALPROJECTILE_POLY
	spawn_probability                 = "0", -- CRYSTALPROJECTILE_POLY
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Elemental("crystalprojectile_poly.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("crystalprojectile_poly.xml")

				add_projectile("data/entities/projectiles/crystalprojectile_poly.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NAIL_OVERHEATED",
	name 		= "NAIL (OVERHEATED)",
	description = "A makeshift bullet, burning enemies it touches",
	sprite 		= "mods/TheArmory/files/actions/nail_overheated.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- NAIL
	spawn_probability                 = "0", -- NAIL
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "nails_ammo", "Nails")) then
				
				applyTrinketsEffectsWeapons_Elemental("nail_overheated.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("nail_overheated.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nail_overheated.xml")

				add_projectile("data/entities/projectiles/nail_overheated.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "nails_ammo", "Nails")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NITROLANCE_BLADE",
	name 		= "NITROLANCE BLADE",
	description = "A magic blade imbued with nitroglycerin",
	sprite 		= "mods/TheArmory/files/actions/nitrolance.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- NITROLANCE_BLADE
	spawn_probability                 = "0", -- NITROLANCE_BLADE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/nitrolance.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAME_SABER",
	name 		= "FLAME SABER",
	description = "A fiery blade that creates small fire explosions when it touches something",
	sprite 		= "mods/TheArmory/files/actions/flamesaber.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAMESABER
	spawn_probability                 = "0", -- FLAMESABER
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/flamesaber.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LONG_SWORD",
	name 		= "LONG SWORD",
	description = "Straight from the round table!",
	sprite 		= "mods/TheArmory/files/actions/longsword.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LONG_SWORD
	spawn_probability                 = "0", -- LONG_SWORD
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/longsword.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MORNING_STAR",
	name 		= "MORNING STAR",
	description = "A spiked blunt weapon",
	sprite 		= "mods/TheArmory/files/actions/morningstar.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MORNING_STAR
	spawn_probability                 = "0", -- MORNING_STAR
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/morningstar.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHORT_AXE",
	name 		= "SHORT AXE",
	description = "Chop time!",
	sprite 		= "mods/TheArmory/files/actions/shortaxe.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHORT_AXE
	spawn_probability                 = "0", -- SHORT_AXE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/shortaxe.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALBLADE_WATER",
	name 		= "ELEMENTAL BLADE (WATER)",
	description = "A magic blade made out of water",
	sprite 		= "mods/TheArmory/files/actions/elementalblade_water.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ELEMENTALBLADE_WATER
	spawn_probability                 = "0", -- ELEMENTALBLADE_WATER
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/elementalblade_water.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CRYSTALPROJECTILE_LAVA",
	name 		= "LAVA CRYSTAL",
	description = "A crystal that explodes into shards on impact",
	sprite 		= "mods/TheArmory/files/actions/crystalprojectile_lava.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CRYSTALPROJECTILE_LAVA
	spawn_probability                 = "0", -- CRYSTALPROJECTILE_LAVA
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Elemental("crystalprojectile_lava.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("crystalprojectile_lava.xml")

				add_projectile("data/entities/projectiles/crystalprojectile_lava.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_VILE_AXE",
	name 		= "VILE AXE",
	description = "A magic axe imbued with poison",
	sprite 		= "mods/TheArmory/files/actions/vileaxe.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- VILE_AXE
	spawn_probability                 = "0", -- VILE_AXE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/vileaxe.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALBLADE_ACID",
	name 		= "ELEMENTAL BLADE (ACID)",
	description = "A magic blade made out of acid",
	sprite 		= "mods/TheArmory/files/actions/elementalblade_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ELEMENTALBLADE_WATER
	spawn_probability                 = "0", -- ELEMENTALBLADE_WATER
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/elementalblade_acid.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALBLADE_BLOOD",
	name 		= "ELEMENTAL BLADE (BLOOD)",
	description = "A magic blade made out of blood",
	sprite 		= "mods/TheArmory/files/actions/elementalblade_blood.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ELEMENTALBLADE_BLOOD
	spawn_probability                 = "0", -- ELEMENTALBLADE_BLOOD
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/elementalblade_blood.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MJOLNIR",
	name 		= "MJOLNIR",
	description = "Only the worthy shall wield it",
	sprite 		= "mods/TheArmory/files/actions/mjolnir.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MJOLNIR
	spawn_probability                 = "0", -- MJOLNIR
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/mjolnir.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BOLAS",
	name 		= "BOLAS",
	description = "A projectile that explodes into small spikeballs on impact",
	sprite 		= "mods/TheArmory/files/actions/bolas.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BOLAS
	spawn_probability                 = "0", -- BOLAS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bolas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bolas.xml")

				add_projectile("data/entities/projectiles/bolas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_RPG",
	name 		= "RPG",
	description = "Rocket propelled grenade, releases deadly shrapnel on impact so be sure to have cover",
	sprite 		= "mods/TheArmory/files/actions/rpg.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BOLAS
	spawn_probability                 = "0", -- BOLAS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rockets_ammo", "Rockets")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("rpg.xml")

				add_projectile("data/entities/projectiles/rpg.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rockets_ammo", "Rockets")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTAL_BOLAS",
	name 		= "ELEMENTAL BOLAS",
	description = "A projectile that explodes into small spikeballs and icespikes on impact",
	sprite 		= "mods/TheArmory/files/actions/elementalbolas.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ELEMENTAL_BOLAS
	spawn_probability                 = "0", -- ELEMENTAL_BOLAS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Elemental("elementalbolas.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("elementalbolas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalbolas.xml")

				add_projectile("data/entities/projectiles/elementalbolas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FIREWORKS_ORB",
	name 		= "FIREWORKS ORB",
	description = "An orb that throws explosive fireworks fragments",
	sprite 		= "mods/TheArmory/files/actions/fireworksorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BOLAS
	spawn_probability                 = "0", -- BOLAS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fireworksorb.xml")

				add_projectile("data/entities/projectiles/fireworksorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FIREWORKS_HEAVY",
	name 		= "HEAVY FIREWORKS",
	description = "A heavy fireworks rocket",
	sprite 		= "mods/TheArmory/files/actions/fireworks_heavy.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FIREWORKS_HEAVY
	spawn_probability                 = "0", -- FIREWORKS_HEAVY
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rockets_ammo", "Rockets")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fireworks_heavy.xml")

				add_projectile("data/entities/projectiles/fireworks_heavy.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rockets_ammo", "Rockets")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_ACID",
	name 		= "SPITBOMB (ACID)",
	description = "A bomb that explodes spitting acid",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_ACID
	spawn_probability                 = "0", -- SPITBOMB_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_acid.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_acid.xml")

				add_projectile("data/entities/projectiles/spitbomb_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_WATER",
	name 		= "SPITBOMB (WATER)",
	description = "A bomb that explodes spitting water",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_water.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_WATER
	spawn_probability                 = "0", -- SPITBOMB_WATER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_water.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_water.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_water.xml")

				add_projectile("data/entities/projectiles/spitbomb_water.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_FREEZING_GAS",
	name 		= "SPITBOMB (FREEZING GAS)",
	description = "A bomb that explodes spitting freezing gas",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_freezing_gas.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_FREEZING_GAS
	spawn_probability                 = "0", -- SPITBOMB_FREEZING_GAS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Elemental("spitbomb_freezing_gas.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_freezing_gas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_freezing_gas.xml")

				add_projectile("data/entities/projectiles/spitbomb_freezing_gas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_RADIOACTIVE_GAS",
	name 		= "SPITBOMB (RADIOACTIVE GAS)",
	description = "A bomb that explodes spitting toxic gas",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_radioactive_gas.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_RADIOACTIVE_GAS
	spawn_probability                 = "0", -- SPITBOMB_RADIOACTIVE_GAS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_radioactive_gas.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_radioactive_gas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_radioactive_gas.xml")

				add_projectile("data/entities/projectiles/spitbomb_radioactive_gas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_NITRO",
	name 		= "SPITBOMB (NITRO)",
	description = "A bomb that explodes spitting nitroglycerin",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_nitro.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_NITRO
	spawn_probability                 = "0", -- SPITBOMB_NITRO
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_nitro.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_nitro.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_nitro.xml")

				add_projectile("data/entities/projectiles/spitbomb_nitro.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_POISON",
	name 		= "SPITBOMB (POISON)",
	description = "A bomb that explodes spitting poison",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_poison.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_POISON
	spawn_probability                 = "0", -- SPITBOMB_POISON
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_poison.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_poison.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_poison.xml")

				add_projectile("data/entities/projectiles/spitbomb_poison.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_POLY",
	name 		= "SPITBOMB (POLY)",
	description = "A bomb that explodes spitting polymorphine",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_poly.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_POLY
	spawn_probability                 = "0", -- SPITBOMB_POLY
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_poly.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_poly.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_poly.xml")

				add_projectile("data/entities/projectiles/spitbomb_poly.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_ANTIPOLY",
	name 		= "SPITBOMB (ANTIPOLY)",
	description = "A bomb that explodes spitting anti-polymorphine",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_antipoly.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_ANTIPOLY
	spawn_probability                 = "0", -- SPITBOMB_ANTIPOLY
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_antipoly.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_antipoly.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_antipoly.xml")

				add_projectile("data/entities/projectiles/spitbomb_antipoly.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_LAVA",
	name 		= "SPITBOMB (LAVA)",
	description = "A bomb that explodes spitting lava",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_lava.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_LAVA
	spawn_probability                 = "0", -- SPITBOMB_LAVA
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_lava.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_lava.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_lava.xml")

				add_projectile("data/entities/projectiles/spitbomb_lava.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_PROPANE_GAS",
	name 		= "SPITBOMB (PROPANE GAS)",
	description = "A bomb that explodes spitting propane gas",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_propane_gas.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_PROPANE_GAS
	spawn_probability                 = "0", -- SPITBOMB_PROPANE_GAS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_propane_gas.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_propane_gas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_propane_gas.xml")

				add_projectile("data/entities/projectiles/spitbomb_propane_gas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_BLOOD",
	name 		= "SPITBOMB (BLOOD)",
	description = "A bomb that explodes spitting blood",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_blood.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_BLOOD
	spawn_probability                 = "0", -- SPITBOMB_BLOOD
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_blood.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_blood.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_blood.xml")

				add_projectile("data/entities/projectiles/spitbomb_blood.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CHAOSSTAR_PROJECTILE",
	name 		= "CHAOS STAR PROJECTILE",
	description = "Explodes into ice spikes on impact",
	sprite 		= "mods/TheArmory/files/actions/chaosstar_projectile.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CHAOSSTAR_PROJECTILE
	spawn_probability                 = "0", -- CHAOSSTAR_PROJECTILE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("chaosstar_projectile.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("chaosstar_projectile.xml")

				add_projectile("data/entities/projectiles/chaosstar_projectile.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPEARPROJECTILE_STICKY",
	name 		= "STICKY SPEAR",
	description = "A spear that pins enemies down",
	sprite 		= "mods/TheArmory/files/actions/spearprojectile_sticky.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPEARPROJECTILE_STICKY
	spawn_probability                 = "0", -- SPEARPROJECTILE_STICKY
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "spears_ammo", "Spears")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spearprojectile_sticky.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spearprojectile_sticky.xml")

				add_projectile("data/entities/projectiles/spearprojectile_sticky.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "spears_ammo", "Spears")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_GRINDER",
	name 		= "GRINDER",
	description = "A grinder wheel that sticks to enemies, spinning and dealing damage overtime",
	sprite 		= "mods/TheArmory/files/actions/grinder.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPINNINGSPIKEBALL
	spawn_probability                 = "0", -- SPINNINGSPIKEBALL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("grinder.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("grinder.xml")

				add_projectile("data/entities/projectiles/grinder.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_GRINDER_SCATTER",
	name 		= "GRINDER",
	description = "Multiple grinders shot at the same time",
	sprite 		= "mods/TheArmory/files/actions/grinder_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- GRINDER_SCATTER
	spawn_probability                 = "0", -- GRINDER_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_ScatterShotRegular("grinder.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("grinder.xml")

				add_projectile("data/entities/projectiles/grinder.xml")
				add_projectile("data/entities/projectiles/grinder.xml")
				add_projectile("data/entities/projectiles/grinder.xml")
				add_projectile("data/entities/projectiles/grinder.xml")
				c.spread_degrees = 25 
				
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP",
	name 		= "BUBBLE TRAP",
	description = "A bubble that traps enemies it comes in contact with and explodes afterwards",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP
	spawn_probability                 = "0", -- BUBBLETRAP
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap.xml")

				add_projectile("data/entities/projectiles/bubbletrap.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_ELECTRIFIED",
	name 		= "ELECTRIFIED BUBBLE TRAP",
	description = "A bubble that traps and electrocutes enemies it comes in contact with and explodes afterwards",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_electrified.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP
	spawn_probability                 = "0", -- BUBBLETRAP
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("bubbletrap_electrified.xml")
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_electrified.xml")

				add_projectile("data/entities/projectiles/bubbletrap_electrified.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_OVERHEATED",
	name 		= "OVERHEATED BUBBLE TRAP",
	description = "A bubble that traps and sets on fire enemies it comes in contact with and explodes afterwards",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_overheated.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP_OVERHEATED
	spawn_probability                 = "0", -- BUBBLETRAP_OVERHEATED
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("bubbletrap_overheated.xml")
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_overheated.xml")

				add_projectile("data/entities/projectiles/bubbletrap_overheated.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_ACID",
	name 		= "ACID BUBBLE TRAP",
	description = "A bubble that traps enemies it comes in contact with and explodes afterwards, releasing acid",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP_ACID
	spawn_probability                 = "0", -- BUBBLETRAP_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("bubbletrap_acid.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_acid.xml")

				add_projectile("data/entities/projectiles/bubbletrap_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_FREEZING",
	name 		= "FREEZING BUBBLE TRAP",
	description = "A bubble that traps and freezes enemies it comes in contact with and explodes afterwards, releasing freezing gas",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_freezing.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP_FREEZING
	spawn_probability                 = "0", -- BUBBLETRAP_FREEZING
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("bubbletrap_freezing.xml")
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_freezing.xml")

				add_projectile("data/entities/projectiles/bubbletrap_freezing.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_GRINDER",
	name 		= "GRINDER BUBBLE TRAP",
	description = "A bubble that traps and damages enemies it comes in contact with and explodes afterwards",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_grinder.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP_GRINDER
	spawn_probability                 = "0", -- BUBBLETRAP_GRINDER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_grinder.xml")

				add_projectile("data/entities/projectiles/bubbletrap_grinder.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAPCONTAINER",
	name 		= "BUBBLE TRAP CONTAINER",
	description = "A container that explodes into many bubble traps",
	sprite 		= "mods/TheArmory/files/actions/bubbletrapcontainer.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP
	spawn_probability                 = "0", -- BUBBLETRAP
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrapcontainer.xml")

				add_projectile("data/entities/projectiles/bubbletrapcontainer.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPINNINGMACE",
	name 		= "SPINNING MACE",
	description = "A spinning mace wheel that sticks to enemies, hitting them for as long as it spins",
	sprite 		= "mods/TheArmory/files/actions/spinningmace.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPINNINGMACE
	spawn_probability                 = "0", -- SPINNINGMACE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spinningmace.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spinningmace.xml")

				add_projectile("data/entities/projectiles/spinningmace.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPINNINGMACE_SCATTER",
	name 		= "SPINNING MACE (SCATTER)",
	description = "Multiple spinning maces shot at once",
	sprite 		= "mods/TheArmory/files/actions/spinningmace_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPINNINGMACE_SCATTER
	spawn_probability                 = "0", -- SPINNINGMACE_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_ScatterShotRegular("spinningmace.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spinningmace.xml")

				add_projectile("data/entities/projectiles/spinningmace.xml")
				add_projectile("data/entities/projectiles/spinningmace.xml")
				add_projectile("data/entities/projectiles/spinningmace.xml")
				add_projectile("data/entities/projectiles/spinningmace.xml")
				c.spread_degrees = 25 
				
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPEARPROJECTILE_FREEZING",
	name 		= "FREEZING SPEAR",
	description = "A spear that pins enemies down, freezing them",
	sprite 		= "mods/TheArmory/files/actions/spearprojectile_freezing.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPEARPROJECTILE_FREEZING
	spawn_probability                 = "0", -- SPEARPROJECTILE_FREEZING
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "spears_ammo", "Spears")) then
			
				applyTrinketsEffectsWeapons_Elemental("spearprojectile_freezing.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spearprojectile_freezing.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spearprojectile_freezing.xml")

				add_projectile("data/entities/projectiles/spearprojectile_freezing.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "spears_ammo", "Spears")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPEARPROJECTILE_OVERHEATED",
	name 		= "OVERHEATED SPEAR",
	description = "A spear that pins enemies down, burning them",
	sprite 		= "mods/TheArmory/files/actions/spearprojectile_overheated.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPEARPROJECTILE_OVERHEATED
	spawn_probability                 = "0", -- SPEARPROJECTILE_OVERHEATED
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "spears_ammo", "Spears")) then
			
				applyTrinketsEffectsWeapons_Elemental("spearprojectile_overheated.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spearprojectile_overheated.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spearprojectile_overheated.xml")

				add_projectile("data/entities/projectiles/spearprojectile_overheated.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "spears_ammo", "Spears")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_50BMG",
	name 		= ".50 BMG",
	description = "High caliber bullet that penetrates hard materials like steel",
	sprite 		= "mods/TheArmory/files/actions/50bmg.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 50BMG
	spawn_probability                 = "0", -- 50BMG
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rifle_ammo", "Rifle Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_50bmg.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_50bmg.xml")

				add_projectile("data/entities/projectiles/bulletammo_50bmg.xml")
				shot_effects.recoil_knockback = shot_effects.recoil_knockback + 25
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rifle_ammo", "Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_50BMG_MG",
	name 		= ".50 BMG",
	description = ".50 BMG",
	sprite 		= "mods/TheArmory/files/actions/50bmg.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 50BMG
	spawn_probability                 = "0", -- 50BMG
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rifle_ammo", "Rifle Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_50bmg.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_50bmg.xml")

				add_projectile("data/entities/projectiles/bulletammo_50bmg.xml")
				shot_effects.recoil_knockback = shot_effects.recoil_knockback + 25
				c.spread_degrees = 4
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rifle_ammo", "Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NANOSHRAPNEL_BOMB",
	name 		= "NANOSHRAPNEL BOMB",
	description = "A bomb that explodes into nanoshrapnel that penetrates walls",
	sprite 		= "mods/TheArmory/files/actions/nanoshrapnel_bomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPINNINGMACE
	spawn_probability                 = "0", -- SPINNINGMACE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_SingleShotRegular("nanoshrapnel_bomb.xml")
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nanoshrapnel_bomb.xml")

				add_projectile("data/entities/projectiles/nanoshrapnel_bomb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NANOSHRAPNEL_BOMB_DIRECTIONAL",
	name 		= "DIRECTIONAL NANOSHRAPNEL BOMB",
	description = "A bomb that explodes into nanoshrapnel that penetrates walls according to its direction",
	sprite 		= "mods/TheArmory/files/actions/nanoshrapnel_bomb_directional.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- NANOSHRAPNEL_BOMB_DIRECTIONAL
	spawn_probability                 = "0", -- NANOSHRAPNEL_BOMB_DIRECTIONAL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_SingleShotRegular("nanoshrapnel_bomb_directional.xml")
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nanoshrapnel_bomb_directional.xml")
				
				add_projectile("data/entities/projectiles/nanoshrapnel_bomb_directional.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NANOSHRAPNEL_BOMB_DIRECTIONAL_ACID",
	name 		= "DIRECTIONAL NANOSHRAPNEL BOMB (ACID)",
	description = "A bomb that explodes into nanoshrapnel that penetrates walls according to its direction, releasing acid",
	sprite 		= "mods/TheArmory/files/actions/nanoshrapnel_bomb_directional_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- NANOSHRAPNEL_BOMB_DIRECTIONAL_ACID
	spawn_probability                 = "0", -- NANOSHRAPNEL_BOMB_DIRECTIONAL_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_SingleShotRegular("nanoshrapnel_bomb_directional_acid.xml")
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nanoshrapnel_bomb_directional_acid.xml")
				
				add_projectile("data/entities/projectiles/nanoshrapnel_bomb_directional_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NANOSHRAPNEL_BOMB_DIRECTIONAL_LAVA",
	name 		= "DIRECTIONAL NANOSHRAPNEL BOMB (LAVA)",
	description = "A bomb that explodes into nanoshrapnel that penetrates walls according to its direction, releasing lava",
	sprite 		= "mods/TheArmory/files/actions/nanoshrapnel_bomb_directional_lava.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- NANOSHRAPNEL_BOMB_DIRECTIONAL_LAVA
	spawn_probability                 = "0", -- NANOSHRAPNEL_BOMB_DIRECTIONAL_LAVA
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("nanoshrapnel_bomb_directional_lava.xml")
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nanoshrapnel_bomb_directional_lava.xml")
				
				add_projectile("data/entities/projectiles/nanoshrapnel_bomb_directional_lava.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BOUNCEBOMB",
	name 		= "BOUNCE BOMB",
	description = "A bomb that bounces around and explodes violently after a certain time",
	sprite 		= "mods/TheArmory/files/actions/bouncebomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BOUNCEBOMB
	spawn_probability                 = "0", -- BOUNCEBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bouncebomb.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bouncebomb.xml")

				add_projectile("data/entities/projectiles/bouncebomb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BOUNCEBOMB_SCATTER",
	name 		= "BOUNCEBOMB (SCATTER)",
	description = "Many bounce bombs shot at the same time",
	sprite 		= "mods/TheArmory/files/actions/bouncebomb_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BOUNCEBOMB_SCATTER
	spawn_probability                 = "0", -- BOUNCEBOMB_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_ScatterShotRegular("bouncebomb.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bouncebomb.xml")

				add_projectile("data/entities/projectiles/bouncebomb.xml")
				add_projectile("data/entities/projectiles/bouncebomb.xml")
				add_projectile("data/entities/projectiles/bouncebomb.xml")
				c.spread_degrees = 25 
				
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MIDASBOMB",
	name 		= "MIDAS BOMB",
	description = "Transforms enemies it touches into gold dust",
	sprite 		= "mods/TheArmory/files/actions/midasbomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MIDASBOMB
	spawn_probability                 = "0", -- MIDASBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("midasbomb.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("midasbomb.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("midasbomb.xml")

				add_projectile("data/entities/projectiles/midasbomb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ENERGYWAVEBOMB",
	name 		= "ENERGY WAVE BOMB",
	description = "Releases an energy wave when it explodes above horizontal surfaces",
	sprite 		= "mods/TheArmory/files/actions/energywavebomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ENERGYWAVEBOMB
	spawn_probability                 = "0", -- ENERGYWAVEBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("energywavebomb.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("energywavebomb.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("energywavebomb.xml")

				add_projectile("data/entities/projectiles/energywavebomb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_INFERNALBOMB",
	name 		= "INFERNAL BOMB",
	description = "Releases a fire wave when it explodes above horizontal surfaces",
	sprite 		= "mods/TheArmory/files/actions/infernalbomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- INFERNALBOMB
	spawn_probability                 = "0", -- INFERNALBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("infernalbomb.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("infernalbomb.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("infernalbomb.xml")

				add_projectile("data/entities/projectiles/infernalbomb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPEARPROJECTILE_ELECTRIFIED",
	name 		= "ELECTRIFIED SPEAR",
	description = "A spear that pins enemies down, electrocuting them",
	sprite 		= "mods/TheArmory/files/actions/spearprojectile_electrified.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPEARPROJECTILE_FREEZING
	spawn_probability                 = "0", -- SPEARPROJECTILE_FREEZING
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "spears_ammo", "Spears")) then
			
				applyTrinketsEffectsWeapons_Elemental("spearprojectile_electrified.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spearprojectile_electrified.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spearprojectile_electrified.xml")

				add_projectile("data/entities/projectiles/spearprojectile_electrified.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "spears_ammo", "Spears")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELLIPSOIDBULLET",
	name 		= "ELLIPSOID BULLET",
	description = "A slow bullet, that consumes grenades ammo and causes small explosions wherever it hits",
	sprite 		= "mods/TheArmory/files/actions/ellipsoidbullet.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MIDASBOMB
	spawn_probability                 = "0", -- MIDASBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("ellipsoidbullet.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("ellipsoidbullet.xml")

				add_projectile("data/entities/projectiles/ellipsoidbullet.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELLIPSOIDBULLET_LIGHT",
	name 		= "ELLIPSOID BULLET (LIGHT)",
	description = "A slow bullet, that consumes grenades ammo and causes small explosions wherever it hits",
	sprite 		= "mods/TheArmory/files/actions/ellipsoidbullet_light.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MIDASBOMB
	spawn_probability                 = "0", -- MIDASBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("ellipsoidbullet_light.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("ellipsoidbullet_light.xml")

				add_projectile("data/entities/projectiles/ellipsoidbullet_light.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELLIPSOIDBULLET_SCATTER",
	name 		= "ELLIPSOID BULLET (SCATTER)",
	description = "Many slow/explosive grenades ammo consuming bullets shot at once",
	sprite 		= "mods/TheArmory/files/actions/ellipsoidbullet_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MIDASBOMB
	spawn_probability                 = "0", -- MIDASBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_ScatterShotRegular("ellipsoidbullet_light.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("ellipsoidbullet_light.xml")

				add_projectile("data/entities/projectiles/ellipsoidbullet_light.xml")
				add_projectile("data/entities/projectiles/ellipsoidbullet_light.xml")
				add_projectile("data/entities/projectiles/ellipsoidbullet_light.xml")
				c.spread_degrees = 20
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_DRILL_OVERHEATED",
	name 		= "DRILL (OVERHEATED)",
	description = "Causes big but controlled cave ins where it hits",
	sprite 		= "mods/TheArmory/files/actions/drill_overheated.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- DRILL
	spawn_probability                 = "0", -- DRILL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("drill_overheated.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("drill_overheated.xml")

				add_projectile("data/entities/projectiles/drill_overheated.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_DRILLBOMB",
	name 		= "DRILL BOMB",
	description = "Sticks to enemies it hits, causing damage overtime, and exploding afterwards",
	sprite 		= "mods/TheArmory/files/actions/drillbomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- DRILL
	spawn_probability                 = "0", -- DRILL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("drillbomb.xml")

				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("drillbomb.xml")

				add_projectile("data/entities/projectiles/drillbomb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CHAINSAWPROJECTILE",
	name 		= "CHAINSAW",
	description = "Sticks to enemies it hits, causing damage overtime, and also digs terrain",
	sprite 		= "mods/TheArmory/files/actions/chainsawprojectile.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CHAINSAWPROJECTILE
	spawn_probability                 = "0", -- CHAINSAWPROJECTILE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("chainsawprojectile.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("chainsawprojectile.xml")

				add_projectile("data/entities/projectiles/chainsawprojectile.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BLEEDERDRILL",
	name 		= "BLEEDER DRILL",
	description = "Sticks to enemies it hits, causing them to bleed a lot and dealing damage overtime",
	sprite 		= "mods/TheArmory/files/actions/bleederdrill.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BLEEDERDRILL
	spawn_probability                 = "0", -- BLEEDERDRILL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bleederdrill.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bleederdrill.xml")

				add_projectile("data/entities/projectiles/bleederdrill.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_HEAVYGRINDER",
	name 		= "HEAVY GRINDER",
	description = "Pins enemies down, causing damage for as long as it spins",
	sprite 		= "mods/TheArmory/files/actions/heavygrinder.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- HEAVYGRINDER
	spawn_probability                 = "0", -- HEAVYGRINDER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("heavygrinder.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("heavygrinder.xml")

				add_projectile("data/entities/projectiles/heavygrinder.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELLIPSOIDBULLET_PLASMA",
	name 		= "ELLIPSOID BULLET (PLASMA)",
	description = "A slow energy bullet and causes plasma energy waves, that eat through most materials, wherever it hits",
	sprite 		= "mods/TheArmory/files/actions/ellipsoidbullet_plasma.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ELLIPSOIDBULLET_PLASMA
	spawn_probability                 = "0", -- ELLIPSOIDBULLET_PLASMA
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Energy("ellipsoidbullet_plasma.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("ellipsoidbullet_plasma.xml")

				add_projectile("data/entities/projectiles/ellipsoidbullet_plasma.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_EARTHMOVERMAUL",
	name 		= "EARTHMOVER MAUL",
	description = "Causes small earthquakes when it touches soil",
	sprite 		= "mods/TheArmory/files/actions/earthmovermaul.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- EARTHMOVERMAUL
	spawn_probability                 = "0", -- EARTHMOVERMAUL
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/earthmovermaul.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_HOOKPIKE_BLADE",
	name 		= "HOOK PIKE",
	description = "Causes enemies hit by it to bleed and take damage overtime",
	sprite 		= "mods/TheArmory/files/actions/hookpike.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- HOOKPIKE_BLADE
	spawn_probability                 = "0", -- HOOKPIKE_BLADE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/hookpike.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_RAZORRANG",
	name 		= "RAZORRANG",
	description = "A boomerang sticks to enemies, causing damage overtime",
	sprite 		= "mods/TheArmory/files/actions/razorrang.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- RAZORRANG
	spawn_probability                 = "0", -- RAZORRANG
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("razorrang.xml")
	
		add_projectile("data/entities/projectiles/razorrang.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_INFERNOLANCE_BLADE",
	name 		= "INFERNO LANCE",
	description = "Causes the burning damage effect on enemies hit by it, dealing damage overtime with a chance of setting them on fire each time damage is inflicted",
	sprite 		= "mods/TheArmory/files/actions/infernolance.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- INFERNOLANCE_BLADE
	spawn_probability                 = "0", -- INFERNOLANCE_BLADE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/infernolance.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CHARGEDSPEAR_BLADE",
	name 		= "CHARGED SPEAR",
	description = "Causes the electrocution damage effect on enemies hit by it, dealing damage overtime with a chance of electrocuting them each time damage is inflicted",
	sprite 		= "mods/TheArmory/files/actions/chargedspear.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CHARGEDSPEAR_BLADE
	spawn_probability                 = "0", -- CHARGEDSPEAR_BLADE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/chargedspear.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CRYOAXE",
	name 		= "CRYOAXE",
	description = "Causes the freeze damage effect on enemies hit by it, dealing damage overtime with a chance of freezing them each time damage is inflicted",
	sprite 		= "mods/TheArmory/files/actions/cryoaxe.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CRYOAXE
	spawn_probability                 = "0", -- CRYOAXE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/cryoaxe.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_GETOVERHERESPEAR",
	name 		= "FLAIL (GET OVER HERE SPEAR)",
	description = "It pulls enemies towards you, dealing damage",
	sprite 		= "mods/TheArmory/files/actions/flail_getoverherespear.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_GETOVERHERESPEAR
	spawn_probability                 = "0", -- FLAIL_GETOVERHERESPEAR
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_getoverherespear.xml")
		
		add_projectile("data/entities/projectiles/flail_getoverherespear.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ACIDORB",
	name 		= "ACID ORB",
	description = "An energy orb that explodes into an acid shockwave when it hits horizontal surfaces",
	sprite 		= "mods/TheArmory/files/actions/acidorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ACIDORB
	spawn_probability                 = "0", -- ACIDORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Energy("acidorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("acidorb.xml")

				add_projectile("data/entities/projectiles/acidorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELLIPSOIDBULLET_LASER",
	name 		= "ELLIPSOID BULLET (LASER)",
	description = "A slow energy bullet and causes laser energy waves wherever it hits",
	sprite 		= "mods/TheArmory/files/actions/ellipsoidbullet_laser.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ELLIPSOIDBULLET_LASER
	spawn_probability                 = "0", -- ELLIPSOIDBULLET_LASER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Energy("ellipsoidbullet_laser.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("ellipsoidbullet_laser.xml")

				add_projectile("data/entities/projectiles/ellipsoidbullet_laser.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_POISONORB",
	name 		= "POISON ORB",
	description = "An energy orb that explodes into a poison shockwave when it hits horizontal surfaces",
	sprite 		= "mods/TheArmory/files/actions/poisonorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- POISONORB
	spawn_probability                 = "0", -- POISONORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Energy("poisonorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("poisonorb.xml")

				add_projectile("data/entities/projectiles/poisonorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CROSSBOW_BOLT_BLEEDER",
	name 		= "CROSSBOW BOLT (BLEEDER)",
	description = "A crossbow bolt that causes enemies hit by it to bleed ",
	sprite 		= "mods/TheArmory/files/actions/crossbowbolt_bleeder.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CROSSBOW_BOLT_POISON
	spawn_probability                 = "0", -- CROSSBOW_BOLT_POISON
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "crossbowbolts_ammo", "Crossbow Bolts")) then
			
				applyTrinketsEffectsWeapons_Elemental("crossbowbolt_bleeder.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("crossbowbolt_bleeder.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("crossbowbolt_bleeder.xml")

				add_projectile("data/entities/projectiles/crossbowbolt_bleeder.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "crossbowbolts_ammo", "Crossbow Bolts")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_ANTICOAGULANT",
	name 		= "SPITBOMB (ANTICOAGULANT)",
	description = "A bomb that explodes spitting anticoagulant",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_anticoagulant.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_ANTICOAGULANT
	spawn_probability                 = "0", -- SPITBOMB_ANTICOAGULANT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_anticoagulant.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_anticoagulant.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_anticoagulant.xml")

				add_projectile("data/entities/projectiles/spitbomb_anticoagulant.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_OVERHEATED_ACID",
	name 		= "SPITBOMB (OVERHEATED ACID)",
	description = "A bomb that explodes spitting overheated acid",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_overheated_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_OVERHEATED_ACID
	spawn_probability                 = "0", -- SPITBOMB_OVERHEATED_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_overheated_acid.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_overheated_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_overheated_acid.xml")

				add_projectile("data/entities/projectiles/spitbomb_overheated_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_EXPLOSIUM",
	name 		= "SYRINGE FILLED WITH EXPLOSIUM",
	description = "Injects enemies with explosium",
	sprite 		= "mods/TheArmory/files/actions/syringe_explosium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_EXPLOSIUM
	spawn_probability                 = "0", -- SYRINGE_EXPLOSIUM
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_explosium.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_explosium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_explosium.xml")

				add_projectile("data/entities/projectiles/syringe_explosium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_ANTICOAGULANT",
	name 		= "SYRINGE FILLED WITH ANTICOAGULANT",
	description = "Injects enemies with anticoagulant",
	sprite 		= "mods/TheArmory/files/actions/syringe_anticoagulant.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_ANTICOAGULANT
	spawn_probability                 = "0", -- SYRINGE_ANTICOAGULANT
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_anticoagulant.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_anticoagulant.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_anticoagulant.xml")

				add_projectile("data/entities/projectiles/syringe_anticoagulant.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_EXPLOSIUM",
	name 		= "SPITBOMB (EXPLOSIUM)",
	description = "A bomb that explodes spitting explosium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_explosium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_EXPLOSIUM
	spawn_probability                 = "0", -- SPITBOMB_EXPLOSIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_explosium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_explosium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_explosium.xml")

				add_projectile("data/entities/projectiles/spitbomb_explosium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_TELEPORTATIUM",
	name 		= "SPITBOMB (TELEPORTATIUM)",
	description = "A bomb that explodes spitting teleportatium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_teleportatium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_TELEPORTATIUM
	spawn_probability                 = "0", -- SPITBOMB_TELEPORTATIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_teleportatium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_teleportatium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_teleportatium.xml")

				add_projectile("data/entities/projectiles/spitbomb_teleportatium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_LIQUID_NITROGEN",
	name 		= "SPITBOMB (LIQUID NITROGEN)",
	description = "A bomb that explodes spitting liquid nitrogen",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_liquid_nitrogen.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_LIQUID_NITROGEN
	spawn_probability                 = "0", -- SPITBOMB_LIQUID_NITROGEN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_liquid_nitrogen.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_liquid_nitrogen.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_liquid_nitrogen.xml")

				add_projectile("data/entities/projectiles/spitbomb_liquid_nitrogen.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CRYSTALPROJECTILE_OVERHEATED_ACID",
	name 		= "OVERHEATED ACID CRYSTAL",
	description = "A crystal that explodes into shards on impact",
	sprite 		= "mods/TheArmory/files/actions/crystalprojectile_overheated_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CRYSTALPROJECTILE_OVERHEATED_ACID
	spawn_probability                 = "0", -- CRYSTALPROJECTILE_OVERHEATED_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("crystalprojectile_overheated_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("crystalprojectile_overheated_acid.xml")

				add_projectile("data/entities/projectiles/crystalprojectile_overheated_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CRYSTALPROJECTILE_EXPLOSIUM",
	name 		= "EXPLOSIUM CRYSTAL",
	description = "A crystal that explodes into shards on impact",
	sprite 		= "mods/TheArmory/files/actions/crystalprojectile_explosium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CRYSTALPROJECTILE_EXPLOSIUM
	spawn_probability                 = "0", -- CRYSTALPROJECTILE_EXPLOSIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("crystalprojectile_explosium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("crystalprojectile_explosium.xml")

				add_projectile("data/entities/projectiles/crystalprojectile_explosium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CRYSTALPROJECTILE_POISON",
	name 		= "POISON CRYSTAL",
	description = "A crystal that explodes into shards on impact",
	sprite 		= "mods/TheArmory/files/actions/crystalprojectile_poison.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CRYSTALPROJECTILE_POISON
	spawn_probability                 = "0", -- CRYSTALPROJECTILE_POISON
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("crystalprojectile_poison.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("crystalprojectile_poison.xml")

				add_projectile("data/entities/projectiles/crystalprojectile_poison.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CANISTER_LIQUID_NITROGEN",
	name 		= "CANISTER (LIQUID NITROGEN)",
	description = "A canister that periodically releases small streams of liquid nitrogen while it travels mid-air",
	sprite 		= "mods/TheArmory/files/actions/canister_liquid_nitrogen.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CANISTER_LIQUID_NITROGEN
	spawn_probability                 = "0", -- CANISTER_LIQUID_NITROGEN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Elemental("canister_liquid_nitrogen.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("canister_liquid_nitrogen.xml")

				add_projectile("data/entities/projectiles/canister_liquid_nitrogen.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CANISTER_ANTICOAGULANT",
	name 		= "CANISTER (ANTICOAGULANT)",
	description = "A canister that periodically releases small streams of anticoagulant while it travels mid-air",
	sprite 		= "mods/TheArmory/files/actions/canister_anticoagulant.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CANISTER_ANTICOAGULANT
	spawn_probability                 = "0", -- CANISTER_ANTICOAGULANT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Elemental("canister_anticoagulant.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("canister_anticoagulant.xml")

				add_projectile("data/entities/projectiles/canister_anticoagulant.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CANISTER_TELEPORTATIUM",
	name 		= "CANISTER (TELEPORTATIUM)",
	description = "A canister that periodically releases small streams of teleportatium while it travels mid-air",
	sprite 		= "mods/TheArmory/files/actions/canister_teleportatium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CANISTER_TELEPORTATIUM
	spawn_probability                 = "0", -- CANISTER_TELEPORTATIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Elemental("canister_teleportatium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("canister_teleportatium.xml")

				add_projectile("data/entities/projectiles/canister_teleportatium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_WATERORB",
	name 		= "WATER ORB",
	description = "An energy orb that explodes into a water shockwave when it hits horizontal surfaces",
	sprite 		= "mods/TheArmory/files/actions/waterorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ACIDORB
	spawn_probability                 = "0", -- ACIDORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Energy("waterorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("waterorb.xml")

				add_projectile("data/entities/projectiles/waterorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NITROORB",
	name 		= "NITRO ORB",
	description = "An energy orb that explodes into a nitroglycerin shockwave when it hits horizontal surfaces",
	sprite 		= "mods/TheArmory/files/actions/nitroorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- NITROORB
	spawn_probability                 = "0", -- NITROORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Energy("nitroorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nitroorb.xml")

				add_projectile("data/entities/projectiles/nitroorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_OVERHEATEDACIDORB",
	name 		= "OVERHEATED ACID ORB",
	description = "An energy orb that explodes into an overheated acid shockwave when it hits horizontal surfaces",
	sprite 		= "mods/TheArmory/files/actions/overheatedacidorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- OVERHEATEDACIDORB
	spawn_probability                 = "0", -- OVERHEATEDACIDORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Energy("overheatedacidorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("overheatedacidorb.xml")

				add_projectile("data/entities/projectiles/overheatedacidorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ANTIPOLYORB",
	name 		= "ANTIPOLY ORB",
	description = "An energy orb that explodes into an antipoly shockwave when it hits horizontal surfaces",
	sprite 		= "mods/TheArmory/files/actions/antipolyorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ANTIPOLYORB
	spawn_probability                 = "0", -- ANTIPOLYORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Energy("antipolyorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("antipolyorb.xml")

				add_projectile("data/entities/projectiles/antipolyorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LAVAORB",
	name 		= "LAVA ORB",
	description = "An energy orb that explodes into a lava shockwave when it hits horizontal surfaces",
	sprite 		= "mods/TheArmory/files/actions/lavaorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LAVAORB
	spawn_probability                 = "0", -- LAVAORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Energy("lavaorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("lavaorb.xml")

				add_projectile("data/entities/projectiles/lavaorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CRYSTALPROJECTILE_ANTIPOLY",
	name 		= "ANTIPOLY CRYSTAL",
	description = "A crystal that explodes into shards on impact",
	sprite 		= "mods/TheArmory/files/actions/crystalprojectile_antipoly.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CRYSTALPROJECTILE_POISON
	spawn_probability                 = "0", -- CRYSTALPROJECTILE_POISON
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("crystalprojectile_antipoly.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("crystalprojectile_antipoly.xml")

				add_projectile("data/entities/projectiles/crystalprojectile_antipoly.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CANISTER_FIRE",
	name 		= "CANISTER (FIRE)",
	description = "A canister that periodically releases small streams of liquid fire while it travels mid-air",
	sprite 		= "mods/TheArmory/files/actions/canister_fire.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CANISTER_FIRE
	spawn_probability                 = "0", -- CANISTER_FIRE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Elemental("canister_fire.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("canister_fire.xml")

				add_projectile("data/entities/projectiles/canister_fire.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )


table.insert( actions,
{
	id          = "THEARMORYACTIONS_BLACKHOLEBOMB",
	name 		= "BLACKHOLE BOMB",
	description = "A bomb that creates a small blackhole that sucks everything that happens to be close",
	sprite 		= "mods/TheArmory/files/actions/blackholebomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BLACKHOLEBOMB
	spawn_probability                 = "0", -- BLACKHOLEBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("blackholebomb.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("blackholebomb.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("blackholebomb.xml")

				add_projectile("data/entities/projectiles/blackholebomb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_SPITIUM",
	name 		= "SPITBOMB (SPITIUM)",
	description = "A bomb that explodes spitting spitium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_spitium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_SPITIUM
	spawn_probability                 = "0", -- SPITBOMB_SPITIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_spitium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_spitium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_spitium.xml")

				add_projectile("data/entities/projectiles/spitbomb_spitium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_CONCENTRATED_SPITIUM",
	name 		= "SPITBOMB (CONCENTRATED SPITIUM)",
	description = "A bomb that explodes spitting concentrated spitium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_concentrated_spitium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_CONCENTRATED_SPITIUM
	spawn_probability                 = "0", -- SPITBOMB_CONCENTRATED_SPITIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_concentrated_spitium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_concentrated_spitium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_concentrated_spitium.xml")

				add_projectile("data/entities/projectiles/spitbomb_concentrated_spitium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_ELECTRICIUM",
	name 		= "SPITBOMB (ELECTRICIUM)",
	description = "A bomb that explodes spitting electricium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_electricium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_ELECTRICIUM
	spawn_probability                 = "0", -- SPITBOMB_ELECTRICIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_electricium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_electricium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_electricium.xml")

				add_projectile("data/entities/projectiles/spitbomb_electricium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_THUNDERBOMB",
	name 		= "THUNDER BOMB",
	description = "Releases a thunder wave when it explodes above horizontal surfaces",
	sprite 		= "mods/TheArmory/files/actions/thunderbomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THUNDERBOMB
	spawn_probability                 = "0", -- THUNDERBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("thunderbomb.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("thunderbomb.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("thunderbomb.xml")

				add_projectile("data/entities/projectiles/thunderbomb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPORE_FIRECAP",
	name 		= "FIRECAP SPORE",
	description = "Shoots firecap spores that grows when hitting surfaces, exploding into fire floating spores after some time",
	sprite 		= "mods/TheArmory/files/actions/fungus_fire.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPORE_FIRECAP
	spawn_probability                 = "0", -- SPORE_FIRECAP
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("fungus_fire.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fungus_fire.xml")

				add_projectile("data/entities/projectiles/fungus_fire.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPORE_ACIDCROWN",
	name 		= "ACID CROWN SPORE",
	description = "Shoots acid crown spores that grow when hitting surfaces, exploding into acid floating spores after some time",
	sprite 		= "mods/TheArmory/files/actions/fungus_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPORE_ACIDCROWN
	spawn_probability                 = "0", -- SPORE_ACIDCROWN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("fungus_acid.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fungus_acid.xml")

				add_projectile("data/entities/projectiles/fungus_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPORE_LAVAOYSTER",
	name 		= "LAVA OYSTER SPORE",
	description = "Shoots lava oyster spores that grow when hitting surfaces, exploding into lava floating spores after some time",
	sprite 		= "mods/TheArmory/files/actions/fungus_lava.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPORE_LAVAOYSTER
	spawn_probability                 = "0", -- SPORE_LAVAOYSTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("fungus_lava.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fungus_lava.xml")

				add_projectile("data/entities/projectiles/fungus_lava.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPORE_POISONBLISTER",
	name 		= "POISON BLISTER SPORE",
	description = "Shoots poison blister spores that grow when hitting surfaces, exploding into poison floating spores after some time",
	sprite 		= "mods/TheArmory/files/actions/fungus_poison.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPORE_POISONBLISTER
	spawn_probability                 = "0", -- SPORE_POISONBLISTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("fungus_poison.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fungus_poison.xml")

				add_projectile("data/entities/projectiles/fungus_poison.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPORE_POLYSTOOL",
	name 		= "POLY STOOL SPORE",
	description = "Shoots poly stool spores that grow when hitting surfaces, exploding into polymorphine floating spores after some time",
	sprite 		= "mods/TheArmory/files/actions/fungus_poly.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPORE_POLYSTOOL
	spawn_probability                 = "0", -- SPORE_POLYSTOOL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("fungus_poly.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fungus_poly.xml")

				add_projectile("data/entities/projectiles/fungus_poly.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPORE_WATERAMANITA",
	name 		= "WATER AMANITA SPORE",
	description = "Shoots water amanita spores that grow when hitting surfaces, exploding into water floating spores after some time",
	sprite 		= "mods/TheArmory/files/actions/fungus_water.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPORE_WATERAMANITA
	spawn_probability                 = "0", -- SPORE_WATERAMANITA
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("fungus_water.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fungus_water.xml")

				add_projectile("data/entities/projectiles/fungus_water.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPORE_OVERHEATEDACIDCROWN",
	name 		= "OVERHEATED ACID CROWN SPORE",
	description = "Shoots overheated acid crown spores that grow when hitting surfaces, exploding into overheated acid floating spores after some time",
	sprite 		= "mods/TheArmory/files/actions/fungus_overheated_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPORE_OVERHEATEDACIDCROWN
	spawn_probability                 = "0", -- SPORE_OVERHEATEDACIDCROWN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("fungus_overheated_acid.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fungus_overheated_acid.xml")

				add_projectile("data/entities/projectiles/fungus_overheated_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPORE_NITROCAP",
	name 		= "NITROCAP SPORE",
	description = "Shoots nitrocap spores that grows when hitting surfaces, exploding into nitroglycerin floating spores after some time",
	sprite 		= "mods/TheArmory/files/actions/fungus_nitro.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPORE_NITROCAP
	spawn_probability                 = "0", -- SPORE_NITROCAP
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("fungus_nitro.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fungus_nitro.xml")

				add_projectile("data/entities/projectiles/fungus_nitro.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPORE_BLEEDINGBLISTER",
	name 		= "BLEEDING BLISTER SPORE",
	description = "Shoots bleeding blister spores that grows when hitting surfaces, exploding into anticoagulant floating spores after some time",
	sprite 		= "mods/TheArmory/files/actions/fungus_anticoagulant.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPORE_BLEEDINGBLISTER
	spawn_probability                 = "0", -- SPORE_BLEEDINGBLISTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("fungus_anticoagulant.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fungus_anticoagulant.xml")

				add_projectile("data/entities/projectiles/fungus_anticoagulant.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPORE_EXPLODINGCROWN",
	name 		= "EXPLODING CROWN SPORE",
	description = "Shoots exploding crown spores that grows when hitting surfaces, exploding into explosium floating spores after some time",
	sprite 		= "mods/TheArmory/files/actions/fungus_explosium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPORE_EXPLODINGCROWN
	spawn_probability                 = "0", -- SPORE_EXPLODINGCROWN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("fungus_explosium.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fungus_explosium.xml")

				add_projectile("data/entities/projectiles/fungus_explosium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPORE_FREEZINGAMANITA",
	name 		= "FREEZING AMANITA SPORE",
	description = "Shoots freezing amanita spores that grows when hitting surfaces, exploding into liquid nitrogen floating spores after some time",
	sprite 		= "mods/TheArmory/files/actions/fungus_liquid_nitrogen.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPORE_FREEZINGAMANITA
	spawn_probability                 = "0", -- SPORE_FREEZINGAMANITA
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("fungus_liquid_nitrogen.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fungus_liquid_nitrogen.xml")

				add_projectile("data/entities/projectiles/fungus_liquid_nitrogen.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPORE_ELECTROSTOOL",
	name 		= "ELECTROSTOOL SPORE",
	description = "Shoots electrostool spores that grows when hitting surfaces, exploding into electricium floating spores after some time",
	sprite 		= "mods/TheArmory/files/actions/fungus_electricium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPORE_ELECTROSTOOL
	spawn_probability                 = "0", -- SPORE_ELECTROSTOOL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("fungus_electricium.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fungus_electricium.xml")

				add_projectile("data/entities/projectiles/fungus_electricium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPORE_SPITTERCROWN",
	name 		= "SPITTER CROWN SPORE",
	description = "Shoots spitter crown spores that grows when hitting surfaces, exploding into spitium floating spores after some time",
	sprite 		= "mods/TheArmory/files/actions/fungus_spitium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPORE_SPITTERCROWN
	spawn_probability                 = "0", -- SPORE_SPITTERCROWN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("fungus_spitium.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fungus_spitium.xml")

				add_projectile("data/entities/projectiles/fungus_spitium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPORE_PUKERCROWN",
	name 		= "PUKER CROWN SPORE",
	description = "Shoots puker crown spores that grows when hitting surfaces, exploding into concentrated spitium floating spores after some time",
	sprite 		= "mods/TheArmory/files/actions/fungus_concentrated_spitium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPORE_PUKERCROWN
	spawn_probability                 = "0", -- SPORE_PUKERCROWN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("fungus_concentrated_spitium.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fungus_concentrated_spitium.xml")

				add_projectile("data/entities/projectiles/fungus_concentrated_spitium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPORE_ANTIPOLYOYSTER",
	name 		= "ANTIPOLY OYSTER SPORE",
	description = "Shoots antipoly oyster spores that grows when hitting surfaces, exploding into anti-polymorphine floating spores after some time",
	sprite 		= "mods/TheArmory/files/actions/fungus_antipoly.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPORE_ANTIPOLYOYSTER
	spawn_probability                 = "0", -- SPORE_ANTIPOLYOYSTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("fungus_antipoly.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fungus_antipoly.xml")

				add_projectile("data/entities/projectiles/fungus_antipoly.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SWITCHERPROJECTILE_ICE",
	name 		= "SWITCHER PROJETILE (ICE)",
	description = "An energy projectile that freezes enemies touched by it",
	sprite 		= "mods/TheArmory/files/actions/switcherprojectile_ice.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SWITCHERPROJECTILE_ICE
	spawn_probability                 = "0", -- SWITCHERPROJECTILE_ICE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("switcherprojectile_ice.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("switcherprojectile_ice.xml")

				add_projectile("data/entities/projectiles/switcherprojectile_ice.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SWITCHERPROJECTILE_FIRE",
	name 		= "SWITCHER PROJETILE (FIRE)",
	description = "An energy projectile that sets on fire enemies touched by it",
	sprite 		= "mods/TheArmory/files/actions/switcherprojectile_fire.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SWITCHERPROJECTILE_FIRE
	spawn_probability                 = "0", -- SWITCHERPROJECTILE_FIRE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("switcherprojectile_fire.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("switcherprojectile_fire.xml")

				add_projectile("data/entities/projectiles/switcherprojectile_fire.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_EXPLODINGMACE",
	name 		= "EXPLODING MACE",
	description = "A magic mace that induces the exploding effect on enemies, causing random explosions around them",
	sprite 		= "mods/TheArmory/files/actions/explodingmace.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- EXPLODINGMACE
	spawn_probability                 = "0", -- EXPLODINGMACE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/explodingmace.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_HANDHELDSAW",
	name 		= "HANDHELD SAW",
	description = "A handheld tool that saws through enemies and even hard materials like steel",
	sprite 		= "mods/TheArmory/files/actions/handheldsaw.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- HANDHELDSAW
	spawn_probability                 = "0", -- HANDHELDSAW
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "fuel_ammo", "Fuel")) then
			
				add_projectile("data/entities/projectiles/handheldsaw.xml")	
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "fuel_ammo", "Fuel")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ACIDPOLEARM_BLADE",
	name 		= "ACID POLEARM BLADE",
	description = "A magic blade imbued with acid",
	sprite 		= "mods/TheArmory/files/actions/acidpolearm.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ACIDPOLEARM_BLADE
	spawn_probability                 = "0", -- ACIDPOLEARM_BLADE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/acidpolearm.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_OVERHEATEDACIDPOLEARM_BLADE",
	name 		= "OVERHEATED ACID POLEARM BLADE",
	description = "A magic blade imbued with overheated acid",
	sprite 		= "mods/TheArmory/files/actions/overheatedacidpolearm.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- OVERHEATEDACIDPOLEARM_BLADE
	spawn_probability                 = "0", -- OVERHEATEDACIDPOLEARM_BLADE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/overheatedacidpolearm.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_EXPLOSIUMBLADE",
	name 		= "FLAIL (EXPLOSIUM BLADE)",
	description = "Causes explosions on enemies touched by it",
	sprite 		= "mods/TheArmory/files/actions/flail_explosiumblade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_EXPLOSIUMBLADE
	spawn_probability                 = "0", -- FLAIL_EXPLOSIUMBLADE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_Elemental("flail_explosiumblade.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_explosiumblade.xml")
		
		add_projectile("data/entities/projectiles/flail_explosiumblade.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_SPITIUMBLADE",
	name 		= "FLAIL (SPITIUM BLADE)",
	description = "Causes enemies touched by it to spit acid overtime",
	sprite 		= "mods/TheArmory/files/actions/flail_spitiumblade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_SPITIUMBLADE
	spawn_probability                 = "0", -- FLAIL_SPITIUMBLADE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_Elemental("flail_spitiumblade.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_spitiumblade.xml")
		
		add_projectile("data/entities/projectiles/flail_spitiumblade.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_CONCENTRATEDSPITIUMBLADE",
	name 		= "FLAIL (CONCENTRATED SPITIUM BLADE)",
	description = "Causes enemies touched by it to spit overheated acid overtime",
	sprite 		= "mods/TheArmory/files/actions/flail_concentratedspitiumblade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_CONCENTRATEDSPITIUMBLADE
	spawn_probability                 = "0", -- FLAIL_CONCENTRATEDSPITIUMBLADE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_Elemental("flail_concentratedspitiumblade.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_concentratedspitiumblade.xml")
		
		add_projectile("data/entities/projectiles/flail_concentratedspitiumblade.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_WAVIUM",
	name 		= "SYRINGE FILLED WITH WAVIUM",
	description = "Injects enemies with wavium",
	sprite 		= "mods/TheArmory/files/actions/syringe_wavium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_EXPLOSIUM
	spawn_probability                 = "0", -- SYRINGE_EXPLOSIUM
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_wavium.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_wavium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_wavium.xml")

				add_projectile("data/entities/projectiles/syringe_wavium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_WAVIUM",
	name 		= "SPITBOMB (WAVIUM)",
	description = "A bomb that explodes spitting wavium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_wavium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_WAVIUM
	spawn_probability                 = "0", -- SPITBOMB_WAVIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_wavium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_wavium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_wavium.xml")

				add_projectile("data/entities/projectiles/spitbomb_wavium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPORE_RADIOACTIVEBLISTER",
	name 		= "RADIOACTIVE BLISTER SPORE",
	description = "Shoots radioactive blister spores that grows when hitting surfaces, exploding into radioactive gas floating spores after some time",
	sprite 		= "mods/TheArmory/files/actions/fungus_radioactive_gas.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPORE_RADIOACTIVEBLISTER
	spawn_probability                 = "0", -- SPORE_RADIOACTIVEBLISTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("fungus_radioactive_gas.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fungus_radioactive_gas.xml")

				add_projectile("data/entities/projectiles/fungus_radioactive_gas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPORE_VENOMOUSBLISTER",
	name 		= "VENOMOUS BLISTER SPORE",
	description = "Shoots venomous blister spores that grows when hitting surfaces, exploding into concentrated poison gas floating spores after some time",
	sprite 		= "mods/TheArmory/files/actions/fungus_concentrated_poison_gas.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPORE_VENOMOUSBLISTER
	spawn_probability                 = "0", -- SPORE_VENOMOUSBLISTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("fungus_concentrated_poison_gas.xml")	
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("fungus_concentrated_poison_gas.xml")

				add_projectile("data/entities/projectiles/fungus_concentrated_poison_gas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_CONCENTRATED_POISON_GAS",
	name 		= "SPITBOMB (CONCENTRATED POISON GAS)",
	description = "A bomb that explodes spitting concentrated poison gas",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_concentrated_poison_gas.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_CONCENTRATED_POISON_GAS
	spawn_probability                 = "0", -- SPITBOMB_CONCENTRATED_POISON_GAS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_concentrated_poison_gas.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_concentrated_poison_gas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_concentrated_poison_gas.xml")

				add_projectile("data/entities/projectiles/spitbomb_concentrated_poison_gas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUNKERBUSTERBOMB",
	name 		= "BUNKER BUSTER BOMB",
	description = "A digging bomb that arms itself after a while, exploding into nanoshrapnel that penetrates walls",
	sprite 		= "mods/TheArmory/files/actions/bunkerbusterbomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUNKERBUSTERBOMB
	spawn_probability                 = "0", -- BUNKERBUSTERBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bunkerbusterbomb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bunkerbusterbomb.xml")

				add_projectile("data/entities/projectiles/bunkerbusterbomb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LONG_SWORD_MAGIC",
	name 		= "MAGIC LONG SWORD",
	description = "Shoots a short ranged projectile that deals slice damage",
	sprite 		= "mods/TheArmory/files/actions/longsword_magic.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LONG_SWORD_MAGIC
	spawn_probability                 = "0", -- LONG_SWORD_MAGIC
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/longsword_magic.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LONG_SWORD_MAGIC_ACID",
	name 		= "MAGIC LONG SWORD (ACID)",
	description = "Shoots a short ranged projectile that deals slice damage and releases acid",
	sprite 		= "mods/TheArmory/files/actions/longsword_magic_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LONG_SWORD_MAGIC_ACID
	spawn_probability                 = "0", -- LONG_SWORD_MAGIC_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/longsword_magic_acid.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LONG_SWORD_MAGIC_BLOOD",
	name 		= "MAGIC LONG SWORD (BLOOD)",
	description = "Shoots a short ranged projectile that deals slice damage and releases blood",
	sprite 		= "mods/TheArmory/files/actions/longsword_magic_blood.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LONG_SWORD_MAGIC_BLOOD
	spawn_probability                 = "0", -- LONG_SWORD_MAGIC_BLOOD
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/longsword_magic_blood.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LONG_SWORD_MAGIC_WATER",
	name 		= "MAGIC LONG SWORD (WATER)",
	description = "Shoots a short ranged projectile that deals slice damage and releases water",
	sprite 		= "mods/TheArmory/files/actions/longsword_magic_water.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LONG_SWORD_MAGIC_WATER
	spawn_probability                 = "0", -- LONG_SWORD_MAGIC_WATER
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/longsword_magic_water.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_HANDHELDSAW_FREEZING",
	name 		= "HANDHELD SAW (FREEZING)",
	description = "A handheld tool that freezes and saws through enemies and even hard materials like steel",
	sprite 		= "mods/TheArmory/files/actions/handheldsaw_freezing.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- HANDHELDSAW_FREEZING
	spawn_probability                 = "0", -- HANDHELDSAW_FREEZING
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "fuel_ammo", "Fuel")) then
			
				add_projectile("data/entities/projectiles/handheldsaw_freezing.xml")	
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "fuel_ammo", "Fuel")
			end
		end

	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_HANDHELDSAW_OVERHEATED",
	name 		= "HANDHELD SAW (OVERHEATED)",
	description = "A handheld tool that burns and saws through enemies and even hard materials like steel",
	sprite 		= "mods/TheArmory/files/actions/handheldsaw_overheated.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- HANDHELDSAW_OVERHEATED
	spawn_probability                 = "0", -- HANDHELDSAW_OVERHEATED
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "fuel_ammo", "Fuel")) then
			
				add_projectile("data/entities/projectiles/handheldsaw_overheated.xml")	
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "fuel_ammo", "Fuel")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_HANDHELDSAW_ELECTRIFIED",
	name 		= "HANDHELD SAW (ELECTRIFIED)",
	description = "A handheld tool that electrocutes and saws through enemies and even hard materials like steel",
	sprite 		= "mods/TheArmory/files/actions/handheldsaw_electrified.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- HANDHELDSAW_ELECTRIFIED
	spawn_probability                 = "0", -- HANDHELDSAW_ELECTRIFIED
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "fuel_ammo", "Fuel")) then
			
				add_projectile("data/entities/projectiles/handheldsaw_electrified.xml")	
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "fuel_ammo", "Fuel")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHOCKWAVESLEDGE",
	name 		= "SHOCKWAVE SLEDGE",
	description = "Causes shockwaves where it hits, mind where you use it otherwise you might get hit too!",
	sprite 		= "mods/TheArmory/files/actions/shockwavesledge.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHOCKWAVESLEDGE
	spawn_probability                 = "0", -- SHOCKWAVESLEDGE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/shockwavesledge.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_POISONSPITTERBLADE",
	name 		= "FLAIL (POISON SPITTER BLADE)",
	description = "Causes enemies touched by it to spit poison overtime",
	sprite 		= "mods/TheArmory/files/actions/flail_poisonspitterblade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_POISONSPITTERBLADE
	spawn_probability                 = "0", -- FLAIL_POISONSPITTERBLADE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_Elemental("flail_poisonspitterblade.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_poisonspitterblade.xml")
		
		add_projectile("data/entities/projectiles/flail_poisonspitterblade.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CONCENTRATEDSPITIUMLANCE_BLADE",
	name 		= "CONCENTRATED SPITIUM LANCE BLADE",
	description = "A magic blade imbued with concentrated spitium, causing enemies hit by it to spit overheated acid",
	sprite 		= "mods/TheArmory/files/actions/concentratedspitiumlance.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CONCENTRATEDSPITIUM_BLADE
	spawn_probability                 = "0", -- CONCENTRATEDSPITIUM_BLADE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/concentratedspitiumlance.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITIUMLANCE_BLADE",
	name 		= "SPITIUM LANCE BLADE",
	description = "A magic blade imbued with spitium, causing enemies hit by it to spit acid",
	sprite 		= "mods/TheArmory/files/actions/spitiumlance.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITIUM_BLADE
	spawn_probability                 = "0", -- SPITIUM_BLADE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/spitiumlance.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_VENOMOUSSPEAR_BLADE",
	name 		= "VENOMOUS SPEAR BLADE",
	description = "A magic blade that causes enemies hit by it to spit poison",
	sprite 		= "mods/TheArmory/files/actions/venomousspear.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- VENOMOUSSPEAR_BLADE
	spawn_probability                 = "0", -- VENOMOUSSPEAR_BLADE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/venomousspear.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_REGULARLANCE_BLADE",
	name 		= "REGULAR LANCE BLADE",
	description = "A regular lance blade, deals improved slice damage",
	sprite 		= "mods/TheArmory/files/actions/regularlance.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- REGULARLANCE_BLADE
	spawn_probability                 = "0", -- REGULARLANCE_BLADE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/regularlance.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_TRITIUM",
	name 		= "SPITBOMB (TRITIUM)",
	description = "A bomb that explodes spitting tritium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_tritium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_TRITIUM
	spawn_probability                 = "0", -- SPITBOMB_TRITIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_tritium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_tritium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_tritium.xml")

				add_projectile("data/entities/projectiles/spitbomb_tritium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_KATANA",
	name 		= "KATANA",
	description = "The most populsar nihontou!",
	sprite 		= "mods/TheArmory/files/actions/katana.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- KATANA
	spawn_probability                 = "0", -- KATANA
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/katana.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_KATANA_ELECTRIC",
	name 		= "ELECTRIC KATANA",
	description = "Denki nihontou",
	sprite 		= "mods/TheArmory/files/actions/katana_electric.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- KATANA_ELECTRIC
	spawn_probability                 = "0", -- KATANA_ELECTRIC
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/katana_electric.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_JIGENTOU",
	name 		= "JIGEN TOU",
	description = "A magic sword capable of creating dimensional rifts when it touches something",
	sprite 		= "mods/TheArmory/files/actions/jigentou.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- JIGENTOU
	spawn_probability                 = "0", -- JIGENTOU
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/jigentou.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_EMPAXE_BLADE_IMPROVED",
	name 		= "EMPAXE BLADE 2.0",
	description = "Electrified justice, with electric shockwaves included",
	sprite 		= "mods/TheArmory/files/actions/empaxe_improved.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- EMPAXE_BLADE_IMPROVED
	spawn_probability                 = "0", -- EMPAXE_BLADE_IMPROVED
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/empaxe_improved.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FREONICAXE",
	name 		= "FREONIC AXE",
	description = "A magic axe that freezes enemies touched by its blade and releases freezing gas on impact",
	sprite 		= "mods/TheArmory/files/actions/freonicaxe.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FREONICAXE
	spawn_probability                 = "0", -- FREONICAXE
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/freonicaxe.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FROSTSPEAR",
	name 		= "FROST SPEAR",
	description = "A magic spear that creates a small freezing area when it hits something",
	sprite 		= "mods/TheArmory/files/actions/frostspear.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FROSTSPEAR
	spawn_probability                 = "0", -- FROSTSPEAR
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/frostspear.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_GLACIALHAMMER",
	name 		= "GLACIAL HAMMER",
	description = "A magic hammer that creates freezing shockwaves whenever it hits something",
	sprite 		= "mods/TheArmory/files/actions/glacialhammer.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- GLACIALHAMMER
	spawn_probability                 = "0", -- GLACIALHAMMER
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/glacialhammer.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LANCEOFEMBERS",
	name 		= "LANCE OF EMBERS",
	description = "A magic lance that creates fire shockwaves whenever it hits something",
	sprite 		= "mods/TheArmory/files/actions/lanceofembers.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LANCEOFEMBERS
	spawn_probability                 = "0", -- LANCEOFEMBERS
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/lanceofembers.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_HELLFIREAXE",
	name 		= "HELLFIRE AXE",
	description = "A magic axe that releases lava on enemies cut by it",
	sprite 		= "mods/TheArmory/files/actions/hellfireaxe.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- HELLFIREAXE
	spawn_probability                 = "0", -- HELLFIREAXE
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/hellfireaxe.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BOXERPOLEARM",
	name 		= "BOXER POLEARM",
	description = "A melee weapon that knocks enemies away with powerful punches",
	sprite 		= "mods/TheArmory/files/actions/boxerpolearm.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BOXERPOLEARM
	spawn_probability                 = "0", -- BOXERPOLEARM
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/boxerpolearm.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BOXERPOLEARM_EXPLOSIUM",
	name 		= "BOXER POLEARM (EXPLOSIUM)",
	description = "A melee weapon that knocks enemies away with powerful punches, inducing the exploding effect on them",
	sprite 		= "mods/TheArmory/files/actions/boxerpolearm_explosium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BOXERPOLEARM_EXPLOSIUM
	spawn_probability                 = "0", -- BOXERPOLEARM_EXPLOSIUM
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/boxerpolearm_explosium.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BOXERPOLEARM_FREEZING",
	name 		= "BOXER POLEARM (FREEZING)",
	description = "A melee weapon that knocks enemies away with powerful punches, inducing the freeze damage effect on them",
	sprite 		= "mods/TheArmory/files/actions/boxerpolearm_freezing.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BOXERPOLEARM_FREEZING
	spawn_probability                 = "0", -- BOXERPOLEARM_FREEZING
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/boxerpolearm_freezing.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BOXERPOLEARM_PUNCTURING",
	name 		= "BOXER POLEARM (PUNCTURING)",
	description = "A melee weapon that knocks enemies away with powerful punches, puncturing them and making them bleed",
	sprite 		= "mods/TheArmory/files/actions/boxerpolearm_puncturing.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BOXERPOLEARM_PUNCTURING
	spawn_probability                 = "0", -- BOXERPOLEARM_PUNCTURING
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/boxerpolearm_puncturing.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BOXERPOLEARM_ELECTRIFIED",
	name 		= "BOXER POLEARM (ELECTRIFIED)",
	description = "A melee weapon that knocks enemies away with powerful punches, inducing the electrocution damage effect on them",
	sprite 		= "mods/TheArmory/files/actions/boxerpolearm_electrified.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BOXERPOLEARM_ELECTRIFIED
	spawn_probability                 = "0", -- BOXERPOLEARM_ELECTRIFIED
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/boxerpolearm_electrified.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CATAPULTSPEAR",
	name 		= "CATAPULT SPEAR",
	description = "A melee weapon that pulls enemies towards you",
	sprite 		= "mods/TheArmory/files/actions/catapultspear.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CATAPULTSPEAR
	spawn_probability                 = "0", -- CATAPULTSPEAR
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/catapultspear.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CATAPULTSPEAR_FREEZING",
	name 		= "CATAPULT SPEAR (FREEZING)",
	description = "A melee weapon that pulls enemies towards you, inducing the freeze damage effect on them",
	sprite 		= "mods/TheArmory/files/actions/catapultspear_freezing.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CATAPULTSPEAR_FREEZING
	spawn_probability                 = "0", -- CATAPULTSPEAR_FREEZING
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/catapultspear_freezing.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CATAPULTSPEAR_ELECTRIFIED",
	name 		= "CATAPULT SPEAR (ELECTRIFIED)",
	description = "A melee weapon that pulls enemies towards you, inducing the electrocution damage effect on them",
	sprite 		= "mods/TheArmory/files/actions/catapultspear_electrified.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CATAPULTSPEAR_ELECTRIFIED
	spawn_probability                 = "0", -- CATAPULTSPEAR_ELECTRIFIED
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/catapultspear_electrified.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CATAPULTSPEAR_OVERHEATED",
	name 		= "CATAPULT SPEAR (OVERHEATED)",
	description = "A melee weapon that pulls enemies towards you, setting them on fire",
	sprite 		= "mods/TheArmory/files/actions/catapultspear_overheated.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CATAPULTSPEAR_OVERHEATED
	spawn_probability                 = "0", -- CATAPULTSPEAR_OVERHEATED
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/catapultspear_overheated.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CATAPULTSPEAR_ACIDSPIT",
	name 		= "CATAPULT SPEAR (ACID SPIT)",
	description = "A melee weapon that pulls enemies towards you, inducing the acid spit effect on them",
	sprite 		= "mods/TheArmory/files/actions/catapultspear_acidspit.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CATAPULTSPEAR_ACIDSPIT
	spawn_probability                 = "0", -- CATAPULTSPEAR_ACIDSPIT
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/catapultspear_acidspit.xml")	
	end,
} )


table.insert( actions,
{
	id          = "THEARMORYACTIONS_NANOSHRAPNEL_SHELL",
	name 		= "Nanoshrapnel Shell",
	description = "12 Gauge Shotgun Shell filled with nanoshrapnel pellets that cover a small range but penetrate walls",
	sprite 		= "mods/TheArmory/files/actions/shell_nanoshrapnel.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- NANOSHRAPNEL_SHELL
	spawn_probability                 = "0", -- NANOSHRAPNEL_SHELL
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "shotgun_ammo", "Shotgun Shells")) then
				
				applyTrinketsEffectsWeapons_Elemental("nanoshrapnelprojectile_pellet.xml")
			
				applyTrinketsEffectsWeapons_ScatterShotRegular("nanoshrapnelprojectile_pellet.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nanoshrapnelprojectile_pellet.xml")

				add_projectile("data/entities/projectiles/nanoshrapnelprojectile_pellet.xml")
				add_projectile("data/entities/projectiles/nanoshrapnelprojectile_pellet.xml")
				add_projectile("data/entities/projectiles/nanoshrapnelprojectile_pellet.xml")
				add_projectile("data/entities/projectiles/nanoshrapnelprojectile_pellet.xml")
				add_projectile("data/entities/projectiles/nanoshrapnelprojectile_pellet.xml")
				add_projectile("data/entities/projectiles/nanoshrapnelprojectile_pellet.xml")

				c.spread_degrees = 40
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "shotgun_ammo", "Shotgun Shells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_TRITIUM",
	name 		= "SYRINGE FILLED WITH TRITIUM",
	description = "Injects enemies with tritium",
	sprite 		= "mods/TheArmory/files/actions/syringe_tritium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_TRITIUM
	spawn_probability                 = "0", -- SYRINGE_TRITIUM
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_tritium.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_tritium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_tritium.xml")

				add_projectile("data/entities/projectiles/syringe_tritium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_CONCENTRATEDPOISONGAS",
	name 		= "SYRINGE FILLED WITH CONCENTRATED POISON GAS",
	description = "Injects enemies with concentrated poison gas",
	sprite 		= "mods/TheArmory/files/actions/syringe_concentratedpoisongas.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_CONCENTRATEDPOISONGAS
	spawn_probability                 = "0", -- SYRINGE_CONCENTRATEDPOISONGAS
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_concentratedpoisongas.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_concentratedpoisongas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_concentratedpoisongas.xml")

				add_projectile("data/entities/projectiles/syringe_concentratedpoisongas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_CONCENTRATEDSPITIUM",
	name 		= "SYRINGE FILLED WITH CONCENTRATED SPITIUM",
	description = "Injects enemies with concentrated spitium",
	sprite 		= "mods/TheArmory/files/actions/syringe_concentratedspitium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_CONCENTRATEDSPITIUM
	spawn_probability                 = "0", -- SYRINGE_CONCENTRATEDSPITIUM
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_concentratedspitium.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_concentratedspitium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_concentratedspitium.xml")

				add_projectile("data/entities/projectiles/syringe_concentratedspitium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_SPITIUM",
	name 		= "SYRINGE FILLED WITH SPITIUM",
	description = "Injects enemies with spitium",
	sprite 		= "mods/TheArmory/files/actions/syringe_spitium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_SPITIUM
	spawn_probability                 = "0", -- SYRINGE_SPITIUM
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_spitium.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_spitium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_spitium.xml")

				add_projectile("data/entities/projectiles/syringe_spitium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_WAVIUMLANCE_BLADE",
	name 		= "WAVIUM LANCE BLADE",
	description = "A magic blade imbued with wavium, causing enemies hit by it to emit energy waves",
	sprite 		= "mods/TheArmory/files/actions/waviumlance.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- WAVIUMLANCE_BLADE
	spawn_probability                 = "0", -- WAVIUMLANCE_BLADE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/waviumlance.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_WAVIUMBLADE",
	name 		= "FLAIL (WAVIUM BLADE)",
	description = "Causes enemies touched by it to emit energy waves",
	sprite 		= "mods/TheArmory/files/actions/flail_waviumblade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_WAVIUMBLADE
	spawn_probability                 = "0", -- FLAIL_WAVIUMBLADE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_Elemental("flail_waviumblade.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_waviumblade.xml")
		
		add_projectile("data/entities/projectiles/flail_waviumblade.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_EXPLOSIUMSPEAR_BLADE",
	name 		= "EXPLOSIUM SPEAR BLADE",
	description = "A magic blade imbued with explosium, causing random explosions around enemies hit by it",
	sprite 		= "mods/TheArmory/files/actions/explosiumspear.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- EXPLOSIUMSPEAR_BLADE
	spawn_probability                 = "0", -- EXPLOSIUMSPEAR_BLADE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/explosiumspear.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_WORLDSHAKERMAUL",
	name 		= "WORLD SHAKER MAUL",
	description = "Causes big explosions when it hits solid obstacles, dealing damage to nearby enemies and sending them flying upwards",
	sprite 		= "mods/TheArmory/files/actions/worldshakermaul.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- WORLDSHAKERMAUL
	spawn_probability                 = "0", -- WORLDSHAKERMAUL
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/worldshakermaul.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_FROGIUM",
	name 		= "SPITBOMB (FROGIUM)",
	description = "A bomb that explodes spitting frogium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_frogium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_FROGIUM
	spawn_probability                 = "0", -- SPITBOMB_FROGIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_frogium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_frogium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_frogium.xml")

				add_projectile("data/entities/projectiles/spitbomb_frogium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_FROGIUM",
	name 		= "SYRINGE FILLED WITH FROGIUM",
	description = "Injects enemies with frogium",
	sprite 		= "mods/TheArmory/files/actions/syringe_frogium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_FROGIUM
	spawn_probability                 = "0", -- SYRINGE_FROGIUM
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_frogium.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_frogium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_frogium.xml")

				add_projectile("data/entities/projectiles/syringe_frogium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_FERROFLUID",
	name 		= "SPITBOMB (FERROFLUID)",
	description = "A bomb that explodes spitting ferrofluid",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_ferrofluid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_FROGIUM
	spawn_probability                 = "0", -- SPITBOMB_FROGIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_ferrofluid.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_ferrofluid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_ferrofluid.xml")

				add_projectile("data/entities/projectiles/spitbomb_ferrofluid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_SLAPIUM",
	name 		= "SPITBOMB (SLAPIUM)",
	description = "A bomb that explodes spitting slapium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_slapium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_FROGIUM
	spawn_probability                 = "0", -- SPITBOMB_FROGIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_slapium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_slapium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_slapium.xml")

				add_projectile("data/entities/projectiles/spitbomb_slapium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_GRAVITIUM",
	name 		= "SPITBOMB (GRAVITIUM)",
	description = "A bomb that explodes spitting gravitium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_gravitium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_GRAVITIUM
	spawn_probability                 = "0", -- SPITBOMB_GRAVITIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_gravitium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_gravitium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_gravitium.xml")

				add_projectile("data/entities/projectiles/spitbomb_gravitium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_CLONIUM",
	name 		= "SPITBOMB (CLONIUM)",
	description = "A bomb that explodes spitting clonium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_clonium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_FROGIUM
	spawn_probability                 = "0", -- SPITBOMB_FROGIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_clonium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_clonium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_clonium.xml")

				add_projectile("data/entities/projectiles/spitbomb_clonium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHIELD",
	name 		= "SHIELD",
	description = "A shield that destroys enemy projectiles when you bash them with it and also knocks enemies back",
	sprite 		= "mods/TheArmory/files/actions/shield.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHIELD
	spawn_probability                 = "0", -- SHIELD
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/shield.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHIELD_DEFLECTING",
	name 		= "DEFLECTING SHIELD",
	description = "A shield that deflects enemy projectiles when you bash them with it and also knocks enemies back",
	sprite 		= "mods/TheArmory/files/actions/shield_deflecting.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHIELD_DEFLECTING
	spawn_probability                 = "0", -- SHIELD_DEFLECTING
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/shield_deflecting.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHIELD_PUNCTURING",
	name 		= "PUNCTURING SHIELD",
	description = "A shield that converts enemy projectiles into spikes when you bash them with it, and knocks enemies back dealing bleeding damage",
	sprite 		= "mods/TheArmory/files/actions/shield_puncturing.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHIELD_PUNCTURING
	spawn_probability                 = "0", -- SHIELD_PUNCTURING
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/shield_puncturing.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHIELD_PUNCTURING_ICE",
	name 		= "ICE PUNCTURING SHIELD",
	description = "A shield that converts enemy projectiles into ice spikes when you bash them with it, and knocks enemies back dealing freeze damage",
	sprite 		= "mods/TheArmory/files/actions/shield_puncturing_ice.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHIELD_PUNCTURING_ICE
	spawn_probability                 = "0", -- SHIELD_PUNCTURING_ICE
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/shield_puncturing_ice.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHIELD_ENERGY",
	name 		= "ENERGY SHIELD",
	description = "A shield that converts enemy projectiles into laser bolts when you bash them with it, and knocks enemies back dealing electrocution damage",
	sprite 		= "mods/TheArmory/files/actions/shield_energy.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHIELD_ENERGY
	spawn_probability                 = "0", -- SHIELD_ENERGY
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/shield_energy.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHIELD_MOLTEN",
	name 		= "MOLTEN SHIELD",
	description = "A shield that converts enemy projectiles into firebombs when you bash them with it, and knocks enemies back dealing burning damage",
	sprite 		= "mods/TheArmory/files/actions/shield_molten.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHIELD_MOLTEN
	spawn_probability                 = "0", -- SHIELD_MOLTEN
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/shield_molten.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHIELD_BUBBLETRAP",
	name 		= "BUBBLETRAP SHIELD",
	description = "A shield that converts enemy projectiles into bubbletraps when you bash them with it, and knocks enemies back dealing electrocution damage",
	sprite 		= "mods/TheArmory/files/actions/shield_bubbletrap.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHIELD_BUBBLETRAP
	spawn_probability                 = "0", -- SHIELD_BUBBLETRAP
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/shield_bubbletrap.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHIELD_DEFLECTMULTI",
	name 		= "MULTI-DEFLECTION SHIELD",
	description = "A shield that deflects and multiplies enemy projectiles, shooting them back, and knocks enemies back dealing electrocution damage",
	sprite 		= "mods/TheArmory/files/actions/shield_deflectmulti.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHIELD_DEFLECTMULTI
	spawn_probability                 = "0", -- SHIELD_DEFLECTMULTI
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/shield_deflectmulti.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHIELD_HEALING",
	name 		= "HEALING SHIELD",
	description = "A shield that absorbs enemy projectiles and heals the player, and knocks enemies back",
	sprite 		= "mods/TheArmory/files/actions/shield_healing.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHIELD_HEALING
	spawn_probability                 = "0", -- SHIELD_HEALING
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/shield_healing.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHIELD_DEFLECTING_RANDOM",
	name 		= "CURVED SHIELD",
	description = "A shield that deflects enemy projectiles at random directions but increases their mass and velocity, and knocks enemies back",
	sprite 		= "mods/TheArmory/files/actions/shield_deflecting_random.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHIELD_DEFLECTING_RANDOM
	spawn_probability                 = "0", -- SHIELD_DEFLECTING_RANDOM
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/shield_deflecting_random.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ISSHINSPEAR",
	name 		= "ISSHIN'S SPEAR",
	description = "The sword saint's spear that clashed with the wolf's sword, sends enemies flying, causes bleeding and also deflects projectiles",
	sprite 		= "mods/TheArmory/files/actions/isshinspear.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ISSHINSPEAR
	spawn_probability                 = "0", -- ISSHINSPEAR
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/isshinspear.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ROBERTSDEMISE",
	name 		= "ROBERT'S DEMISE",
	description = "A massive sword pertaining to a massive warrior",
	sprite 		= "mods/TheArmory/files/actions/robertsdemise.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ROBERTSDEMISE
	spawn_probability                 = "0", -- ROBERTSDEMISE
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/robertsdemise.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_OWLSDECEPTION",
	name 		= "OWL'S DECEPTION",
	description = "A huge shinobi sword that releases fireworks when it hits something",
	sprite 		= "mods/TheArmory/files/actions/owlsdeception.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- OWLSDECEPTION
	spawn_probability                 = "0", -- OWLSDECEPTION
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/owlsdeception.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_SODIUMACETATE",
	name 		= "SPITBOMB (SODIUM ACETATE)",
	description = "A bomb that explodes spitting sodium acetate",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_sodium_acetate.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_ACID
	spawn_probability                 = "0", -- SPITBOMB_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_sodium_acetate.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_sodium_acetate.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_sodium_acetate.xml")

				add_projectile("data/entities/projectiles/spitbomb_sodium_acetate.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_FERROFLUID",
	name 		= "SYRINGE FILLED WITH FERROFLUID",
	description = "Injects enemies with ferrofluid",
	sprite 		= "mods/TheArmory/files/actions/syringe_ferrofluid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_FERROFLUID
	spawn_probability                 = "0", -- SYRINGE_FERROFLUID
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_ferrofluid.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_ferrofluid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_ferrofluid.xml")

				add_projectile("data/entities/projectiles/syringe_ferrofluid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_DEUTERIUM",
	name 		= "SPITBOMB (DEUTERIUM)",
	description = "A bomb that explodes spitting deuterium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_deuterium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_DEUTERIUM
	spawn_probability                 = "0", -- SPITBOMB_DEUTERIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_deuterium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_deuterium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_deuterium.xml")

				add_projectile("data/entities/projectiles/spitbomb_deuterium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_FREON_GAS",
	name 		= "SPITBOMB (FREON GAS)",
	description = "A bomb that explodes spitting freon gas",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_freon_gas.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_FREON_GAS
	spawn_probability                 = "0", -- SPITBOMB_FREON_GAS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_freon_gas.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_freon_gas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_freon_gas.xml")

				add_projectile("data/entities/projectiles/spitbomb_freon_gas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_NEON_GAS",
	name 		= "SPITBOMB (NEON GAS)",
	description = "A bomb that explodes spitting neon gas",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_neon_gas.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_NEON_GAS
	spawn_probability                 = "0", -- SPITBOMB_NEON_GAS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_neon_gas.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_neon_gas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_neon_gas.xml")

				add_projectile("data/entities/projectiles/spitbomb_neon_gas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_REPELLIUM",
	name 		= "SPITBOMB (REPELLIUM)",
	description = "A bomb that explodes spitting repellium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_repellium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_REPELLIUM
	spawn_probability                 = "0", -- SPITBOMB_REPELLIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_repellium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_repellium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_repellium.xml")

				add_projectile("data/entities/projectiles/spitbomb_repellium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_SULFUR_GAS",
	name 		= "SPITBOMB (SULFUR GAS)",
	description = "A bomb that explodes spitting sulfur gas",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_sulfur_gas.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_SULFUR_GAS
	spawn_probability                 = "0", -- SPITBOMB_SULFUR_GAS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_sulfur_gas.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_sulfur_gas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_sulfur_gas.xml")

				add_projectile("data/entities/projectiles/spitbomb_sulfur_gas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MAGNETICPIKE_BLADE",
	name 		= "MAGNETIC PIKE BLADE",
	description = "A pike that magnetizes enemies touched by it",
	sprite 		= "mods/TheArmory/files/actions/magneticpike.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MAGNETICPIKE_BLADE
	spawn_probability                 = "0", -- MAGNETICPIKE_BLADE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/magneticpike.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SLAPIUMLANCE_BLADE",
	name 		= "SLAPIUM LANCE BLADE",
	description = "A lance that induces the slap effect on enemies touched by it",
	sprite 		= "mods/TheArmory/files/actions/slapiumlance.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SLAPIUMLANCE_BLADE
	spawn_probability                 = "0", -- SLAPIUMLANCE_BLADE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/slapiumlance.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NANOSHRAPNEL_BOMB_DIRECTIONAL_OVERHEATED_ACID",
	name 		= "DIRECTIONAL NANOSHRAPNEL BOMB (OVERHEATED ACID)",
	description = "A bomb that explodes into nanoshrapnel that penetrates walls according to its direction, releasing overheated acid",
	sprite 		= "mods/TheArmory/files/actions/nanoshrapnel_bomb_directional_overheated_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- NANOSHRAPNEL_BOMB_DIRECTIONAL_OVERHEATED_ACID
	spawn_probability                 = "0", -- NANOSHRAPNEL_BOMB_DIRECTIONAL_OVERHEATED_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("nanoshrapnel_bomb_directional_overheated_acid.xml")
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nanoshrapnel_bomb_directional_overheated_acid.xml")
				
				add_projectile("data/entities/projectiles/nanoshrapnel_bomb_directional_overheated_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MULTIDRILL",
	name 		= "MULTIDRILL",
	description = "A projectile that breaks down into digging drills once it hits an obstacle",
	sprite 		= "mods/TheArmory/files/actions/multidrill.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MULTIDRILL
	spawn_probability                 = "0", -- MULTIDRILL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("multidrill_main.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("multidrill_main.xml")

				add_projectile("data/entities/projectiles/multidrill_main.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CORRODINGFLATTENER",
	name 		= "CORRODING FLATTENER",
	description = "A magic hammer that creates acid shockwaves whenever it hits something",
	sprite 		= "mods/TheArmory/files/actions/corrodingflattener.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CORRODINGFLATTENER
	spawn_probability                 = "0", -- CORRODINGFLATTENER
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/corrodingflattener.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NITRO_ROCKET",
	name 		= "NITROGLYCERIN LOADED ROCKET",
	description = "A rocket that explodes releasing unstable nitroglycerin on impact",
	sprite 		= "mods/TheArmory/files/actions/rocket_nitro.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- GUNPOWDER_ROCKET
	spawn_probability                 = "0", -- GUNPOWDER_ROCKET
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rockets_ammo", "Rockets")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("rocket_nitro.xml")

				add_projectile("data/entities/projectiles/rocket_nitro.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rockets_ammo", "Rockets")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CRYSTALPROJECTILE_WATER",
	name 		= "WATER CRYSTAL",
	description = "A crystal that explodes into shards on impact",
	sprite 		= "mods/TheArmory/files/actions/crystalprojectile_water.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CRYSTALPROJECTILE_WATER
	spawn_probability                 = "0", -- CRYSTALPROJECTILE_WATER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("crystalprojectile_water.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("crystalprojectile_water.xml")

				add_projectile("data/entities/projectiles/crystalprojectile_water.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FROGIUMSPEAR_BLADE",
	name 		= "FROGIUM SPEAR BLADE",
	description = "A magic blade imbued with frogium, inducing the force up effect on enemies it touches",
	sprite 		= "mods/TheArmory/files/actions/frogiumspear.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FROGIUMSPEAR_BLADE
	spawn_probability                 = "0", -- FROGIUMSPEAR_BLADE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/frogiumspear.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_INFERNOBLADE",
	name 		= "FLAIL (INFERNO BLADE)",
	description = "Induces the burning damage effect on enemies it touches",
	sprite 		= "mods/TheArmory/files/actions/flail_infernoblade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_INFERNOBLADE
	spawn_probability                 = "0", -- FLAIL_INFERNOBLADE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_Elemental("flail_infernoblade.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_infernoblade.xml")
		
		add_projectile("data/entities/projectiles/flail_infernoblade.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_LIGHTNIUM",
	name 		= "SPITBOMB (LIGHTNIUM)",
	description = "A bomb that explodes spitting lightnium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_lightnium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_LIGHTNIUM
	spawn_probability                 = "0", -- SPITBOMB_LIGHTNIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_lightnium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_lightnium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_lightnium.xml")

				add_projectile("data/entities/projectiles/spitbomb_lightnium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_OVERLOADEDBOOMERANG",
	name 		= "OVERLOADED BOOMERANG",
	description = "A boomerang that induces the lightning effect on enemies it touches",
	sprite 		= "mods/TheArmory/files/actions/overloadedboomerang.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- OVERLOADEDBOOMERANG
	spawn_probability                 = "0", -- OVERLOADEDBOOMERANG
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()

		applyTrinketsEffectsWeapons_Elemental("overloadedboomerang.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("overloadedboomerang.xml")
		
		add_projectile("data/entities/projectiles/overloadedboomerang.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_THUNDERLANCE_BLADE",
	name 		= "THUNDER LANCE BLADE",
	description = "A magic blade that induces the lightning effect on enemies touched by it",
	sprite 		= "mods/TheArmory/files/actions/thunderlance.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THUNDERLANCE_BLADE
	spawn_probability                 = "0", -- THUNDERLANCE_BLADE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/thunderlance.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHIELD_THUNDER",
	name 		= "THUNDER SHIELD",
	description = "A shield that converts enemy projectiles into thunderbolts when you bash them with it, and knocks enemies back dealing lightning damage",
	sprite 		= "mods/TheArmory/files/actions/shield_thunder.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHIELD_THUNDER
	spawn_probability                 = "0", -- SHIELD_THUNDER
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/shield_thunder.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHIELD_DRILLBOMB",
	name 		= "DRILLBOMB SHIELD",
	description = "A shield that converts enemy projectiles into drillbombs when you bash them with it, and knocks enemies back dealing bleed damage",
	sprite 		= "mods/TheArmory/files/actions/shield_drillbomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHIELD_DRILLBOMB
	spawn_probability                 = "0", -- SHIELD_DRILLBOMB
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/shield_drillbomb.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_INFERNIUM",
	name 		= "SPITBOMB (INFERNIUM)",
	description = "A bomb that explodes spitting infernium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_infernium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_LIGHTNIUM
	spawn_probability                 = "0", -- SPITBOMB_LIGHTNIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_infernium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_infernium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_infernium.xml")

				add_projectile("data/entities/projectiles/spitbomb_infernium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_THUNDERIUM",
	name 		= "SPITBOMB (THUNDERIUM)",
	description = "A bomb that explodes spitting thunderium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_thunderium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_LIGHTNIUM
	spawn_probability                 = "0", -- SPITBOMB_LIGHTNIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_thunderium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_thunderium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_thunderium.xml")

				add_projectile("data/entities/projectiles/spitbomb_thunderium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_CHILLIUM",
	name 		= "SPITBOMB (CHILLIUM)",
	description = "A bomb that explodes spitting chillium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_chillium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_CHILLIUM
	spawn_probability                 = "0", -- SPITBOMB_CHILLIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_chillium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_chillium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_chillium.xml")

				add_projectile("data/entities/projectiles/spitbomb_chillium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_TESLIUM",
	name 		= "SPITBOMB (TESLIUM)",
	description = "A bomb that explodes spitting teslium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_teslium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_TESLIUM
	spawn_probability                 = "0", -- SPITBOMB_TESLIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_teslium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_teslium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_teslium.xml")

				add_projectile("data/entities/projectiles/spitbomb_teslium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_INFERNIUM",
	name 		= "SYRINGE FILLED WITH INFERNIUM",
	description = "Injects enemies with infernium",
	sprite 		= "mods/TheArmory/files/actions/syringe_infernium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_INFERNIUM
	spawn_probability                 = "0", -- SYRINGE_INFERNIUM
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_infernium.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_infernium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_infernium.xml")

				add_projectile("data/entities/projectiles/syringe_infernium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_THUNDERIUM",
	name 		= "SYRINGE FILLED WITH THUNDERIUM",
	description = "Injects enemies with thunderium",
	sprite 		= "mods/TheArmory/files/actions/syringe_thunderium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_THUNDERIUM
	spawn_probability                 = "0", -- SYRINGE_THUNDERIUM
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_thunderium.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_thunderium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_thunderium.xml")

				add_projectile("data/entities/projectiles/syringe_thunderium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_CHILLIUM",
	name 		= "SYRINGE FILLED WITH CHILLIUM",
	description = "Injects enemies with chillium",
	sprite 		= "mods/TheArmory/files/actions/syringe_chillium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_CHILLIUM
	spawn_probability                 = "0", -- SYRINGE_CHILLIUM
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_chillium.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_chillium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_chillium.xml")

				add_projectile("data/entities/projectiles/syringe_chillium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_TESLIUM",
	name 		= "SYRINGE FILLED WITH TESLIUM",
	description = "Injects enemies with teslium",
	sprite 		= "mods/TheArmory/files/actions/syringe_teslium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_TESLIUM
	spawn_probability                 = "0", -- SYRINGE_TESLIUM
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_teslium.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_teslium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_teslium.xml")

				add_projectile("data/entities/projectiles/syringe_teslium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_LIGHTNIUM",
	name 		= "SYRINGE FILLED WITH LIGHTNIUM",
	description = "Injects enemies with lightnium",
	sprite 		= "mods/TheArmory/files/actions/syringe_lightnium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SYRINGE_LIGHTNIUM
	spawn_probability                 = "0", -- SYRINGE_LIGHTNIUM
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_lightnium.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_lightnium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_lightnium.xml")

				add_projectile("data/entities/projectiles/syringe_lightnium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAIL_MAGNETICBLADE",
	name 		= "FLAIL (MAGNETIC BLADE)",
	description = "Induces the attraction effect on enemies it touches",
	sprite 		= "mods/TheArmory/files/actions/flail_magneticblade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- FLAIL_MAGNETICBLADE
	spawn_probability                 = "0", -- FLAIL_MAGNETICBLADE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		applyTrinketsEffectsWeapons_Elemental("flail_magneticblade.xml")
		
		applyTrinketsEffectsWeapons_StackableBonusesRanged("flail_magneticblade.xml")
		
		add_projectile("data/entities/projectiles/flail_magneticblade.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_RATSUMMONER",
	name 		= "RATSUMMONER",
	description = "Summons plague rats that fight for you",
	sprite 		= "mods/TheArmory/files/actions/ratsummoner.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- RATSUMMONER
	spawn_probability                 = "0", -- RATSUMMONER
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Energy("ratsummoner.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("ratsummoner.xml")

				add_projectile("data/entities/projectiles/ratsummoner.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_RATSUMMONER_TNT",
	name 		= "RATSUMMONER (TNT)",
	description = "Summons suicide rats that explode when close to enemies",
	sprite 		= "mods/TheArmory/files/actions/ratsummoner_tnt.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- RATSUMMONER_TNT
	spawn_probability                 = "0", -- RATSUMMONER_TNT
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Energy("ratsummoner_tnt.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("ratsummoner_tnt.xml")

				add_projectile("data/entities/projectiles/ratsummoner_tnt.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_RATSUMMONER_MAGICSTONE",
	name 		= "RATSUMMONER (MAGIC STONE)",
	description = "Summons suicide rats that explode into spark bolts when close to enemies",
	sprite 		= "mods/TheArmory/files/actions/ratsummoner_magicstone.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- RATSUMMONER_MAGICSTONE
	spawn_probability                 = "0", -- RATSUMMONER_MAGICSTONE
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Energy("ratsummoner_magicstone.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("ratsummoner_magicstone.xml")

				add_projectile("data/entities/projectiles/ratsummoner_magicstone.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_RATSUMMONER_ACID",
	name 		= "RATSUMMONER (ACID)",
	description = "Summons suicide rats that explode releasing acid when close to enemies",
	sprite 		= "mods/TheArmory/files/actions/ratsummoner_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- RATSUMMONER_ACID
	spawn_probability                 = "0", -- RATSUMMONER_ACID
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Energy("ratsummoner_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("ratsummoner_acid.xml")

				add_projectile("data/entities/projectiles/ratsummoner_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELLIPSOIDBULLET_SCATTER_HEAVY",
	name 		= "ELLIPSOID BULLET (SCATTER HEAVY)",
	description = "Many slow/explosive grenades ammo consuming heavy bullets shot at once",
	sprite 		= "mods/TheArmory/files/actions/ellipsoidbullet_scatter_heavy.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ELLIPSOIDBULLET_SCATTER_HEAVY
	spawn_probability                 = "0", -- ELLIPSOIDBULLET_SCATTER_HEAVY
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_ScatterShotRegular("ellipsoidbullet.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("ellipsoidbullet.xml")

				add_projectile("data/entities/projectiles/ellipsoidbullet.xml")
				add_projectile("data/entities/projectiles/ellipsoidbullet.xml")
				add_projectile("data/entities/projectiles/ellipsoidbullet.xml")
				c.spread_degrees = 35
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_HIGHEXPLOSIVEGRENADE",
	name 		= "HIGH EXPLOSIVE GRENADE",
	description = "A powerful grenade that creates a sequence of explosions",
	sprite 		= "mods/TheArmory/files/actions/highexplosivegrenade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- HIGHEXPLOSIVEGRENADE
	spawn_probability                 = "0", -- HIGHEXPLOSIVEGRENADE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_StackableBonusesRanged("highexplosivegrenade.xml")

				add_projectile("data/entities/projectiles/highexplosivegrenade.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CLUSTERGRENADE",
	name 		= "CLUSTER GRENADE",
	description = "A grenade that releases smaller grenades on hit",
	sprite 		= "mods/TheArmory/files/actions/clustergrenade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CLUSTERGRENADE
	spawn_probability                 = "0", -- CLUSTERGRENADE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_StackableBonusesRanged("clustergrenade.xml")

				add_projectile("data/entities/projectiles/clustergrenade.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_PURPLEPLASMABOLT",
	name 		= "PURPLE PLASMA BOLT",
	description = "A beam of purple plasma that creates small explosions on hit",
	sprite 		= "mods/TheArmory/files/actions/purpleplasmabolt.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- PURPLEPLASMABOLT
	spawn_probability                 = "0", -- PURPLEPLASMABOLT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("purpleplasmabolt.xml")
				
				applyTrinketsEffectsWeapons_Energy("purpleplasmabolt.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("purpleplasmabolt.xml")

				add_projectile("data/entities/projectiles/purpleplasmabolt.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_PURPLEPLASMAORB",
	name 		= "PURPLE PLASMA ORB",
	description = "A plasma orb that causes a series of explosions",
	sprite 		= "mods/TheArmory/files/actions/purpleplasmaorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- PURPLEPLASMABOLT
	spawn_probability                 = "0", -- PURPLEPLASMABOLT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("purpleplasmaorb.xml")
				
				applyTrinketsEffectsWeapons_Energy("purpleplasmaorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("purpleplasmaorb.xml")

				add_projectile("data/entities/projectiles/purpleplasmaorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ORANGELASERBOLT",
	name 		= "ORANGE LASER BOLT",
	description = "A beam of concentrated light, releases small pockets of lava on hit",
	sprite 		= "mods/TheArmory/files/actions/orangelaserbolt.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ORANGELASERBOLT
	spawn_probability                 = "0", -- REDLASERBOLT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("orangelaserbolt.xml")
				
				applyTrinketsEffectsWeapons_Energy("orangelaserbolt.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("orangelaserbolt.xml")

				add_projectile("data/entities/projectiles/orangelaserbolt.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ORANGEPLASMAORB",
	name 		= "ORANGE PLASMA ORB",
	description = "A plasma orb that releases a wave of scorching orbs when it explodes",
	sprite 		= "mods/TheArmory/files/actions/orangeplasmaorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- PURPLEPLASMABOLT
	spawn_probability                 = "0", -- PURPLEPLASMABOLT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("orangeplasmaorb.xml")
				
				applyTrinketsEffectsWeapons_Energy("orangeplasmaorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("orangeplasmaorb.xml")

				add_projectile("data/entities/projectiles/orangeplasmaorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_GREENLASERBOLT_SCATTER",
	name 		= "GREEN LASER BOLTS",
	description = "Beams of concentrated light that release small pockets of toxic gas on hit",
	sprite 		= "mods/TheArmory/files/actions/greenlaserbolt_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- GREENLASERBOLT_SCATTER
	spawn_probability                 = "0", -- GREENLASERBOLT_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("greenlaserbolt.xml")
				
				applyTrinketsEffectsWeapons_Energy("greenlaserbolt.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("greenlaserbolt.xml")

				add_projectile("data/entities/projectiles/greenlaserbolt.xml")
				add_projectile("data/entities/projectiles/greenlaserbolt.xml")
				add_projectile("data/entities/projectiles/greenlaserbolt.xml")
				add_projectile("data/entities/projectiles/greenlaserbolt.xml")
				c.spread_degrees = 15
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_GREENPLASMAORB",
	name 		= "GREEN PLASMA ORB",
	description = "A plasma orb that releases a wave of corroding orbs when it explodes",
	sprite 		= "mods/TheArmory/files/actions/greenplasmaorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- GREENPLASMAORB
	spawn_probability                 = "0", -- GREENPLASMAORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("greenplasmaorb.xml")
				
				applyTrinketsEffectsWeapons_Energy("greenplasmaorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("greenplasmaorb.xml")

				add_projectile("data/entities/projectiles/greenplasmaorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CLUSTERSHRAPNELGRENADE",
	name 		= "CLUSTER SHRAPNEL GRENADE",
	description = "A grenade that releases shrapnel grenades on hit",
	sprite 		= "mods/TheArmory/files/actions/clustershrapnelgrenade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CLUSTERGRENADE
	spawn_probability                 = "0", -- CLUSTERGRENADE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_StackableBonusesRanged("clustershrapnelgrenade.xml")

				add_projectile("data/entities/projectiles/clustershrapnelgrenade.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BALLISTIC_SLUG",
	name 		= "Ballistic Slug Shell",
	description = "12 Gauge Slug Shell that shoots .50 BMG bullets when it hits something",
	sprite 		= "mods/TheArmory/files/actions/ballistic_slug.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BALLISTIC_SLUG
	spawn_probability                 = "0", -- BALLISTIC_SLUG
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "shotgun_ammo", "Shotgun Shells")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("ballistic_slug.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("ballistic_slug.xml")

				add_projectile("data/entities/projectiles/ballistic_slug.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "shotgun_ammo", "Shotgun Shells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MAD_SHELL",
	name 		= "Mad Shell",
	description = "Shoots shotgun pellets, 5.56 and 7.62 bullets",
	sprite 		= "mods/TheArmory/files/actions/mad_shell.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHOTGUNSHELL
	spawn_probability                 = "0", -- SHOTGUNSHELL
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "shotgun_ammo", "Shotgun Shells")) then
			
				add_projectile("data/entities/projectiles/bulletammo_buckshot_pellet.xml")
				add_projectile("data/entities/projectiles/bulletammo_buckshot_pellet.xml")
				add_projectile("data/entities/projectiles/bulletammo_buckshot_pellet.xml")
				add_projectile("data/entities/projectiles/bulletammo_buckshot_pellet.xml")
				add_projectile("data/entities/projectiles/bulletammo_762.xml")
				add_projectile("data/entities/projectiles/bulletammo_762.xml")
				add_projectile("data/entities/projectiles/bulletammo_762.xml")
				add_projectile("data/entities/projectiles/bulletammo_762.xml")
				add_projectile("data/entities/projectiles/bulletammo_556.xml")
				add_projectile("data/entities/projectiles/bulletammo_556.xml")
				add_projectile("data/entities/projectiles/bulletammo_556.xml")
				add_projectile("data/entities/projectiles/bulletammo_556.xml")

				c.spread_degrees = 35
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "shotgun_ammo", "Shotgun Shells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ROCKET_CLAW",
	name 		= "CLAW ROCKET",
	description = "A homing rocket that deals slice damage",
	sprite 		= "mods/TheArmory/files/actions/rocket_claw.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ROCKET_CLAW
	spawn_probability                 = "0", -- ROCKET_CLAW
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rockets_ammo", "Rockets")) then
				
				applyTrinketsEffectsWeapons_Explosive()

				applyTrinketsEffectsWeapons_StackableBonusesRanged("rocket_claw.xml")

				add_projectile("data/entities/projectiles/rocket_claw.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rockets_ammo", "Rockets")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ROCKET_BOXINGGLOVE",
	name 		= "BOXING GLOVE ROCKET",
	description = "A homing rocket that deals melee damage",
	sprite 		= "mods/TheArmory/files/actions/rocket_boxingglove.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ROCKET_CLAW
	spawn_probability                 = "0", -- ROCKET_CLAW
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rockets_ammo", "Rockets")) then
				
				applyTrinketsEffectsWeapons_Explosive()

				applyTrinketsEffectsWeapons_StackableBonusesRanged("rocket_boxingglove.xml")

				add_projectile("data/entities/projectiles/rocket_boxingglove.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rockets_ammo", "Rockets")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_INFERNOWAVEBOMB",
	name 		= "INFERNO WAVE BOMB",
	description = "Releases a burning wave when it explodes above horizontal surfaces",
	sprite 		= "mods/TheArmory/files/actions/infernowavebomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- INFERNOWAVEBOMB
	spawn_probability                 = "0", -- INFERNOWAVEBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("infernowavebomb.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("infernowavebomb.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("infernowavebomb.xml")

				add_projectile("data/entities/projectiles/infernowavebomb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SELF_SCORCHING_FIELD",
	name 		= "SCORCHING FIELD PROJECTOR",
	description = "Projects a scorching field around you",
	sprite 		= "mods/TheArmory/files/actions/self_scorching_field.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SELF_SCORCHING_FIELD
	spawn_probability                 = "0", -- SELF_SCORCHING_FIELD
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				add_projectile("data/entities/projectiles/self_scorching_field.xml")

				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SELF_REPELLING_FIELD",
	name 		= "REPELLING FIELD PROJECTOR",
	description = "Projects a repelling field around you",
	sprite 		= "mods/TheArmory/files/actions/self_repelling_field.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SELF_REPELLING_FIELD
	spawn_probability                 = "0", -- SELF_REPELLING_FIELD
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				add_projectile("data/entities/projectiles/self_repelling_field.xml")

				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CYANPLASMAORB",
	name 		= "CYAN PLASMA ORB",
	description = "A plasma orb that releases a wave of freezing orbs on impact",
	sprite 		= "mods/TheArmory/files/actions/cyanplasmaorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- PURPLEPLASMABOLT
	spawn_probability                 = "0", -- PURPLEPLASMABOLT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("cyanplasmaorb.xml")
				
				applyTrinketsEffectsWeapons_Energy("cyanplasmaorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("cyanplasmaorb.xml")

				add_projectile("data/entities/projectiles/cyanplasmaorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CORRUPTEDMAUL",
	name 		= "CORRUPTED MAUL",
	description = "A magic hammer that creates poison shockwaves whenever it hits something",
	sprite 		= "mods/TheArmory/files/actions/corruptedmaul.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CORRUPTEDMAUL
	spawn_probability                 = "0", -- CORRUPTEDMAUL
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/corruptedmaul.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_RAYTRACER_BLADE",
	name 		= "RAYTRACER BLADE",
	description = "A magic blade that creates laser shockwaves whenever it hits something",
	sprite 		= "mods/TheArmory/files/actions/raytracer.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- RAYTRACER_BLADE
	spawn_probability                 = "0", -- RAYTRACER_BLADE
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/raytracer.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LEADBALLS",
	name 		= "LEAD BALLS",
	description = "Make'em ead the lead!",
	sprite 		= "mods/TheArmory/files/actions/leadballs.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LEADBALLS
	spawn_probability                 = "0", -- LEADBALLS
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "shotgun_ammo", "Shotgun Shells")) then
			
				applyTrinketsEffectsWeapons_ScatterShotRegular("bulletammo_leadball.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_leadball.xml")

				add_projectile("data/entities/projectiles/bulletammo_leadball.xml")
				add_projectile("data/entities/projectiles/bulletammo_leadball.xml")
				add_projectile("data/entities/projectiles/bulletammo_leadball.xml")
				add_projectile("data/entities/projectiles/bulletammo_leadball.xml")
				add_projectile("data/entities/projectiles/bulletammo_leadball.xml")
				add_projectile("data/entities/projectiles/bulletammo_leadball.xml")
				add_projectile("data/entities/projectiles/bulletammo_leadball.xml")
				add_projectile("data/entities/projectiles/bulletammo_leadball.xml")
				add_projectile("data/entities/projectiles/bulletammo_leadball.xml")
				add_projectile("data/entities/projectiles/bulletammo_leadball.xml")
				add_projectile("data/entities/projectiles/bulletammo_leadball.xml")
				add_projectile("data/entities/projectiles/bulletammo_leadball.xml")
				
				c.spread_degrees = 45
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "shotgun_ammo", "Shotgun Shells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_50AE",
	name 		= ".50 AE",
	description = ".50 Action Express round",
	sprite 		= "mods/TheArmory/files/actions/50ae.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 50AE
	spawn_probability                 = "0", -- 50AE
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "pistol_ammo", "Pistol Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_50ae.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_50ae.xml")

				add_projectile("data/entities/projectiles/bulletammo_50ae.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "pistol_ammo", "Pistol Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CLUSTERROCKETBOMB",
	name 		= "CLUSTER ROCKET BOMB",
	description = "A bomb that explodes releasing homing rockets mid-air",
	sprite 		= "mods/TheArmory/files/actions/clusterrocketbomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_ACID
	spawn_probability                 = "0", -- SPITBOMB_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("clusterrocketbomb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("clusterrocketbomb.xml")

				add_projectile("data/entities/projectiles/clusterrocketbomb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ATOMICSLEDGE_EXPOSEDCORES",
	name 		= "ATOMIC SLEDGE WITH EXPOSED CORES",
	description = "Releases a wave of radioactive material on impact!",
	sprite 		= "mods/TheArmory/files/actions/atomicsledge_exposedcores.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ATOMICSLEDGE
	spawn_probability                 = "0", -- ATOMICSLEDGE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/atomicsledge_exposedcores.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SLIMEBOMB",
	name 		= "SLIME BOMB",
	description = "Releases a wave of slime projectiles on impact",
	sprite 		= "mods/TheArmory/files/actions/slimebomb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THUNDERBOMB
	spawn_probability                 = "0", -- THUNDERBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("slimebomb.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("slimebomb.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("slimebomb.xml")

				add_projectile("data/entities/projectiles/slimebomb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ICESTONE",
	name 		= "ICE STONE",
	description = "Releases an ice wave when it explodes above horizontal surfaces",
	sprite 		= "mods/TheArmory/files/actions/icestone.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ICESTONE
	spawn_probability                 = "0", -- ICESTONE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("icestone.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("icestone.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("icestone.xml")

				add_projectile("data/entities/projectiles/icestone.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SELF_CHILLING_FIELD",
	name 		= "CHILLING FIELD PROJECTOR",
	description = "Projects a chilling field around you",
	sprite 		= "mods/TheArmory/files/actions/self_chilling_field.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SELF_CHILLING_FIELD
	spawn_probability                 = "0", -- SELF_CHILLING_FIELD
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				add_projectile("data/entities/projectiles/self_chilling_field.xml")

				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TASERSHELL",
	name 		= "Shotgun Shell loaded with Taser Rounds",
	description = "Releases stun projectiles when shot",
	sprite 		= "mods/TheArmory/files/actions/taser_shell.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TASERSHELL
	spawn_probability                 = "0", -- TASERSHELL
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "shotgun_ammo", "Shotgun Shells")) then
			
				applyTrinketsEffectsWeapons_ScatterShotRegular("stunprojectile.xml")
				
				applyTrinketsEffectsWeapons_Elemental("stunprojectile.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("stunprojectile.xml")

				add_projectile("data/entities/projectiles/stunprojectile.xml")
				add_projectile("data/entities/projectiles/stunprojectile.xml")
				add_projectile("data/entities/projectiles/stunprojectile.xml")
				add_projectile("data/entities/projectiles/stunprojectile.xml")
				add_projectile("data/entities/projectiles/stunprojectile.xml")
				add_projectile("data/entities/projectiles/stunprojectile.xml")

				c.spread_degrees = 35
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "shotgun_ammo", "Shotgun Shells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SELF_ZAPPING_FIELD",
	name 		= "ZAPPING FIELD PROJECTOR",
	description = "Projects a zapping field around you",
	sprite 		= "mods/TheArmory/files/actions/self_zapping_field.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SELF_CHILLING_FIELD
	spawn_probability                 = "0", -- SELF_CHILLING_FIELD
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				add_projectile("data/entities/projectiles/self_zapping_field.xml")

				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_HIGHEXPLOSIVE_LASER",
	name 		= "HIGH EXPLOSIVE LASER BOLT",
	description = "A powerful red laser bolt that creates explosions where it hits, shooting secondary laser bolts from them",
	sprite 		= "mods/TheArmory/files/actions/highexplosive_laser.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- HIGHEXPLOSIVE_LASER
	spawn_probability                 = "0", -- HIGHEXPLOSIVE_LASER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Energy("highexplosive_laser.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("highexplosive_laser.xml")

				add_projectile("data/entities/projectiles/highexplosive_laser.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAPSPAWNERORB",
	name 		= "BUBBLE TRAP SPAWNER ORB",
	description = "An energy orb that spawns bubbletraps at random directions while it travels mid-air",
	sprite 		= "mods/TheArmory/files/actions/bubbletrapspawnerorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAPSPAWNERORB
	spawn_probability                 = "0", -- BUBBLETRAPSPAWNERORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Energy("bubbletrapspawnerorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrapspawnerorb.xml")

				add_projectile("data/entities/projectiles/bubbletrapspawnerorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_CLUSTER",
	name 		= "CLUSTER GRENADES BUBBLE TRAP",
	description = "A bubble that traps enemies it comes in contact with and explodes afterwards, releasing grenades",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_cluster.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP
	spawn_probability                 = "0", -- BUBBLETRAP
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_cluster.xml")

				add_projectile("data/entities/projectiles/bubbletrap_cluster.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_GRENADEBUNDLE_ACID",
	name 		= "GRENADE BUNDLE (ACID)",
	description = "A bundle of acid grenades shot at once",
	sprite 		= "mods/TheArmory/files/actions/grenadebundle_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- GRENADEBUNDLE_ACID
	spawn_probability                 = "0", -- GRENADEBUNDLE_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_acid.xml")
			
				applyTrinketsEffectsWeapons_ScatterShotRegular("spitbomb_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_acid.xml")

				add_projectile("data/entities/projectiles/spitbomb_acid.xml")
				add_projectile("data/entities/projectiles/spitbomb_acid.xml")
				add_projectile("data/entities/projectiles/spitbomb_acid.xml")
				add_projectile("data/entities/projectiles/spitbomb_acid.xml")
				c.spread_degrees = 35
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_HIGHEXPLOSIVE",
	name 		= "HIGH EXPLOSIVE BUBBLE TRAP",
	description = "A bubble that traps enemies it comes in contact with and blows up in a sequence of explosions afterwards",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_highexplosive.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP_HIGHEXPLOSIVE
	spawn_probability                 = "0", -- BUBBLETRAP_HIGHEXPLOSIVE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_highexplosive.xml")

				add_projectile("data/entities/projectiles/bubbletrap_highexplosive.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_HIGHEXPLOSIVE_ACID",
	name 		= "HIGH EXPLOSIVE ACID BUBBLE TRAP",
	description = "A bubble that traps enemies it comes in contact with and blows up in a sequence of acid explosions afterwards",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_highexplosive_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP_HIGHEXPLOSIVE_ACID
	spawn_probability                 = "0", -- BUBBLETRAP_HIGHEXPLOSIVE_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Elemental("bubbletrap_highexplosive_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_highexplosive_acid.xml")

				add_projectile("data/entities/projectiles/bubbletrap_highexplosive_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BIGCANISTER_EXPLOSIUM",
	name 		= "BIG CANISTER (EXPLOSIUM)",
	description = "A canister that spills explosium while it travels mid-air, and releases more of this material on impact",
	sprite 		= "mods/TheArmory/files/actions/bigcanister_explosium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BIGCANISTER_EXPLOSIUM
	spawn_probability                 = "0", -- BIGCANISTER_EXPLOSIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Elemental("bigcanister_explosium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bigcanister_explosium.xml")

				add_projectile("data/entities/projectiles/bigcanister_explosium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_EXPLOSIUM",
	name 		= "EXPLOSIUM BUBBLE TRAP",
	description = "A bubble that traps enemies it comes in contact with and explodes afterwards, releasing explosium",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_explosium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP_EXPLOSIUM
	spawn_probability                 = "0", -- BUBBLETRAP_EXPLOSIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("bubbletrap_explosium.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_explosium.xml")

				add_projectile("data/entities/projectiles/bubbletrap_explosium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_LIQUID_NITROGEN",
	name 		= "LIQUID NITROGEN BUBBLE TRAP",
	description = "A bubble that traps enemies it comes in contact with and explodes afterwards, releasing liquid nitrogen",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_liquid_nitrogen.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP_LIQUID_NITROGEN
	spawn_probability                 = "0", -- BUBBLETRAP_LIQUID_NITROGEN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("bubbletrap_liquid_nitrogen.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_liquid_nitrogen.xml")

				add_projectile("data/entities/projectiles/bubbletrap_liquid_nitrogen.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_ELECTRICIUM",
	name 		= "ELECTRICIUM BUBBLE TRAP",
	description = "A bubble that traps enemies it comes in contact with and explodes afterwards, releasing electricium",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_electricium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP_ELECTRICIUM
	spawn_probability                 = "0", -- BUBBLETRAP_ELECTRICIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("bubbletrap_electricium.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_electricium.xml")

				add_projectile("data/entities/projectiles/bubbletrap_electricium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_FROGIUM",
	name 		= "FROGIUM BUBBLE TRAP",
	description = "A bubble that traps enemies it comes in contact with and explodes afterwards, releasing frogium",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_frogium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP_FROGIUM
	spawn_probability                 = "0", -- BUBBLETRAP_FROGIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("bubbletrap_frogium.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_frogium.xml")

				add_projectile("data/entities/projectiles/bubbletrap_frogium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_GRAVITIUM",
	name 		= "GRAVITIUM BUBBLE TRAP",
	description = "A bubble that traps enemies it comes in contact with and explodes afterwards, releasing gravitium",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_gravitium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP_GRAVITIUM
	spawn_probability                 = "0", -- BUBBLETRAP_GRAVITIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("bubbletrap_gravitium.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_gravitium.xml")

				add_projectile("data/entities/projectiles/bubbletrap_gravitium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_POISON",
	name 		= "POISON BUBBLE TRAP",
	description = "A bubble that traps enemies it comes in contact with and explodes afterwards, releasing poison",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_poison.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP_POISON
	spawn_probability                 = "0", -- BUBBLETRAP_POISON
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Elemental("bubbletrap_poison.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_poison.xml")

				add_projectile("data/entities/projectiles/bubbletrap_poison.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BIGCANISTER_ACID",
	name 		= "BIG CANISTER (ACID)",
	description = "A canister that spills acid while it travels mid-air, and releases more of this material on impact",
	sprite 		= "mods/TheArmory/files/actions/bigcanister_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BIGCANISTER_EXPLOSIUM
	spawn_probability                 = "0", -- BIGCANISTER_EXPLOSIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Elemental("bigcanister_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bigcanister_acid.xml")

				add_projectile("data/entities/projectiles/bigcanister_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_HIGHEXPLOSIVE_EXPLOSIUM",
	name 		= "HIGH EXPLOSIVE EXPLOSIUM BUBBLE TRAP",
	description = "A bubble that traps enemies it comes in contact with and blows up in a sequence of explosium explosions afterwards",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_highexplosive_explosium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP_HIGHEXPLOSIVE_EXPLOSIUM
	spawn_probability                 = "0", -- BUBBLETRAP_HIGHEXPLOSIVE_EXPLOSIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Elemental("bubbletrap_highexplosive_explosium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_highexplosive_explosium.xml")

				add_projectile("data/entities/projectiles/bubbletrap_highexplosive_explosium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_HIGHEXPLOSIVE_LIQUID_NITROGEN",
	name 		= "HIGH EXPLOSIVE LIQUID NITROGEN BUBBLE TRAP",
	description = "A bubble that traps enemies it comes in contact with and blows up in a sequence of liquid nitrogen explosions afterwards",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_highexplosive_liquid_nitrogen.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP_HIGHEXPLOSIVE_LIQUID_NITROGEN
	spawn_probability                 = "0", -- BUBBLETRAP_HIGHEXPLOSIVE_LIQUID_NITROGEN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Elemental("bubbletrap_highexplosive_liquid_nitrogen.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_highexplosive_liquid_nitrogen.xml")

				add_projectile("data/entities/projectiles/bubbletrap_highexplosive_liquid_nitrogen.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_GRENADEBUNDLE_LIQUID_NITROGEN",
	name 		= "GRENADE BUNDLE (LIQUID NITROGEN)",
	description = "A bundle of liquid nitrogen grenades shot at once",
	sprite 		= "mods/TheArmory/files/actions/grenadebundle_liquid_nitrogen.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- GRENADEBUNDLE_LIQUID_NITROGEN
	spawn_probability                 = "0", -- GRENADEBUNDLE_LIQUID_NITROGEN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_liquid_nitrogen.xml")
			
				applyTrinketsEffectsWeapons_ScatterShotRegular("spitbomb_liquid_nitrogen.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_liquid_nitrogen.xml")

				add_projectile("data/entities/projectiles/spitbomb_liquid_nitrogen.xml")
				add_projectile("data/entities/projectiles/spitbomb_liquid_nitrogen.xml")
				add_projectile("data/entities/projectiles/spitbomb_liquid_nitrogen.xml")
				add_projectile("data/entities/projectiles/spitbomb_liquid_nitrogen.xml")
				c.spread_degrees = 35
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BIGCANISTER_ELECTRICIUM",
	name 		= "BIG CANISTER (ELECTRICIUM)",
	description = "A canister that spills electricium while it travels mid-air, and releases more of this material on impact",
	sprite 		= "mods/TheArmory/files/actions/bigcanister_electricium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BIGCANISTER_ELECTRICIUM
	spawn_probability                 = "0", -- BIGCANISTER_ELECTRICIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Elemental("bigcanister_electricium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bigcanister_electricium.xml")

				add_projectile("data/entities/projectiles/bigcanister_electricium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_GRENADEBUNDLE_ELECTRICIUM",
	name 		= "GRENADE BUNDLE (ELECTRICIUM)",
	description = "A bundle of electricium grenades shot at once",
	sprite 		= "mods/TheArmory/files/actions/grenadebundle_electricium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- GRENADEBUNDLE_ELECTRICIUM
	spawn_probability                 = "0", -- GRENADEBUNDLE_ELECTRICIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_electricium.xml")
			
				applyTrinketsEffectsWeapons_ScatterShotRegular("spitbomb_electricium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_electricium.xml")

				add_projectile("data/entities/projectiles/spitbomb_electricium.xml")
				add_projectile("data/entities/projectiles/spitbomb_electricium.xml")
				add_projectile("data/entities/projectiles/spitbomb_electricium.xml")
				add_projectile("data/entities/projectiles/spitbomb_electricium.xml")
				c.spread_degrees = 35
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_HIGHEXPLOSIVE_FROGIUM",
	name 		= "HIGH EXPLOSIVE FROGIUM BUBBLE TRAP",
	description = "A bubble that traps enemies it comes in contact with and blows up in a sequence of frogium explosions afterwards",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_highexplosive_frogium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP_HIGHEXPLOSIVE_FROGIUM
	spawn_probability                 = "0", -- BUBBLETRAP_HIGHEXPLOSIVE_FROGIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Elemental("bubbletrap_highexplosive_frogium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_highexplosive_frogium.xml")

				add_projectile("data/entities/projectiles/bubbletrap_highexplosive_frogium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BIGCANISTER_FROGIUM",
	name 		= "BIG CANISTER (FROGIUM)",
	description = "A canister that spills frogium while it travels mid-air, and releases more of this material on impact",
	sprite 		= "mods/TheArmory/files/actions/bigcanister_frogium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BIGCANISTER_FROGIUM
	spawn_probability                 = "0", -- BIGCANISTER_FROGIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Elemental("bigcanister_frogium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bigcanister_frogium.xml")

				add_projectile("data/entities/projectiles/bigcanister_frogium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BIGCANISTER_GRAVITIUM",
	name 		= "BIG CANISTER (GRAVITIUM)",
	description = "A canister that spills gravitium while it travels mid-air, and releases more of this material on impact",
	sprite 		= "mods/TheArmory/files/actions/bigcanister_gravitium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BIGCANISTER_FROGIUM
	spawn_probability                 = "0", -- BIGCANISTER_FROGIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Elemental("bigcanister_gravitium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bigcanister_gravitium.xml")

				add_projectile("data/entities/projectiles/bigcanister_gravitium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_GRENADEBUNDLE_GRAVITIUM",
	name 		= "GRENADE BUNDLE (GRAVITIUM)",
	description = "A bundle of gravitium grenades shot at once",
	sprite 		= "mods/TheArmory/files/actions/grenadebundle_gravitium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- GRENADEBUNDLE_GRAVITIUM
	spawn_probability                 = "0", -- GRENADEBUNDLE_GRAVITIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_gravitium.xml")
			
				applyTrinketsEffectsWeapons_ScatterShotRegular("spitbomb_gravitium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_gravitium.xml")

				add_projectile("data/entities/projectiles/spitbomb_gravitium.xml")
				add_projectile("data/entities/projectiles/spitbomb_gravitium.xml")
				add_projectile("data/entities/projectiles/spitbomb_gravitium.xml")
				add_projectile("data/entities/projectiles/spitbomb_gravitium.xml")
				c.spread_degrees = 35
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_HIGHEXPLOSIVE_POISON",
	name 		= "HIGH EXPLOSIVE POISON BUBBLE TRAP",
	description = "A bubble that traps enemies it comes in contact with and blows up in a sequence of poison explosions afterwards",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_highexplosive_poison.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP_HIGHEXPLOSIVE_POISON
	spawn_probability                 = "0", -- BUBBLETRAP_HIGHEXPLOSIVE_POISON
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_Elemental("bubbletrap_highexplosive_poison.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_highexplosive_poison.xml")

				add_projectile("data/entities/projectiles/bubbletrap_highexplosive_poison.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BIGCANISTER_POISON",
	name 		= "BIG CANISTER (POISON)",
	description = "A canister that spills poison while it travels mid-air, and releases more of this material on impact",
	sprite 		= "mods/TheArmory/files/actions/bigcanister_poison.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BIGCANISTER_FROGIUM
	spawn_probability                 = "0", -- BIGCANISTER_FROGIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Elemental("bigcanister_poison.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bigcanister_poison.xml")

				add_projectile("data/entities/projectiles/bigcanister_poison.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLETRAP_TINY",
	name 		= "TINY BUBBLE TRAP",
	description = "A bubble trap encased in an SMG round",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_tiny.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLETRAP_TINY
	spawn_probability                 = "0", -- BUBBLETRAP_TINY
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "smg_ammo", "Submachine Gun Ammo")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_tiny.xml")

				add_projectile("data/entities/projectiles/bubbletrap_tiny.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "smg_ammo", "Submachine Gun Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLE_MINIONS",
	name 		= "MINION SPAWNER BUBBLE",
	description = "A bubble that spawns Technobubble minions that fight on your aid",
	sprite 		= "mods/TheArmory/files/actions/bubbletrap_minions.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BUBBLE_MINIONS
	spawn_probability                 = "0", -- BUBBLE_MINIONS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubbletrap_minions.xml")

				add_projectile("data/entities/projectiles/bubbletrap_minions.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CANNONBALL",
	name 		= "CANNON BALL",
	description = "A cannon ball that deals melee damage when it hits enemies, and explodes after a while",
	sprite 		= "mods/TheArmory/files/actions/cannonball.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CANNONBALL
	spawn_probability                 = "0", -- CANNONBALL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("cannonball.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("cannonball.xml")

				add_projectile("data/entities/projectiles/cannonball.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BLEEDING_KNIVES",
	name 		= "BLEEDING KNIVES",
	description = "Releases a barrage of knives that slice through enemies and cause them to bleed on impact",
	sprite 		= "mods/TheArmory/files/actions/bleeding_knives.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- BLEEDING_KNIVES
	spawn_probability                 = "0", -- BLEEDING_KNIVES
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "knives_ammo", "Knives")) then
				
				add_projectile("data/entities/projectiles/bleedingknives.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "knives_ammo", "Knives")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SOUNDWAVE",
	name 		= "SOUNDWAVE",
	description = "An energy projectile comprised of intense vibration that causes linear cave-ins when it hits something",
	sprite 		= "mods/TheArmory/files/actions/soundwave.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SOUNDWAVE
	spawn_probability                 = "0", -- SOUNDWAVE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("soundwave.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("soundwave.xml")

				add_projectile("data/entities/projectiles/soundwave.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_HUGEBULLET",
	name 		= "HUGE BULLET",
	description = "An enourmous bullet that consumes grenades ammo and detonates in a large explosion on impact",
	sprite 		= "mods/TheArmory/files/actions/hugebullet.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- HUGEBULLET
	spawn_probability                 = "0", -- HUGEBULLET
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("hugebullet.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("hugebullet.xml")

				add_projectile("data/entities/projectiles/hugebullet.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_REMOTE_TRIGGER_TRAPS",
	name 		= "REMOTE TRIGGER FOR TRAPS",
	description = "Detonates any proximity traps in the vicinity on activation",
	sprite 		= "mods/TheArmory/files/actions/remote_trigger_traps.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- REMOTE_TRIGGER
	spawn_probability                 = "0", -- REMOTE_TRIGGER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				add_projectile("data/entities/projectiles/remote_trigger_traps.xml")

				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_C4",
	name 		= "C4 EXPLOSIVE",
	description = "A plastic explosive payload that can be detonated remotely (right-mouse button to trigger)",
	sprite 		= "mods/TheArmory/files/actions/c4.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- REMOTE_TRIGGER_C4
	spawn_probability                 = "0", -- REMOTE_TRIGGER_C4
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_explosives_ammo", "Throwable Explosives Ammo")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("c4.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("c4.xml")

				add_projectile("data/entities/projectiles/c4.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_explosives_ammo", "Throwable Explosives Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHURIKEN",
	name 		= "SHURIKEN",
	description = "A razor sharp throwable japanese weapon, slices through stuff",
	sprite 		= "mods/TheArmory/files/actions/shuriken.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHURIKEN
	spawn_probability                 = "0", -- SHURIKEN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("shuriken.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("shuriken.xml")

				add_projectile("data/entities/projectiles/shuriken.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_HATCHET",
	name 		= "HATCHET",
	description = "A throwable axe that deals melee and slice damage",
	sprite 		= "mods/TheArmory/files/actions/hatchet.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHURIKEN
	spawn_probability                 = "0", -- SHURIKEN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("hatchet.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("hatchet.xml")

				add_projectile("data/entities/projectiles/hatchet.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_HAND_GRENADE",
	name 		= "HAND GRENADE",
	description = "A fragmentation grenade that releases deadly shrapnel when it explodes",
	sprite 		= "mods/TheArmory/files/actions/hand_grenade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- HAND_GRENADE
	spawn_probability                 = "0", -- HAND_GRENADE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_explosives_ammo", "Throwable Explosives Ammo")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("hand_grenade.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("hand_grenade.xml")

				add_projectile("data/entities/projectiles/hand_grenade.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_explosives_ammo", "Throwable Explosives Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_HANDGRANATE_43",
	name 		= "HANDGRANATE 43",
	description = "A fragmentation grenade that releases deadly shrapnel when it explodes",
	sprite 		= "mods/TheArmory/files/actions/handgranate_43.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- HANDGRANATE_43
	spawn_probability                 = "0", -- HANDGRANATE_43
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_explosives_ammo", "Throwable Explosives Ammo")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("handgranate_43.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("handgranate_43.xml")

				add_projectile("data/entities/projectiles/handgranate_43.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_explosives_ammo", "Throwable Explosives Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FRAG_GRENADE",
	name 		= "FRAG GRENADE",
	description = "A fragmentation grenade that releases deadly shrapnel when it explodes",
	sprite 		= "mods/TheArmory/files/actions/frag_grenade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- HAND_GRENADE
	spawn_probability                 = "0", -- HAND_GRENADE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_explosives_ammo", "Throwable Explosives Ammo")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("frag_grenade.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("frag_grenade.xml")

				add_projectile("data/entities/projectiles/frag_grenade.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_explosives_ammo", "Throwable Explosives Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MOLOTOV",
	name 		= "MOLOTOV COCKTAIL",
	description = "An improvised incendiary bomb",
	sprite 		= "mods/TheArmory/files/actions/molotov.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- HAND_GRENADE
	spawn_probability                 = "0", -- HAND_GRENADE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_explosives_ammo", "Throwable Explosives Ammo")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("molotov.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("molotov.xml")

				add_projectile("data/entities/projectiles/molotov.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_explosives_ammo", "Throwable Explosives Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CLUSTER_GRENADE",
	name 		= "CLUSTER GRENADE",
	description = "A grenade that releases microbombs when it explodes",
	sprite 		= "mods/TheArmory/files/actions/cluster_grenade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CLUSTER_GRENADE
	spawn_probability                 = "0", -- CLUSTER_GRENADE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_explosives_ammo", "Throwable Explosives Ammo")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("cluster_grenade.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("cluster_grenade.xml")

				add_projectile("data/entities/projectiles/cluster_grenade.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_explosives_ammo", "Throwable Explosives Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CONCENTRATED_POISON_GAS_GRENADE",
	name 		= "CONCENTRATED POISON GAS GRENADE",
	description = "A grenade that releases a large cloud of concentrated poison gas when it explodes",
	sprite 		= "mods/TheArmory/files/actions/concentrated_poison_gas_grenade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CONCENTRATED_POISON_GAS_GRENADE
	spawn_probability                 = "0", -- CONCENTRATED_POISON_GAS_GRENADE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_explosives_ammo", "Throwable Explosives Ammo")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("concentrated_poison_gas_grenade.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("concentrated_poison_gas_grenade.xml")

				add_projectile("data/entities/projectiles/concentrated_poison_gas_grenade.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_explosives_ammo", "Throwable Explosives Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_GAS_GRENADE",
	name 		= "GAS GRENADE",
	description = "A grenade that releases a large cloud of toxic gas when it explodes",
	sprite 		= "mods/TheArmory/files/actions/gas_grenade.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- GAS_GRENADE
	spawn_probability                 = "0", -- GAS_GRENADE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_explosives_ammo", "Throwable Explosives Ammo")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("gas_grenade.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("gas_grenade.xml")

				add_projectile("data/entities/projectiles/gas_grenade.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_explosives_ammo", "Throwable Explosives Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHORT_MACE",
	name 		= "SHORT MACE",
	description = "A throwable mace that deals heavy melee damage",
	sprite 		= "mods/TheArmory/files/actions/short_mace.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHORT_MACE
	spawn_probability                 = "0", -- SHORT_MACE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("short_mace.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("short_mace.xml")

				add_projectile("data/entities/projectiles/short_mace.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_KITCHEN_KNIFE",
	name 		= "KITCHEN KNIFE",
	description = "A throwable knife that deals slice damage",
	sprite 		= "mods/TheArmory/files/actions/kitchen_knife.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHURIKEN
	spawn_probability                 = "0", -- SHURIKEN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("kitchen_knife.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("kitchen_knife.xml")

				add_projectile("data/entities/projectiles/kitchen_knife.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SAI",
	name 		= "SAI",
	description = "A throwable japanese knife that deals heavy slice damage",
	sprite 		= "mods/TheArmory/files/actions/sai.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SHURIKEN
	spawn_probability                 = "0", -- SHURIKEN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("sai.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("sai.xml")

				add_projectile("data/entities/projectiles/sai.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_KUNAI",
	name 		= "KUNAI",
	description = "A throwable japanese knife that deals both melee and slice damage",
	sprite 		= "mods/TheArmory/files/actions/kunai.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- KUNAI
	spawn_probability                 = "0", -- KUNAI
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("kunai.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("kunai.xml")

				add_projectile("data/entities/projectiles/kunai.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_NITRO",
	name 		= "TEST TUBE FILLED WITH NITROGLYCERIN",
	description = "A throwable test tube that releases nitroglycerin on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_NITRO
	spawn_probability                 = "0", -- TESTTUBE_NITRO
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_nitro.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_nitro.xml")

				add_projectile("data/entities/projectiles/testtube_nitro.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_ACID",
	name 		= "TEST TUBE FILLED WITH ACID",
	description = "A throwable test tube that releases acid on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_ACID
	spawn_probability                 = "0", -- TESTTUBE_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_acid.xml")

				add_projectile("data/entities/projectiles/testtube_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_AGITATED_NEUTRON_MASS",
	name 		= "TEST TUBE FILLED WITH AGITATED NEUTRON MASS",
	description = "A throwable test tube that releases agitated neutron mass on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_ACID
	spawn_probability                 = "0", -- TESTTUBE_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_agitated_neutron_mass.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_agitated_neutron_mass.xml")

				add_projectile("data/entities/projectiles/testtube_agitated_neutron_mass.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_OVERHEATED_ACID",
	name 		= "TEST TUBE FILLED WITH OVERHEATED ACID",
	description = "A throwable test tube that releases overheated acid on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_OVERHEATED_ACID
	spawn_probability                 = "0", -- TESTTUBE_OVERHEATED_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_overheated_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_overheated_acid.xml")

				add_projectile("data/entities/projectiles/testtube_overheated_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_EXPLOSIUM",
	name 		= "TEST TUBE FILLED WITH EXPLOSIUM",
	description = "A throwable test tube that releases explosium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_EXPLOSIUM
	spawn_probability                 = "0", -- TESTTUBE_EXPLOSIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_explosium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_explosium.xml")

				add_projectile("data/entities/projectiles/testtube_explosium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_ELECTRICIUM",
	name 		= "TEST TUBE FILLED WITH ELECTRICIUM",
	description = "A throwable test tube that releases electricium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_ELECTRICIUM
	spawn_probability                 = "0", -- TESTTUBE_ELECTRICIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_electricium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_electricium.xml")

				add_projectile("data/entities/projectiles/testtube_electricium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_ANTI_POLYMORPHINE",
	name 		= "TEST TUBE FILLED WITH ANTI POLYMORPHINE",
	description = "A throwable test tube that releases anti-polymorphine on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_ANTI_POLY
	spawn_probability                 = "0", -- TESTTUBE_ANTI_POLY
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_anti_poly.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_anti_poly.xml")

				add_projectile("data/entities/projectiles/testtube_anti_poly.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_LIQUID_NITROGEN",
	name 		= "TEST TUBE FILLED WITH LIQUID NITROGEN",
	description = "A throwable test tube that releases liquid nitrogen on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_LIQUID_NITROGEN
	spawn_probability                 = "0", -- TESTTUBE_LIQUID_NITROGEN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_liquid_nitrogen.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_liquid_nitrogen.xml")

				add_projectile("data/entities/projectiles/testtube_liquid_nitrogen.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_ANTICOAGULANT",
	name 		= "TEST TUBE FILLED WITH ANTICOAGULANT",
	description = "A throwable test tube that releases anticoagulant on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_ANTICOAGULANT
	spawn_probability                 = "0", -- TESTTUBE_ANTICOAGULANT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_anticoagulant.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_anticoagulant.xml")

				add_projectile("data/entities/projectiles/testtube_anticoagulant.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_SPITIUM",
	name 		= "TEST TUBE FILLED WITH SPITIUM",
	description = "A throwable test tube that releases spitium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_ANTICOAGULANT
	spawn_probability                 = "0", -- TESTTUBE_ANTICOAGULANT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_spitium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_spitium.xml")

				add_projectile("data/entities/projectiles/testtube_spitium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_CONCENTRATED_SPITIUM",
	name 		= "TEST TUBE FILLED WITH CONCENTRATED SPITIUM",
	description = "A throwable test tube that releases concentrated spitium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_CONCENTRATED_SPITIUM
	spawn_probability                 = "0", -- TESTTUBE_CONCENTRATED_SPITIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_concentrated_spitium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_concentrated_spitium.xml")

				add_projectile("data/entities/projectiles/testtube_concentrated_spitium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_FROGIUM",
	name 		= "TEST TUBE FILLED WITH FROGIUM",
	description = "A throwable test tube that releases frogium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_FROGIUM
	spawn_probability                 = "0", -- TESTTUBE_FROGIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_frogium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_frogium.xml")

				add_projectile("data/entities/projectiles/testtube_frogium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_GRAVITIUM",
	name 		= "TEST TUBE FILLED WITH GRAVITIUM",
	description = "A throwable test tube that releases gravitium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_GRAVITIUM
	spawn_probability                 = "0", -- TESTTUBE_GRAVITIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_gravitium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_gravitium.xml")

				add_projectile("data/entities/projectiles/testtube_gravitium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_FERROFLUID",
	name 		= "TEST TUBE FILLED WITH FERROFLUID",
	description = "A throwable test tube that releases ferrofluid on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_FERROFLUID
	spawn_probability                 = "0", -- TESTTUBE_FERROFLUID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_ferrofluid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_ferrofluid.xml")

				add_projectile("data/entities/projectiles/testtube_ferrofluid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_TRITIUM",
	name 		= "TEST TUBE FILLED WITH TRITIUM",
	description = "A throwable test tube that releases tritium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_TRITIUM
	spawn_probability                 = "0", -- TESTTUBE_TRITIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_tritium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_tritium.xml")

				add_projectile("data/entities/projectiles/testtube_tritium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_SLAPIUM",
	name 		= "TEST TUBE FILLED WITH SLAPIUM",
	description = "A throwable test tube that releases slapium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_SLAPIUM
	spawn_probability                 = "0", -- TESTTUBE_SLAPIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_slapium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_slapium.xml")

				add_projectile("data/entities/projectiles/testtube_slapium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_WATER",
	name 		= "TEST TUBE FILLED WITH WATER",
	description = "A throwable test tube that releases water on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_WATER
	spawn_probability                 = "0", -- TESTTUBE_WATER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_water.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_water.xml")

				add_projectile("data/entities/projectiles/testtube_water.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_PROPANE_GAS",
	name 		= "TEST TUBE FILLED WITH PROPANE GAS",
	description = "A throwable test tube that releases propane gas on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_PROPANE_GAS
	spawn_probability                 = "0", -- TESTTUBE_PROPANE_GAS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_propane_gas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_propane_gas.xml")

				add_projectile("data/entities/projectiles/testtube_propane_gas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_LIGHTNIUM",
	name 		= "TEST TUBE FILLED WITH LIGHTNIUM",
	description = "A throwable test tube that releases lightnium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_LIGHTNIUM
	spawn_probability                 = "0", -- TESTTUBE_LIGHTNIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_lightnium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_lightnium.xml")

				add_projectile("data/entities/projectiles/testtube_lightnium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_INFERNIUM",
	name 		= "TEST TUBE FILLED WITH INFERNIUM",
	description = "A throwable test tube that releases infernium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_INFERNIUM
	spawn_probability                 = "0", -- TESTTUBE_INFERNIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_infernium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_infernium.xml")

				add_projectile("data/entities/projectiles/testtube_infernium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_THUNDERIUM",
	name 		= "TEST TUBE FILLED WITH THUNDERIUM",
	description = "A throwable test tube that releases thunderium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_THUNDERIUM
	spawn_probability                 = "0", -- TESTTUBE_THUNDERIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_thunderium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_thunderium.xml")

				add_projectile("data/entities/projectiles/testtube_thunderium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_CHILLIUM",
	name 		= "TEST TUBE FILLED WITH CHILLIUM",
	description = "A throwable test tube that releases chillium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_CHILLIUM
	spawn_probability                 = "0", -- TESTTUBE_CHILLIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_chillium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_chillium.xml")

				add_projectile("data/entities/projectiles/testtube_chillium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_TESLIUM",
	name 		= "TEST TUBE FILLED WITH TESLIUM",
	description = "A throwable test tube that releases teslium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_TESLIUM
	spawn_probability                 = "0", -- TESTTUBE_TESLIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_teslium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_teslium.xml")

				add_projectile("data/entities/projectiles/testtube_teslium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_VOIDORB",
	name 		= "VOID ORB",
	description = "An energy orb that sucks everything that happens to be close by",
	sprite 		= "mods/TheArmory/files/actions/voidorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- VOIDORB
	spawn_probability                 = "0", -- VOIDORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("voidorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("voidorb.xml")

				add_projectile("data/entities/projectiles/voidorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TRIPWIREMINE",
	name 		= "TRIPWIRE MINE",
	description = "A special mine that creates laser tripwires around it, exploding if a creature interrupts any of its lasers",
	sprite 		= "mods/TheArmory/files/actions/tripwiremine.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TRIPWIREMINE
	spawn_probability                 = "0", -- TRIPWIREMINE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("tripwiremine.xml")

				add_projectile("data/entities/projectiles/tripwiremine.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LASEREMITTER",
	name 		= "LASER EMITTER",
	description = "A device that emits intense laser beams that damage whatever they touch",
	sprite 		= "mods/TheArmory/files/actions/laseremitter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- LASEREMITTER
	spawn_probability                 = "0", -- LASEREMITTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("laseremitter.xml")

				add_projectile("data/entities/projectiles/laseremitter.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SECURITYPROBE",
	name 		= "SECURITY PROBE",
	description = "A device that shoots any creature that touches its lasers",
	sprite 		= "mods/TheArmory/files/actions/securityprobe.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SECURITYPROBE
	spawn_probability                 = "0", -- SECURITYPROBE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("securityprobe.xml")

				add_projectile("data/entities/projectiles/securityprobe.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_STICKYMINE",
	name 		= "STICKY MINE",
	description = "A special mine that sticks to the first enemy it touches, then arms itself with a detection field, exploding if another enemy enters it",
	sprite 		= "mods/TheArmory/files/actions/stickymine.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- STICKYMINE
	spawn_probability                 = "0", -- STICKYMINE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("stickymine.xml")

				add_projectile("data/entities/projectiles/stickymine.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_REDLASERBOLT_SNIPER",
	name 		= "CONCENTRATED RED LASER BOLT",
	description = "A powerful red laser bolt that travels fast and destroys most materials it collides with",
	sprite 		= "mods/TheArmory/files/actions/redlaserbolt_sniper.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_REDLASERBOLT_SNIPER
	spawn_probability                 = "0", -- THEARMORYACTIONS_REDLASERBOLT_SNIPER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("laser_red_sniper.xml")
				
				applyTrinketsEffectsWeapons_Energy("laser_red_sniper.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("laser_red_sniper.xml")

				add_projectile("data/entities/projectiles/laser_red_sniper.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_PLASMABOLT_SNIPER",
	name 		= "CONCENTRATED PLASMA BOLT",
	description = "A powerful bolt of plasma energy that travels fast and destroys most materials it collides with",
	sprite 		= "mods/TheArmory/files/actions/plasmabolt_sniper.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_PLASMABOLT_SNIPER
	spawn_probability                 = "0", -- THEARMORYACTIONS_PLASMABOLT_SNIPER
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Elemental("plasmabolt_sniper.xml")
				
				applyTrinketsEffectsWeapons_Energy("plasmabolt_sniper.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("plasmabolt_sniper.xml")

				add_projectile("data/entities/projectiles/plasmabolt_sniper.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BFGPROJECTILE",
	name 		= "BFG PROJECTILE",
	description = "A highly destructive energy projectile that targets and shoots thunderbolts at enemies in the vicinity",
	sprite 		= "mods/TheArmory/files/actions/bfgprojectile.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_BFGPROJECTILE
	spawn_probability                 = "0", -- THEARMORYACTIONS_BFGPROJECTILE
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Elemental("bfgprojectile.xml")
				
				applyTrinketsEffectsWeapons_Energy("bfgprojectile.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bfgprojectile.xml")

				add_projectile("data/entities/projectiles/bfgprojectile.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_DROPIUM",
	name 		= "SPITBOMB (DROPIUM)",
	description = "A bomb that explodes spitting dropium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_dropium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SPITBOMB_DROPIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_SPITBOMB_DROPIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_dropium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_dropium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_dropium.xml")

				add_projectile("data/entities/projectiles/spitbomb_dropium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SELF_MIDAS_FIELD",
	name 		= "MIDAS FIELD PROJECTOR",
	description = "Projects a midas field around you, converting enemies that touch it into gold",
	sprite 		= "mods/TheArmory/files/actions/self_midas_field.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SELF_MIDAS_FIELD
	spawn_probability                 = "0", -- THEARMORYACTIONS_SELF_MIDAS_FIELD
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				add_projectile("data/entities/projectiles/self_midas_field.xml")

				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_MIDAS",
	name 		= "SYRINGE FILLED WITH MIDAS LIQUID",
	description = "Injects enemies with midas liquid, converting their blood to gold",
	sprite 		= "mods/TheArmory/files/actions/syringe_midas.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SYRINGE_MIDAS
	spawn_probability                 = "0", -- THEARMORYACTIONS_SYRINGE_MIDAS
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_midas.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_midas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_midas.xml")

				add_projectile("data/entities/projectiles/syringe_midas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_EMBERBALL",
	name 		= "EMBERBALL",
	description = "A ball made of embers that cause melee and fire damage on enemies it hits, exploding into smaller ember balls afterwards",
	sprite 		= "mods/TheArmory/files/actions/emberball.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_EMBERBALL
	spawn_probability                 = "0", -- THEARMORYACTIONS_EMBERBALL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("emberball.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("emberball.xml")

				add_projectile("data/entities/projectiles/emberball.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELLIPSOIDBULLET_MOLTEN",
	name 		= "ELLIPSOID BULLET (MOLTEN)",
	description = "A slow bullet, that consumes grenades ammo and causes small fire explosions wherever it hits",
	sprite 		= "mods/TheArmory/files/actions/ellipsoidbullet_molten.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- MIDASBOMB
	spawn_probability                 = "0", -- MIDASBOMB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("ellipsoidbullet_molten.xml")
				
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("ellipsoidbullet_molten.xml")

				add_projectile("data/entities/projectiles/ellipsoidbullet_molten.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_STICKYMINE_INCENDIARY",
	name 		= "INCENDIARY STICKY MINE",
	description = "A special mine that sticks to the first enemy it touches, then arms itself with a detection field, exploding releasing flaming orbs if another enemy enters it",
	sprite 		= "mods/TheArmory/files/actions/stickymine.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_STICKYMINE_INCENDIARY
	spawn_probability                 = "0", -- THEARMORYACTIONS_STICKYMINE_INCENDIARY
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("stickymine_incendiary.xml")

				add_projectile("data/entities/projectiles/stickymine_incendiary.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_DEFLECTINGFIELDORB",
	name 		= "DEFLECTING FIELD ORB",
	description = "An energy orb that creates a deflecting field once it explodes, deflecting enemy projectiles and damaging creatures that come in contact with it",
	sprite 		= "mods/TheArmory/files/actions/deflectingfieldorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_DEFLECTINGFIELDORB
	spawn_probability                 = "0", -- THEARMORYACTIONS_DEFLECTINGFIELDORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("deflectingfieldorb.xml")
				
				applyTrinketsEffectsWeapons_Energy("deflectingfieldorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("deflectingfieldorb.xml")

				add_projectile("data/entities/projectiles/deflectingfieldorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FLAMINGORB",
	name 		= "FLAMING ORB",
	description = "An energy orb that burns everything on its path",
	sprite 		= "mods/TheArmory/files/actions/flamingorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_FLAMINGORB
	spawn_probability                 = "0", -- THEARMORYACTIONS_FLAMINGORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("flamingorb.xml")
				
				applyTrinketsEffectsWeapons_Energy("flamingorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("flamingorb.xml")

				add_projectile("data/entities/projectiles/flamingorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_THUNDERBOLT_PURPLE",
	name 		= "PURPLE THUNDERBOLT",
	description = "A purple bolt of concentrated electricity",
	sprite 		= "mods/TheArmory/files/actions/thunderbolt_purple.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_THUNDERBOLT_PURPLE
	spawn_probability                 = "0", -- THEARMORYACTIONS_THUNDERBOLT_PURPLE
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Elemental("thunderbolt_purple.xml")
			
				applyTrinketsEffectsWeapons_Energy("thunderbolt_purple.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("thunderbolt_purple.xml")

				add_projectile("data/entities/projectiles/thunderbolt_purple.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_THUNDERORB",
	name 		= "THUNDERORB",
	description = "An energy orb that explodes into purple thunderbolts",
	sprite 		= "mods/TheArmory/files/actions/thunderorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_THUNDERORB
	spawn_probability                 = "0", -- THEARMORYACTIONS_THUNDERORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("thunderorb.xml")
				
				applyTrinketsEffectsWeapons_Energy("thunderorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("thunderorb.xml")

				add_projectile("data/entities/projectiles/thunderorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_NITROMISSILE",
	name 		= "NITROMISSILE",
	description = "An energy projectile that releases nitroglycerin on impact",
	sprite 		= "mods/TheArmory/files/actions/nitromissile.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_NITROMISSILE
	spawn_probability                 = "0", -- THEARMORYACTIONS_NITROMISSILE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("nitromissile.xml")
				
				applyTrinketsEffectsWeapons_Energy("nitromissile.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("nitromissile.xml")

				add_projectile("data/entities/projectiles/nitromissile.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BUBBLE_NITRO",
	name 		= "NITRO BUBBLE",
	description = "Bubble filled with nitroglycerin",
	sprite 		= "mods/TheArmory/files/actions/bubble_nitro.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_BUBBLE_NITRO
	spawn_probability                 = "0", -- THEARMORYACTIONS_BUBBLE_NITRO
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "fluid_ammo", "Fluid Ammo")) then
				
				applyTrinketsEffectsWeapons_Elemental("bubble_nitro.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bubble_nitro.xml")

				add_projectile("data/entities/projectiles/bubble_nitro.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "fluid_ammo", "Fluid Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SNOWBALL",
	name 		= "SNOWBALL",
	description = "A ball made of snow that cause melee and freeze damage on enemies it hits, exploding into smaller snow balls afterwards",
	sprite 		= "mods/TheArmory/files/actions/snowball.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SNOWBALL
	spawn_probability                 = "0", -- THEARMORYACTIONS_SNOWBALL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("snowball.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("snowball.xml")

				add_projectile("data/entities/projectiles/snowball.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SNOWBALL_MINIONS",
	name 		= "MINION SPAWNER SNOWBALL",
	description = "A snowball that spawns snowball minions that freeze enemies that come close to them",
	sprite 		= "mods/TheArmory/files/actions/snowball_minions.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SNOWBALL_MINIONS
	spawn_probability                 = "0", -- THEARMORYACTIONS_SNOWBALL_MINIONS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("snowball_minion_spawner.xml")

				add_projectile("data/entities/projectiles/snowball_minion_spawner.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_STICKYMINE_FREEZING",
	name 		= "FREEZING STICKY MINE",
	description = "A special mine that sticks to the first enemy it touches, then arms itself with a detection field, exploding and activating a freezing field if another enemy enters it",
	sprite 		= "mods/TheArmory/files/actions/stickymine_freezing.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_STICKYMINE_FREEZING
	spawn_probability                 = "0", -- THEARMORYACTIONS_STICKYMINE_FREEZING
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("stickymine_freezing.xml")

				add_projectile("data/entities/projectiles/stickymine_freezing.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ACIDMISSILE",
	name 		= "ACIDMISSILE",
	description = "An energy projectile that releases acid on impact",
	sprite 		= "mods/TheArmory/files/actions/acidmissile.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ACIDMISSILE
	spawn_probability                 = "0", -- THEARMORYACTIONS_ACIDMISSILE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("acidmissile.xml")
				
				applyTrinketsEffectsWeapons_Energy("acidmissile.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("acidmissile.xml")

				add_projectile("data/entities/projectiles/acidmissile.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CAUSTICORB",
	name 		= "CAUSTIC ORB",
	description = "An energy orb that explodes into acid",
	sprite 		= "mods/TheArmory/files/actions/causticorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_CAUSTICORB
	spawn_probability                 = "0", -- THEARMORYACTIONS_CAUSTICORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("causticorb.xml")
				
				applyTrinketsEffectsWeapons_Energy("causticorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("causticorb.xml")

				add_projectile("data/entities/projectiles/causticorb.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CHIPOTECHILLON",
	name 		= "EL CHIPOTE CHILLON",
	description = "No contaban con mi astucia!",
	sprite 		= "mods/TheArmory/files/actions/chipotechillon.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_CHIPOTECHILLON
	spawn_probability                 = "0", -- THEARMORYACTIONS_CHIPOTECHILLON
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/chipotechillon.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_STICKYMINE_NUCLEAR",
	name 		= "NUCLEAR STICKY MINE",
	description = "A special mine that sticks to the first enemy it touches, then arms itself, detonating in a huge explosion after 6 ticks",
	sprite 		= "mods/TheArmory/files/actions/stickymine_nuclear.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_STICKYMINE_NUCLEAR
	spawn_probability                 = "0", -- THEARMORYACTIONS_STICKYMINE_NUCLEAR
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("stickymine_nuclear.xml")

				add_projectile("data/entities/projectiles/stickymine_nuclear.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_ICE",
	name 		= "SPITBOMB (ICE)",
	description = "A bomb that explodes creating ice",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_ice.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPITBOMB_ACID
	spawn_probability                 = "0", -- SPITBOMB_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_ice.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_ice.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_ice.xml")

				add_projectile("data/entities/projectiles/spitbomb_ice.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_STICKYMINE_ACID",
	name 		= "ACID STICKY MINE",
	description = "A special mine that sticks to the first enemy it touches, then arms itself, detonating in a sequence of acid explosions after 6 ticks",
	sprite 		= "mods/TheArmory/files/actions/stickymine_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_STICKYMINE_ACID
	spawn_probability                 = "0", -- THEARMORYACTIONS_STICKYMINE_ACID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("stickymine_acid.xml")

				add_projectile("data/entities/projectiles/stickymine_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_STICKYMINE_NITRO",
	name 		= "NITRO STICKY MINE",
	description = "A special mine that sticks to the first enemy it touches, then arms itself, detonating in a sequence of nitro explosions after 6 ticks",
	sprite 		= "mods/TheArmory/files/actions/stickymine_nitro.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_STICKYMINE_NITRO
	spawn_probability                 = "0", -- THEARMORYACTIONS_STICKYMINE_NITRO
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("stickymine_nitro.xml")

				add_projectile("data/entities/projectiles/stickymine_nitro.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CANNONBALL_SMALL",
	name 		= "SMALL CANNON BALL",
	description = "A tiny cannon ball that deals melee damage when it hits enemies, and explodes after a while",
	sprite 		= "mods/TheArmory/files/actions/cannonball_small.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_CANNONBALL_SMALL
	spawn_probability                 = "0", -- THEARMORYACTIONS_CANNONBALL_SMALL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("cannonball_small.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("cannonball_small.xml")

				add_projectile("data/entities/projectiles/cannonball_small.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CANNONBALL_SPIKED",
	name 		= "SPIKED CANNON BALL",
	description = "A spiked cannon ball that deals slice damage when it hits enemies, and explodes after a while",
	sprite 		= "mods/TheArmory/files/actions/cannonball_spiked.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_CANNONBALL_SPIKED
	spawn_probability                 = "0", -- THEARMORYACTIONS_CANNONBALL_SPIKED
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("cannonball_spiked.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("cannonball_spiked.xml")

				add_projectile("data/entities/projectiles/cannonball_spiked.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SYRINGE_NANOEXPLOSIVES",
	name 		= "SYRINGE FILLED WITH NANOEXPLOSIVES",
	description = "Injects enemies with nanoexplosives, making them explode violently after being hit",
	sprite 		= "mods/TheArmory/files/actions/syringe_nanoexplosives.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SYRINGE_NANOEXPLOSIVES
	spawn_probability                 = "0", -- THEARMORYACTIONS_SYRINGE_NANOEXPLOSIVES
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "syringes_ammo", "Syringes")) then
				
				applyTrinketsEffectsWeapons_Elemental("syringe_nanoexplosives.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("syringe_nanoexplosives.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("syringe_nanoexplosives.xml")

				add_projectile("data/entities/projectiles/syringe_nanoexplosives.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "syringes_ammo", "Syringes")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_20MMROUND",
	name 		= "20MM ROUND",
	description = "A highly destructive round that removes anything it touches from existence",
	sprite 		= "mods/TheArmory/files/actions/20mmround.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 50BMG
	spawn_probability                 = "0", -- 50BMG
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rifle_ammo", "Rifle Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("bulletammo_20mm.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("bulletammo_20mm.xml")

				add_projectile("data/entities/projectiles/bulletammo_20mm.xml")
				shot_effects.recoil_knockback = shot_effects.recoil_knockback + 25
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rifle_ammo", "Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_HEAVYBLEEDERKNIFE",
	name 		= "HEAVY BLEEDER KNIFE",
	description = "A razor-sharp knife that causes fast bleeding on enemies hit by it",
	sprite 		= "mods/TheArmory/files/actions/heavybleederknife.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- KNIFE
	spawn_probability                 = "0", -- KNIFE
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "knives_ammo", "Knives")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("heavybleederknife.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("heavybleederknife.xml")

				add_projectile("data/entities/projectiles/heavybleederknife.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "knives_ammo", "Knives")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_ACID",
	name 		= "ELEMENTAL ORB (ACID)",
	description = "An elemental orb that explodes spitting acid",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- ACIDORB
	spawn_probability                 = "0", -- ACIDORB
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_acid.xml")

				add_projectile("data/entities/projectiles/elementalorb_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_ALCOHOL",
	name 		= "ELEMENTAL ORB (ALCOHOL)",
	description = "An elemental orb that explodes spitting alcohol",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_alcohol.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_ALCOHOL
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_ALCOHOL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_alcohol.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_alcohol.xml")

				add_projectile("data/entities/projectiles/elementalorb_alcohol.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_ANTICOAGULANT",
	name 		= "ELEMENTAL ORB (ANTICOAGULANT)",
	description = "An elemental orb that explodes spitting anticoagulant",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_anticoagulant.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_ANTICOAGULANT
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_ANTICOAGULANT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_anticoagulant.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_anticoagulant.xml")

				add_projectile("data/entities/projectiles/elementalorb_anticoagulant.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_ANTIPOLY",
	name 		= "ELEMENTAL ORB (ANTIPOLY)",
	description = "An elemental orb that explodes spitting antipolymorphine",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_antipoly.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_ANTIPOLY
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_ANTIPOLY
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_antipoly.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_antipoly.xml")

				add_projectile("data/entities/projectiles/elementalorb_antipoly.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_BERSERKIUM",
	name 		= "ELEMENTAL ORB (BERSERKIUM)",
	description = "An elemental orb that explodes spitting berserkium",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_berserkium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_BERSERKIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_BERSERKIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_berserkium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_berserkium.xml")

				add_projectile("data/entities/projectiles/elementalorb_berserkium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_BLOOD",
	name 		= "ELEMENTAL ORB (BLOOD)",
	description = "An elemental orb that explodes spitting blood",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_blood.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_BLOOD
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_BLOOD
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_blood.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_blood.xml")

				add_projectile("data/entities/projectiles/elementalorb_blood.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_CHILLIUM",
	name 		= "ELEMENTAL ORB (CHILLIUM)",
	description = "An elemental orb that explodes spitting chillium",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_chillium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_CHILLIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_CHILLIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_chillium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_chillium.xml")

				add_projectile("data/entities/projectiles/elementalorb_chillium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_CONCENTRATEDSPITIUM",
	name 		= "ELEMENTAL ORB (CONCENTRATED SPITIUM)",
	description = "An elemental orb that explodes spitting concentrated spitium",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_concentratedspitium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_CONCENTRATEDSPITIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_CONCENTRATEDSPITIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_concentratedspitium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_concentratedspitium.xml")

				add_projectile("data/entities/projectiles/elementalorb_concentratedspitium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_DROPIUM",
	name 		= "ELEMENTAL ORB (DROPIUM)",
	description = "An elemental orb that explodes spitting dropium",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_dropium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_DROPIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_DROPIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_dropium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_dropium.xml")

				add_projectile("data/entities/projectiles/elementalorb_dropium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_ELECTRICIUM",
	name 		= "ELEMENTAL ORB (ELECTRICIUM)",
	description = "An elemental orb that explodes spitting electricium",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_electricium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_ELECTRICIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_ELECTRICIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_electricium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_electricium.xml")

				add_projectile("data/entities/projectiles/elementalorb_electricium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_EXPLOSIUM",
	name 		= "ELEMENTAL ORB (EXPLOSIUM)",
	description = "An elemental orb that explodes spitting explosium",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_explosium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_EXPLOSIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_EXPLOSIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_explosium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_explosium.xml")

				add_projectile("data/entities/projectiles/elementalorb_explosium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_FERROFLUID",
	name 		= "ELEMENTAL ORB (FERROFLUID)",
	description = "An elemental orb that explodes spitting ferrofluid",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_ferrofluid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_FERROFLUID
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_FERROFLUID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_ferrofluid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_ferrofluid.xml")

				add_projectile("data/entities/projectiles/elementalorb_ferrofluid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_FROGIUM",
	name 		= "ELEMENTAL ORB (FROGIUM)",
	description = "An elemental orb that explodes spitting frogium",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_frogium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_FROGIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_FROGIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_frogium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_frogium.xml")

				add_projectile("data/entities/projectiles/elementalorb_frogium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_GRAVITIUM",
	name 		= "ELEMENTAL ORB (GRAVITIUM)",
	description = "An elemental orb that explodes spitting gravitium",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_gravitium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_GRAVITIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_GRAVITIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_gravitium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_gravitium.xml")

				add_projectile("data/entities/projectiles/elementalorb_gravitium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_GUNPOWDERUNSTABLE",
	name 		= "ELEMENTAL ORB (FIREWORKS)",
	description = "An elemental orb that explodes spitting fireworks",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_gunpowderunstable.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_GUNPOWDERUNSTABLE
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_GUNPOWDERUNSTABLE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_gunpowderunstable.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_gunpowderunstable.xml")

				add_projectile("data/entities/projectiles/elementalorb_gunpowderunstable.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_INFERNIUM",
	name 		= "ELEMENTAL ORB (INFERNIUM)",
	description = "An elemental orb that explodes spitting infernium",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_infernium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_INFERNIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_INFERNIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_infernium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_infernium.xml")

				add_projectile("data/entities/projectiles/elementalorb_infernium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_LAVA",
	name 		= "ELEMENTAL ORB (LAVA)",
	description = "An elemental orb that explodes spitting lava",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_lava.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_LAVA
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_LAVA
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_lava.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_lava.xml")

				add_projectile("data/entities/projectiles/elementalorb_lava.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_LIQUIDNITROGEN",
	name 		= "ELEMENTAL ORB (LIQUID NITROGEN)",
	description = "An elemental orb that explodes spitting liquidnitrogen",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_liquidnitrogen.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_LIQUIDNITROGEN
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_LIQUIDNITROGEN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_liquidnitrogen.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_liquidnitrogen.xml")

				add_projectile("data/entities/projectiles/elementalorb_liquidnitrogen.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_OVERHEATEDACID",
	name 		= "ELEMENTAL ORB (OVERHEATED ACID)",
	description = "An elemental orb that explodes spitting overheatedacid",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_overheatedacid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_OVERHEATEDACID
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_OVERHEATEDACID
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_overheatedacid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_overheatedacid.xml")

				add_projectile("data/entities/projectiles/elementalorb_overheatedacid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_MILK",
	name 		= "ELEMENTAL ORB (MILK)",
	description = "An elemental orb that explodes spitting milk",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_milk.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_MILK
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_MILK
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_milk.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_milk.xml")

				add_projectile("data/entities/projectiles/elementalorb_milk.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_NITRO",
	name 		= "ELEMENTAL ORB (NITRO)",
	description = "An elemental orb that explodes spitting nitroglycerin",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_nitro.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_NITRO
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_NITRO
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_nitro.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_nitro.xml")

				add_projectile("data/entities/projectiles/elementalorb_nitro.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_OIL",
	name 		= "ELEMENTAL ORB (OIL)",
	description = "An elemental orb that explodes spitting oil",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_oil.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_OIL
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_OIL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_oil.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_oil.xml")

				add_projectile("data/entities/projectiles/elementalorb_oil.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_POLY",
	name 		= "ELEMENTAL ORB (POLY)",
	description = "An elemental orb that explodes spitting polymorphine",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_poly.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_POLY
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_POLY
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_poly.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_poly.xml")

				add_projectile("data/entities/projectiles/elementalorb_poly.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_POISON",
	name 		= "ELEMENTAL ORB (POISON)",
	description = "An elemental orb that explodes spitting poison",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_poison.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_POISON
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_POISON
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_poison.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_poison.xml")

				add_projectile("data/entities/projectiles/elementalorb_poison.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_SLAPIUM",
	name 		= "ELEMENTAL ORB (SLAPIUM)",
	description = "An elemental orb that explodes spitting slapium",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_slapium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_SLAPIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_SLAPIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_slapium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_slapium.xml")

				add_projectile("data/entities/projectiles/elementalorb_slapium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_SPITIUM",
	name 		= "ELEMENTAL ORB (SPITIUM)",
	description = "An elemental orb that explodes spitting spitium",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_spitium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_SPITIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_SPITIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_spitium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_spitium.xml")

				add_projectile("data/entities/projectiles/elementalorb_spitium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_TELEPORTATIUM",
	name 		= "ELEMENTAL ORB (TELEPORTATIUM)",
	description = "An elemental orb that explodes spitting teleportatium",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_teleportatium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_TELEPORTATIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_TELEPORTATIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_teleportatium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_teleportatium.xml")

				add_projectile("data/entities/projectiles/elementalorb_teleportatium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_TESLIUM",
	name 		= "ELEMENTAL ORB (TESLIUM)",
	description = "An elemental orb that explodes spitting teslium",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_teslium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_TESLIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_TESLIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_teslium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_teslium.xml")

				add_projectile("data/entities/projectiles/elementalorb_teslium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_THUNDERIUM",
	name 		= "ELEMENTAL ORB (THUNDERIUM)",
	description = "An elemental orb that explodes spitting thunderium",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_thunderium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_THUNDERIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_THUNDERIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_thunderium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_thunderium.xml")

				add_projectile("data/entities/projectiles/elementalorb_thunderium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_TOXIC",
	name 		= "ELEMENTAL ORB (TOXIC SLUDGE)",
	description = "An elemental orb that explodes spitting toxic sludge",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_toxic.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_TOXIC
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_TOXIC
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_toxic.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_toxic.xml")

				add_projectile("data/entities/projectiles/elementalorb_toxic.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_TRITIUM",
	name 		= "ELEMENTAL ORB (TRITIUM)",
	description = "An elemental orb that explodes spitting tritium",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_tritium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_TRITIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_TRITIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_tritium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_tritium.xml")

				add_projectile("data/entities/projectiles/elementalorb_tritium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_WATER",
	name 		= "ELEMENTAL ORB (WATER)",
	description = "An elemental orb that explodes spitting water",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_water.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_WATER
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_WATER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_water.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_water.xml")

				add_projectile("data/entities/projectiles/elementalorb_water.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ELEMENTALORB_WAVIUM",
	name 		= "ELEMENTAL ORB (WAVIUM)",
	description = "An elemental orb that explodes spitting wavium",
	sprite 		= "mods/TheArmory/files/actions/elementalorb_wavium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ELEMENTALORB_WAVIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_ELEMENTALORB_WAVIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("elementalorb_wavium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("elementalorb_wavium.xml")

				add_projectile("data/entities/projectiles/elementalorb_wavium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_FIRE",
	name 		= "SPITBOMB (FIRE)",
	description = "A bomb that explodes spitting fire",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_fire.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SPITBOMB_FIRE
	spawn_probability                 = "0", -- THEARMORYACTIONS_SPITBOMB_FIRE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_fire.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_fire.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_fire.xml")

				add_projectile("data/entities/projectiles/spitbomb_fire.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_EMBERBALL_SMALL",
	name 		= "SMALL EMBERBALL",
	description = "A small ball made of embers that causes fire damage on enemies it hits, exploding afterwards",
	sprite 		= "mods/TheArmory/files/actions/emberball_small.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_EMBERBALL_SMALL
	spawn_probability                 = "0", -- THEARMORYACTIONS_EMBERBALL_SMALL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("emberball_small_standalone.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("emberball_small_standalone.xml")

				add_projectile("data/entities/projectiles/emberball_small_standalone.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_FREEZINGORB",
	name 		= "FREEZING ORB",
	description = "An energy orb that freezes creatures touched by it",
	sprite 		= "mods/TheArmory/files/actions/freezingorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- PURPLEPLASMABOLT
	spawn_probability                 = "0", -- PURPLEPLASMABOLT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("freezingorb.xml")
				
				applyTrinketsEffectsWeapons_Energy("freezingorb.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("freezingorb.xml")

				add_projectile("data/entities/projectiles/freezingorb_standalone.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SCORCHINGORB",
	name 		= "SCORCHING ORB",
	description = "An energy orb that sets creatures touched by it on fire",
	sprite 		= "mods/TheArmory/files/actions/scorchingorb.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- PURPLEPLASMABOLT
	spawn_probability                 = "0", -- PURPLEPLASMABOLT
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("scorchingorb_standalone.xml")
				
				applyTrinketsEffectsWeapons_Energy("scorchingorb_standalone.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("scorchingorb_standalone.xml")

				add_projectile("data/entities/projectiles/scorchingorb_standalone.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SNOWBALL_SMALL",
	name 		= "SMALL SNOWBALL",
	description = "A small ball made of snow that freezes enemies, exploding afterwards",
	sprite 		= "mods/TheArmory/files/actions/snowball_small.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SNOWBALL_SMALL
	spawn_probability                 = "0", -- THEARMORYACTIONS_SNOWBALL_SMALL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("snowball_small_standalone.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("snowball_small_standalone.xml")

				add_projectile("data/entities/projectiles/snowball_small_standalone.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPIKEBALL_BLEEDER",
	name 		= "BLEEDER SPIKEBALL",
	description = "A spikeball that releases bleeder spikes on impact",
	sprite 		= "mods/TheArmory/files/actions/spikeball_bleeder.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPIKEBALL
	spawn_probability                 = "0", -- SPIKEBALL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_SingleShotRegular("spikeball_bleeder.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spikeball_bleeder.xml")

				add_projectile("data/entities/projectiles/spikeball_bleeder.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPIKEBALL_FIRE",
	name 		= "FIRE SPIKEBALL",
	description = "A spikeball that releases incendiary spikes on impact",
	sprite 		= "mods/TheArmory/files/actions/spikeball_fire.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPIKEBALL
	spawn_probability                 = "0", -- SPIKEBALL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_SingleShotRegular("spikeball_fire.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spikeball_fire.xml")

				add_projectile("data/entities/projectiles/spikeball_fire.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPIKEBALL_ICE",
	name 		= "ICE SPIKEBALL",
	description = "A spikeball that releases freezing spikes on impact",
	sprite 		= "mods/TheArmory/files/actions/spikeball_ice.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- SPIKEBALL
	spawn_probability                 = "0", -- SPIKEBALL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_SingleShotRegular("spikeball_ice.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spikeball_ice.xml")

				add_projectile("data/entities/projectiles/spikeball_ice.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_JESTERBALL",
	name 		= "JESTERBALL",
	description = "A colored ball that releases fireworks when it explodes",
	sprite 		= "mods/TheArmory/files/actions/jesterball.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_EMBERBALL
	spawn_probability                 = "0", -- THEARMORYACTIONS_EMBERBALL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("jesterball.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("jesterball.xml")

				add_projectile("data/entities/projectiles/jesterball.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_JESTERBALL_NITRO",
	name 		= "JESTERBALL (NITRO)",
	description = "A colored ball that releases nitroglycerin when it explodes",
	sprite 		= "mods/TheArmory/files/actions/jesterball_nitro.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_EMBERBALL
	spawn_probability                 = "0", -- THEARMORYACTIONS_EMBERBALL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_SingleShotRegular("jesterball_nitro.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("jesterball_nitro.xml")

				add_projectile("data/entities/projectiles/jesterball_nitro.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CORN",
	name 		= "CORN PROJECTILE",
	description = "A weaponized corn grain!",
	sprite 		= "mods/TheArmory/files/actions/corn.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- 556AMMO
	spawn_probability                 = "0", -- 556AMMO
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "smg_ammo", "Submachine Gun Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("corn.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("corn.xml")

				add_projectile("data/entities/projectiles/corn.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "smg_ammo", "Submachine Gun Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LONG_SWORD_MAGIC_ICE",
	name 		= "MAGIC LONG SWORD (ICE)",
	description = "Shoots a short ranged projectile that deals slice damage and freezes creatures it touches",
	sprite 		= "mods/TheArmory/files/actions/longsword_magic_ice.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_LONG_SWORD_MAGIC_ICE
	spawn_probability                 = "0", -- THEARMORYACTIONS_LONG_SWORD_MAGIC_ICE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/longsword_magic_ice.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LONG_SWORD_MAGIC_FIRE",
	name 		= "MAGIC LONG SWORD (FIRE)",
	description = "Shoots a short ranged projectile that deals slice damage and sets on fire creatures it touches",
	sprite 		= "mods/TheArmory/files/actions/longsword_magic_fire.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_LONG_SWORD_MAGIC_FIRE
	spawn_probability                 = "0", -- THEARMORYACTIONS_LONG_SWORD_MAGIC_FIRE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/longsword_magic_fire.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LONG_SWORD_MAGIC_POISON",
	name 		= "MAGIC LONG SWORD (POISON)",
	description = "Shoots a short ranged projectile that deals slice damage and releases poison",
	sprite 		= "mods/TheArmory/files/actions/longsword_magic_poison.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_LONG_SWORD_MAGIC_POISON
	spawn_probability                 = "0", -- THEARMORYACTIONS_LONG_SWORD_MAGIC_POISON
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/longsword_magic_poison.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BOWCASTERPROJECTILE",
	name 		= "BOWCASTER PROJECTILE",
	description = "An energy projectile that freezes creatures it touches",
	sprite 		= "mods/TheArmory/files/actions/knightprojectile.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_BOWCASTERPROJECTILE
	spawn_probability                 = "0", -- THEARMORYACTIONS_BOWCASTERPROJECTILE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("knightprojectile.xml")
				
				applyTrinketsEffectsWeapons_Energy("knightprojectile.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("knightprojectile.xml")

				add_projectile("data/entities/projectiles/knightprojectile.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BOWCASTERPROJECTILE_ACID_SPIT",
	name 		= "BOWCASTER PROJECTILE (ACID SPIT)",
	description = "An energy projectile that inflicts the acid spit effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/knightprojectile_acid.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_BOWCASTERPROJECTILE
	spawn_probability                 = "0", -- THEARMORYACTIONS_BOWCASTERPROJECTILE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("knightprojectile_acid.xml")
				
				applyTrinketsEffectsWeapons_Energy("knightprojectile_acid.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("knightprojectile_acid.xml")

				add_projectile("data/entities/projectiles/knightprojectile_acid.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BOWCASTERPROJECTILE_POISON_SPIT",
	name 		= "BOWCASTER PROJECTILE (POISON SPIT)",
	description = "An energy projectile that inflicts the poison spit effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/knightprojectile_poison.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_BOWCASTERPROJECTILE
	spawn_probability                 = "0", -- THEARMORYACTIONS_BOWCASTERPROJECTILE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("knightprojectile_poison.xml")
				
				applyTrinketsEffectsWeapons_Energy("knightprojectile_poison.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("knightprojectile_poison.xml")

				add_projectile("data/entities/projectiles/knightprojectile_poison.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BOWCASTERPROJECTILE_FIRE_SPIT",
	name 		= "BOWCASTER PROJECTILE (FIRE SPIT)",
	description = "An energy projectile that inflicts the burning damage effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/knightprojectile_fire.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_BOWCASTERPROJECTILE
	spawn_probability                 = "0", -- THEARMORYACTIONS_BOWCASTERPROJECTILE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
			
				applyTrinketsEffectsWeapons_Elemental("knightprojectile_fire.xml")
				
				applyTrinketsEffectsWeapons_Energy("knightprojectile_fire.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("knightprojectile_fire.xml")

				add_projectile("data/entities/projectiles/knightprojectile_fire.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LANCE_MAGIC",
	name 		= "MAGIC LANCE",
	description = "Shoots a short ranged projectile that deals slice damage and electrocutes enemies",
	sprite 		= "mods/TheArmory/files/actions/lance_magic.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_LANCE_MAGIC
	spawn_probability                 = "0", -- THEARMORYACTIONS_LANCE_MAGIC
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/lance_magic.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LANCE_MAGIC_BLEEDER",
	name 		= "MAGIC LANCE (BLEEDER)",
	description = "Shoots a short ranged projectile that deals slice damage and inflicts bleeding on enemies",
	sprite 		= "mods/TheArmory/files/actions/lance_magic_bleeder.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_LANCE_MAGIC_BLEEDER
	spawn_probability                 = "0", -- THEARMORYACTIONS_LANCE_MAGIC_BLEEDER
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/lance_magic_bleeder.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LANCE_MAGIC_POLY",
	name 		= "MAGIC LANCE (POLY)",
	description = "Shoots a short ranged projectile that deals slice damage and polymorphs enemies",
	sprite 		= "mods/TheArmory/files/actions/lance_magic_poly.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_LANCE_MAGIC_POLY
	spawn_probability                 = "0", -- THEARMORYACTIONS_LANCE_MAGIC_POLY
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/lance_magic_poly.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LANCE_MAGIC_NITRO",
	name 		= "MAGIC LANCE (NITRO)",
	description = "Shoots a short ranged projectile that deals slice damage and releases nitroglycerin",
	sprite 		= "mods/TheArmory/files/actions/lance_magic_nitro.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_LANCE_MAGIC_NITRO
	spawn_probability                 = "0", -- THEARMORYACTIONS_LANCE_MAGIC_NITRO
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/lance_magic_nitro.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LANCE_MAGIC_ICE",
	name 		= "MAGIC LANCE (ICE)",
	description = "Shoots a short ranged projectile that deals slice damage and freezes enemies",
	sprite 		= "mods/TheArmory/files/actions/lance_magic_ice.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_LANCE_MAGIC_ICE
	spawn_probability                 = "0", -- THEARMORYACTIONS_LANCE_MAGIC_ICE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/lance_magic_ice.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LANCE_MAGIC_FIRE",
	name 		= "MAGIC LANCE (FIRE)",
	description = "Shoots a short ranged projectile that deals slice damage and sets enemies on fire",
	sprite 		= "mods/TheArmory/files/actions/lance_magic_fire.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_LANCE_MAGIC_FIRE
	spawn_probability                 = "0", -- THEARMORYACTIONS_LANCE_MAGIC_FIRE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/lance_magic_fire.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CURSEDCRYSTAL",
	name 		= "CURSED CRYSTAL",
	description = "Releases a barrage of sharp crystal shards that deal slice damage",
	sprite 		= "mods/TheArmory/files/actions/cursedcrystal.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_CURSEDCRYSTAL
	spawn_probability                 = "0", -- THEARMORYACTIONS_CURSEDCRYSTAL
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "knives_ammo", "Knives")) then
				
				add_projectile("data/entities/projectiles/sharpcrystal_shards.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "knives_ammo", "Knives")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CURSEDCRYSTAL_EXPLOSIUM",
	name 		= "CURSED CRYSTAL (EXPLOSIUM)",
	description = "Releases a barrage of sharp crystal shards that deal slice damage and inflict the exploding effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/cursedcrystal_explosium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_CURSEDCRYSTAL
	spawn_probability                 = "0", -- THEARMORYACTIONS_CURSEDCRYSTAL
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "knives_ammo", "Knives")) then
				
				add_projectile("data/entities/projectiles/sharpcrystal_shards_explosium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "knives_ammo", "Knives")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CURSEDCRYSTAL_EXPLOSIVE",
	name 		= "CURSED CRYSTAL (EXPLOSIVE)",
	description = "Releases a barrage of sharp explosive crystal shards that deal slice damage",
	sprite 		= "mods/TheArmory/files/actions/cursedcrystal_explosive.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_CURSEDCRYSTAL
	spawn_probability                 = "0", -- THEARMORYACTIONS_CURSEDCRYSTAL
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "knives_ammo", "Knives")) then
				
				add_projectile("data/entities/projectiles/sharpcrystal_shards_explosive.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "knives_ammo", "Knives")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CURSEDCRYSTAL_SLAPIUM",
	name 		= "CURSED CRYSTAL (SLAPIUM)",
	description = "Releases a barrage of sharp crystal shards that deal slice damage and inflict the slap effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/cursedcrystal_slapium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_CURSEDCRYSTAL
	spawn_probability                 = "0", -- THEARMORYACTIONS_CURSEDCRYSTAL
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "knives_ammo", "Knives")) then
				
				add_projectile("data/entities/projectiles/sharpcrystal_shards_slapium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "knives_ammo", "Knives")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CURSEDCRYSTAL_BLEEDER",
	name 		= "CURSED CRYSTAL (BLEEDER)",
	description = "Releases a barrage of sharp crystal shards that deal slice damage and inflict the bleeding effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/cursedcrystal_bleeder.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_CURSEDCRYSTAL
	spawn_probability                 = "0", -- THEARMORYACTIONS_CURSEDCRYSTAL
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "knives_ammo", "Knives")) then
				
				add_projectile("data/entities/projectiles/sharpcrystal_shards_bleeder.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "knives_ammo", "Knives")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CURSEDCRYSTAL_FREEZING",
	name 		= "CURSED CRYSTAL (FREEZING)",
	description = "Releases a barrage of sharp crystal shards that deal slice damage and freeze enemies",
	sprite 		= "mods/TheArmory/files/actions/cursedcrystal_freezing.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_CURSEDCRYSTAL
	spawn_probability                 = "0", -- THEARMORYACTIONS_CURSEDCRYSTAL
	price = 600,
	mana = 20,
	action 		= function()
	
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "knives_ammo", "Knives")) then
				
				add_projectile("data/entities/projectiles/sharpcrystal_shards_freezing.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "knives_ammo", "Knives")
			end
		end
	    
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_ROTORROCKET",
	name 		= "ROTOR ROCKET",
	description = "A rocket that grabs enemies and deals slice damage overtime, exploding afterwards",
	sprite 		= "mods/TheArmory/files/actions/rotorrocket.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ROTORROCKET
	spawn_probability                 = "0", -- THEARMORYACTIONS_ROTORROCKET
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rockets_ammo", "Rockets")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("rotorrocket.xml")

				add_projectile("data/entities/projectiles/rotorrocket.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rockets_ammo", "Rockets")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_GRINDERROCKET",
	name 		= "GRINDER ROCKET",
	description = "A rocket that grabs enemies and deals melee damage overtime, exploding afterwards",
	sprite 		= "mods/TheArmory/files/actions/grinderrocket.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ROTORROCKET
	spawn_probability                 = "0", -- THEARMORYACTIONS_ROTORROCKET
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rockets_ammo", "Rockets")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("grinderrocket.xml")

				add_projectile("data/entities/projectiles/grinderrocket.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rockets_ammo", "Rockets")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MICROROCKET",
	name 		= "MICRO ROCKET",
	description = "A tiny rocket with great punch!",
	sprite 		= "mods/TheArmory/files/actions/microrocket.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_MICROROCKET
	spawn_probability                 = "0", -- THEARMORYACTIONS_MICROROCKET
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rifle_ammo", "Rifle Ammo")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_SingleShotRegular("microrocket.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("microrocket.xml")

				add_projectile("data/entities/projectiles/microrocket.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rifle_ammo", "Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SLASHERPROJECTILE",
	name 		= "SLASHER PROJECTILE",
	description = "An energy projectile that inflicts the slashing effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/slasherprojectile.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SLASHERPROJECTILE
	spawn_probability                 = "0", -- THEARMORYACTIONS_SLASHERPROJECTILE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("slasherprojectile.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("slasherprojectile.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("slasherprojectile.xml")

				add_projectile("data/entities/projectiles/slasherprojectile.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MACHETE",
	name 		= "MACHETE",
	description = "A survival blade that inflicts bleeding on enemies",
	sprite 		= "mods/TheArmory/files/actions/machete.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_MACHETE
	spawn_probability                 = "0", -- THEARMORYACTIONS_MACHETE
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/machete.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MACHETE_SERRATED",
	name 		= "SERRATED MACHETE",
	description = "A survival blade that inflicts quick bleeding on enemies",
	sprite 		= "mods/TheArmory/files/actions/machete_serrated.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_MACHETE_SERRATED
	spawn_probability                 = "0", -- THEARMORYACTIONS_MACHETE_SERRATED
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/machete_serrated.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MACHETE_KUKRI",
	name 		= "KUKRI",
	description = "A survival blade that packs great punch (and slice)",
	sprite 		= "mods/TheArmory/files/actions/machete_kukri.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_MACHETE_KUKRI
	spawn_probability                 = "0", -- THEARMORYACTIONS_MACHETE_KUKRI
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/machete_kukri.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MACHETE_KUKRI_CORRODED",
	name 		= "CORRODED KUKRI",
	description = "A corroded blade that inflicts the acid spit on enemies",
	sprite 		= "mods/TheArmory/files/actions/machete_kukri_corroded.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_MACHETE_KUKRI_CORRODED
	spawn_probability                 = "0", -- THEARMORYACTIONS_MACHETE_KUKRI_CORRODED
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/machete_kukri_corroded.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MAGMAUL",
	name 		= "MAGMAUL",
	description = "A magic hammer that creates lava shockwaves whenever it hits something",
	sprite 		= "mods/TheArmory/files/actions/magmaul.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- CORRODINGFLATTENER
	spawn_probability                 = "0", -- CORRODINGFLATTENER
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/magmaul.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_HELLBLUDGEON",
	name 		= "HELL BLUDGEON",
	description = "A magic mace that induces the inferno waves effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/hellbludgeon.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- EXPLODINGMACE
	spawn_probability                 = "0", -- EXPLODINGMACE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/hellbludgeon.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CHILLCLUB",
	name 		= "CHILL CLUB",
	description = "A magic mace that induces the ice waves effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/chillclub.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- EXPLODINGMACE
	spawn_probability                 = "0", -- EXPLODINGMACE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/chillclub.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_LIGHTNINGROD",
	name 		= "LIGHTNING ROD",
	description = "A magic blade that induces the thunder waveS effect on enemies touched by it",
	sprite 		= "mods/TheArmory/files/actions/lightningrod.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_LIGHTNINGROD
	spawn_probability                 = "0", -- THEARMORYACTIONS_LIGHTNINGROD
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/lightningrod.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_STUNROD",
	name 		= "STUN ROD",
	description = "A magic mace that electrocutes enemies",
	sprite 		= "mods/TheArmory/files/actions/stunrod.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_STUNROD
	spawn_probability                 = "0", -- THEARMORYACTIONS_STUNROD
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/stunrod.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPARKHATCHET",
	name 		= "SPARK HATCHET",
	description = "A magic axe that inflicts the electro waves effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/sparkhatchet.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SPARKHATCHET
	spawn_probability                 = "0", -- THEARMORYACTIONS_SPARKHATCHET
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/sparkhatchet.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SLASHPIKE",
	name 		= "SLASH PIKE",
	description = "A magic blade that induces the slashing effect on enemies touched by it",
	sprite 		= "mods/TheArmory/files/actions/slashpike.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SLASHPIKE
	spawn_probability                 = "0", -- THEARMORYACTIONS_SLASHPIKE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/slashpike.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SERRATEDPOLEARM",
	name 		= "SERRATED POLEARM",
	description = "Causes heavy bleeding on enemies",
	sprite 		= "mods/TheArmory/files/actions/serratedpolearm.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SERRATEDPOLEARM
	spawn_probability                 = "0", -- THEARMORYACTIONS_SERRATEDPOLEARM
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/serratedpolearm.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MOLTENHAWK",
	name 		= "MOLTENHAWK",
	description = "A magic axe that inflicts the burning damage effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/moltenhawk.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_MOLTENHAWK
	spawn_probability                 = "0", -- THEARMORYACTIONS_MOLTENHAWK
	price = 600,
	mana = 20,
	action 		= function()

		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/moltenhawk.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CLEAVER",
	name 		= "CLEAVER",
	description = "A short ranged but deadly knife",
	sprite 		= "mods/TheArmory/files/actions/cleaver.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_CLEAVER
	spawn_probability                 = "0", -- THEARMORYACTIONS_CLEAVER
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/cleaver.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CLEAVER_BLOODIED",
	name 		= "BLOODIED CLEAVER",
	description = "A short ranged knife that deals bleeding damage",
	sprite 		= "mods/TheArmory/files/actions/cleaver_bloodied.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_CLEAVER_BLOODIED
	spawn_probability                 = "0", -- THEARMORYACTIONS_CLEAVER_BLOODIED
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/cleaver_bloodied.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CLEAVER_TOXIC",
	name 		= "TOXIC CLEAVER",
	description = "A short ranged knife that induces the acid spit effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/cleaver_toxic.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_CLEAVER_TOXIC
	spawn_probability                 = "0", -- THEARMORYACTIONS_CLEAVER_TOXIC
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/cleaver_toxic.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BASEBALLBAT",
	name 		= "BASEBALL BAT",
	description = "There is no baseball, so use this bat to bash some skulls",
	sprite 		= "mods/TheArmory/files/actions/baseballbat.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_BASEBALLBAT
	spawn_probability                 = "0", -- THEARMORYACTIONS_BASEBALLBAT
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/baseballbat.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BASEBALLBAT_METALLIC",
	name 		= "BASEBALL BAT",
	description = "There is no baseball, so use this metallic bat to bash some skulls",
	sprite 		= "mods/TheArmory/files/actions/baseballbat_metallic.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_BASEBALLBAT_METALLIC
	spawn_probability                 = "0", -- THEARMORYACTIONS_BASEBALLBAT_METALLIC
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/baseballbat_metallic.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BASEBALLBAT_PUNCTURING",
	name 		= "PUNCTURING BASEBALL BAT",
	description = "There is no baseball, so use this puncturing bat to bash some skulls and make them bleed to death",
	sprite 		= "mods/TheArmory/files/actions/baseballbat_puncturing.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_BASEBALLBAT_PUNCTURING
	spawn_probability                 = "0", -- THEARMORYACTIONS_BASEBALLBAT_PUNCTURING
	price = 600,
	mana = 20,
	action 		= function()
		
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/baseballbat_puncturing.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_BASEBALL",
	name 		= "BASEBALL",
	description = "Ensure your homerun with this specially prepared baseball",
	sprite 		= "mods/TheArmory/files/actions/baseball.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_BASEBALL
	spawn_probability                 = "0", -- THEARMORYACTIONS_BASEBALL
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_SingleShotRegular("baseball_bat.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("baseball_bat.xml")

				add_projectile("data/entities/projectiles/baseball_bat.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_THEBREACHER",
	name 		= "THE BREACHER",
	description = "A spear that breaches through most materials and pushes enemies away",
	sprite 		= "mods/TheArmory/files/actions/thebreacher.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_THEBREACHER
	spawn_probability                 = "0", -- THEARMORYACTIONS_THEBREACHER
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/thebreacher.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_THEPUNCHER",
	name 		= "THE PUNCHER",
	description = "A spear that punches through the hardest materials and pushes enemies away dealing bleed damage",
	sprite 		= "mods/TheArmory/files/actions/thepuncher.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_THEPUNCHER
	spawn_probability                 = "0", -- THEARMORYACTIONS_THEPUNCHER
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/thepuncher.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_DIGGINGSHOVEL",
	name 		= "DIGGING SHOVEL",
	description = "A digger tool",
	sprite 		= "mods/TheArmory/files/actions/diggingshovel.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_DIGGINGSHOVEL
	spawn_probability                 = "0", -- THEARMORYACTIONS_DIGGINGSHOVEL
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/diggingshovel.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_DIGGINGSHOVEL_DIAMOND",
	name 		= "DIAMOND DIGGING SHOVEL",
	description = "A digger tool, capable of digging through hard materials such as steel",
	sprite 		= "mods/TheArmory/files/actions/diggingshovel_diamond.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_DIGGINGSHOVEL_DIAMOND
	spawn_probability                 = "0", -- THEARMORYACTIONS_DIGGINGSHOVEL_DIAMOND
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/diggingshovel_diamond.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_DIGGINGSHOVEL_TACTICAL",
	name 		= "TACTICAL DIGGING SHOVEL",
	description = "A digger tool, capable of digging through hard materials such as steel and dealing significant melee damage",
	sprite 		= "mods/TheArmory/files/actions/diggingshovel_tactical.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_DIGGINGSHOVEL_TACTICAL
	spawn_probability                 = "0", -- THEARMORYACTIONS_DIGGINGSHOVEL_TACTICAL
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/diggingshovel_tactical.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHOVELROCKET",
	name 		= "SHOVEL ROCKET",
	description = "A rocket propelled shovel that creates large holes where it hits",
	sprite 		= "mods/TheArmory/files/actions/shovelrocket.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_ROTORROCKET
	spawn_probability                 = "0", -- THEARMORYACTIONS_ROTORROCKET
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rockets_ammo", "Rockets")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("shovelrocket.xml")

				add_projectile("data/entities/projectiles/shovelrocket.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rockets_ammo", "Rockets")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SHORTSPEAR",
	name 		= "SHORT SPEAR",
	description = "A short ranged spear that deals improved slice damage",
	sprite 		= "mods/TheArmory/files/actions/shortspear.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SHORTSPEAR
	spawn_probability                 = "0", -- THEARMORYACTIONS_SHORTSPEAR
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/shortspear.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_THEBLASTER",
	name 		= "THE BLASTER",
	description = "A spear that blasts through the hardest materials and pushes enemies away dealing burning damage",
	sprite 		= "mods/TheArmory/files/actions/theblaster.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_THEPUNCHER
	spawn_probability                 = "0", -- THEARMORYACTIONS_THEPUNCHER
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/theblaster.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_SLASHIUM",
	name 		= "SPITBOMB (SLASHIUM)",
	description = "A bomb that explodes spitting slashium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_slashium.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SPITBOMB_SLASHIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_SPITBOMB_SLASHIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_slashium.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_slashium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_slashium.xml")

				add_projectile("data/entities/projectiles/spitbomb_slashium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_SLASHIUM_GREEN",
	name 		= "SPITBOMB (GREEN SLASHIUM)",
	description = "A bomb that explodes spitting green slashium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_slashium_green.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SPITBOMB_SLASHIUM
	spawn_probability                 = "0", -- THEARMORYACTIONS_SPITBOMB_SLASHIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_slashium_green.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_slashium_green.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_slashium_green.xml")

				add_projectile("data/entities/projectiles/spitbomb_slashium_green.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_SLASHIUM_RED",
	name 		= "SPITBOMB (RED SLASHIUM)",
	description = "A bomb that explodes spitting red slashium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_slashium_red.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SPITBOMB_SLASHIUM_RED
	spawn_probability                 = "0", -- THEARMORYACTIONS_SPITBOMB_SLASHIUM_RED
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_slashium_red.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_slashium_red.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_slashium_red.xml")

				add_projectile("data/entities/projectiles/spitbomb_slashium_red.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_SLASHIUM_ORANGE",
	name 		= "SPITBOMB (ORANGE SLASHIUM)",
	description = "A bomb that explodes spitting orange slashium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_slashium_orange.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SPITBOMB_SLASHIUM_ORANGE
	spawn_probability                 = "0", -- THEARMORYACTIONS_SPITBOMB_SLASHIUM_ORANGE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_slashium_orange.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_slashium_orange.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_slashium_orange.xml")

				add_projectile("data/entities/projectiles/spitbomb_slashium_orange.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_SLASHIUM_PURPLE",
	name 		= "SPITBOMB (PURPLE SLASHIUM)",
	description = "A bomb that explodes spitting purple slashium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_slashium_purple.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SPITBOMB_SLASHIUM_PURPLE
	spawn_probability                 = "0", -- THEARMORYACTIONS_SPITBOMB_SLASHIUM_PURPLE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_slashium_purple.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_slashium_purple.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_slashium_purple.xml")

				add_projectile("data/entities/projectiles/spitbomb_slashium_purple.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_EXPLOSIUM_GREEN",
	name 		= "SPITBOMB (GREEN EXPLOSIUM)",
	description = "A bomb that explodes spitting green explosium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_explosium_green.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SPITBOMB_EXPLOSIUM_GREEN
	spawn_probability                 = "0", -- THEARMORYACTIONS_SPITBOMB_EXPLOSIUM_GREEN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_explosium_green.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_explosium_green.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_explosium_green.xml")

				add_projectile("data/entities/projectiles/spitbomb_explosium_green.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_EXPLOSIUM_RED",
	name 		= "SPITBOMB (RED EXPLOSIUM)",
	description = "A bomb that explodes spitting red explosium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_explosium_red.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SPITBOMB_EXPLOSIUM_GREEN
	spawn_probability                 = "0", -- THEARMORYACTIONS_SPITBOMB_EXPLOSIUM_GREEN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_explosium_red.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_explosium_red.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_explosium_red.xml")

				add_projectile("data/entities/projectiles/spitbomb_explosium_red.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_EXPLOSIUM_ORANGE",
	name 		= "SPITBOMB (ORANGE EXPLOSIUM)",
	description = "A bomb that explodes spitting orange explosium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_explosium_orange.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SPITBOMB_EXPLOSIUM_ORANGE
	spawn_probability                 = "0", -- THEARMORYACTIONS_SPITBOMB_EXPLOSIUM_ORANGE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_explosium_orange.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_explosium_orange.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_explosium_orange.xml")

				add_projectile("data/entities/projectiles/spitbomb_explosium_orange.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_EXPLOSIUM_PURPLE",
	name 		= "SPITBOMB (PURPLE EXPLOSIUM)",
	description = "A bomb that explodes spitting purple explosium",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_explosium_purple.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SPITBOMB_EXPLOSIUM_PURPLE
	spawn_probability                 = "0", -- THEARMORYACTIONS_SPITBOMB_EXPLOSIUM_PURPLE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_explosium_purple.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_explosium_purple.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_explosium_purple.xml")

				add_projectile("data/entities/projectiles/spitbomb_explosium_purple.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_EXPLODING_GAS_YELLOW",
	name 		= "SPITBOMB (YELLOW EXPLODING GAS)",
	description = "A bomb that explodes spitting yellow exploding gas",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_exploding_gas_yellow.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SPITBOMB_EXPLODING_GAS_YELLOW
	spawn_probability                 = "0", -- THEARMORYACTIONS_SPITBOMB_EXPLODING_GAS_YELLOW
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_exploding_gas_yellow.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_exploding_gas_yellow.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_exploding_gas_yellow.xml")

				add_projectile("data/entities/projectiles/spitbomb_exploding_gas_yellow.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_EXPLODING_GAS_GREEN",
	name 		= "SPITBOMB (GREEN EXPLODING GAS)",
	description = "A bomb that explodes spitting green exploding gas",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_exploding_gas_green.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SPITBOMB_EXPLODING_GAS_GREEN
	spawn_probability                 = "0", -- THEARMORYACTIONS_SPITBOMB_EXPLODING_GAS_GREEN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_exploding_gas_green.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_exploding_gas_green.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_exploding_gas_green.xml")

				add_projectile("data/entities/projectiles/spitbomb_exploding_gas_green.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_EXPLODING_GAS_RED",
	name 		= "SPITBOMB (RED EXPLODING GAS)",
	description = "A bomb that explodes spitting red exploding gas",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_exploding_gas_red.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SPITBOMB_EXPLODING_GAS_RED
	spawn_probability                 = "0", -- THEARMORYACTIONS_SPITBOMB_EXPLODING_GAS_RED
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_exploding_gas_red.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_exploding_gas_red.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_exploding_gas_red.xml")

				add_projectile("data/entities/projectiles/spitbomb_exploding_gas_red.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_EXPLODING_GAS_ORANGE",
	name 		= "SPITBOMB (ORANGE EXPLODING GAS)",
	description = "A bomb that explodes spitting orange exploding gas",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_exploding_gas_orange.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SPITBOMB_EXPLODING_GAS_ORANGE
	spawn_probability                 = "0", -- THEARMORYACTIONS_SPITBOMB_EXPLODING_GAS_ORANGE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_exploding_gas_orange.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_exploding_gas_orange.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_exploding_gas_orange.xml")

				add_projectile("data/entities/projectiles/spitbomb_exploding_gas_orange.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITBOMB_EXPLODING_GAS_PURPLE",
	name 		= "SPITBOMB (PURPLE EXPLODING GAS)",
	description = "A bomb that explodes spitting purple exploding gas",
	sprite 		= "mods/TheArmory/files/actions/spitbomb_exploding_gas_purple.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SPITBOMB_EXPLODING_GAS_PURPLE
	spawn_probability                 = "0", -- THEARMORYACTIONS_SPITBOMB_EXPLODING_GAS_PURPLE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
				
				applyTrinketsEffectsWeapons_Explosive()
			
				applyTrinketsEffectsWeapons_Elemental("spitbomb_exploding_gas_purple.xml")
			
				applyTrinketsEffectsWeapons_SingleShotRegular("spitbomb_exploding_gas_purple.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("spitbomb_exploding_gas_purple.xml")

				add_projectile("data/entities/projectiles/spitbomb_exploding_gas_purple.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SLASHERPROJECTILE_GREEN",
	name 		= "GREEN SLASHER PROJECTILE",
	description = "An energy projectile that inflicts the acid slashing effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/slasherprojectile_green.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SLASHERPROJECTILE_GREEN
	spawn_probability                 = "0", -- THEARMORYACTIONS_SLASHERPROJECTILE_GREEN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("slasherprojectile_green.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("slasherprojectile_green.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("slasherprojectile_green.xml")

				add_projectile("data/entities/projectiles/slasherprojectile_green.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SLASHERPROJECTILE_RED",
	name 		= "RED SLASHER PROJECTILE",
	description = "An energy projectile that inflicts the overheated acid slashing effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/slasherprojectile_red.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SLASHERPROJECTILE_GREEN
	spawn_probability                 = "0", -- THEARMORYACTIONS_SLASHERPROJECTILE_GREEN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("slasherprojectile_red.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("slasherprojectile_red.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("slasherprojectile_red.xml")

				add_projectile("data/entities/projectiles/slasherprojectile_red.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SLASHERPROJECTILE_ORANGE",
	name 		= "ORANGE SLASHER PROJECTILE",
	description = "An energy projectile that inflicts the lava slashing effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/slasherprojectile_orange.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SLASHERPROJECTILE_GREEN
	spawn_probability                 = "0", -- THEARMORYACTIONS_SLASHERPROJECTILE_GREEN
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("slasherprojectile_orange.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("slasherprojectile_orange.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("slasherprojectile_orange.xml")

				add_projectile("data/entities/projectiles/slasherprojectile_orange.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SLASHERPROJECTILE_PURPLE",
	name 		= "PURPLE SLASHER PROJECTILE",
	description = "An energy projectile that inflicts the poison slashing effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/slasherprojectile_purple.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SLASHERPROJECTILE_PURPLE
	spawn_probability                 = "0", -- THEARMORYACTIONS_SLASHERPROJECTILE_PURPLE
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "energy_cells", "Energy Cells")) then
				
				applyTrinketsEffectsWeapons_Energy("slasherprojectile_purple.xml")
				
				applyTrinketsEffectsWeapons_SingleShotRegular("slasherprojectile_purple.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("slasherprojectile_purple.xml")

				add_projectile("data/entities/projectiles/slasherprojectile_purple.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "energy_cells", "Energy Cells")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SPITFIREROD",
	name 		= "SPITFIRE ROD",
	description = "A blade that induces the heavy fire exploding effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/spitfirerod.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SPITFIREROD
	spawn_probability                 = "0", -- THEARMORYACTIONS_SPITFIREROD
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/spitfirerod.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_IGNEOUSHATCHET",
	name 		= "IGNEOUS HATCHET",
	description = "An axe that induces the lava slashing effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/igneoushatchet.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_IGNEOUSHATCHET
	spawn_probability                 = "0", -- THEARMORYACTIONS_IGNEOUSHATCHET
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/igneoushatchet.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_CAUSTICMACE",
	name 		= "CAUSTIC MACE",
	description = "A magic mace that induces the acid exploding effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/causticmace.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_CAUSTICMACE
	spawn_probability                 = "0", -- THEARMORYACTIONS_CAUSTICMACE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/causticmace.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SOURSPEAR",
	name 		= "SOUR SPEAR",
	description = "A magic blade that induces the acid slashing effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/sourspear.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SOURSPEAR
	spawn_probability                 = "0", -- THEARMORYACTIONS_SOURSPEAR
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/sourspear.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_VILEDAGGER",
	name 		= "VILE DAGGER",
	description = "A short ranged blade that induces the poison slashing effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/viledagger.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_VILEDAGGER
	spawn_probability                 = "0", -- THEARMORYACTIONS_VILEDAGGER
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/viledagger.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_PUNGENTINJECTOR",
	name 		= "PUNGENT INJECTOR",
	description = "A needle that causes the overheated acid slashing effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/pungentinjector.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_PUNGENTINJECTOR
	spawn_probability                 = "0", -- THEARMORYACTIONS_PUNGENTINJECTOR
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/pungentinjector.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MAGMABEATER",
	name 		= "MAGMA BEATER",
	description = "A blunt weapon that induces the lava exploding effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/magmabeater.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_MAGMABEATER
	spawn_probability                 = "0", -- THEARMORYACTIONS_MAGMABEATER
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/magmabeater.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_VENOMOUSCLUB",
	name 		= "VENOMOUS CLUB",
	description = "A weapon that induces the poison exploding effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/venomousclub.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_VENOMOUSCLUB
	spawn_probability                 = "0", -- THEARMORYACTIONS_VENOMOUSCLUB
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/venomousclub.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_SULFURICLANCE",
	name 		= "SULFURIC LANCE",
	description = "A blade that induces the overheated acid exploding effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/sulfuriclance.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_SULFURICLANCE
	spawn_probability                 = "0", -- THEARMORYACTIONS_SULFURICLANCE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/sulfuriclance.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_STELARSPEAR",
	name 		= "STELAR SPEAR",
	description = "A blade that induces the heavy acid exploding effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/stelarspear.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_STELARSPEAR
	spawn_probability                 = "0", -- THEARMORYACTIONS_STELARSPEAR
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/stelarspear.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_STELARMACE",
	name 		= "STELAR MACE",
	description = "A blunt weapon that induces the heavy overheated acid exploding effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/stelarmace.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_STELARMACE
	spawn_probability                 = "0", -- THEARMORYACTIONS_STELARMACE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/stelarmace.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_STELARAXE",
	name 		= "STELAR AXE",
	description = "A blade that induces the heavy lava exploding effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/stelaraxe.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_STELARAXE
	spawn_probability                 = "0", -- THEARMORYACTIONS_STELARAXE
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/stelaraxe.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_STELARHAMMER",
	name 		= "STELAR HAMMER",
	description = "A blunt weapon that induces the heavy poison exploding effect on enemies",
	sprite 		= "mods/TheArmory/files/actions/stelarhammer.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_STELARHAMMER
	spawn_probability                 = "0", -- THEARMORYACTIONS_STELARHAMMER
	price = 600,
	mana = 20,
	action 		= function()
	
		applyTrinketsEffectsWeapons_Melee()

		applyTrinketsEffectsWeapons_StackableBonusesMelee()
		
		add_projectile("data/entities/projectiles/stelarhammer.xml")	
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_GRINDER_OVERHEATED",
	name 		= "OVERHEATED GRINDER",
	description = "A grinder wheel that sticks to enemies dealing damage overtime and setting them on fire",
	sprite 		= "mods/TheArmory/files/actions/grinder_overheated.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_GRINDER_OVERHEATED
	spawn_probability                 = "0", -- THEARMORYACTIONS_GRINDER_OVERHEATED
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("grinder_overheated.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("grinder_overheated.xml")

				add_projectile("data/entities/projectiles/grinder_overheated.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_GRINDER_ELECTRIFIED",
	name 		= "ELECTRIFIED GRINDER",
	description = "A grinder wheel that sticks to enemies dealing damage overtime and electrocuting them",
	sprite 		= "mods/TheArmory/files/actions/grinder_electrified.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_GRINDER_ELECTRIFIED
	spawn_probability                 = "0", -- THEARMORYACTIONS_GRINDER_ELECTRIFIED
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "grenades_ammo", "Grenades")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("grinder_electrified.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("grinder_electrified.xml")

				add_projectile("data/entities/projectiles/grinder_electrified.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "grenades_ammo", "Grenades")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MICROROCKET_SCATTER",
	name 		= "SCATTERED MICRO ROCKETS",
	description = "Many microrockets shot at once",
	sprite 		= "mods/TheArmory/files/actions/microrocket_scatter.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_MICROROCKET_SCATTER
	spawn_probability                 = "0", -- THEARMORYACTIONS_MICROROCKET_SCATTER
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rifle_ammo", "Rifle Ammo")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_ScatterShotRegular("microrocket.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("microrocket.xml")

				add_projectile("data/entities/projectiles/microrocket.xml")
				add_projectile("data/entities/projectiles/microrocket.xml")
				add_projectile("data/entities/projectiles/microrocket.xml")
				add_projectile("data/entities/projectiles/microrocket.xml")
				
				c.spread_degrees = 25 
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rifle_ammo", "Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_MICROROCKET_PUNCHER",
	name 		= "MICRO ROCKET (PUNCHER)",
	description = "A tiny rocket with even greater punch!",
	sprite 		= "mods/TheArmory/files/actions/microrocket_puncher.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_MICROROCKET
	spawn_probability                 = "0", -- THEARMORYACTIONS_MICROROCKET
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "rifle_ammo", "Rifle Ammo")) then
			
				applyTrinketsEffectsWeapons_Explosive()
				
				applyTrinketsEffectsWeapons_SingleShotRegular("microrocket_puncher.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("microrocket_puncher.xml")

				add_projectile("data/entities/projectiles/microrocket_puncher.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "rifle_ammo", "Rifle Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_SLASHIUM",
	name 		= "TEST TUBE FILLED WITH SLASHIUM",
	description = "A throwable test tube that releases slashium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_TESLIUM
	spawn_probability                 = "0", -- TESTTUBE_TESLIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_slashium.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_slashium.xml")

				add_projectile("data/entities/projectiles/testtube_slashium.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_SLASHIUM_RED",
	name 		= "TEST TUBE FILLED WITH RED SLASHIUM",
	description = "A throwable test tube that releases red slashium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_TESLIUM
	spawn_probability                 = "0", -- TESTTUBE_TESLIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_slashium_red.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_slashium_red.xml")

				add_projectile("data/entities/projectiles/testtube_slashium_red.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_SLASHIUM_GREEN",
	name 		= "TEST TUBE FILLED WITH GREEN SLASHIUM",
	description = "A throwable test tube that releases green slashium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_TESLIUM
	spawn_probability                 = "0", -- TESTTUBE_TESLIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_slashium_green.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_slashium_green.xml")

				add_projectile("data/entities/projectiles/testtube_slashium_green.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_SLASHIUM_ORANGE",
	name 		= "TEST TUBE FILLED WITH ORANGE SLASHIUM",
	description = "A throwable test tube that releases orange slashium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_TESLIUM
	spawn_probability                 = "0", -- TESTTUBE_TESLIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_slashium_orange.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_slashium_orange.xml")

				add_projectile("data/entities/projectiles/testtube_slashium_orange.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_SLASHIUM_PURPLE",
	name 		= "TEST TUBE FILLED WITH PURPLE SLASHIUM",
	description = "A throwable test tube that releases purple slashium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_TESLIUM
	spawn_probability                 = "0", -- TESTTUBE_TESLIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_slashium_purple.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_slashium_purple.xml")

				add_projectile("data/entities/projectiles/testtube_slashium_purple.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_EXPLOSIUM_RED",
	name 		= "TEST TUBE FILLED WITH RED EXPLOSIUM",
	description = "A throwable test tube that releases red explosium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_EXPLOSIUM
	spawn_probability                 = "0", -- TESTTUBE_EXPLOSIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_explosium_red.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_explosium_red.xml")

				add_projectile("data/entities/projectiles/testtube_explosium_red.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_EXPLOSIUM_ORANGE",
	name 		= "TEST TUBE FILLED WITH ORANGE EXPLOSIUM",
	description = "A throwable test tube that releases orange explosium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_EXPLOSIUM
	spawn_probability                 = "0", -- TESTTUBE_EXPLOSIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_explosium_orange.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_explosium_orange.xml")

				add_projectile("data/entities/projectiles/testtube_explosium_orange.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_EXPLOSIUM_PURPLE",
	name 		= "TEST TUBE FILLED WITH PURPLE EXPLOSIUM",
	description = "A throwable test tube that releases purple explosium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_EXPLOSIUM
	spawn_probability                 = "0", -- TESTTUBE_EXPLOSIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_explosium_purple.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_explosium_purple.xml")

				add_projectile("data/entities/projectiles/testtube_explosium_purple.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_EXPLOSIUM_GREEN",
	name 		= "TEST TUBE FILLED WITH GREEN EXPLOSIUM",
	description = "A throwable test tube that releases green explosium on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- TESTTUBE_EXPLOSIUM
	spawn_probability                 = "0", -- TESTTUBE_EXPLOSIUM
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_explosium_green.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_explosium_green.xml")

				add_projectile("data/entities/projectiles/testtube_explosium_green.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_CONCENTRATED_POISON_GAS",
	name 		= "TEST TUBE FILLED WITH CONCENTRATED POISON GAS",
	description = "A throwable test tube that releases concentrated poison gas on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_TESTTUBE_CONCENTRATED_POISON_GAS
	spawn_probability                 = "0", -- THEARMORYACTIONS_TESTTUBE_CONCENTRATED_POISON_GAS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_concentrated_poison_gas.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_concentrated_poison_gas.xml")

				add_projectile("data/entities/projectiles/testtube_concentrated_poison_gas.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_EXPLODING_GAS_YELLOW",
	name 		= "TEST TUBE FILLED WITH YELLOW EXPLODING GAS",
	description = "A throwable test tube that releases yellow exploding gas on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_TESTTUBE_CONCENTRATED_POISON_GAS
	spawn_probability                 = "0", -- THEARMORYACTIONS_TESTTUBE_CONCENTRATED_POISON_GAS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_exploding_gas_yellow.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_exploding_gas_yellow.xml")

				add_projectile("data/entities/projectiles/testtube_exploding_gas_yellow.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_EXPLODING_GAS_RED",
	name 		= "TEST TUBE FILLED WITH RED EXPLODING GAS",
	description = "A throwable test tube that releases red exploding gas on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_TESTTUBE_CONCENTRATED_POISON_GAS
	spawn_probability                 = "0", -- THEARMORYACTIONS_TESTTUBE_CONCENTRATED_POISON_GAS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_exploding_gas_red.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_exploding_gas_red.xml")

				add_projectile("data/entities/projectiles/testtube_exploding_gas_red.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_EXPLODING_GAS_GREEN",
	name 		= "TEST TUBE FILLED WITH GREEN EXPLODING GAS",
	description = "A throwable test tube that releases green exploding gas on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_TESTTUBE_CONCENTRATED_POISON_GAS
	spawn_probability                 = "0", -- THEARMORYACTIONS_TESTTUBE_CONCENTRATED_POISON_GAS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_exploding_gas_green.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_exploding_gas_green.xml")

				add_projectile("data/entities/projectiles/testtube_exploding_gas_green.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_EXPLODING_GAS_ORANGE",
	name 		= "TEST TUBE FILLED WITH ORANGE EXPLODING GAS",
	description = "A throwable test tube that releases green exploding gas on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_TESTTUBE_CONCENTRATED_POISON_GAS
	spawn_probability                 = "0", -- THEARMORYACTIONS_TESTTUBE_CONCENTRATED_POISON_GAS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_exploding_gas_orange.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_exploding_gas_orange.xml")

				add_projectile("data/entities/projectiles/testtube_exploding_gas_orange.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

table.insert( actions,
{
	id          = "THEARMORYACTIONS_TESTTUBE_EXPLODING_GAS_PURPLE",
	name 		= "TEST TUBE FILLED WITH PURPLE EXPLODING GAS",
	description = "A throwable test tube that releases purple exploding gas on impact",
	sprite 		= "mods/TheArmory/files/actions/material_testtube.png",
	type 		= ACTION_TYPE_MATERIAL,
	spawn_level                       = "0", -- THEARMORYACTIONS_TESTTUBE_CONCENTRATED_POISON_GAS
	spawn_probability                 = "0", -- THEARMORYACTIONS_TESTTUBE_CONCENTRATED_POISON_GAS
	price = 600,
	mana = 20,
	action 		= function()
		
		if(getPlayerEntity() ~= nil) then
			if(checkPlayerAmmo(1, "throwable_weapons_ammo", "Throwable Weapons Ammo")) then
			
				applyTrinketsEffectsWeapons_SingleShotRegular("testtube_exploding_gas_purple.xml")
				
				applyTrinketsEffectsWeapons_StackableBonusesRanged("testtube_exploding_gas_purple.xml")

				add_projectile("data/entities/projectiles/testtube_exploding_gas_purple.xml")
				
				addPlayerAmmo(applyTrinketsEffectsAmmo_Consumption(-1), "throwable_weapons_ammo", "Throwable Weapons Ammo")
			end
		end
		
	end,
} )

--#NEW_ENTRY#