dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/thearmory_utilities.lua")

function collision_trigger(colliding_entity_id)

	local x, y = EntityGetTransform(colliding_entity_id)
	
	-- strips projectile from its ability to explode on death, then kills it
	edit_component( colliding_entity_id, "ProjectileComponent", function(comp,vars)
		vars.on_death_explode=false
	end)
	EntityKill(colliding_entity_id)
	
	-- Loads audiovisual feedback
	GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/shield/block", x, y )
	EntityLoad("data/entities/particles/particle_explosion/explosion_flare_green_small.xml", x, y)
	EntityLoad("data/entities/smoke_pocket_smaller.xml", x, y)
	
	-- Heals the player when projectile is cancelled but also deals damage to enemy to prevent health gain exploiting
	local threshold_player = 5
	local threshold_enemy = 0.1
	
	addPlayerHealth(threshold_player)
	
	comp_ids = EntityGetComponent( colliding_entity_id, "ProjectileComponent" )
	if( comp_ids ~= nil ) then
		local shooterId = ComponentGetValue( comp_ids[1], "mWhoShot")
		EntityInflictDamage( shooterId, threshold_enemy, "DAMAGE_MELEE", "deflect", "BLOOD_SPRAY", 0, 0)
	end
end